/** @file samp_base.h
 *  @brief PGETvx[XNXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _SAMP_BASE_H_
#define _SAMP_BASE_H_

#include "scene.h"
#include "camera.h"
#include "light.h"
#include "model.h"
#include "primitive.h"

class SampBase : public Task
{
	//==============================================
	// oϐ
	//==============================================
private:
	float	m_fDist;
	float	m_fTheta;
	float	m_fPhi;
	float   m_fParam1;
	Vector  m_vLightDir;
	
	Scene  * m_pScene;
	Camera * m_pCamera;
	Light  * m_pLight;

	Model  * m_pSkyDome;
	Model  * m_pBuilding;
	u32		 m_unModel;
	Model ** m_ppModel;
	

	pge::Arrow * m_pLine;

	//==============================================
	// o֐
	//==============================================
protected:
	//----------------------------------------------
	// bZ[W
	//----------------------------------------------
	virtual int OnInit();		// ^XN
	virtual int OnMain();		// ^XNC
	virtual int OnKill();		// ^XN

public:
	static Task * Create( Task * pParent );
	SampBase();
	virtual ~SampBase();
};

#endif //_SAMP_BASE_H_
