/** @main_ogl.cpp
 *  @brief OpenGLpC֐ъe
 *
 *  @author yasufuku
 *  @date 2010/12
 *  @version 0.10
 *
 *  Copyright(C) 2010 Kensuke Yasufuku
 */
#include <stdio.h>
#include "sys_config.h"
#include "main_loop.h"
#include "task.h"
#include "view.h"

SystemConfig sc;
MainLoop g_MainLoop;// glutMainLoopexitĂfXgN^ĂŏȊׂΏ
const int DEFAULT_FPS = 60;
const int DEFAULT_WINDOW_WIDTH  = 1280;
const int DEFAULT_WINDOW_HEIGHT = 720;

//--------------------------------------------------------------------
// XV
//--------------------------------------------------------------------
void Update( void )
{
	g_MainLoop.Update(); // AvP[VXV
	glutPostRedisplay();
}

//--------------------------------------------------------------------
// `
//--------------------------------------------------------------------
void Draw( void )
{
	g_MainLoop.Draw();	// AvP[V`揈
}

//--------------------------------------------------------------------
// EBhETCY
//--------------------------------------------------------------------
void Resize(int w, int h)
{
	sc.nScreenWidth  = w;
	sc.nScreenHeight = h;

	// V[_O
	//DisplayController::Resize();
}

//--------------------------------------------------------------------
// VXeݒ菉
//--------------------------------------------------------------------
int InitSystemConfig()
{
	// ftHgVXeݒ
	sc.nFPS = DEFAULT_FPS;

	sc.bFullScreen = false;
	sc.nScreenWidth  = DEFAULT_WINDOW_WIDTH;
	sc.nScreenHeight = DEFAULT_WINDOW_HEIGHT;
	sc.afBackGroundColor[0] = 0.1f;
	sc.afBackGroundColor[1] = 0.2f;
	sc.afBackGroundColor[2] = 0.4f;
	sc.afBackGroundColor[3] = 1.0f;
	
	sprintf( sc.pszWindowTitle, "Personal Game Engine Demo" );

	FILE * fp;
	// Ot@Cgp\
	fp = fopen( "system.ini", "r" );	
	if( fp ) {
		fscanf( fp, "%d\n", &sc.nFPS);
		fscanf( fp, "%d\n", &sc.bFullScreen);
		fscanf( fp, "%d\n", &sc.nScreenWidth);
		fscanf( fp, "%d\n", &sc.nScreenHeight);
		fscanf( fp, "%s\n", &sc.pszWindowTitle);
		fclose(fp);
	}
	printf("=== Personal Game Engine ver.0.1\n");
	printf("=== SYSTEM SETTING ===\n");
	printf("FPS=%d\n", sc.nFPS);
	if( sc.bFullScreen ) {
		printf("FullScreenMode\n");
	} else {
		printf("WindowMode ( %d x %d )\n", sc.nScreenWidth, sc.nScreenHeight);
	}
	return 0;
}

//--------------------------------------------------------------------
// OpenGL
//--------------------------------------------------------------------
int InitOpenGL( int argc, char ** argv )
{
	// glut
	glutInit(&argc , argv);
	// EBhEʒu
	glutInitWindowPosition(100 , 50);
	// EBhETCY
	glutInitWindowSize( sc.nScreenWidth, sc.nScreenHeight );
	// fBXvC[h̏
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_STENCIL );
	// EBhE쐬
	glutCreateWindow(sc.pszWindowTitle);

	// NAJ[̐ݒ
	glClearColor(0.0, 0.0, 0.0, 0.0);
	glClearStencil(0);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

	if( sc.bFullScreen ) {
		glutFullScreen();
	}
	
	// ACh֐ݒ
	glutIdleFunc( Update );

	// fBXvC֐ݒ
	glutDisplayFunc(Draw);

	// VF[v֐ݒ
	glutReshapeFunc( Resize );

	// L[{[h֐ݒ
	//glutKeyboardFunc(keyboard);
	//glutKeyboardUpFunc(upkeyboard);
	//glutSpecialFunc(special);
	//glutSpecialUpFunc(upspecial);	
	glEnable(GL_DEPTH_TEST);
	glDepthFunc( GL_LESS );

	glewInit();

	return 0;
}

//---------------------------------------------------------
// IItݒ(Windows)
//---------------------------------------------------------
#if 0
typedef BOOL (APIENTRY *PFNWGLSWAPINTERVALFARPROC)( int );
PFNWGLSWAPINTERVALFARPROC wglSwapIntervalEXT = 0;
void setVSync( int interval=1 )
{
	const char * extensions = (const char *)glGetString( GL_EXTENSIONS );
	if( strstr( extensions, "WGL_EXT_swap_control" ) == 0 ) {
		return; // Error: WGL_EXT_swap_control extension not supported on your computer.\n");
	}
	else {
		wglSwapIntervalEXT = (PFNWGLSWAPINTERVALFARPROC)wglGetProcAddress( "wglSwapIntervalEXT" );
	}
	if( wglSwapIntervalEXT ) {
		wglSwapIntervalEXT(interval);
	}
}
#endif

//--------------------------------------------------------------------
// C֐
//--------------------------------------------------------------------
int main( int argc, char ** argv )
{
	PRINTF("%s-%s\n", __DATE__, __TIME__);

	// OpenGL
	InitSystemConfig();
	InitOpenGL( argc , argv );
	//setVSync(1);

	// C[vNXJn
	g_MainLoop.Start( argc, argv );
	
	// C[vJn
	glutMainLoop();
	
	return 0;
}
