/** @file static__phong.frag
 *  @brief X^eBbNbVitHˁj
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#version 130

uniform vec3 EyePos   = vec3( 0.0f, 0.0f, 0.0f );
uniform vec4 Specular = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 Ambient  = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec4 Diffuse  = vec4(1.0, 1.0, 1.0, 1.0);
uniform vec3 LightDir = vec3(0.0, 1.0, 0.0);
uniform vec3 LightIntensity = vec3(1.0, 1.0, 1.0);
uniform float SurfaceSmooth=15.0;

in vec3 WorldPos;
in vec3 WorldNormal;

out vec4 Color;

vec3 Shade(vec3 p, vec3 n)
{
     vec3 eyeVec   = normalize(EyePos - p);
     vec3 lightVec = normalize(LightDir);
     vec3 halfVec = normalize(0.5 * (eyeVec + lightVec));
     float cosTh = clamp(dot(n, halfVec),  0, 1);
     float cosTi = clamp(dot(n, lightVec), 0, 1);
     //vec3 Lo = vec3(Ambient) + LightIntensity*vec3(Diffuse)*cosTi +  vec3(Specular)*pow(cosTh, SurfaceSmooth);
     vec3 Lo = vec3(Ambient) + vec3( Diffuse + Specular* max(pow(cosTh, SurfaceSmooth), 0.000001)*5.0f) * 1.0f * cosTi;
     return Lo;
}

void main() {
     vec3 nw   = normalize(WorldNormal);
     Color.rgb = Shade( WorldPos, nw );
     Color.a   = Diffuse.a;
}
