/** @file camera.h
 *  @brief CameraNXwb_
 *
 *  @author yasufuku
 *  @date 2004/07
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#ifndef _CAMERA_H_
#define _CAMERA_H_

#include "include.h"
#include "element.h"
/**
 *	  @brief CameraNX
 *
 *    CameraNX
 */
class Camera : public Element
{
private:
	enum {
		ORTHO = 0,
		PERSPECTIVE,
	};
	
	int   m_nType;
	float m_fNear;
	float m_fFar;
	float m_fFovy;
	
public:
	/// _W
	Vector lookat;
	Vector up;
	Matrix proj;

protected:
	/// XV
	virtual int OnUpdate();	
	int UpdateMatrix();
	int UpdatePerspectiveMatrix();
	int UpdateOrthoMatrix();

	/// _O
	virtual int OnRender();
public:
	/// ֐
	static Camera * Create( Element * pParent, int nPriority = TP_CAMERA );
	static Camera * Create( Element * pParent, const Vector & pos, const Vector & at, int nPriority = TP_CAMERA );
	Camera(); /// RXgN^
	virtual ~Camera(); /// fXgN^

	void SetFovy( float fovy ) { m_fFovy = fovy; }
	void SetNearClip( float fNear ){ m_fNear = fNear; }
	void SetFarClip ( float fFar  ){ m_fFar  = fFar;  }
	float GetFovy(){ return m_fFovy; }
	void Perspective(){ m_nType = PERSPECTIVE; }
	void Ortho(){ m_nType = ORTHO; }
};

#endif //_CAMERA_H_
