/** @file material.h
 *  @brief MaterialNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _MATERIAL_H_
#define _MATERIAL_H_

#include "include.h"
#include "model_data.h"
#include "color.h"
#include "texture_manager.h"
#include "texture.h"
#include "shader_manager.h"

/**
 *  @brief MaterialNX
 *
 *	}eAf[^
*/
class Material
{
private:
	MaterialData * m_pData;
	Color		m_Specular;		///< XyLJ[
	Color		m_Diffuse;		///< fBt[YJ[
	Color		m_Ambient;		///< ArGgJ[
	float       m_fShininess;	///<

	bool		m_bValidTex;	///< eNX`L
	HTexture    m_hTexture;		///< eNX`nh
	//Texture   * m_pTexture;		///< eNX`

	ShaderBase * m_pShader;
	
protected:
	Material * Init( MaterialData * pData, eShaderMeshType shaderMeshType );
public:
	static Material * Create( MaterialData * pData, eShaderMeshType shaderMeshType );	///< ֐
	Material();					///< RXgN^
	virtual ~Material();		///< fXgN^
	void Fill();				///< Fill
	MaterialData * GetData(){ return m_pData; }
	bool CheckTrans();
	u32  GetTexSize();
	u32  GetTexNum();
	void ValidTexture( bool bValid ) { m_bValidTex = bValid; }
	ShaderBase * GetShader(){ return m_pShader; }
};

#endif //_MATERIAL_H_
