/** @file mesh_base.h
 *  @brief MeshBaseNXwb_
 *
 *  @author yasufuku
 *  @date 2004/10
 *  @version 0.10
 *
 *  Copyright(C) 2004 Kensuke Yasufuku
 */
#ifndef _MESH_BASE_H_
#define _MESH_BASE_H_

#include "include.h"
#include "model_data.h"
#include "material.h"
#include "matrix.h"

#define MAX_MAP 4
/**
 *  @brief MeshBaseNX
 *
 *	bV`p{NX
 */
class MeshBase
{
private:
	int			m_nReference;		///< QƉ

protected:
	MeshData  *  m_pData;			///< bVf[^
	int         m_nVFmt;
	Material  ** m_paMaterialTbl;	///< }eAe[u

	u32			 m_unShader;
	ShaderBase ** m_paShaderList;
	
	bool         m_bColor;
	Color        m_Color;
	bool         m_bDrawBody;
	
protected:
	MeshBase();
	virtual ~MeshBase();
	u32 GetVertexSize( u32 vtxFormat );
	void MakeShaderList();

public:
	virtual MeshBase * Reference();	///< Q
	virtual void   Release();	///< J
	virtual void   Fill() = 0;	///< `
	virtual void   FillMotion( Mtx44 * pMatrixList, int num ) = 0;	///< [V
	
	virtual void     SetColor( const Color & c ) { m_bColor = true; m_Color = c; }
	virtual void     ResetColor() { m_bColor = false; }
	virtual void	 SetVtxFmt( int fmt ){ m_nVFmt = fmt; }
	virtual void     SetDrawBody( bool bDraw ){ m_bDrawBody = bDraw; }
};

#endif //_MESH_BASE_
