/** @file model.h
 *  @brief 3D ModelNXwb_
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _MODEL_H_
#define _MODEL_H_

#include "include.h"
#include "element.h"
#include "mesh_base.h"
#include "motion.h"

class Motion;

/**
 *  @brief 3D ModelNX
 *
 *	fNX
 */
class Model : public Element
{
private:
	ModelData  * m_pData;			// ff[^
	MeshBase   * m_pMesh;			// bVNX|C^
	Motion     * m_pMotion;			// [VNX|C^

protected:
	Model();					// RXgN^
	virtual ~Model();			// fXgN^
	virtual int OnInit();		// 
	virtual int OnUpdate();		// XV
	virtual int OnRender();		// _O
	
public:
	/// ֐
	static Model * Create( Element * pParent, ModelData * pData, int nPriority = TP_MODEL );
	/// [Vf[^ݒ
	void SetMotion(  MotionData * pMotion, float fBlend = 0.0f );
	void IncTime( float fTime = 1.0f );
	/// f[^擾
	ModelData * GetData(){ return m_pData; }
	MeshBase  * GetMesh(){ return m_pMesh; }
	Motion    * GetMotion(){ return m_pMotion; }
};

#endif //_MODEL_H_
