/** @file scene.cpp
 *  @brief SceneNX\[X
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */

#include "scene.h"

Scene * Scene::s_pCurScene = NULL;
//====================================================================
// SceneNXo֐`
//====================================================================
//---------------------------------------------------------------
// 
//---------------------------------------------------------------
/**
 *	@param	pParent:	eGg
 *	@param	nPriority:	Dx
 */
Scene * Scene::Create( Element * pParent, int nPriority )
{
	Scene * pScene = NEW Scene;
	return (Scene *)pScene->Init( pParent, nPriority );
}

//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
Scene::Scene()
{
	SetName("Scene");

	m_pProjMatrix = NULL;
	m_pViewMatrix = NULL;
	m_pModelMatrix = NULL;
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
Scene::~Scene()
{
}

//---------------------------------------------------------------
// XV
//---------------------------------------------------------------
int Scene::OnUpdate()
{
	// SceneGraph\
	// ZSort\
	OnUpdateChildren();
	return 0;
}

//---------------------------------------------------------------
// _O
//---------------------------------------------------------------
int Scene::OnRender()
{
	s_pCurScene = this;
	return 0;
}

//---------------------------------------------------------------
// ProjViewsZbg
//---------------------------------------------------------------
void Scene::SetViewProjMatrixPtr( const Matrix * view, const Matrix * proj  )
{
	s_pCurScene->m_ViewProjMatrix = *proj * *view;
	s_pCurScene->m_pProjMatrix = proj;
	s_pCurScene->m_pViewMatrix = view;
}

//---------------------------------------------------------------
// ModelsZbg
//---------------------------------------------------------------
void Scene::SetModelMatrixPtr( const Matrix * model )
{
	s_pCurScene->m_ModelViewProjMatrix = s_pCurScene->m_ViewProjMatrix *  *model;
	s_pCurScene->m_ModelViewMatrix     = *s_pCurScene->m_pViewMatrix   *  *model;
	s_pCurScene->m_pModelMatrix        = model;
}

//---------------------------------------------------------------
// CameraNXZbg
//---------------------------------------------------------------
void Scene::SetCameraPtr( const Camera * pCamera )
{
	s_pCurScene->m_pCamera = pCamera;
	SetViewProjMatrixPtr( &pCamera->m, &pCamera->proj );
}

//---------------------------------------------------------------
// LightNXZbg
//---------------------------------------------------------------
void Scene::SetLightPtr( const Light * pLight )
{
	s_pCurScene->m_pLight = pLight;
}
