/** @file shader_manager.cpp
 *  @brief ShaderManagerNX\[X
 *
 *  @author yasufuku
 *  @date 2011/01
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#include "shader_manager.h"

// 肪Ȃ̂ŎgsxǉĂB

// Sprite
#define VS_FILE_SPRITE			           SHADER_PATH"sprite.vert"
#define FS_FILE_SPRITE			           SHADER_PATH"sprite.frag"
#define VS_FILE_FONT			           SHADER_PATH"font.vert"
#define FS_FILE_FONT			           SHADER_PATH"font.frag"
#define VS_FILE_POINT_SPRITE	           SHADER_PATH"point_sprite.vert"
#define FS_FILE_POINT_SPRITE	           SHADER_PATH"point_sprite.frag"

// Static Mesh
#define VS_FILE_STATIC_COLOR               SHADER_PATH"static__color.vert"
#define FS_FILE_STATIC_COLOR               SHADER_PATH"static__color.frag"
#define VS_FILE_STATIC_LAMBERT             SHADER_PATH"static__lambert.vert"
#define FS_FILE_STATIC_LAMBERT             SHADER_PATH"static__lambert.frag"
#define VS_FILE_STATIC_PHONG               SHADER_PATH"static__phong.vert"
#define FS_FILE_STATIC_PHONG               SHADER_PATH"static__phong.frag"
#define VS_FILE_STATIC_LAMBERT_DIFFUSEMAP  SHADER_PATH"static__lambert_dm.vert"
#define FS_FILE_STATIC_LAMBERT_DIFFUSEMAP  SHADER_PATH"static__lambert_dm.frag"
#define VS_FILE_STATIC_DIFFUSEMAP          SHADER_PATH"static__dm.vert"
#define FS_FILE_STATIC_DIFFUSEMAP          SHADER_PATH"static__dm.frag"
#define VS_FILE_STATIC_DIFFUSEMAP_LIGHTMAP SHADER_PATH"static__dm_lm.vert"
#define FS_FILE_STATIC_DIFFUSEMAP_LIGHTMAP SHADER_PATH"static__dm_lm.frag"

// Skin Mesh
#define VS_FILE_SKIN_LAMBERT               SHADER_PATH"skin__lambert.vert"
#define FS_FILE_SKIN_LAMBERT               SHADER_PATH"skin__lambert.frag"


//====================================================================
// ShaderMangerNXo֐`
//====================================================================
//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
ShaderManager::ShaderManager()
{
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
ShaderManager::~ShaderManager()
{
}

//---------------------------------------------------------------
// VOg̃CX^X擾
//---------------------------------------------------------------
ShaderManager * ShaderManager::Get()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderManager s_ShaderManager;
	return &s_ShaderManager;
}

//---------------------------------------------------------------
// ^XvCgbViwJ[&eNX`jVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::Sprite()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_SPRITE,
									FS_FILE_SPRITE );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// tHgpiwJ[&eNX`jVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::Font()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_FONT,
									FS_FILE_FONT );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// |CgXvCgVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::PointSprite()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_POINT_SPRITE,
									FS_FILE_POINT_SPRITE );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViwJ[jVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticColor()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_COLOR,
									FS_FILE_STATIC_COLOR );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViLambertˁjVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticLambert()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_LAMBERT,
									FS_FILE_STATIC_LAMBERT );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViLambertˁjVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticPhong()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_PHONG,
									FS_FILE_STATIC_PHONG );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViLambert + Diffuse Mapj VF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticLambertDiffuseMap()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_LAMBERT_DIFFUSEMAP,
									FS_FILE_STATIC_LAMBERT_DIFFUSEMAP );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViDiffuse Mapj VF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticDiffuseMap()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_DIFFUSEMAP,
									FS_FILE_STATIC_DIFFUSEMAP );
	return &s_ShaderBase;
}

//---------------------------------------------------------------
// StaticbViDiffuse Map + LightMapj VF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::StaticDiffuseMapLightMap()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_STATIC_DIFFUSEMAP_LIGHTMAP,
									FS_FILE_STATIC_DIFFUSEMAP_LIGHTMAP );
	return &s_ShaderBase;
}





//---------------------------------------------------------------
// SkinbViLambertˁjVF[_[擾
//---------------------------------------------------------------
ShaderBase * ShaderManager::SkinLambert()
{
	// static֐͂̊֐ŏɌĂяoƂɃRXgN^Ăяo
	static ShaderBase s_ShaderBase( VS_FILE_SKIN_LAMBERT,
									FS_FILE_SKIN_LAMBERT );
	return &s_ShaderBase;
}
