/** @file shader_manager.h
 *  @brief ShaderManagerNXwb_
 *
 *  @author yasufuku
 *  @date 2011/11
 *  @version 0.10
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _SHADER_MANAGER_H_
#define _SHADER_MANAGER_H_

//====================================================================
// CN[h
//====================================================================
#include "include.h"
#include "shader_base.h"

//====================================================================
// 񋓌^
//====================================================================
enum eShaderMeshType {
	STATIC_MESH_SHADER = 0,
	SKIN_MESH_SHADER
};

/**
 *	  @brief ShaderManagerNX
 *
 *    GLSLVF[_[ǗNX
 */
class ShaderManager
{	
private:
	ShaderManager();
	~ShaderManager();
public:
	// VOg
	static ShaderManager * Get();
	
	
	ShaderBase * StaticMeshLambertUV1();
	ShaderBase * SkinMeshLambertUV1();

	// Sprite
	ShaderBase * Sprite();
	ShaderBase * Font();
	ShaderBase * PointSprite();
	
	// StaticbV
	ShaderBase * StaticColor();
	ShaderBase * StaticLambert();
	ShaderBase * StaticPhong();
	ShaderBase * StaticDiffuseMap();
	ShaderBase * StaticLambertDiffuseMap();
	ShaderBase * StaticDiffuseMapLightMap();
	
	// SkinbV
	ShaderBase * SkinLambert();
};

#endif //_HANDLE_H_
