/** @file skin_mesh.h
 *  @brief VertexBuffer MeshNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _SKIN_MESH_H_
#define _SKIN_MESH_H_

#include "include.h"
#include "material.h"
#include "mesh_base.h"
#include "shader_base.h"

/**
 *  @brief SkinMeshNX
 *
 *	bVNXi[VȂj
 */
class SkinMesh : public MeshBase
{
private:		
	// VAO
	GLuint * m_pVAO;
	GLuint * m_pVBO;
	GLuint * m_pEBO;
	
	// bV
	u32  m_unVertex;			///< _
	u32  m_unPolygon;			///< |S
	u32  m_unTex;				///< eNX`
	u32  m_unTexSize;			///< eNX`TCY(MB)

	s16  m_sBone;
	s16  m_sWeight;
	
protected:
	SkinMesh();						///< RXgN^
	virtual ~SkinMesh();				///< fXgN^
	int  Init( MeshData * pData );
	void MakeVertexBuffer();
	virtual void DeleteVertexBuffer();

public:
	static SkinMesh * Create( MeshData * pData, s16 sBone, s16 sWeight );	///< ֐
	virtual void Fill();		///< `
	virtual void FillMotion( Mtx44 * pMatrixList, int num );	///< [V
};

#endif //_SKIN_MESH_H_
