/** @file sprite.h
 *  @brief SpriteNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2011 Kensuke Yasufuku
 */
#ifndef _SPRITE_H_
#define _SPRITE_H_

#include "include.h"
#include "element.h"
#include "color.h"
#include "model_data.h"
#include "shader_base.h"
#include "texture_manager.h"

#define SPRITE_VERTICES_SIZE 36
/**
 *  @brief SpriteNX
 *
 *	v~eBuNX
 */
class Sprite : public Element
{
private:
	typedef struct _SpriteVertex {
		float x;
		float y;
		float z;
		float r;
		float g;
		float b;
		float a;
		float u;
		float v;
	} SpriteVertex;

protected:
	SpriteVertex  m_Vertices[SPRITE_VERTICES_SIZE];

	ShaderBase * m_pShader;
	GLuint     * m_paVAO;
	GLuint     * m_paVBO;
	TexImage     m_TexImage;
	TexHeader    m_TexHeader;
	HTexture     m_hTexture;


	Sprite( const char * tgafile, float w, float h );
	virtual ~Sprite();
	virtual int OnInit();
	virtual int OnUpdate(){ return Element::OnUpdate(); }
	virtual int OnRender();
	virtual int OnKill();
public:
	static Sprite * Create( Element * pParent, const char * tgafile, float w, float h );
	//void SetMaterial();
	//void SetColor( const Color & c[4] );
	//void SetTexAnimeConfig();
};

#endif //_SPRITE_H_
