/** @file texture.h
 *  @brief TextureNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.20
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _TEXTURE_H_
#define _TEXTURE_H_

#include "tex_data.h"

/**
 *  @brief TextureNX
 *
 *  eNX`̊Ot@Cǂݍ݂GPUւ̓]
*/
class Texture
{
	friend class TextureManager;
public:
	struct HeaderTbl {
		u16		sTexNum;				///< eNX`̖
		const TexHeader *  pHeaderTbl;	///< eNX`wb_z
	};
	
private:
	HeaderTbl m_HeaderTbl;
	u8	***	m_pImageTbl;		///< ̃C[We[u
	u32 *   m_pIdTbl;			///< eNX`IDe[u
	u32     m_unSize;			///< eNX`TCY
protected:
	
public:
	Texture();							///< RXgN^
	Texture( const Texture & rhs );		///< RXgN^
	virtual ~Texture();					///< fXgN^

	void operator = (const Texture & rhs ){}
	
	/// [hA[h
	bool Load( const HeaderTbl & header_tbl );
	void Unload();
	
	/// Fill
	void Fill( GLuint diffuse, GLuint light=-1 );
	
	/// C[W[h
	u8 * LoadImageData( const TexImage * pImage,      u32 * pLoadSize = NULL );
	u8 * LoadRGBAImageData( const TexImage * pImage,  u32 * pLoadSize = NULL );
	u8 * LoadAlphaImageData( const TexImage * pImage, u32 * pLoadSize = NULL );

	u32 GetNum()  { return m_HeaderTbl.sTexNum; }
	u32 GetSize() { return m_unSize; }
};

#endif //_TEXTURE_H_
