/** @file texture_manager.cpp
 *  @brief TextureManagerNXCvg
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#include "texture_manager.h"

//====================================================================
// TextureMangerNXo֐`
//====================================================================
//---------------------------------------------------------------
// RXgN^
//---------------------------------------------------------------
TextureManager::TextureManager()
{
}

//---------------------------------------------------------------
// fXgN^
//---------------------------------------------------------------
TextureManager::~TextureManager()
{
	HeaderIndex::iterator i, begin = m_HeaderIndex.begin(), end = m_HeaderIndex.end();

	for( i=begin; i!=end; i++ ) {
		m_Textures.Dereference( i->second )->Unload();
	}
}

//---------------------------------------------------------------
// eNX`擾
//---------------------------------------------------------------
HTexture TextureManager::GetHandle( const HeaderTbl & HeaderTbl )
{
	HeaderIndexInsertRc rc =
	m_HeaderIndex.insert( std::make_pair( HeaderTbl, HTexture() ) );

	if( rc.second ) {

		Texture * tex = m_Textures.Acquire( rc.first->second );
		if( !tex->Load( rc.first->first ) ) {
			DeleteTexture( rc.first->second );
			rc.first->second = HTexture();
		}
	}
	return rc.first->second;
}

//---------------------------------------------------------------
// eNX`
//---------------------------------------------------------------
void TextureManager::DeleteTexture( HTexture htex )
{
	Texture * tex = m_Textures.Dereference( htex );

	if( tex != 0 ) {

		m_HeaderIndex.erase( m_HeaderIndex.find( tex->m_HeaderTbl ) );

		tex->Unload();
		m_Textures.Release( htex );
	}
}
