/** @file texture_manager.h
 *  @brief TextureManagerNXwb_
 *
 *  @author yasufuku
 *  @date 2011/02
 *  @version 0.10
 *
 *  Copyright(C) 2004-2011 Kensuke Yasufuku
 */
#ifndef _TEXTURE_MANAGER_H_
#define _TEXTURE_MANAGER_H_

#include "include.h"
#include <vector>
#include <map>

#include "handle.h"
#include "handle_manager.h"
#include "texture.h"

struct tagTexture { };
typedef Handle <tagTexture> HTexture;

/**
 *	  @brief TextureManagerNX
 *
 *    eNX`ǗNX
 *		GAME PROGRAMMING GEMSQlɂ܂
 */

class TextureManager
{
	typedef Texture::HeaderTbl	HeaderTbl;
	// case-insensitive string comparison predicate
    struct header_less
    {
        bool operator () ( const HeaderTbl & lhs, const HeaderTbl & rhs ) const
            {  return ( (lhs.pHeaderTbl) < (rhs.pHeaderTbl) );  }
    };
	
	typedef HandleManager < Texture, HTexture > HTextureManager;
	
	typedef std::map< HeaderTbl, HTexture, header_less > HeaderIndex;
	typedef std::pair< HeaderIndex::iterator, bool > HeaderIndexInsertRc;
	
	
private:
	//-----------------------------
	// oϐ
	//-----------------------------
	HTextureManager m_Textures;
	HeaderIndex       m_HeaderIndex;
	//-----------------------------
	// o֐
	//-----------------------------
	TextureManager();
	~TextureManager();

public:
	HTexture GetHandle( const HeaderTbl & HeaderTbl );
	void     DeleteTexture( HTexture htex );

	const Texture & GetTexture( HTexture htex ) const {
		return * m_Textures.Dereference( htex );
	}
	Texture * GetTexturePtr( HTexture htex ) const {
		return (Texture *)m_Textures.Dereference( htex );
	}
	static TextureManager & Get(){ static TextureManager s_Self; return s_Self; }
};

#endif //_HANDLE_H_
