#include "include.h"
#include "model_data.h"

//-----------------------------------------------------------------------------
//	Ԑڍ\
//-----------------------------------------------------------------------------
//	  0:april_Bip01
//	  1:|    april_Bip01_Pelvis
//	  2:|    |    april_Bip01_Spine
//	  3:|    |    |    april_Bip01_R_Thigh
//	  4:|    |    |    |    april_Bip01_R_Calf
//	  5:|    |    |    |    |    april_Bip01_R_Foot
//	  6:|    |    |    |    |    |    april_Bip01_R_Toe0
//	  7:|    |    |    april_Bip01_L_Thigh
//	  8:|    |    |    |    april_Bip01_L_Calf
//	  9:|    |    |    |    |    april_Bip01_L_Foot
//	 10:|    |    |    |    |    |    april_Bip01_L_Toe0
//	 11:|    |    |    april_Bip01_Spine1
//	 12:|    |    |    |    april_Bip01_Spine2
//	 13:|    |    |    |    |    april_Bip01_Neck
//	 14:|    |    |    |    |    |    april_Bip01_R_Clavicle
//	 15:|    |    |    |    |    |    |    april_Bip01_RUpArmTwist
//	 16:|    |    |    |    |    |    |    april_Bip01_R_UpperArm
//	 17:|    |    |    |    |    |    |    |    april_Bip01_R_Forearm
//	 18:|    |    |    |    |    |    |    |    |    april_Bip01_R_Hand
//	 19:|    |    |    |    |    |    |    |    |    |    april_Bip01_R_Finger1
//	 20:|    |    |    |    |    |    |    |    |    |    april_Bip01_R_Finger0
//	 21:|    |    |    |    |    |    april_Bip01_L_Clavicle
//	 22:|    |    |    |    |    |    |    april_Bip01_LUpArmTwist
//	 23:|    |    |    |    |    |    |    april_Bip01_L_UpperArm
//	 24:|    |    |    |    |    |    |    |    april_Bip01_L_Forearm
//	 25:|    |    |    |    |    |    |    |    |    april_Bip01_L_Hand
//	 26:|    |    |    |    |    |    |    |    |    |    april_Bip01_L_Finger1
//	 27:|    |    |    |    |    |    |    |    |    |    april_Bip01_L_Finger0
//	 28:|    |    |    |    |    |    april_Bip01_Head


//-----------------------------------------------------------------------------
//	Ԑڔԍ
//-----------------------------------------------------------------------------
// Single Bone Weight List
#define april_Bip01	0
#define april_Bip01_Pelvis	1
#define april_Bip01_Spine	2
#define april_Bip01_R_Thigh	3
#define april_Bip01_R_Calf	4
#define april_Bip01_R_Foot	5
#define april_Bip01_R_Toe0	6
#define april_Bip01_L_Thigh	7
#define april_Bip01_L_Calf	8
#define april_Bip01_L_Foot	9
#define april_Bip01_L_Toe0	10
#define april_Bip01_Spine1	11
#define april_Bip01_Spine2	12
#define april_Bip01_Neck	13
#define april_Bip01_R_Clavicle	14
#define april_Bip01_RUpArmTwist	15
#define april_Bip01_R_UpperArm	16
#define april_Bip01_R_Forearm	17
#define april_Bip01_R_Hand	18
#define april_Bip01_R_Finger1	19
#define april_Bip01_R_Finger0	20
#define april_Bip01_L_Clavicle	21
#define april_Bip01_LUpArmTwist	22
#define april_Bip01_L_UpperArm	23
#define april_Bip01_L_Forearm	24
#define april_Bip01_L_Hand	25
#define april_Bip01_L_Finger1	26
#define april_Bip01_L_Finger0	27
#define april_Bip01_Head	28

// Multi Bone Weight List
#define april_MULTI_WEIGHT_0	29
#define april_MULTI_WEIGHT_1	30
#define april_MULTI_WEIGHT_2	31
#define april_MULTI_WEIGHT_3	32
#define april_MULTI_WEIGHT_4	33
#define april_MULTI_WEIGHT_5	34
#define april_MULTI_WEIGHT_6	35
#define april_MULTI_WEIGHT_7	36
#define april_MULTI_WEIGHT_8	37
#define april_MULTI_WEIGHT_9	38
#define april_MULTI_WEIGHT_10	39
#define april_MULTI_WEIGHT_11	40
#define april_MULTI_WEIGHT_12	41
#define april_MULTI_WEIGHT_13	42
#define april_MULTI_WEIGHT_14	43
#define april_MULTI_WEIGHT_15	44
#define april_MULTI_WEIGHT_16	45
#define april_MULTI_WEIGHT_17	46
#define april_MULTI_WEIGHT_18	47
#define april_MULTI_WEIGHT_19	48
#define april_MULTI_WEIGHT_20	49

// Weight Matrix Num
#define april_BONE_NUM	29
#define april_MULTI_BONE_WEIGHT_NUM	21



//-----------------------------------------------------------------------------
//	{[\
//-----------------------------------------------------------------------------
static BoneData april_bone[] =
{
	{	// 0 april_Bip01
		0,
		april_Bip01_Pelvis,
	},
	{	// 1 april_Bip01_Pelvis
		0,
		april_Bip01_Spine,
	},
	{	// 2 april_Bip01_Spine
		0,
		april_Bip01_R_Thigh,
	},
	{	// 3 april_Bip01_R_Thigh
		0,
		april_Bip01_L_Thigh,
	},
	{	// 4 april_Bip01_R_Calf
		0,
		april_Bip01_R_Foot,
	},
	{	// 5 april_Bip01_R_Foot
		0,
		april_Bip01_R_Toe0,
	},
	{	// 6 april_Bip01_R_Toe0
		0,
		0,
	},
	{	// 7 april_Bip01_L_Thigh
		0,
		april_Bip01_Spine1,
	},
	{	// 8 april_Bip01_L_Calf
		0,
		april_Bip01_L_Foot,
	},
	{	// 9 april_Bip01_L_Foot
		0,
		april_Bip01_L_Toe0,
	},
	{	// 10 april_Bip01_L_Toe0
		0,
		0,
	},
	{	// 11 april_Bip01_Spine1
		0,
		april_Bip01_Spine2,
	},
	{	// 12 april_Bip01_Spine2
		0,
		april_Bip01_Neck,
	},
	{	// 13 april_Bip01_Neck
		0,
		april_Bip01_R_Clavicle,
	},
	{	// 14 april_Bip01_R_Clavicle
		0,
		april_Bip01_L_Clavicle,
	},
	{	// 15 april_Bip01_RUpArmTwist
		0,
		april_Bip01_R_UpperArm,
	},
	{	// 16 april_Bip01_R_UpperArm
		0,
		april_Bip01_R_Forearm,
	},
	{	// 17 april_Bip01_R_Forearm
		0,
		april_Bip01_R_Hand,
	},
	{	// 18 april_Bip01_R_Hand
		0,
		april_Bip01_R_Finger1,
	},
	{	// 19 april_Bip01_R_Finger1
		0,
		april_Bip01_R_Finger0,
	},
	{	// 20 april_Bip01_R_Finger0
		0,
		0,
	},
	{	// 21 april_Bip01_L_Clavicle
		0,
		april_Bip01_Head,
	},
	{	// 22 april_Bip01_LUpArmTwist
		0,
		april_Bip01_L_UpperArm,
	},
	{	// 23 april_Bip01_L_UpperArm
		0,
		april_Bip01_L_Forearm,
	},
	{	// 24 april_Bip01_L_Forearm
		0,
		april_Bip01_L_Hand,
	},
	{	// 25 april_Bip01_L_Hand
		0,
		april_Bip01_L_Finger1,
	},
	{	// 26 april_Bip01_L_Finger1
		0,
		april_Bip01_L_Finger0,
	},
	{	// 27 april_Bip01_L_Finger0
		0,
		0,
	},
	{	// 28 april_Bip01_Head
		0,
		0,
	},
};

//-----------------------------------------------------------------------------
//	{[sqr̋t}gbNX
//-----------------------------------------------------------------------------
static Mtx44 april_bone_inv_mtx[] =
{
	{	// april_Bip01
		0.000001f, -0.000000f, -1.000000f, 0.0f,
		0.000000f, 1.000000f, -0.000000f, 0.0f,
		1.000000f, -0.000000f, 0.000001f, 0.0f,
		-0.000000f, -0.875610f, 0.000000f, 1.0f,
	},
	{	// april_Bip01_Pelvis
		-0.000001f, 1.000000f, -0.000003f, 0.0f,
		1.000000f, 0.000001f, -0.000000f, 0.0f,
		0.000000f, -0.000003f, -1.000000f, 0.0f,
		-0.875610f, -0.000001f, 0.000000f, 1.0f,
	},
	{	// april_Bip01_Spine
		0.000000f, 1.000000f, 0.000001f, 0.0f,
		1.000000f, -0.000000f, 0.000796f, 0.0f,
		0.000796f, 0.000001f, -1.000000f, 0.0f,
		-0.966326f, 0.000000f, -0.000878f, 1.0f,
	},
	{	// april_Bip01_R_Thigh
		-0.006234f, -0.999981f, -0.000224f, 0.0f,
		-0.999744f, 0.006237f, -0.021730f, 0.0f,
		0.021731f, 0.000088f, -0.999764f, 0.0f,
		0.874895f, -0.084343f, 0.019009f, 1.0f,
	},
	{	// april_Bip01_R_Calf
		-0.006234f, -0.999981f, 0.000236f, 0.0f,
		-0.998634f, 0.006237f, 0.051886f, 0.0f,
		-0.051886f, 0.000088f, -0.998653f, 0.0f,
		0.518219f, -0.084343f, -0.019171f, 1.0f,
	},
	{	// april_Bip01_R_Foot
		0.000000f, -1.000000f, -0.000001f, 0.0f,
		-1.000000f, -0.000000f, 0.000000f, 0.0f,
		-0.000000f, 0.000001f, -1.000000f, 0.0f,
		0.108750f, -0.083668f, -0.013566f, 1.0f,
	},
	{	// april_Bip01_R_Toe0
		0.000001f, -1.000000f, -0.000000f, 0.0f,
		-0.000000f, 0.000000f, -1.000000f, 0.0f,
		1.000000f, 0.000001f, -0.000000f, 0.0f,
		-0.120794f, -0.083668f, 0.004236f, 1.0f,
	},
	{	// april_Bip01_L_Thigh
		0.006234f, -0.999981f, 0.000221f, 0.0f,
		-0.999744f, -0.006237f, -0.021730f, 0.0f,
		0.021731f, -0.000085f, -0.999764f, 0.0f,
		0.874895f, 0.084343f, 0.019009f, 1.0f,
	},
	{	// april_Bip01_L_Calf
		0.006233f, -0.999981f, -0.000238f, 0.0f,
		-0.998634f, -0.006237f, 0.051886f, 0.0f,
		-0.051886f, -0.000085f, -0.998653f, 0.0f,
		0.518219f, 0.084343f, -0.019171f, 1.0f,
	},
	{	// april_Bip01_L_Foot
		0.000000f, -1.000000f, -0.000001f, 0.0f,
		-1.000000f, -0.000000f, 0.000000f, 0.0f,
		-0.000000f, 0.000001f, -1.000000f, 0.0f,
		0.108750f, 0.083668f, -0.013566f, 1.0f,
	},
	{	// april_Bip01_L_Toe0
		0.000001f, -1.000000f, 0.000000f, 0.0f,
		-0.000000f, -0.000000f, -1.000000f, 0.0f,
		1.000000f, 0.000001f, -0.000000f, 0.0f,
		-0.120794f, 0.083668f, 0.004236f, 1.0f,
	},
	{	// april_Bip01_Spine1
		0.000000f, 1.000000f, 0.000001f, 0.0f,
		1.000000f, -0.000000f, 0.000796f, 0.0f,
		0.000796f, 0.000001f, -1.000000f, 0.0f,
		-1.103057f, 0.000000f, -0.000987f, 1.0f,
	},
	{	// april_Bip01_Spine2
		0.000000f, 1.000000f, 0.000001f, 0.0f,
		1.000000f, -0.000000f, 0.000796f, 0.0f,
		0.000796f, 0.000001f, -1.000000f, 0.0f,
		-1.239788f, 0.000000f, -0.001096f, 1.0f,
	},
	{	// april_Bip01_Neck
		0.000000f, 1.000000f, 0.000001f, 0.0f,
		1.000000f, -0.000000f, 0.000796f, 0.0f,
		0.000796f, 0.000001f, -1.000000f, 0.0f,
		-1.376520f, 0.000000f, -0.001155f, 1.0f,
	},
	{	// april_Bip01_R_Clavicle
		-1.000000f, 0.000000f, 0.000001f, 0.0f,
		-0.000000f, -1.000000f, -0.000000f, 0.0f,
		0.000001f, -0.000000f, 1.000000f, 0.0f,
		-0.027609f, 1.376520f, -0.000000f, 1.0f,
	},
	{	// april_Bip01_RUpArmTwist
		-0.999304f, -0.036466f, -0.007828f, 0.0f,
		0.037279f, -0.970249f, -0.239222f, 0.0f,
		0.001128f, -0.239348f, 0.970933f, 0.0f,
		-0.181383f, 1.330821f, 0.328275f, 1.0f,
	},
	{	// april_Bip01_R_UpperArm
		-0.999304f, -0.037206f, -0.002598f, 0.0f,
		0.037279f, -0.994314f, -0.099747f, 0.0f,
		0.001128f, -0.099774f, 0.995009f, 0.0f,
		-0.181383f, 1.363851f, 0.136965f, 1.0f,
	},
	{	// april_Bip01_R_Forearm
		-0.999308f, -0.037206f, -0.000110f, 0.0f,
		0.037031f, -0.994314f, -0.099839f, 0.0f,
		0.003605f, -0.099774f, 0.995004f, 0.0f,
		-0.443833f, 1.363851f, 0.138070f, 1.0f,
	},
	{	// april_Bip01_R_Hand
		-0.998762f, 0.032993f, 0.037232f, 0.0f,
		0.033700f, -0.101804f, 0.994233f, 0.0f,
		0.036593f, 0.994257f, 0.100566f, 0.0f,
		-0.685871f, 0.161985f, -1.363722f, 1.0f,
	},
	{	// april_Bip01_R_Finger1
		-0.998762f, 0.033022f, 0.037206f, 0.0f,
		0.033700f, -0.101012f, 0.994314f, 0.0f,
		0.036593f, 0.994337f, 0.099774f, 0.0f,
		-0.768444f, 0.160899f, -1.363851f, 1.0f,
	},
	{	// april_Bip01_R_Finger0
		-0.910931f, 0.333380f, 0.243028f, 0.0f,
		-0.138707f, -0.802270f, 0.580623f, 0.0f,
		0.388542f, 0.495198f, 0.777055f, 0.0f,
		-0.441567f, 1.311624f, -0.664985f, 1.0f,
	},
	{	// april_Bip01_L_Clavicle
		1.000000f, 0.000000f, 0.000001f, 0.0f,
		-0.000000f, 1.000000f, -0.000000f, 0.0f,
		-0.000001f, -0.000000f, 1.000000f, 0.0f,
		-0.027609f, -1.376520f, -0.000000f, 1.0f,
	},
	{	// april_Bip01_LUpArmTwist
		0.999304f, -0.036465f, 0.007831f, 0.0f,
		0.037279f, 0.970249f, -0.239222f, 0.0f,
		0.001125f, 0.239348f, 0.970933f, 0.0f,
		-0.181383f, -1.330821f, 0.328275f, 1.0f,
	},
	{	// april_Bip01_L_UpperArm
		0.999304f, -0.037206f, 0.002601f, 0.0f,
		0.037279f, 0.994314f, -0.099747f, 0.0f,
		0.001125f, 0.099774f, 0.995009f, 0.0f,
		-0.181383f, -1.363851f, 0.136965f, 1.0f,
	},
	{	// april_Bip01_L_Forearm
		0.999308f, -0.037206f, 0.000113f, 0.0f,
		0.037031f, 0.994314f, -0.099839f, 0.0f,
		0.003603f, 0.099774f, 0.995004f, 0.0f,
		-0.443833f, -1.363851f, 0.138070f, 1.0f,
	},
	{	// april_Bip01_L_Hand
		0.998762f, 0.032990f, -0.037232f, 0.0f,
		0.033700f, 0.101804f, 0.994233f, 0.0f,
		0.036590f, -0.994257f, 0.100566f, 0.0f,
		-0.685871f, -0.161985f, -1.363722f, 1.0f,
	},
	{	// april_Bip01_L_Finger1
		0.998762f, 0.033020f, -0.037206f, 0.0f,
		0.033700f, 0.101012f, 0.994314f, 0.0f,
		0.036590f, -0.994337f, 0.099774f, 0.0f,
		-0.768444f, -0.160899f, -1.363851f, 1.0f,
	},
	{	// april_Bip01_L_Finger0
		0.910932f, 0.333378f, -0.243026f, 0.0f,
		-0.138707f, 0.802270f, 0.580624f, 0.0f,
		0.388540f, -0.495199f, 0.777055f, 0.0f,
		-0.441567f, -1.311624f, -0.664986f, 1.0f,
	},
	{	// april_Bip01_Head
		0.000000f, 1.000000f, 0.000001f, 0.0f,
		1.000000f, -0.000000f, -0.000001f, 0.0f,
		-0.000001f, 0.000001f, -1.000000f, 0.0f,
		-1.450159f, -0.000000f, 0.000002f, 1.0f,
	},
};

//-----------------------------------------------------------------------------
//	}`{[EFCg
//-----------------------------------------------------------------------------
static s8 april_weight[] =
{
	april_Bip01_L_Clavicle, 40, april_Bip01_LUpArmTwist, -60, 
	april_Bip01_Spine, 50, april_Bip01_L_Thigh, -50, 
	april_Bip01_Pelvis, 25, april_Bip01_L_Thigh, -75, 
	april_Bip01_Pelvis, 27, april_Bip01_Spine, 20, april_Bip01_L_Thigh, 30, april_Bip01_R_Thigh, -20, 
	april_Bip01_L_Thigh, 50, april_Bip01_L_Calf, -50, 
	april_Bip01_R_Clavicle, 40, april_Bip01_RUpArmTwist, -60, 
	april_Bip01_Pelvis, 27, april_Bip01_Spine, 20, april_Bip01_R_Thigh, 30, april_Bip01_L_Thigh, -20, 
	april_Bip01_Spine, 50, april_Bip01_R_Thigh, -50, 
	april_Bip01_Pelvis, 25, april_Bip01_R_Thigh, -75, 
	april_Bip01_R_Thigh, 50, april_Bip01_R_Calf, -50, 
	april_Bip01_L_Thigh, 89, april_Bip01_R_Thigh, -10, 
	april_Bip01_Pelvis, 20, april_Bip01_L_Thigh, 40, april_Bip01_R_Thigh, -40, 
	april_Bip01_R_Thigh, 50, april_Bip01_L_Thigh, -50, 
	april_Bip01_Pelvis, 25, april_Bip01_L_Thigh, 50, april_Bip01_R_Thigh, -25, 
	april_Bip01_R_Thigh, 89, april_Bip01_L_Thigh, -10, 
	april_Bip01_L_Thigh, 75, april_Bip01_R_Thigh, -25, 
	april_Bip01_Pelvis, 75, april_Bip01_L_Thigh, -25, 
	april_Bip01_R_Thigh, 75, april_Bip01_L_Thigh, -25, 
	april_Bip01_Pelvis, 75, april_Bip01_R_Thigh, -25, 
	april_Bip01_L_Thigh, 69, april_Bip01_R_Thigh, -30, 
	april_Bip01_R_Thigh, 69, april_Bip01_L_Thigh, -30, 
};

//-----------------------------------------------------------------------------
//	_obt@
//-----------------------------------------------------------------------------
static float april_vertex_buf0[] = {
	// 0
	0.407841f, 0.658511f,
	-0.053152f, 0.663334f, 0.746433f,
	0.015962f, 1.380349f, 0.045197f,
	13.000000f,
	// 1
	0.410038f, 0.641463f,
	-0.000000f, 0.671180f, 0.741295f,
	-0.000000f, 1.375417f, 0.044863f,
	12.000000f,
	// 2
	0.419667f, 0.641463f,
	-0.000000f, 0.566963f, 0.823743f,
	-0.000000f, 1.361825f, 0.063236f,
	12.000000f,
	// 3
	0.374394f, 0.752150f,
	-0.106994f, 0.993272f, 0.044303f,
	0.088672f, 1.416274f, -0.009552f,
	29.000000f,
	// 4
	0.396754f, 0.765488f,
	-0.131458f, 0.735771f, 0.664349f,
	0.107862f, 1.406926f, 0.030175f,
	29.000000f,
	// 5
	0.374394f, 0.765488f,
	-0.157189f, 0.987307f, -0.022736f,
	0.104439f, 1.420709f, -0.007843f,
	29.000000f,
	// 6
	0.397003f, 0.748952f,
	-0.162334f, 0.733059f, 0.660509f,
	0.088524f, 1.399766f, 0.032618f,
	29.000000f,
	// 7
	0.400259f, 0.706496f,
	-0.076308f, 0.771432f, 0.631720f,
	0.060831f, 1.388081f, 0.036465f,
	13.000000f,
	// 8
	0.419667f, 0.682825f,
	-0.005915f, 0.685701f, 0.727859f,
	0.040272f, 1.364417f, 0.060980f,
	12.000000f,
	// 9
	0.433587f, 0.641463f,
	-0.000000f, 0.650283f, 0.759692f,
	-0.000000f, 1.346102f, 0.069792f,
	12.000000f,
	// 10
	0.433587f, 0.684418f,
	-0.026055f, 0.722489f, 0.690891f,
	0.043859f, 1.349651f, 0.075880f,
	12.000000f,
	// 11
	0.433445f, 0.735340f,
	0.271564f, 0.669845f, 0.691057f,
	0.084600f, 1.351900f, 0.069191f,
	12.000000f,
	// 12
	0.418420f, 0.749369f,
	0.160482f, 0.530594f, 0.832296f,
	0.092998f, 1.372765f, 0.049880f,
	12.000000f,
	// 13
	0.437538f, 0.765488f,
	0.574365f, 0.253314f, 0.778419f,
	0.110367f, 1.343243f, 0.055328f,
	11.000000f,
	// 14
	0.418590f, 0.765488f,
	0.048268f, 0.404634f, 0.913204f,
	0.110733f, 1.379087f, 0.043289f,
	29.000000f,
	// 15
	0.419311f, 0.966417f,
	0.000000f, 0.236695f, -0.971584f,
	0.000000f, 1.353497f, -0.077306f,
	12.000000f,
	// 16
	0.397343f, 0.966419f,
	0.000000f, 0.412948f, -0.910755f,
	0.000000f, 1.404656f, -0.058341f,
	13.000000f,
	// 17
	0.419311f, 0.893435f,
	0.098109f, 0.368436f, -0.924462f,
	0.065681f, 1.373106f, -0.069522f,
	12.000000f,
	// 18
	0.397343f, 0.895498f,
	0.229858f, 0.669763f, -0.706104f,
	0.062372f, 1.402144f, -0.048034f,
	13.000000f,
	// 19
	0.399296f, 0.857681f,
	-0.056043f, 0.809799f, -0.584025f,
	0.089427f, 1.403596f, -0.041083f,
	29.000000f,
	// 20
	0.409079f, 0.855957f,
	-0.042411f, 0.671782f, -0.739534f,
	0.090030f, 1.390020f, -0.054351f,
	12.000000f,
	// 21
	0.398600f, 0.832844f,
	-0.062254f, 0.810578f, -0.582312f,
	0.099793f, 1.407216f, -0.040111f,
	29.000000f,
	// 22
	0.374394f, 0.835903f,
	-0.157189f, 0.987307f, -0.022736f,
	0.104439f, 1.420709f, -0.007843f,
	29.000000f,
	// 23
	0.374394f, 0.859625f,
	-0.106994f, 0.993272f, 0.044303f,
	0.088672f, 1.416274f, -0.009552f,
	29.000000f,
	// 24
	0.578854f, 0.912479f,
	0.136446f, 0.268298f, -0.953624f,
	0.041299f, 1.075810f, -0.042223f,
	1.000000f,
	// 25
	0.581550f, 0.963641f,
	0.000000f, 0.288899f, -0.957360f,
	0.000000f, 1.069469f, -0.042442f,
	1.000000f,
	// 26
	0.558951f, 0.963641f,
	0.000000f, -0.063261f, -0.997997f,
	0.000000f, 1.119183f, -0.035787f,
	11.000000f,
	// 27
	0.559664f, 0.864799f,
	0.787280f, -0.070876f, -0.612509f,
	0.075915f, 1.122943f, -0.022182f,
	11.000000f,
	// 28
	0.559308f, 0.912479f,
	0.169301f, -0.094545f, -0.981019f,
	0.039091f, 1.119632f, -0.041707f,
	11.000000f,
	// 29
	0.536103f, 0.963641f,
	0.000000f, -0.273393f, -0.961902f,
	0.000000f, 1.150385f, -0.042012f,
	11.000000f,
	// 30
	0.514714f, 0.844435f,
	0.749236f, -0.320875f, -0.579383f,
	0.085280f, 1.185984f, -0.032149f,
	11.000000f,
	// 31
	0.535718f, 0.911657f,
	0.182367f, -0.249513f, -0.951044f,
	0.039427f, 1.150849f, -0.048790f,
	11.000000f,
	// 32
	0.514714f, 0.909191f,
	0.227398f, -0.280587f, -0.932503f,
	0.042479f, 1.182160f, -0.056419f,
	11.000000f,
	// 33
	0.514714f, 0.963641f,
	0.000000f, -0.299474f, -0.954105f,
	0.000000f, 1.183371f, -0.054116f,
	11.000000f,
	// 34
	0.538270f, 0.694891f,
	0.467793f, -0.157877f, 0.869623f,
	0.048430f, 1.147814f, 0.094726f,
	11.000000f,
	// 35
	0.566360f, 0.694145f,
	0.409883f, 0.001960f, 0.912136f,
	0.042918f, 1.109224f, 0.091450f,
	2.000000f,
	// 36
	0.535165f, 0.753256f,
	0.890732f, -0.174426f, 0.419728f,
	0.082822f, 1.153856f, 0.059772f,
	11.000000f,
	// 37
	0.562577f, 0.744148f,
	0.833282f, 0.016948f, 0.552589f,
	0.075028f, 1.121452f, 0.065797f,
	11.000000f,
	// 38
	0.559664f, 0.807103f,
	0.998058f, -0.044226f, -0.043868f,
	0.085612f, 1.125121f, 0.014755f,
	11.000000f,
	// 39
	0.535108f, 0.807103f,
	0.983346f, -0.165053f, -0.076078f,
	0.089060f, 1.155290f, 0.008567f,
	11.000000f,
	// 40
	0.536920f, 0.862972f,
	0.770256f, -0.210928f, -0.601843f,
	0.078874f, 1.152369f, -0.026350f,
	11.000000f,
	// 41
	0.514714f, 0.807047f,
	0.974124f, -0.211976f, -0.078414f,
	0.095795f, 1.189531f, 0.005634f,
	11.000000f,
	// 42
	0.514714f, 0.755250f,
	0.886533f, -0.330176f, 0.324104f,
	0.092273f, 1.189302f, 0.057185f,
	11.000000f,
	// 43
	0.514714f, 0.699400f,
	0.459080f, -0.277012f, 0.844103f,
	0.055418f, 1.186178f, 0.098968f,
	11.000000f,
	// 44
	0.514714f, 0.642689f,
	-0.000000f, -0.182383f, 0.983228f,
	-0.000000f, 1.185516f, 0.108128f,
	11.000000f,
	// 45
	0.539566f, 0.642689f,
	-0.000000f, -0.115658f, 0.993289f,
	-0.000000f, 1.144702f, 0.103573f,
	11.000000f,
	// 46
	0.568154f, 0.642689f,
	-0.000000f, 0.026398f, 0.999651f,
	-0.000000f, 1.102226f, 0.098432f,
	2.000000f,
	// 47
	0.582820f, 0.642689f,
	-0.000000f, 0.090218f, 0.995922f,
	-0.000000f, 1.071874f, 0.102770f,
	1.000000f,
	// 48
	0.580681f, 0.694145f,
	0.347495f, 0.120770f, 0.929872f,
	0.045364f, 1.077084f, 0.093755f,
	1.000000f,
	// 49
	0.575165f, 0.744148f,
	0.739238f, 0.222482f, 0.635633f,
	0.075760f, 1.086335f, 0.073799f,
	1.000000f,
	// 50
	0.575165f, 0.807103f,
	0.978123f, 0.207117f, 0.019426f,
	0.087998f, 1.094485f, 0.024131f,
	1.000000f,
	// 51
	0.575721f, 0.864799f,
	0.744217f, 0.033101f, -0.667117f,
	0.076568f, 1.091758f, -0.023238f,
	1.000000f,
	// 52
	0.873035f, 0.601218f,
	0.126194f, 0.613800f, 0.779310f,
	0.087625f, 0.022129f, 0.179242f,
	9.000000f,
	// 53
	0.860116f, 0.587474f,
	-0.787219f, 0.607724f, 0.104675f,
	0.030237f, 0.022544f, 0.116848f,
	9.000000f,
	// 54
	0.872973f, 0.593395f,
	-0.568129f, 0.618821f, 0.542484f,
	0.043040f, 0.022545f, 0.164826f,
	9.000000f,
	// 55
	0.724033f, 0.593090f,
	-0.658555f, 0.645592f, -0.386673f,
	0.048407f, 0.067232f, -0.044316f,
	9.000000f,
	// 56
	0.724032f, 0.610774f,
	0.631647f, 0.652488f, -0.418666f,
	0.113260f, 0.067232f, -0.044673f,
	9.000000f,
	// 57
	0.721402f, 0.601937f,
	-0.013369f, 0.617239f, -0.786662f,
	0.079915f, 0.067232f, -0.061146f,
	9.000000f,
	// 58
	0.734547f, 0.588600f,
	-0.727729f, 0.681828f, 0.074302f,
	0.043794f, 0.061580f, -0.012009f,
	9.000000f,
	// 59
	0.734545f, 0.615238f,
	0.738033f, 0.673213f, 0.045743f,
	0.120596f, 0.061580f, -0.012016f,
	9.000000f,
	// 60
	0.797331f, 0.588037f,
	-0.661766f, 0.731353f, 0.164887f,
	0.041876f, 0.040736f, 0.063957f,
	9.000000f,
	// 61
	0.797425f, 0.615598f,
	0.646203f, 0.753697f, 0.119839f,
	0.124372f, 0.041293f, 0.064103f,
	9.000000f,
	// 62
	0.860306f, 0.615958f,
	0.769837f, 0.611174f, 0.183895f,
	0.134851f, 0.022546f, 0.117146f,
	9.000000f,
	// 63
	0.873097f, 0.609041f,
	0.612658f, 0.642602f, 0.460123f,
	0.122117f, 0.022546f, 0.154527f,
	9.000000f,
	// 64
	0.946574f, 0.532751f,
	0.631647f, 0.652488f, -0.418666f,
	0.113260f, 0.067232f, -0.044673f,
	9.000000f,
	// 65
	0.876883f, 0.524000f,
	-0.012254f, -0.616962f, -0.786898f,
	0.080172f, 0.000466f, -0.061148f,
	9.000000f,
	// 66
	0.948952f, 0.524001f,
	-0.013369f, 0.617239f, -0.786662f,
	0.079915f, 0.067232f, -0.061146f,
	9.000000f,
	// 67
	0.876884f, 0.532750f,
	0.611804f, -0.641518f, -0.462764f,
	0.109797f, 0.000466f, -0.044675f,
	9.000000f,
	// 68
	0.942728f, 0.541085f,
	0.738033f, 0.673213f, 0.045743f,
	0.120596f, 0.061580f, -0.012016f,
	9.000000f,
	// 69
	0.876884f, 0.541085f,
	0.690684f, -0.714775f, -0.109782f,
	0.116710f, 0.000466f, -0.012018f,
	9.000000f,
	// 70
	0.924110f, 0.572633f,
	0.646203f, 0.753697f, 0.119839f,
	0.124372f, 0.041293f, 0.064103f,
	9.000000f,
	// 71
	0.876850f, 0.572633f,
	0.762842f, -0.635962f, -0.116721f,
	0.131891f, 0.000466f, 0.065830f,
	9.000000f,
	// 72
	0.914625f, 0.601771f,
	0.769837f, 0.611174f, 0.183895f,
	0.134851f, 0.022546f, 0.117146f,
	9.000000f,
	// 73
	0.876815f, 0.601771f,
	0.738506f, -0.666388f, 0.102643f,
	0.134851f, 0.000466f, 0.117143f,
	9.000000f,
	// 74
	0.914623f, 0.609737f,
	0.612658f, 0.642602f, 0.460123f,
	0.122117f, 0.022546f, 0.154527f,
	9.000000f,
	// 75
	0.876814f, 0.609737f,
	0.601190f, -0.655519f, 0.457018f,
	0.121403f, 0.000466f, 0.154523f,
	9.000000f,
	// 76
	0.914624f, 0.616063f,
	0.126194f, 0.613800f, 0.779310f,
	0.087625f, 0.022129f, 0.179242f,
	9.000000f,
	// 77
	0.876813f, 0.616062f,
	0.119634f, -0.618895f, 0.776309f,
	0.087308f, 0.000466f, 0.179238f,
	9.000000f,
	// 78
	0.948952f, 0.524001f,
	-0.013369f, 0.617239f, -0.786662f,
	0.079915f, 0.067232f, -0.061146f,
	9.000000f,
	// 79
	0.876883f, 0.524000f,
	-0.012254f, -0.616962f, -0.786898f,
	0.080172f, 0.000466f, -0.061148f,
	9.000000f,
	// 80
	0.946574f, 0.532751f,
	-0.658555f, 0.645592f, -0.386673f,
	0.048407f, 0.067232f, -0.044316f,
	9.000000f,
	// 81
	0.876881f, 0.532751f,
	-0.636612f, -0.640040f, -0.430202f,
	0.052166f, 0.000466f, -0.044319f,
	9.000000f,
	// 82
	0.942728f, 0.541088f,
	-0.727729f, 0.681828f, 0.074302f,
	0.043794f, 0.061580f, -0.012009f,
	9.000000f,
	// 83
	0.876881f, 0.541088f,
	-0.681221f, -0.726937f, -0.086605f,
	0.047715f, 0.000466f, -0.012012f,
	9.000000f,
	// 84
	0.876846f, 0.572633f,
	-0.713010f, -0.696737f, -0.078581f,
	0.038671f, 0.000466f, 0.065684f,
	9.000000f,
	// 85
	0.924110f, 0.572633f,
	-0.661766f, 0.731353f, 0.164887f,
	0.041876f, 0.040736f, 0.063957f,
	9.000000f,
	// 86
	0.876812f, 0.601771f,
	-0.752746f, -0.657872f, 0.024050f,
	0.030238f, 0.000466f, 0.116845f,
	9.000000f,
	// 87
	0.914625f, 0.601771f,
	-0.787219f, 0.607724f, 0.104675f,
	0.030237f, 0.022544f, 0.116848f,
	9.000000f,
	// 88
	0.876812f, 0.609737f,
	-0.574300f, -0.612572f, 0.543079f,
	0.042939f, 0.000466f, 0.164823f,
	9.000000f,
	// 89
	0.914623f, 0.609737f,
	-0.568129f, 0.618821f, 0.542484f,
	0.043040f, 0.022545f, 0.164826f,
	9.000000f,
	// 90
	0.876813f, 0.616062f,
	0.119634f, -0.618895f, 0.776309f,
	0.087308f, 0.000466f, 0.179238f,
	9.000000f,
	// 91
	0.914624f, 0.616063f,
	0.126194f, 0.613800f, 0.779310f,
	0.087625f, 0.022129f, 0.179242f,
	9.000000f,
	// 92
	0.724146f, 0.570868f,
	-0.012254f, -0.616962f, -0.786898f,
	0.080172f, 0.000466f, -0.061148f,
	9.000000f,
	// 93
	0.726180f, 0.562191f,
	0.611804f, -0.641518f, -0.462764f,
	0.109797f, 0.000466f, -0.044675f,
	9.000000f,
	// 94
	0.726181f, 0.579544f,
	-0.636612f, -0.640040f, -0.430202f,
	0.052166f, 0.000466f, -0.044319f,
	9.000000f,
	// 95
	0.735812f, 0.557859f,
	0.690684f, -0.714775f, -0.109782f,
	0.116710f, 0.000466f, -0.012018f,
	9.000000f,
	// 96
	0.735814f, 0.583877f,
	-0.681221f, -0.726937f, -0.086605f,
	0.047715f, 0.000466f, -0.012012f,
	9.000000f,
	// 97
	0.798477f, 0.557507f,
	0.762842f, -0.635962f, -0.116721f,
	0.131891f, 0.000466f, 0.065830f,
	9.000000f,
	// 98
	0.798383f, 0.584426f,
	-0.713010f, -0.696737f, -0.078581f,
	0.038671f, 0.000466f, 0.065684f,
	9.000000f,
	// 99
	0.861141f, 0.557155f,
	0.738506f, -0.666388f, 0.102643f,
	0.134851f, 0.000466f, 0.117143f,
	9.000000f,
	// 100
	0.860952f, 0.584976f,
	-0.752746f, -0.657872f, 0.024050f,
	0.030238f, 0.000466f, 0.116845f,
	9.000000f,
	// 101
	0.874340f, 0.564057f,
	0.601190f, -0.655519f, 0.457018f,
	0.121403f, 0.000466f, 0.154523f,
	9.000000f,
	// 102
	0.874218f, 0.579213f,
	-0.574300f, -0.612572f, 0.543079f,
	0.042939f, 0.000466f, 0.164823f,
	9.000000f,
	// 103
	0.874279f, 0.571635f,
	0.119634f, -0.618895f, 0.776309f,
	0.087308f, 0.000466f, 0.179238f,
	9.000000f,
	// 104
	0.111502f, 0.449324f,
	0.767418f, 0.044009f, 0.639635f,
	0.130703f, 0.885822f, 0.078484f,
	30.000000f,
	// 105
	0.161690f, 0.459498f,
	0.992184f, 0.124682f, 0.004966f,
	0.144544f, 0.913699f, 0.020404f,
	30.000000f,
	// 106
	0.110282f, 0.509129f,
	0.725861f, 0.202993f, 0.657206f,
	0.105995f, 0.985262f, 0.078218f,
	1.000000f,
	// 107
	0.162910f, 0.496226f,
	0.963986f, 0.264891f, 0.023737f,
	0.131682f, 0.985262f, 0.021511f,
	1.000000f,
	// 108
	0.104403f, 0.527681f,
	0.739238f, 0.222482f, 0.635633f,
	0.075760f, 1.086335f, 0.073799f,
	1.000000f,
	// 109
	0.162910f, 0.530358f,
	0.978123f, 0.207117f, 0.019426f,
	0.087998f, 1.094485f, 0.024131f,
	1.000000f,
	// 110
	0.220828f, 0.499730f,
	0.736593f, 0.273287f, -0.618664f,
	0.102612f, 0.985262f, -0.051726f,
	1.000000f,
	// 111
	0.230905f, 0.529020f,
	0.762650f, 0.364625f, -0.534241f,
	0.076568f, 1.094146f, -0.023238f,
	1.000000f,
	// 112
	0.267442f, 0.495955f,
	0.252859f, 0.214145f, -0.943506f,
	0.056319f, 0.985262f, -0.082786f,
	1.000000f,
	// 113
	0.278565f, 0.527347f,
	0.136446f, 0.268298f, -0.953624f,
	0.041299f, 1.075810f, -0.042223f,
	1.000000f,
	// 114
	0.314799f, 0.526343f,
	0.000000f, 0.288899f, -0.957360f,
	0.000000f, 1.069469f, -0.042442f,
	1.000000f,
	// 115
	0.317565f, 0.490317f,
	0.000000f, 0.230413f, -0.973093f,
	0.000000f, 0.985262f, -0.083537f,
	1.000000f,
	// 116
	0.216490f, 0.480597f,
	0.770540f, 0.116134f, -0.626723f,
	0.112386f, 0.954109f, -0.050302f,
	1.000000f,
	// 117
	0.259479f, 0.472209f,
	0.355585f, -0.030493f, -0.934146f,
	0.068860f, 0.955351f, -0.079611f,
	1.000000f,
	// 118
	0.318322f, 0.467424f,
	0.000000f, -0.158074f, -0.987427f,
	0.000000f, 0.932615f, -0.084160f,
	1.000000f,
	// 119
	0.242260f, 0.442506f,
	0.313564f, -0.079046f, -0.946271f,
	0.082859f, 0.873314f, -0.062585f,
	7.000000f,
	// 120
	0.200058f, 0.434942f,
	0.805160f, 0.023644f, -0.592587f,
	0.130992f, 0.876346f, -0.035772f,
	7.000000f,
	// 121
	0.301557f, 0.441406f,
	-0.332980f, -0.366028f, -0.868993f,
	0.019576f, 0.884431f, -0.072782f,
	1.000000f,
	// 122
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 123
	0.032832f, 0.495481f,
	0.123291f, -0.099500f, 0.987370f,
	0.020283f, 0.985262f, 0.104951f,
	1.000000f,
	// 124
	0.007127f, 0.446012f,
	0.000000f, -0.692625f, 0.721298f,
	-0.000000f, 0.892416f, 0.083870f,
	1.000000f,
	// 125
	0.033429f, 0.441549f,
	-0.205524f, -0.338494f, 0.918249f,
	0.027055f, 0.899856f, 0.078798f,
	1.000000f,
	// 126
	0.007127f, 0.492684f,
	-0.000000f, -0.097221f, 0.995263f,
	-0.000000f, 0.985262f, 0.106487f,
	1.000000f,
	// 127
	0.007127f, 0.523666f,
	-0.000000f, 0.090218f, 0.995922f,
	-0.000000f, 1.071874f, 0.102770f,
	1.000000f,
	// 128
	0.056805f, 0.525339f,
	0.347495f, 0.120770f, 0.929872f,
	0.045364f, 1.077084f, 0.093755f,
	1.000000f,
	// 129
	0.073431f, 0.496250f,
	0.280269f, 0.043402f, 0.958940f,
	0.072110f, 0.985262f, 0.097305f,
	1.000000f,
	// 130
	0.073625f, 0.420769f,
	0.008179f, -0.029530f, 0.999530f,
	0.079041f, 0.858605f, 0.100184f,
	31.000000f,
	// 131
	0.442684f, 0.898787f,
	0.156125f, -0.002541f, -0.987734f,
	0.055858f, 1.312527f, -0.079060f,
	12.000000f,
	// 132
	0.469882f, 0.966426f,
	0.000000f, -0.163270f, -0.986581f,
	0.000000f, 1.265166f, -0.079362f,
	12.000000f,
	// 133
	0.442684f, 0.966907f,
	0.000000f, 0.032776f, -0.999463f,
	0.000000f, 1.312527f, -0.084641f,
	12.000000f,
	// 134
	0.469882f, 0.902897f,
	0.227756f, -0.141979f, -0.963312f,
	0.052836f, 1.264943f, -0.076689f,
	12.000000f,
	// 135
	0.493150f, 0.907830f,
	0.229771f, -0.295132f, -0.927417f,
	0.046262f, 1.215374f, -0.066694f,
	11.000000f,
	// 136
	0.514714f, 0.966394f,
	0.000000f, -0.299474f, -0.954105f,
	0.000000f, 1.183371f, -0.054116f,
	11.000000f,
	// 137
	0.493150f, 0.966394f,
	0.000000f, -0.298716f, -0.954342f,
	0.000000f, 1.214327f, -0.064312f,
	11.000000f,
	// 138
	0.469882f, 0.849585f,
	0.699149f, -0.267053f, -0.663230f,
	0.098638f, 1.265948f, -0.056863f,
	12.000000f,
	// 139
	0.441078f, 0.853608f,
	0.431827f, -0.066865f, -0.899474f,
	0.100592f, 1.323173f, -0.071627f,
	29.000000f,
	// 140
	0.418195f, 0.856892f,
	0.198022f, 0.392426f, -0.898215f,
	0.090676f, 1.376861f, -0.065705f,
	12.000000f,
	// 141
	0.410841f, 0.827869f,
	0.304495f, 0.400581f, -0.864186f,
	0.104405f, 1.382154f, -0.057950f,
	29.000000f,
	// 142
	0.430229f, 0.966420f,
	0.000000f, 0.236695f, -0.971584f,
	0.000000f, 1.353497f, -0.077306f,
	12.000000f,
	// 143
	0.419311f, 0.893435f,
	0.098109f, 0.368436f, -0.924462f,
	0.065681f, 1.373106f, -0.069522f,
	12.000000f,
	// 144
	0.413842f, 0.866108f,
	-0.042411f, 0.671782f, -0.739534f,
	0.090030f, 1.390020f, -0.054351f,
	12.000000f,
	// 145
	0.398600f, 0.832844f,
	-0.062254f, 0.810578f, -0.582312f,
	0.099793f, 1.407216f, -0.040111f,
	29.000000f,
	// 146
	0.397739f, 0.807699f,
	0.083646f, 0.717732f, -0.691277f,
	0.124538f, 1.405653f, -0.037899f,
	29.000000f,
	// 147
	0.416440f, 0.806646f,
	0.232515f, 0.286938f, -0.929302f,
	0.123654f, 1.380929f, -0.050470f,
	29.000000f,
	// 148
	0.374394f, 0.806541f,
	-0.033511f, 0.999136f, -0.024587f,
	0.124737f, 1.421756f, -0.004796f,
	29.000000f,
	// 149
	0.374394f, 0.835903f,
	-0.157189f, 0.987307f, -0.022736f,
	0.104439f, 1.420709f, -0.007843f,
	29.000000f,
	// 150
	0.434720f, 0.818888f,
	0.547946f, -0.269108f, -0.792046f,
	0.123001f, 1.341022f, -0.053068f,
	29.000000f,
	// 151
	0.445893f, 0.802300f,
	0.702055f, -0.688466f, -0.182027f,
	0.133527f, 1.319623f, -0.004570f,
	29.000000f,
	// 152
	0.469882f, 0.795507f,
	0.964101f, -0.262302f, -0.041302f,
	0.119418f, 1.266555f, 0.017236f,
	12.000000f,
	// 153
	0.437175f, 0.788739f,
	0.533464f, -0.454487f, 0.713343f,
	0.139391f, 1.333704f, 0.034157f,
	29.000000f,
	// 154
	0.453445f, 0.767679f,
	0.896751f, -0.006087f, 0.442493f,
	0.115546f, 1.303552f, 0.058939f,
	11.000000f,
	// 155
	0.436820f, 0.767347f,
	0.574365f, 0.253314f, 0.778419f,
	0.110367f, 1.343243f, 0.055328f,
	11.000000f,
	// 156
	0.416602f, 0.799456f,
	-0.041573f, 0.237235f, 0.970562f,
	0.140417f, 1.385688f, 0.041621f,
	29.000000f,
	// 157
	0.418590f, 0.767015f,
	0.048268f, 0.404634f, 0.913204f,
	0.110733f, 1.379087f, 0.043289f,
	29.000000f,
	// 158
	0.397996f, 0.796130f,
	-0.034843f, 0.762221f, 0.646379f,
	0.126735f, 1.410009f, 0.028843f,
	29.000000f,
	// 159
	0.396754f, 0.767015f,
	-0.131458f, 0.735771f, 0.664349f,
	0.107862f, 1.406926f, 0.030175f,
	29.000000f,
	// 160
	0.374394f, 0.765038f,
	-0.157189f, 0.987307f, -0.022736f,
	0.104439f, 1.420709f, -0.007843f,
	29.000000f,
	// 161
	0.374394f, 0.802037f,
	-0.033511f, 0.999136f, -0.024587f,
	0.124737f, 1.421756f, -0.004796f,
	29.000000f,
	// 162
	0.494004f, 0.791631f,
	0.965824f, -0.257644f, -0.028348f,
	0.109643f, 1.228123f, 0.020338f,
	11.000000f,
	// 163
	0.493150f, 0.843740f,
	0.791870f, -0.284876f, -0.540173f,
	0.094453f, 1.221027f, -0.039166f,
	11.000000f,
	// 164
	0.514714f, 0.805775f,
	0.730536f, -0.679494f, -0.067867f,
	0.098454f, 1.189635f, 0.004204f,
	11.000000f,
	// 165
	0.469658f, 0.764856f,
	0.968391f, -0.120143f, 0.218599f,
	0.114190f, 1.265171f, 0.062797f,
	12.000000f,
	// 166
	0.495560f, 0.744603f,
	0.848349f, -0.394604f, 0.352976f,
	0.099276f, 1.228731f, 0.083087f,
	11.000000f,
	// 167
	0.514714f, 0.751397f,
	0.886533f, -0.330176f, 0.324104f,
	0.092273f, 1.189302f, 0.057185f,
	11.000000f,
	// 168
	0.514714f, 0.847181f,
	0.749236f, -0.320875f, -0.579383f,
	0.085280f, 1.185984f, -0.032149f,
	11.000000f,
	// 169
	0.514714f, 0.911941f,
	0.227398f, -0.280587f, -0.932503f,
	0.042479f, 1.182160f, -0.056419f,
	11.000000f,
	// 170
	0.503562f, 0.703177f,
	0.433834f, -0.490610f, 0.755705f,
	0.068642f, 1.212893f, 0.103134f,
	11.000000f,
	// 171
	0.514714f, 0.698177f,
	0.459080f, -0.277012f, 0.844103f,
	0.055418f, 1.186178f, 0.098968f,
	11.000000f,
	// 172
	0.499926f, 0.675159f,
	0.123084f, -0.283300f, 0.951100f,
	0.033085f, 1.215091f, 0.113233f,
	11.000000f,
	// 173
	0.514714f, 0.641463f,
	-0.000000f, -0.182383f, 0.983228f,
	-0.000000f, 1.185516f, 0.108128f,
	11.000000f,
	// 174
	0.499926f, 0.641511f,
	-0.000000f, -0.218353f, 0.975870f,
	-0.000000f, 1.215169f, 0.112476f,
	11.000000f,
	// 175
	0.481220f, 0.641512f,
	-0.000000f, -0.076487f, 0.997071f,
	-0.000000f, 1.246720f, 0.122061f,
	12.000000f,
	// 176
	0.003726f, 0.089349f,
	-0.039706f, -0.998808f, 0.028380f,
	0.205818f, 1.330921f, -0.000900f,
	22.000000f,
	// 177
	0.043042f, 0.123400f,
	0.533464f, -0.454487f, 0.713343f,
	0.139391f, 1.333704f, 0.034157f,
	29.000000f,
	// 178
	0.003792f, 0.123400f,
	0.702055f, -0.688466f, -0.182027f,
	0.133527f, 1.319623f, -0.004570f,
	29.000000f,
	// 179
	0.136540f, 0.123400f,
	-0.034843f, 0.762221f, 0.646379f,
	0.126735f, 1.410009f, 0.028843f,
	29.000000f,
	// 180
	0.093574f, 0.123400f,
	-0.041573f, 0.237235f, 0.970562f,
	0.140417f, 1.385688f, 0.041621f,
	29.000000f,
	// 181
	0.093574f, 0.109966f,
	-0.080332f, 0.167190f, 0.982647f,
	0.161710f, 1.382619f, 0.045793f,
	22.000000f,
	// 182
	0.043042f, 0.050988f,
	-0.120512f, -0.603958f, 0.787852f,
	0.284369f, 1.335829f, 0.039815f,
	22.000000f,
	// 183
	0.003726f, 0.064964f,
	-0.235241f, -0.966333f, 0.104223f,
	0.259732f, 1.317142f, -0.001475f,
	22.000000f,
	// 184
	0.003726f, 0.034683f,
	-0.076526f, -0.993516f, 0.084085f,
	0.301722f, 1.307683f, -0.001433f,
	22.000000f,
	// 185
	0.093574f, 0.050054f,
	-0.114712f, 0.076099f, 0.990480f,
	0.284317f, 1.379409f, 0.048647f,
	22.000000f,
	// 186
	0.183292f, 0.108682f,
	-0.026438f, 0.998612f, -0.045549f,
	0.160912f, 1.422797f, -0.007084f,
	22.000000f,
	// 187
	0.183292f, 0.123400f,
	-0.033511f, 0.999136f, -0.024587f,
	0.124737f, 1.421756f, -0.004796f,
	29.000000f,
	// 188
	0.136540f, 0.108682f,
	-0.011077f, 0.782502f, 0.622550f,
	0.163493f, 1.407825f, 0.028009f,
	22.000000f,
	// 189
	0.136540f, 0.048907f,
	-0.153038f, 0.734074f, 0.661601f,
	0.282264f, 1.419667f, 0.033135f,
	22.000000f,
	// 190
	0.093574f, 0.014077f,
	0.214642f, 0.083310f, 0.973133f,
	0.349737f, 1.381934f, 0.061904f,
	22.000000f,
	// 191
	0.043042f, 0.014508f,
	0.315620f, -0.586205f, 0.746155f,
	0.351262f, 1.337043f, 0.050481f,
	22.000000f,
	// 192
	0.003726f, 0.014508f,
	0.440047f, -0.897646f, 0.024315f,
	0.351779f, 1.311155f, -0.002666f,
	22.000000f,
	// 193
	0.136540f, 0.013885f,
	0.130391f, 0.739339f, 0.660588f,
	0.342186f, 1.427078f, 0.040667f,
	22.000000f,
	// 194
	0.183292f, 0.064964f,
	-0.115981f, 0.990778f, -0.070052f,
	0.258534f, 1.426646f, -0.006999f,
	22.000000f,
	// 195
	0.226789f, 0.108682f,
	-0.039257f, 0.722838f, -0.689901f,
	0.160251f, 1.409291f, -0.034191f,
	22.000000f,
	// 196
	0.003726f, 0.000616f,
	0.541311f, -0.840716f, -0.013401f,
	0.382784f, 1.350020f, -0.002715f,
	23.000000f,
	// 197
	0.043042f, 0.000616f,
	0.542366f, -0.460069f, 0.702976f,
	0.384252f, 1.363773f, 0.031336f,
	23.000000f,
	// 198
	0.136540f, 0.000616f,
	0.352364f, 0.573293f, 0.739713f,
	0.383611f, 1.408865f, 0.030471f,
	23.000000f,
	// 199
	0.183292f, 0.014223f,
	0.115277f, 0.993200f, 0.016259f,
	0.337650f, 1.443473f, -0.001583f,
	23.000000f,
	// 200
	0.183292f, 0.037445f,
	-0.220668f, 0.975234f, -0.014987f,
	0.295798f, 1.433906f, -0.002477f,
	22.000000f,
	// 201
	0.226789f, 0.053036f,
	-0.167028f, 0.735904f, -0.656160f,
	0.276992f, 1.414561f, -0.041644f,
	22.000000f,
	// 202
	0.226789f, 0.014794f,
	0.117217f, 0.746095f, -0.655441f,
	0.335163f, 1.427565f, -0.050554f,
	22.000000f,
	// 203
	0.183292f, 0.000616f,
	0.245827f, 0.969268f, -0.009379f,
	0.381563f, 1.421781f, -0.002501f,
	23.000000f,
	// 204
	0.226789f, 0.000616f,
	0.303048f, 0.589640f, -0.748657f,
	0.380310f, 1.409226f, -0.031437f,
	23.000000f,
	// 205
	0.270245f, 0.050054f,
	-0.148592f, 0.047769f, -0.987744f,
	0.278656f, 1.376552f, -0.062452f,
	22.000000f,
	// 206
	0.270245f, 0.015131f,
	0.194113f, 0.071418f, -0.978376f,
	0.335648f, 1.382423f, -0.073234f,
	22.000000f,
	// 207
	0.311334f, 0.000616f,
	0.510921f, -0.487267f, -0.708188f,
	0.381087f, 1.362063f, -0.032532f,
	23.000000f,
	// 208
	0.353752f, 0.000616f,
	0.541311f, -0.840716f, -0.013401f,
	0.382784f, 1.350020f, -0.002715f,
	23.000000f,
	// 209
	0.353752f, 0.014508f,
	0.440047f, -0.897646f, 0.024315f,
	0.351779f, 1.311155f, -0.002666f,
	22.000000f,
	// 210
	0.311334f, 0.015329f,
	0.320905f, -0.628936f, -0.708138f,
	0.344088f, 1.329369f, -0.054350f,
	22.000000f,
	// 211
	0.311334f, 0.048659f,
	-0.127076f, -0.732818f, -0.668453f,
	0.280444f, 1.326092f, -0.043675f,
	22.000000f,
	// 212
	0.270245f, 0.109966f,
	0.009412f, 0.217028f, -0.976120f,
	0.155739f, 1.376819f, -0.050109f,
	22.000000f,
	// 213
	0.226789f, 0.123400f,
	0.083646f, 0.717732f, -0.691277f,
	0.124538f, 1.405653f, -0.037899f,
	29.000000f,
	// 214
	0.353752f, 0.034683f,
	-0.076526f, -0.993516f, 0.084085f,
	0.301722f, 1.307683f, -0.001433f,
	22.000000f,
	// 215
	0.353752f, 0.064964f,
	-0.235241f, -0.966333f, 0.104223f,
	0.259732f, 1.317142f, -0.001475f,
	22.000000f,
	// 216
	0.353752f, 0.089349f,
	-0.039706f, -0.998808f, 0.028380f,
	0.205818f, 1.330921f, -0.000900f,
	22.000000f,
	// 217
	0.270245f, 0.123400f,
	0.232515f, 0.286938f, -0.929302f,
	0.123654f, 1.380929f, -0.050470f,
	29.000000f,
	// 218
	0.311334f, 0.123400f,
	0.547946f, -0.269108f, -0.792046f,
	0.123001f, 1.341022f, -0.053068f,
	29.000000f,
	// 219
	0.353818f, 0.123400f,
	0.702055f, -0.688466f, -0.182027f,
	0.133527f, 1.319623f, -0.004570f,
	29.000000f,
	// 220
	0.731146f, 0.524127f,
	0.608457f, 0.791724f, -0.054343f,
	0.400002f, 1.422087f, -0.004238f,
	23.000000f,
	// 221
	0.728222f, 0.523114f,
	0.635985f, 0.457585f, 0.621402f,
	0.401960f, 1.409176f, 0.028738f,
	23.000000f,
	// 222
	0.733802f, 0.523038f,
	0.550786f, 0.442900f, -0.707442f,
	0.399092f, 1.408209f, -0.034239f,
	23.000000f,
	// 223
	0.728268f, 0.519791f,
	0.701235f, -0.381983f, 0.601962f,
	0.402533f, 1.366835f, 0.028192f,
	23.000000f,
	// 224
	0.734027f, 0.520001f,
	0.566571f, -0.317562f, -0.760363f,
	0.399720f, 1.369514f, -0.036818f,
	23.000000f,
	// 225
	0.731146f, 0.518697f,
	0.681114f, -0.728840f, -0.069829f,
	0.401234f, 1.352893f, -0.004310f,
	23.000000f,
	// 226
	0.646372f, 0.543317f,
	0.541311f, -0.840716f, -0.013401f,
	0.382784f, 1.350020f, -0.002715f,
	23.000000f,
	// 227
	0.646372f, 0.517516f,
	0.681114f, -0.728840f, -0.069829f,
	0.401234f, 1.352893f, -0.004310f,
	23.000000f,
	// 228
	0.677020f, 0.543317f,
	0.542366f, -0.460069f, 0.702976f,
	0.384252f, 1.363773f, 0.031336f,
	23.000000f,
	// 229
	0.677027f, 0.517516f,
	0.701235f, -0.381983f, 0.601962f,
	0.402533f, 1.366835f, 0.028192f,
	23.000000f,
	// 230
	0.707982f, 0.543317f,
	0.352364f, 0.573293f, 0.739713f,
	0.383611f, 1.408865f, 0.030471f,
	23.000000f,
	// 231
	0.707923f, 0.517516f,
	0.635985f, 0.457585f, 0.621402f,
	0.401960f, 1.409176f, 0.028738f,
	23.000000f,
	// 232
	0.737656f, 0.543317f,
	0.245827f, 0.969268f, -0.009379f,
	0.381563f, 1.421781f, -0.002501f,
	23.000000f,
	// 233
	0.737534f, 0.517516f,
	0.608457f, 0.791724f, -0.054343f,
	0.400002f, 1.422087f, -0.004238f,
	23.000000f,
	// 234
	0.766813f, 0.543317f,
	0.303048f, 0.589640f, -0.748657f,
	0.380310f, 1.409226f, -0.031437f,
	23.000000f,
	// 235
	0.766632f, 0.517516f,
	0.550786f, 0.442900f, -0.707442f,
	0.399092f, 1.408209f, -0.034239f,
	23.000000f,
	// 236
	0.796673f, 0.517516f,
	0.566571f, -0.317562f, -0.760363f,
	0.399720f, 1.369514f, -0.036818f,
	23.000000f,
	// 237
	0.796914f, 0.543317f,
	0.510921f, -0.487267f, -0.708188f,
	0.381087f, 1.362063f, -0.032532f,
	23.000000f,
	// 238
	0.824108f, 0.543317f,
	0.541311f, -0.840716f, -0.013401f,
	0.382784f, 1.350020f, -0.002715f,
	23.000000f,
	// 239
	0.824108f, 0.517516f,
	0.681114f, -0.728840f, -0.069829f,
	0.401234f, 1.352893f, -0.004310f,
	23.000000f,
	// 240
	0.462224f, 0.653538f,
	-0.000000f, 0.728300f, 0.685259f,
	-0.000000f, 1.332309f, 0.087884f,
	12.000000f,
	// 241
	0.462224f, 0.653538f,
	0.012797f, 0.645820f, 0.763382f,
	0.046380f, 1.331445f, 0.095112f,
	12.000000f,
	// 242
	0.462224f, 0.653538f,
	-0.000000f, 0.142630f, 0.989776f,
	-0.000000f, 1.269728f, 0.120447f,
	12.000000f,
	// 243
	0.462224f, 0.653538f,
	0.022763f, 0.084387f, 0.996173f,
	0.046108f, 1.268688f, 0.123733f,
	12.000000f,
	// 244
	0.462224f, 0.653538f,
	0.038529f, 0.428736f, 0.902608f,
	0.047076f, 1.307309f, 0.110732f,
	12.000000f,
	// 245
	0.462224f, 0.653538f,
	-0.000000f, 0.463751f, 0.885966f,
	-0.000000f, 1.308572f, 0.109531f,
	12.000000f,
	// 246
	0.462224f, 0.653538f,
	0.066694f, -0.226159f, 0.971804f,
	0.037090f, 1.236245f, 0.119131f,
	12.000000f,
	// 247
	0.462224f, 0.653538f,
	0.438594f, -0.493712f, 0.750922f,
	0.083145f, 1.230884f, 0.112938f,
	12.000000f,
	// 248
	0.462224f, 0.653538f,
	0.610332f, -0.053056f, 0.790367f,
	0.096324f, 1.262098f, 0.119371f,
	12.000000f,
	// 249
	0.462224f, 0.653538f,
	0.583204f, 0.345182f, 0.735338f,
	0.094937f, 1.302676f, 0.107490f,
	12.000000f,
	// 250
	0.462224f, 0.653538f,
	0.472935f, 0.559326f, 0.680799f,
	0.090646f, 1.331672f, 0.089689f,
	12.000000f,
	// 251
	0.407841f, 0.658511f,
	0.053152f, 0.663334f, 0.746433f,
	-0.015962f, 1.380349f, 0.045197f,
	13.000000f,
	// 252
	0.419667f, 0.641463f,
	-0.000000f, 0.566963f, 0.823743f,
	-0.000000f, 1.361825f, 0.063236f,
	12.000000f,
	// 253
	0.410038f, 0.641463f,
	-0.000000f, 0.671180f, 0.741295f,
	-0.000000f, 1.375417f, 0.044863f,
	12.000000f,
	// 254
	0.374394f, 0.752150f,
	0.106992f, 0.993272f, 0.044303f,
	-0.088672f, 1.416274f, -0.009552f,
	34.000000f,
	// 255
	0.374394f, 0.765488f,
	0.157189f, 0.987307f, -0.022736f,
	-0.104439f, 1.420709f, -0.007843f,
	34.000000f,
	// 256
	0.396754f, 0.765488f,
	0.131458f, 0.735771f, 0.664349f,
	-0.107862f, 1.406926f, 0.030175f,
	34.000000f,
	// 257
	0.397003f, 0.748952f,
	0.162334f, 0.733059f, 0.660509f,
	-0.088524f, 1.399766f, 0.032618f,
	34.000000f,
	// 258
	0.400259f, 0.706496f,
	0.076308f, 0.771432f, 0.631720f,
	-0.060831f, 1.388081f, 0.036465f,
	13.000000f,
	// 259
	0.419667f, 0.682825f,
	0.005915f, 0.685701f, 0.727859f,
	-0.040272f, 1.364417f, 0.060980f,
	12.000000f,
	// 260
	0.433587f, 0.641463f,
	-0.000000f, 0.650283f, 0.759692f,
	-0.000000f, 1.346102f, 0.069792f,
	12.000000f,
	// 261
	0.433587f, 0.684418f,
	0.026055f, 0.722489f, 0.690891f,
	-0.043859f, 1.349651f, 0.075880f,
	12.000000f,
	// 262
	0.433445f, 0.735340f,
	-0.271564f, 0.669846f, 0.691057f,
	-0.084600f, 1.351900f, 0.069191f,
	12.000000f,
	// 263
	0.418420f, 0.749369f,
	-0.160482f, 0.530594f, 0.832296f,
	-0.092998f, 1.372765f, 0.049880f,
	12.000000f,
	// 264
	0.437538f, 0.765488f,
	-0.574365f, 0.253314f, 0.778419f,
	-0.110367f, 1.343243f, 0.055328f,
	11.000000f,
	// 265
	0.418590f, 0.765488f,
	-0.048268f, 0.404634f, 0.913204f,
	-0.110733f, 1.379087f, 0.043289f,
	34.000000f,
	// 266
	0.419311f, 0.966417f,
	0.000000f, 0.236695f, -0.971584f,
	0.000000f, 1.353497f, -0.077306f,
	12.000000f,
	// 267
	0.419311f, 0.893435f,
	-0.098109f, 0.368436f, -0.924462f,
	-0.065681f, 1.373106f, -0.069522f,
	12.000000f,
	// 268
	0.397343f, 0.966419f,
	0.000000f, 0.412948f, -0.910755f,
	0.000000f, 1.404656f, -0.058341f,
	13.000000f,
	// 269
	0.397343f, 0.895498f,
	-0.229858f, 0.669763f, -0.706104f,
	-0.062372f, 1.402144f, -0.048034f,
	13.000000f,
	// 270
	0.399296f, 0.857681f,
	0.056043f, 0.809799f, -0.584025f,
	-0.089427f, 1.403596f, -0.041083f,
	34.000000f,
	// 271
	0.409079f, 0.855957f,
	0.042411f, 0.671782f, -0.739534f,
	-0.090030f, 1.390020f, -0.054351f,
	12.000000f,
	// 272
	0.398600f, 0.832844f,
	0.062254f, 0.810578f, -0.582312f,
	-0.099793f, 1.407216f, -0.040111f,
	34.000000f,
	// 273
	0.374394f, 0.835903f,
	0.157189f, 0.987307f, -0.022736f,
	-0.104439f, 1.420709f, -0.007843f,
	34.000000f,
	// 274
	0.374394f, 0.859625f,
	0.106992f, 0.993272f, 0.044303f,
	-0.088672f, 1.416274f, -0.009552f,
	34.000000f,
	// 275
	0.578854f, 0.912479f,
	-0.136446f, 0.268298f, -0.953624f,
	-0.041299f, 1.075810f, -0.042223f,
	1.000000f,
	// 276
	0.558951f, 0.963641f,
	0.000000f, -0.063261f, -0.997997f,
	0.000000f, 1.119183f, -0.035787f,
	11.000000f,
	// 277
	0.581550f, 0.963641f,
	0.000000f, 0.288899f, -0.957360f,
	0.000000f, 1.069469f, -0.042442f,
	1.000000f,
	// 278
	0.559664f, 0.864799f,
	-0.787280f, -0.070876f, -0.612509f,
	-0.075915f, 1.122943f, -0.022182f,
	11.000000f,
	// 279
	0.559308f, 0.912479f,
	-0.169301f, -0.094545f, -0.981019f,
	-0.039091f, 1.119632f, -0.041707f,
	11.000000f,
	// 280
	0.536103f, 0.963641f,
	0.000000f, -0.273393f, -0.961902f,
	0.000000f, 1.150385f, -0.042012f,
	11.000000f,
	// 281
	0.514714f, 0.844435f,
	-0.749236f, -0.320875f, -0.579383f,
	-0.085280f, 1.185984f, -0.032149f,
	11.000000f,
	// 282
	0.514714f, 0.909191f,
	-0.227398f, -0.280587f, -0.932503f,
	-0.042479f, 1.182160f, -0.056419f,
	11.000000f,
	// 283
	0.535718f, 0.911657f,
	-0.182367f, -0.249513f, -0.951044f,
	-0.039427f, 1.150849f, -0.048790f,
	11.000000f,
	// 284
	0.514714f, 0.963641f,
	0.000000f, -0.299474f, -0.954105f,
	0.000000f, 1.183371f, -0.054116f,
	11.000000f,
	// 285
	0.538270f, 0.694891f,
	-0.467793f, -0.157877f, 0.869623f,
	-0.048430f, 1.147814f, 0.094726f,
	11.000000f,
	// 286
	0.535165f, 0.753256f,
	-0.890732f, -0.174426f, 0.419728f,
	-0.082822f, 1.153856f, 0.059772f,
	11.000000f,
	// 287
	0.566360f, 0.694145f,
	-0.409883f, 0.001960f, 0.912136f,
	-0.042918f, 1.109224f, 0.091450f,
	2.000000f,
	// 288
	0.562577f, 0.744148f,
	-0.833282f, 0.016948f, 0.552589f,
	-0.075028f, 1.121452f, 0.065797f,
	11.000000f,
	// 289
	0.559664f, 0.807103f,
	-0.998058f, -0.044226f, -0.043868f,
	-0.085612f, 1.125121f, 0.014755f,
	11.000000f,
	// 290
	0.535108f, 0.807103f,
	-0.983346f, -0.165053f, -0.076078f,
	-0.089060f, 1.155290f, 0.008567f,
	11.000000f,
	// 291
	0.536920f, 0.862972f,
	-0.770256f, -0.210928f, -0.601843f,
	-0.078874f, 1.152369f, -0.026350f,
	11.000000f,
	// 292
	0.514714f, 0.807047f,
	-0.974124f, -0.211976f, -0.078414f,
	-0.095795f, 1.189531f, 0.005634f,
	11.000000f,
	// 293
	0.514714f, 0.755250f,
	-0.886533f, -0.330176f, 0.324104f,
	-0.092273f, 1.189302f, 0.057185f,
	11.000000f,
	// 294
	0.514714f, 0.699400f,
	-0.459080f, -0.277012f, 0.844103f,
	-0.055418f, 1.186178f, 0.098968f,
	11.000000f,
	// 295
	0.514714f, 0.642689f,
	-0.000000f, -0.182383f, 0.983228f,
	-0.000000f, 1.185516f, 0.108128f,
	11.000000f,
	// 296
	0.539566f, 0.642689f,
	-0.000000f, -0.115658f, 0.993289f,
	-0.000000f, 1.144702f, 0.103573f,
	11.000000f,
	// 297
	0.568154f, 0.642689f,
	-0.000000f, 0.026398f, 0.999651f,
	-0.000000f, 1.102226f, 0.098432f,
	2.000000f,
	// 298
	0.582820f, 0.642689f,
	-0.000000f, 0.090218f, 0.995922f,
	-0.000000f, 1.071874f, 0.102770f,
	1.000000f,
	// 299
	0.580681f, 0.694145f,
	-0.347495f, 0.120770f, 0.929872f,
	-0.045364f, 1.077084f, 0.093755f,
	1.000000f,
	// 300
	0.575165f, 0.744148f,
	-0.739238f, 0.222482f, 0.635633f,
	-0.075760f, 1.086335f, 0.073799f,
	1.000000f,
	// 301
	0.575165f, 0.807103f,
	-0.978123f, 0.207117f, 0.019425f,
	-0.087998f, 1.094485f, 0.024131f,
	1.000000f,
	// 302
	0.575721f, 0.864799f,
	-0.744217f, 0.033101f, -0.667117f,
	-0.076568f, 1.091758f, -0.023238f,
	1.000000f,
	// 303
	0.873035f, 0.601218f,
	-0.126194f, 0.613800f, 0.779310f,
	-0.087625f, 0.022129f, 0.179242f,
	5.000000f,
	// 304
	0.872973f, 0.593395f,
	0.568129f, 0.618821f, 0.542484f,
	-0.043040f, 0.022545f, 0.164826f,
	5.000000f,
	// 305
	0.860116f, 0.587474f,
	0.787219f, 0.607724f, 0.104675f,
	-0.030237f, 0.022544f, 0.116848f,
	5.000000f,
	// 306
	0.724033f, 0.593090f,
	0.658555f, 0.645592f, -0.386673f,
	-0.048407f, 0.067232f, -0.044316f,
	5.000000f,
	// 307
	0.721402f, 0.601937f,
	0.013369f, 0.617239f, -0.786662f,
	-0.079915f, 0.067232f, -0.061146f,
	5.000000f,
	// 308
	0.724032f, 0.610774f,
	-0.631647f, 0.652488f, -0.418666f,
	-0.113260f, 0.067232f, -0.044673f,
	5.000000f,
	// 309
	0.734547f, 0.588600f,
	0.727729f, 0.681828f, 0.074302f,
	-0.043794f, 0.061580f, -0.012009f,
	5.000000f,
	// 310
	0.734545f, 0.615238f,
	-0.738033f, 0.673213f, 0.045743f,
	-0.120596f, 0.061580f, -0.012016f,
	5.000000f,
	// 311
	0.797331f, 0.588037f,
	0.661766f, 0.731353f, 0.164887f,
	-0.041876f, 0.040736f, 0.063957f,
	5.000000f,
	// 312
	0.797425f, 0.615598f,
	-0.646203f, 0.753697f, 0.119839f,
	-0.124372f, 0.041293f, 0.064103f,
	5.000000f,
	// 313
	0.860306f, 0.615958f,
	-0.769837f, 0.611174f, 0.183895f,
	-0.134851f, 0.022546f, 0.117146f,
	5.000000f,
	// 314
	0.873097f, 0.609041f,
	-0.612658f, 0.642602f, 0.460123f,
	-0.122117f, 0.022546f, 0.154527f,
	5.000000f,
	// 315
	0.946574f, 0.532751f,
	-0.631647f, 0.652488f, -0.418666f,
	-0.113260f, 0.067232f, -0.044673f,
	5.000000f,
	// 316
	0.948952f, 0.524001f,
	0.013369f, 0.617239f, -0.786662f,
	-0.079915f, 0.067232f, -0.061146f,
	5.000000f,
	// 317
	0.876883f, 0.524000f,
	0.012254f, -0.616962f, -0.786898f,
	-0.080172f, 0.000466f, -0.061148f,
	5.000000f,
	// 318
	0.876884f, 0.532750f,
	-0.611804f, -0.641518f, -0.462764f,
	-0.109797f, 0.000466f, -0.044675f,
	5.000000f,
	// 319
	0.942728f, 0.541085f,
	-0.738033f, 0.673213f, 0.045743f,
	-0.120596f, 0.061580f, -0.012016f,
	5.000000f,
	// 320
	0.876884f, 0.541085f,
	-0.690684f, -0.714775f, -0.109782f,
	-0.116710f, 0.000466f, -0.012018f,
	5.000000f,
	// 321
	0.924110f, 0.572633f,
	-0.646203f, 0.753697f, 0.119839f,
	-0.124372f, 0.041293f, 0.064103f,
	5.000000f,
	// 322
	0.876850f, 0.572633f,
	-0.762842f, -0.635962f, -0.116721f,
	-0.131891f, 0.000466f, 0.065830f,
	5.000000f,
	// 323
	0.914625f, 0.601771f,
	-0.769837f, 0.611174f, 0.183895f,
	-0.134851f, 0.022546f, 0.117146f,
	5.000000f,
	// 324
	0.876815f, 0.601771f,
	-0.738506f, -0.666388f, 0.102643f,
	-0.134851f, 0.000466f, 0.117143f,
	5.000000f,
	// 325
	0.914623f, 0.609737f,
	-0.612658f, 0.642602f, 0.460123f,
	-0.122117f, 0.022546f, 0.154527f,
	5.000000f,
	// 326
	0.876814f, 0.609737f,
	-0.601190f, -0.655519f, 0.457018f,
	-0.121403f, 0.000466f, 0.154523f,
	5.000000f,
	// 327
	0.914624f, 0.616063f,
	-0.126194f, 0.613800f, 0.779310f,
	-0.087625f, 0.022129f, 0.179242f,
	5.000000f,
	// 328
	0.876813f, 0.616062f,
	-0.119634f, -0.618895f, 0.776309f,
	-0.087308f, 0.000466f, 0.179238f,
	5.000000f,
	// 329
	0.948952f, 0.524001f,
	0.013369f, 0.617239f, -0.786662f,
	-0.079915f, 0.067232f, -0.061146f,
	5.000000f,
	// 330
	0.946574f, 0.532751f,
	0.658555f, 0.645592f, -0.386673f,
	-0.048407f, 0.067232f, -0.044316f,
	5.000000f,
	// 331
	0.876883f, 0.524000f,
	0.012254f, -0.616962f, -0.786898f,
	-0.080172f, 0.000466f, -0.061148f,
	5.000000f,
	// 332
	0.876881f, 0.532751f,
	0.636612f, -0.640040f, -0.430202f,
	-0.052166f, 0.000466f, -0.044319f,
	5.000000f,
	// 333
	0.942728f, 0.541088f,
	0.727729f, 0.681828f, 0.074302f,
	-0.043794f, 0.061580f, -0.012009f,
	5.000000f,
	// 334
	0.876881f, 0.541088f,
	0.681221f, -0.726937f, -0.086604f,
	-0.047715f, 0.000466f, -0.012012f,
	5.000000f,
	// 335
	0.876846f, 0.572633f,
	0.713010f, -0.696737f, -0.078581f,
	-0.038671f, 0.000466f, 0.065684f,
	5.000000f,
	// 336
	0.924110f, 0.572633f,
	0.661766f, 0.731353f, 0.164887f,
	-0.041876f, 0.040736f, 0.063957f,
	5.000000f,
	// 337
	0.876812f, 0.601771f,
	0.752746f, -0.657872f, 0.024050f,
	-0.030238f, 0.000466f, 0.116845f,
	5.000000f,
	// 338
	0.914625f, 0.601771f,
	0.787219f, 0.607724f, 0.104675f,
	-0.030237f, 0.022544f, 0.116848f,
	5.000000f,
	// 339
	0.876812f, 0.609737f,
	0.574300f, -0.612572f, 0.543079f,
	-0.042939f, 0.000466f, 0.164823f,
	5.000000f,
	// 340
	0.914623f, 0.609737f,
	0.568129f, 0.618821f, 0.542484f,
	-0.043040f, 0.022545f, 0.164826f,
	5.000000f,
	// 341
	0.876813f, 0.616062f,
	-0.119634f, -0.618895f, 0.776309f,
	-0.087308f, 0.000466f, 0.179238f,
	5.000000f,
	// 342
	0.914624f, 0.616063f,
	-0.126194f, 0.613800f, 0.779310f,
	-0.087625f, 0.022129f, 0.179242f,
	5.000000f,
	// 343
	0.724146f, 0.570868f,
	0.012254f, -0.616962f, -0.786898f,
	-0.080172f, 0.000466f, -0.061148f,
	5.000000f,
	// 344
	0.726181f, 0.579544f,
	0.636612f, -0.640040f, -0.430202f,
	-0.052166f, 0.000466f, -0.044319f,
	5.000000f,
	// 345
	0.726180f, 0.562191f,
	-0.611804f, -0.641518f, -0.462764f,
	-0.109797f, 0.000466f, -0.044675f,
	5.000000f,
	// 346
	0.735812f, 0.557859f,
	-0.690684f, -0.714775f, -0.109782f,
	-0.116710f, 0.000466f, -0.012018f,
	5.000000f,
	// 347
	0.735814f, 0.583877f,
	0.681221f, -0.726937f, -0.086604f,
	-0.047715f, 0.000466f, -0.012012f,
	5.000000f,
	// 348
	0.798477f, 0.557507f,
	-0.762842f, -0.635962f, -0.116721f,
	-0.131891f, 0.000466f, 0.065830f,
	5.000000f,
	// 349
	0.798383f, 0.584426f,
	0.713010f, -0.696737f, -0.078581f,
	-0.038671f, 0.000466f, 0.065684f,
	5.000000f,
	// 350
	0.861141f, 0.557155f,
	-0.738506f, -0.666388f, 0.102643f,
	-0.134851f, 0.000466f, 0.117143f,
	5.000000f,
	// 351
	0.860952f, 0.584976f,
	0.752746f, -0.657872f, 0.024050f,
	-0.030238f, 0.000466f, 0.116845f,
	5.000000f,
	// 352
	0.874340f, 0.564057f,
	-0.601190f, -0.655519f, 0.457018f,
	-0.121403f, 0.000466f, 0.154523f,
	5.000000f,
	// 353
	0.874218f, 0.579213f,
	0.574300f, -0.612572f, 0.543079f,
	-0.042939f, 0.000466f, 0.164823f,
	5.000000f,
	// 354
	0.874279f, 0.571635f,
	-0.119634f, -0.618895f, 0.776309f,
	-0.087308f, 0.000466f, 0.179238f,
	5.000000f,
	// 355
	0.111502f, 0.449324f,
	-0.767418f, 0.044009f, 0.639635f,
	-0.130703f, 0.885822f, 0.078484f,
	36.000000f,
	// 356
	0.110282f, 0.509129f,
	-0.725861f, 0.202993f, 0.657206f,
	-0.105995f, 0.985262f, 0.078218f,
	1.000000f,
	// 357
	0.161690f, 0.459498f,
	-0.992184f, 0.124682f, 0.004965f,
	-0.144544f, 0.913699f, 0.020404f,
	36.000000f,
	// 358
	0.162910f, 0.496226f,
	-0.963986f, 0.264891f, 0.023737f,
	-0.131682f, 0.985262f, 0.021511f,
	1.000000f,
	// 359
	0.104403f, 0.527681f,
	-0.739238f, 0.222482f, 0.635633f,
	-0.075760f, 1.086335f, 0.073799f,
	1.000000f,
	// 360
	0.162910f, 0.530358f,
	-0.978123f, 0.207117f, 0.019425f,
	-0.087998f, 1.094485f, 0.024131f,
	1.000000f,
	// 361
	0.220828f, 0.499730f,
	-0.736593f, 0.273286f, -0.618664f,
	-0.102612f, 0.985262f, -0.051726f,
	1.000000f,
	// 362
	0.230905f, 0.529020f,
	-0.762650f, 0.364625f, -0.534241f,
	-0.076568f, 1.094146f, -0.023238f,
	1.000000f,
	// 363
	0.267442f, 0.495955f,
	-0.252859f, 0.214145f, -0.943506f,
	-0.056319f, 0.985262f, -0.082786f,
	1.000000f,
	// 364
	0.278565f, 0.527347f,
	-0.136446f, 0.268298f, -0.953624f,
	-0.041299f, 1.075810f, -0.042223f,
	1.000000f,
	// 365
	0.314799f, 0.526343f,
	0.000000f, 0.288899f, -0.957360f,
	0.000000f, 1.069469f, -0.042442f,
	1.000000f,
	// 366
	0.317565f, 0.490317f,
	0.000000f, 0.230413f, -0.973093f,
	0.000000f, 0.985262f, -0.083537f,
	1.000000f,
	// 367
	0.216490f, 0.480597f,
	-0.770540f, 0.116134f, -0.626723f,
	-0.112386f, 0.954109f, -0.050302f,
	1.000000f,
	// 368
	0.259479f, 0.472209f,
	-0.355585f, -0.030493f, -0.934146f,
	-0.068860f, 0.955351f, -0.079611f,
	1.000000f,
	// 369
	0.318322f, 0.467424f,
	0.000000f, -0.158074f, -0.987427f,
	0.000000f, 0.932615f, -0.084160f,
	1.000000f,
	// 370
	0.242260f, 0.442506f,
	-0.313564f, -0.079045f, -0.946271f,
	-0.082859f, 0.873314f, -0.062585f,
	3.000000f,
	// 371
	0.200058f, 0.434942f,
	-0.805160f, 0.023644f, -0.592587f,
	-0.130992f, 0.876346f, -0.035772f,
	3.000000f,
	// 372
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 373
	0.301557f, 0.441406f,
	0.332980f, -0.366028f, -0.868993f,
	-0.019576f, 0.884431f, -0.072782f,
	1.000000f,
	// 374
	0.032832f, 0.495481f,
	-0.123291f, -0.099500f, 0.987370f,
	-0.020283f, 0.985262f, 0.104951f,
	1.000000f,
	// 375
	0.033429f, 0.441549f,
	0.205524f, -0.338494f, 0.918249f,
	-0.027055f, 0.899856f, 0.078798f,
	1.000000f,
	// 376
	0.007127f, 0.446012f,
	0.000000f, -0.692625f, 0.721298f,
	-0.000000f, 0.892416f, 0.083870f,
	1.000000f,
	// 377
	0.007127f, 0.492684f,
	-0.000000f, -0.097221f, 0.995263f,
	-0.000000f, 0.985262f, 0.106487f,
	1.000000f,
	// 378
	0.007127f, 0.523666f,
	-0.000000f, 0.090218f, 0.995922f,
	-0.000000f, 1.071874f, 0.102770f,
	1.000000f,
	// 379
	0.056805f, 0.525339f,
	-0.347495f, 0.120770f, 0.929872f,
	-0.045364f, 1.077084f, 0.093755f,
	1.000000f,
	// 380
	0.073431f, 0.496250f,
	-0.280269f, 0.043402f, 0.958940f,
	-0.072110f, 0.985262f, 0.097305f,
	1.000000f,
	// 381
	0.073625f, 0.420769f,
	-0.008179f, -0.029530f, 0.999530f,
	-0.079041f, 0.858605f, 0.100184f,
	37.000000f,
	// 382
	0.442684f, 0.898787f,
	-0.156125f, -0.002541f, -0.987734f,
	-0.055858f, 1.312527f, -0.079060f,
	12.000000f,
	// 383
	0.442684f, 0.966907f,
	0.000000f, 0.032776f, -0.999463f,
	0.000000f, 1.312527f, -0.084641f,
	12.000000f,
	// 384
	0.469882f, 0.966426f,
	0.000000f, -0.163270f, -0.986581f,
	0.000000f, 1.265166f, -0.079362f,
	12.000000f,
	// 385
	0.469882f, 0.902897f,
	-0.227756f, -0.141979f, -0.963312f,
	-0.052836f, 1.264943f, -0.076689f,
	12.000000f,
	// 386
	0.493150f, 0.907830f,
	-0.229771f, -0.295132f, -0.927417f,
	-0.046262f, 1.215374f, -0.066694f,
	11.000000f,
	// 387
	0.493150f, 0.966394f,
	0.000000f, -0.298716f, -0.954342f,
	0.000000f, 1.214327f, -0.064312f,
	11.000000f,
	// 388
	0.514714f, 0.966394f,
	0.000000f, -0.299474f, -0.954105f,
	0.000000f, 1.183371f, -0.054116f,
	11.000000f,
	// 389
	0.469882f, 0.849585f,
	-0.699149f, -0.267053f, -0.663230f,
	-0.098638f, 1.265948f, -0.056863f,
	12.000000f,
	// 390
	0.441078f, 0.853608f,
	-0.431827f, -0.066865f, -0.899474f,
	-0.100592f, 1.323173f, -0.071627f,
	12.000000f,
	// 391
	0.418195f, 0.856892f,
	-0.198021f, 0.392426f, -0.898215f,
	-0.090676f, 1.376861f, -0.065705f,
	12.000000f,
	// 392
	0.410841f, 0.827869f,
	-0.304495f, 0.400581f, -0.864186f,
	-0.104405f, 1.382154f, -0.057950f,
	34.000000f,
	// 393
	0.430229f, 0.966420f,
	0.000000f, 0.236695f, -0.971584f,
	0.000000f, 1.353497f, -0.077306f,
	12.000000f,
	// 394
	0.419311f, 0.893435f,
	-0.098109f, 0.368436f, -0.924462f,
	-0.065681f, 1.373106f, -0.069522f,
	12.000000f,
	// 395
	0.413842f, 0.866108f,
	0.042411f, 0.671782f, -0.739534f,
	-0.090030f, 1.390020f, -0.054351f,
	12.000000f,
	// 396
	0.398600f, 0.832844f,
	0.062254f, 0.810578f, -0.582312f,
	-0.099793f, 1.407216f, -0.040111f,
	34.000000f,
	// 397
	0.397739f, 0.807699f,
	-0.083646f, 0.717732f, -0.691277f,
	-0.124538f, 1.405653f, -0.037899f,
	34.000000f,
	// 398
	0.416440f, 0.806646f,
	-0.232515f, 0.286938f, -0.929303f,
	-0.123654f, 1.380929f, -0.050470f,
	34.000000f,
	// 399
	0.374394f, 0.806541f,
	0.033511f, 0.999136f, -0.024587f,
	-0.124737f, 1.421756f, -0.004796f,
	34.000000f,
	// 400
	0.374394f, 0.835903f,
	0.157189f, 0.987307f, -0.022736f,
	-0.104439f, 1.420709f, -0.007843f,
	34.000000f,
	// 401
	0.434720f, 0.818888f,
	-0.547946f, -0.269108f, -0.792046f,
	-0.123001f, 1.341022f, -0.053068f,
	34.000000f,
	// 402
	0.445893f, 0.802300f,
	-0.702055f, -0.688466f, -0.182027f,
	-0.133527f, 1.319623f, -0.004570f,
	34.000000f,
	// 403
	0.469882f, 0.795507f,
	-0.964101f, -0.262302f, -0.041302f,
	-0.119418f, 1.266555f, 0.017236f,
	12.000000f,
	// 404
	0.437175f, 0.788739f,
	-0.533464f, -0.454487f, 0.713343f,
	-0.139391f, 1.333704f, 0.034157f,
	34.000000f,
	// 405
	0.453445f, 0.767679f,
	-0.896751f, -0.006087f, 0.442493f,
	-0.115546f, 1.303552f, 0.058939f,
	11.000000f,
	// 406
	0.436820f, 0.767347f,
	-0.574365f, 0.253314f, 0.778419f,
	-0.110367f, 1.343243f, 0.055328f,
	11.000000f,
	// 407
	0.416602f, 0.799456f,
	0.041573f, 0.237236f, 0.970562f,
	-0.140417f, 1.385688f, 0.041621f,
	34.000000f,
	// 408
	0.418590f, 0.767015f,
	-0.048268f, 0.404634f, 0.913204f,
	-0.110733f, 1.379087f, 0.043289f,
	34.000000f,
	// 409
	0.397996f, 0.796130f,
	0.034843f, 0.762221f, 0.646379f,
	-0.126735f, 1.410009f, 0.028843f,
	34.000000f,
	// 410
	0.396754f, 0.767015f,
	0.131458f, 0.735771f, 0.664349f,
	-0.107862f, 1.406926f, 0.030175f,
	34.000000f,
	// 411
	0.374394f, 0.765038f,
	0.157189f, 0.987307f, -0.022736f,
	-0.104439f, 1.420709f, -0.007843f,
	34.000000f,
	// 412
	0.374394f, 0.802037f,
	0.033511f, 0.999136f, -0.024587f,
	-0.124737f, 1.421756f, -0.004796f,
	34.000000f,
	// 413
	0.494004f, 0.791631f,
	-0.965824f, -0.257644f, -0.028348f,
	-0.109643f, 1.228123f, 0.020338f,
	11.000000f,
	// 414
	0.493150f, 0.843740f,
	-0.791870f, -0.284876f, -0.540173f,
	-0.094453f, 1.221027f, -0.039166f,
	11.000000f,
	// 415
	0.514714f, 0.805775f,
	-0.730536f, -0.679494f, -0.067867f,
	-0.098454f, 1.189635f, 0.004204f,
	11.000000f,
	// 416
	0.469658f, 0.764856f,
	-0.968391f, -0.120143f, 0.218599f,
	-0.114190f, 1.265171f, 0.062797f,
	12.000000f,
	// 417
	0.495560f, 0.744603f,
	-0.848349f, -0.394603f, 0.352976f,
	-0.099276f, 1.228731f, 0.083087f,
	12.000000f,
	// 418
	0.514714f, 0.751397f,
	-0.886533f, -0.330176f, 0.324104f,
	-0.092273f, 1.189302f, 0.057185f,
	11.000000f,
	// 419
	0.514714f, 0.847181f,
	-0.749236f, -0.320875f, -0.579383f,
	-0.085280f, 1.185984f, -0.032149f,
	11.000000f,
	// 420
	0.514714f, 0.911941f,
	-0.227398f, -0.280587f, -0.932503f,
	-0.042479f, 1.182160f, -0.056419f,
	11.000000f,
	// 421
	0.503562f, 0.703177f,
	-0.433834f, -0.490609f, 0.755705f,
	-0.068642f, 1.212893f, 0.103134f,
	11.000000f,
	// 422
	0.514714f, 0.698177f,
	-0.459080f, -0.277012f, 0.844103f,
	-0.055418f, 1.186178f, 0.098968f,
	11.000000f,
	// 423
	0.499926f, 0.675159f,
	-0.123084f, -0.283300f, 0.951100f,
	-0.033085f, 1.215091f, 0.113233f,
	11.000000f,
	// 424
	0.514714f, 0.641463f,
	-0.000000f, -0.182383f, 0.983228f,
	-0.000000f, 1.185516f, 0.108128f,
	11.000000f,
	// 425
	0.499926f, 0.641511f,
	-0.000000f, -0.218353f, 0.975870f,
	-0.000000f, 1.215169f, 0.112476f,
	11.000000f,
	// 426
	0.481220f, 0.641512f,
	-0.000000f, -0.076487f, 0.997071f,
	-0.000000f, 1.246720f, 0.122061f,
	12.000000f,
	// 427
	0.003726f, 0.089349f,
	0.039706f, -0.998808f, 0.028380f,
	-0.205818f, 1.330921f, -0.000900f,
	15.000000f,
	// 428
	0.003792f, 0.123400f,
	-0.702055f, -0.688466f, -0.182027f,
	-0.133527f, 1.319623f, -0.004570f,
	34.000000f,
	// 429
	0.043042f, 0.123400f,
	-0.533464f, -0.454487f, 0.713343f,
	-0.139391f, 1.333704f, 0.034157f,
	34.000000f,
	// 430
	0.136540f, 0.123400f,
	0.034843f, 0.762221f, 0.646379f,
	-0.126735f, 1.410009f, 0.028843f,
	34.000000f,
	// 431
	0.093574f, 0.109966f,
	0.080331f, 0.167190f, 0.982647f,
	-0.161710f, 1.382619f, 0.045793f,
	15.000000f,
	// 432
	0.093574f, 0.123400f,
	0.041573f, 0.237236f, 0.970562f,
	-0.140417f, 1.385688f, 0.041621f,
	34.000000f,
	// 433
	0.043042f, 0.050988f,
	0.120512f, -0.603958f, 0.787852f,
	-0.284369f, 1.335829f, 0.039815f,
	15.000000f,
	// 434
	0.003726f, 0.064964f,
	0.235241f, -0.966333f, 0.104223f,
	-0.259732f, 1.317142f, -0.001475f,
	15.000000f,
	// 435
	0.003726f, 0.034683f,
	0.076526f, -0.993516f, 0.084085f,
	-0.301722f, 1.307683f, -0.001433f,
	15.000000f,
	// 436
	0.093574f, 0.050054f,
	0.114712f, 0.076099f, 0.990480f,
	-0.284317f, 1.379409f, 0.048647f,
	15.000000f,
	// 437
	0.183292f, 0.123400f,
	0.033511f, 0.999136f, -0.024587f,
	-0.124737f, 1.421756f, -0.004796f,
	34.000000f,
	// 438
	0.183292f, 0.108682f,
	0.026438f, 0.998612f, -0.045549f,
	-0.160912f, 1.422797f, -0.007084f,
	15.000000f,
	// 439
	0.136540f, 0.108682f,
	0.011077f, 0.782502f, 0.622550f,
	-0.163493f, 1.407825f, 0.028009f,
	15.000000f,
	// 440
	0.136540f, 0.048907f,
	0.153038f, 0.734074f, 0.661600f,
	-0.282264f, 1.419667f, 0.033135f,
	15.000000f,
	// 441
	0.093574f, 0.014077f,
	-0.214642f, 0.083310f, 0.973133f,
	-0.349737f, 1.381934f, 0.061904f,
	15.000000f,
	// 442
	0.043042f, 0.014508f,
	-0.315620f, -0.586205f, 0.746155f,
	-0.351262f, 1.337043f, 0.050481f,
	15.000000f,
	// 443
	0.003726f, 0.014508f,
	-0.440047f, -0.897646f, 0.024315f,
	-0.351779f, 1.311155f, -0.002666f,
	15.000000f,
	// 444
	0.136540f, 0.013885f,
	-0.130391f, 0.739339f, 0.660588f,
	-0.342186f, 1.427078f, 0.040667f,
	15.000000f,
	// 445
	0.183292f, 0.064964f,
	0.115981f, 0.990778f, -0.070052f,
	-0.258534f, 1.426646f, -0.006999f,
	15.000000f,
	// 446
	0.226789f, 0.108682f,
	0.039257f, 0.722838f, -0.689901f,
	-0.160251f, 1.409291f, -0.034191f,
	15.000000f,
	// 447
	0.003726f, 0.000616f,
	-0.541311f, -0.840716f, -0.013401f,
	-0.382784f, 1.350020f, -0.002715f,
	16.000000f,
	// 448
	0.043042f, 0.000616f,
	-0.542366f, -0.460069f, 0.702976f,
	-0.384252f, 1.363773f, 0.031336f,
	16.000000f,
	// 449
	0.136540f, 0.000616f,
	-0.352364f, 0.573293f, 0.739712f,
	-0.383611f, 1.408865f, 0.030471f,
	16.000000f,
	// 450
	0.183292f, 0.014223f,
	-0.115277f, 0.993200f, 0.016259f,
	-0.337650f, 1.443473f, -0.001583f,
	16.000000f,
	// 451
	0.183292f, 0.037445f,
	0.220669f, 0.975234f, -0.014987f,
	-0.295798f, 1.433906f, -0.002477f,
	15.000000f,
	// 452
	0.226789f, 0.053036f,
	0.167028f, 0.735904f, -0.656160f,
	-0.276992f, 1.414561f, -0.041644f,
	15.000000f,
	// 453
	0.226789f, 0.014794f,
	-0.117217f, 0.746095f, -0.655441f,
	-0.335163f, 1.427565f, -0.050554f,
	15.000000f,
	// 454
	0.183292f, 0.000616f,
	-0.245827f, 0.969268f, -0.009379f,
	-0.381563f, 1.421781f, -0.002501f,
	16.000000f,
	// 455
	0.226789f, 0.000616f,
	-0.303048f, 0.589640f, -0.748657f,
	-0.380310f, 1.409226f, -0.031437f,
	16.000000f,
	// 456
	0.270245f, 0.050054f,
	0.148592f, 0.047769f, -0.987744f,
	-0.278656f, 1.376552f, -0.062452f,
	15.000000f,
	// 457
	0.270245f, 0.015131f,
	-0.194113f, 0.071418f, -0.978376f,
	-0.335648f, 1.382423f, -0.073234f,
	15.000000f,
	// 458
	0.311334f, 0.000616f,
	-0.510921f, -0.487267f, -0.708188f,
	-0.381087f, 1.362063f, -0.032532f,
	16.000000f,
	// 459
	0.353752f, 0.000616f,
	-0.541311f, -0.840716f, -0.013401f,
	-0.382784f, 1.350020f, -0.002715f,
	16.000000f,
	// 460
	0.353752f, 0.014508f,
	-0.440047f, -0.897646f, 0.024315f,
	-0.351779f, 1.311155f, -0.002666f,
	15.000000f,
	// 461
	0.311334f, 0.015329f,
	-0.320905f, -0.628936f, -0.708138f,
	-0.344088f, 1.329369f, -0.054350f,
	15.000000f,
	// 462
	0.311334f, 0.048659f,
	0.127076f, -0.732818f, -0.668454f,
	-0.280444f, 1.326092f, -0.043675f,
	15.000000f,
	// 463
	0.270245f, 0.109966f,
	-0.009412f, 0.217028f, -0.976120f,
	-0.155739f, 1.376819f, -0.050109f,
	15.000000f,
	// 464
	0.226789f, 0.123400f,
	-0.083646f, 0.717732f, -0.691277f,
	-0.124538f, 1.405653f, -0.037899f,
	34.000000f,
	// 465
	0.353752f, 0.034683f,
	0.076526f, -0.993516f, 0.084085f,
	-0.301722f, 1.307683f, -0.001433f,
	15.000000f,
	// 466
	0.353752f, 0.064964f,
	0.235241f, -0.966333f, 0.104223f,
	-0.259732f, 1.317142f, -0.001475f,
	15.000000f,
	// 467
	0.353752f, 0.089349f,
	0.039706f, -0.998808f, 0.028380f,
	-0.205818f, 1.330921f, -0.000900f,
	15.000000f,
	// 468
	0.270245f, 0.123400f,
	-0.232515f, 0.286938f, -0.929303f,
	-0.123654f, 1.380929f, -0.050470f,
	34.000000f,
	// 469
	0.311334f, 0.123400f,
	-0.547946f, -0.269108f, -0.792046f,
	-0.123001f, 1.341022f, -0.053068f,
	34.000000f,
	// 470
	0.353818f, 0.123400f,
	-0.702055f, -0.688466f, -0.182027f,
	-0.133527f, 1.319623f, -0.004570f,
	34.000000f,
	// 471
	0.731146f, 0.524127f,
	-0.608457f, 0.791724f, -0.054343f,
	-0.400002f, 1.422087f, -0.004238f,
	16.000000f,
	// 472
	0.733802f, 0.523038f,
	-0.550787f, 0.442900f, -0.707442f,
	-0.399092f, 1.408209f, -0.034239f,
	16.000000f,
	// 473
	0.728222f, 0.523114f,
	-0.635984f, 0.457585f, 0.621402f,
	-0.401960f, 1.409176f, 0.028738f,
	16.000000f,
	// 474
	0.728268f, 0.519791f,
	-0.701235f, -0.381983f, 0.601962f,
	-0.402533f, 1.366835f, 0.028192f,
	16.000000f,
	// 475
	0.734027f, 0.520001f,
	-0.566571f, -0.317562f, -0.760363f,
	-0.399720f, 1.369514f, -0.036818f,
	16.000000f,
	// 476
	0.731146f, 0.518697f,
	-0.681114f, -0.728840f, -0.069829f,
	-0.401234f, 1.352893f, -0.004310f,
	16.000000f,
	// 477
	0.646372f, 0.543317f,
	-0.541311f, -0.840716f, -0.013401f,
	-0.382784f, 1.350020f, -0.002715f,
	16.000000f,
	// 478
	0.677020f, 0.543317f,
	-0.542366f, -0.460069f, 0.702976f,
	-0.384252f, 1.363773f, 0.031336f,
	16.000000f,
	// 479
	0.646372f, 0.517516f,
	-0.681114f, -0.728840f, -0.069829f,
	-0.401234f, 1.352893f, -0.004310f,
	16.000000f,
	// 480
	0.677027f, 0.517516f,
	-0.701235f, -0.381983f, 0.601962f,
	-0.402533f, 1.366835f, 0.028192f,
	16.000000f,
	// 481
	0.707982f, 0.543317f,
	-0.352364f, 0.573293f, 0.739712f,
	-0.383611f, 1.408865f, 0.030471f,
	16.000000f,
	// 482
	0.707923f, 0.517516f,
	-0.635984f, 0.457585f, 0.621402f,
	-0.401960f, 1.409176f, 0.028738f,
	16.000000f,
	// 483
	0.737656f, 0.543317f,
	-0.245827f, 0.969268f, -0.009379f,
	-0.381563f, 1.421781f, -0.002501f,
	16.000000f,
	// 484
	0.737534f, 0.517516f,
	-0.608457f, 0.791724f, -0.054343f,
	-0.400002f, 1.422087f, -0.004238f,
	16.000000f,
	// 485
	0.766813f, 0.543317f,
	-0.303048f, 0.589640f, -0.748657f,
	-0.380310f, 1.409226f, -0.031437f,
	16.000000f,
	// 486
	0.766632f, 0.517516f,
	-0.550787f, 0.442900f, -0.707442f,
	-0.399092f, 1.408209f, -0.034239f,
	16.000000f,
	// 487
	0.796673f, 0.517516f,
	-0.566571f, -0.317562f, -0.760363f,
	-0.399720f, 1.369514f, -0.036818f,
	16.000000f,
	// 488
	0.796914f, 0.543317f,
	-0.510921f, -0.487267f, -0.708188f,
	-0.381087f, 1.362063f, -0.032532f,
	16.000000f,
	// 489
	0.824108f, 0.543317f,
	-0.541311f, -0.840716f, -0.013401f,
	-0.382784f, 1.350020f, -0.002715f,
	16.000000f,
	// 490
	0.824108f, 0.517516f,
	-0.681114f, -0.728840f, -0.069829f,
	-0.401234f, 1.352893f, -0.004310f,
	16.000000f,
	// 491
	0.462224f, 0.653538f,
	-0.012797f, 0.645820f, 0.763382f,
	-0.046380f, 1.331445f, 0.095112f,
	12.000000f,
	// 492
	0.462224f, 0.653538f,
	-0.000000f, 0.728300f, 0.685259f,
	-0.000000f, 1.332309f, 0.087884f,
	12.000000f,
	// 493
	0.462224f, 0.653538f,
	-0.038530f, 0.428735f, 0.902608f,
	-0.047076f, 1.307309f, 0.110732f,
	12.000000f,
	// 494
	0.462224f, 0.653538f,
	-0.022763f, 0.084387f, 0.996173f,
	-0.046108f, 1.268688f, 0.123733f,
	12.000000f,
	// 495
	0.462224f, 0.653538f,
	-0.000000f, 0.142630f, 0.989776f,
	-0.000000f, 1.269728f, 0.120447f,
	12.000000f,
	// 496
	0.462224f, 0.653538f,
	-0.000000f, 0.463751f, 0.885966f,
	-0.000000f, 1.308572f, 0.109531f,
	12.000000f,
	// 497
	0.462224f, 0.653538f,
	-0.066694f, -0.226159f, 0.971804f,
	-0.037090f, 1.236245f, 0.119131f,
	12.000000f,
	// 498
	0.462224f, 0.653538f,
	-0.438595f, -0.493713f, 0.750921f,
	-0.083145f, 1.230884f, 0.112938f,
	12.000000f,
	// 499
	0.462224f, 0.653538f,
	-0.610332f, -0.053057f, 0.790367f,
	-0.096324f, 1.262098f, 0.119371f,
	12.000000f,
	// 500
	0.462224f, 0.653538f,
	-0.583204f, 0.345182f, 0.735338f,
	-0.094937f, 1.302676f, 0.107490f,
	12.000000f,
	// 501
	0.462224f, 0.653538f,
	-0.472935f, 0.559326f, 0.680799f,
	-0.090646f, 1.331672f, 0.089689f,
	12.000000f,
	// 502
	0.789672f, 0.515204f,
	0.775369f, 0.312584f, 0.548720f,
	0.077733f, 1.086230f, 0.071373f,
	1.000000f,
	// 503
	0.821396f, 0.496163f,
	0.900481f, 0.360294f, 0.243560f,
	0.107349f, 1.041497f, 0.042854f,
	1.000000f,
	// 504
	0.825224f, 0.504051f,
	0.904474f, 0.364878f, 0.220885f,
	0.102695f, 1.058696f, 0.035711f,
	1.000000f,
	// 505
	0.811609f, 0.515204f,
	0.894515f, 0.325480f, 0.306441f,
	0.086584f, 1.090416f, 0.049048f,
	1.000000f,
	// 506
	0.852453f, 0.481746f,
	0.950259f, 0.309391f, 0.035843f,
	0.133370f, 0.988381f, 0.009724f,
	1.000000f,
	// 507
	0.843655f, 0.498475f,
	0.923272f, 0.383701f, 0.018515f,
	0.111759f, 1.043930f, 0.014227f,
	1.000000f,
	// 508
	0.834856f, 0.515204f,
	0.917519f, 0.396872f, 0.025538f,
	0.089909f, 1.093423f, 0.022922f,
	1.000000f,
	// 509
	0.819544f, 0.483651f,
	0.897835f, 0.338089f, 0.282113f,
	0.111646f, 1.025690f, 0.051282f,
	1.000000f,
	// 510
	0.837506f, 0.460853f,
	0.921618f, 0.293467f, 0.253963f,
	0.125876f, 0.992314f, 0.042620f,
	1.000000f,
	// 511
	0.805561f, 0.480388f,
	0.810144f, 0.318340f, 0.492266f,
	0.101016f, 1.033032f, 0.070011f,
	1.000000f,
	// 512
	0.822763f, 0.438226f,
	0.805119f, 0.251842f, 0.536990f,
	0.118556f, 0.981240f, 0.070564f,
	1.000000f,
	// 513
	0.783247f, 0.431030f,
	0.481593f, 0.157183f, 0.862184f,
	0.075637f, 0.987712f, 0.105501f,
	1.000000f,
	// 514
	0.800973f, 0.438978f,
	0.636070f, 0.166734f, 0.753402f,
	0.096965f, 0.990145f, 0.089704f,
	1.000000f,
	// 515
	0.796521f, 0.468693f,
	0.664496f, 0.244964f, 0.706001f,
	0.092400f, 1.024622f, 0.083951f,
	1.000000f,
	// 516
	0.785741f, 0.477466f,
	0.573157f, 0.258273f, 0.777680f,
	0.079539f, 1.038727f, 0.089793f,
	1.000000f,
	// 517
	0.806171f, 0.396344f,
	0.518930f, 0.220558f, 0.825873f,
	0.098398f, 0.923656f, 0.098398f,
	1.000000f,
	// 518
	0.818408f, 0.376052f,
	0.245110f, 0.306754f, 0.919686f,
	0.109262f, 0.927053f, 0.094584f,
	1.000000f,
	// 519
	0.799201f, 0.368403f,
	0.602452f, 0.162762f, 0.781383f,
	0.087255f, 0.924736f, 0.110319f,
	1.000000f,
	// 520
	0.816742f, 0.301898f,
	0.390865f, 0.005358f, 0.920432f,
	0.098725f, 0.861543f, 0.113877f,
	31.000000f,
	// 521
	0.766825f, 0.301494f,
	0.125442f, -0.043747f, 0.991136f,
	0.047596f, 0.867015f, 0.124124f,
	31.000000f,
	// 522
	0.790205f, 0.300791f,
	0.193598f, -0.035259f, 0.980447f,
	0.073173f, 0.864265f, 0.120287f,
	31.000000f,
	// 523
	0.789937f, 0.342238f,
	0.238081f, 0.136186f, 0.961650f,
	0.075310f, 0.921685f, 0.117107f,
	1.000000f,
	// 524
	0.777683f, 0.363476f,
	0.140784f, 0.104292f, 0.984532f,
	0.064176f, 0.922345f, 0.117134f,
	1.000000f,
	// 525
	0.784455f, 0.271085f,
	0.166689f, -0.096558f, 0.981270f,
	0.066700f, 0.822213f, 0.116465f,
	7.000000f,
	// 526
	0.793036f, 0.261089f,
	0.088014f, -0.109011f, 0.990136f,
	0.075711f, 0.794622f, 0.113090f,
	7.000000f,
	// 527
	0.770342f, 0.260726f,
	0.222927f, -0.141907f, 0.964451f,
	0.051583f, 0.792716f, 0.116374f,
	7.000000f,
	// 528
	0.771778f, 0.228634f,
	0.123265f, -0.237282f, 0.963589f,
	0.051217f, 0.721600f, 0.102444f,
	7.000000f,
	// 529
	0.746537f, 0.255060f,
	0.000058f, -0.206229f, 0.978504f,
	-0.000000f, 0.721489f, 0.103722f,
	41.000000f,
	// 530
	0.755944f, 0.270320f,
	-0.093611f, -0.107913f, 0.989743f,
	0.025126f, 0.792057f, 0.116993f,
	44.000000f,
	// 531
	0.747262f, 0.277817f,
	0.032286f, -0.130372f, 0.990939f,
	0.016399f, 0.819577f, 0.119420f,
	44.000000f,
	// 532
	0.736336f, 0.270883f,
	0.000255f, -0.166406f, 0.986057f,
	-0.000000f, 0.805361f, 0.118754f,
	42.000000f,
	// 533
	0.745549f, 0.296351f,
	0.063361f, -0.107804f, 0.992151f,
	0.021091f, 0.860719f, 0.126113f,
	31.000000f,
	// 534
	0.726136f, 0.286706f,
	0.000267f, -0.101673f, 0.994818f,
	-0.000000f, 0.859699f, 0.126431f,
	42.000000f,
	// 535
	0.723804f, 0.409193f,
	0.002812f, 0.087149f, 0.996191f,
	0.000001f, 0.973807f, 0.127366f,
	1.000000f,
	// 536
	0.724970f, 0.347949f,
	0.000268f, -0.002234f, 0.999997f,
	-0.000000f, 0.908239f, 0.128311f,
	1.000000f,
	// 537
	0.739685f, 0.329195f,
	0.055480f, -0.018836f, 0.998282f,
	0.016873f, 0.897009f, 0.127757f,
	1.000000f,
	// 538
	0.745260f, 0.350988f,
	0.096204f, 0.011738f, 0.995292f,
	0.023841f, 0.920432f, 0.127241f,
	1.000000f,
	// 539
	0.722750f, 0.515204f,
	0.004897f, 0.285450f, 0.958381f,
	-0.000004f, 1.073321f, 0.102984f,
	1.000000f,
	// 540
	0.723277f, 0.462198f,
	0.003763f, 0.258673f, 0.965958f,
	0.000000f, 1.023705f, 0.118432f,
	1.000000f,
	// 541
	0.732983f, 0.448387f,
	0.118330f, 0.225326f, 0.967071f,
	0.010997f, 1.016904f, 0.119507f,
	1.000000f,
	// 542
	0.737656f, 0.467019f,
	0.164744f, 0.268011f, 0.949226f,
	0.017747f, 1.031223f, 0.114256f,
	1.000000f,
	// 543
	0.739405f, 0.413056f,
	0.142041f, 0.133468f, 0.980821f,
	0.017964f, 0.984794f, 0.124769f,
	1.000000f,
	// 544
	0.751690f, 0.425053f,
	0.246533f, 0.158057f, 0.956159f,
	0.033714f, 0.991927f, 0.120153f,
	1.000000f,
	// 545
	0.759561f, 0.367359f,
	0.272170f, 0.049022f, 0.961000f,
	0.041269f, 0.932479f, 0.123645f,
	1.000000f,
	// 546
	0.748437f, 0.373880f,
	0.169591f, 0.054986f, 0.983979f,
	0.027870f, 0.943590f, 0.126280f,
	1.000000f,
	// 547
	0.766696f, 0.424590f,
	0.336516f, 0.126973f, 0.933078f,
	0.054123f, 0.986485f, 0.114691f,
	1.000000f,
	// 548
	0.768297f, 0.383107f,
	0.321275f, 0.084688f, 0.943192f,
	0.053596f, 0.944593f, 0.118835f,
	1.000000f,
	// 549
	0.762709f, 0.457613f,
	0.335321f, 0.212049f, 0.917930f,
	0.052727f, 1.019655f, 0.108972f,
	1.000000f,
	// 550
	0.752487f, 0.469326f,
	0.233772f, 0.245951f, 0.940669f,
	0.040183f, 1.033222f, 0.109304f,
	1.000000f,
	// 551
	0.768284f, 0.474696f,
	0.413652f, 0.242257f, 0.877612f,
	0.061590f, 1.035217f, 0.101193f,
	1.000000f,
	// 552
	0.753149f, 0.515204f,
	0.309923f, 0.273691f, 0.910517f,
	0.046027f, 1.077753f, 0.094548f,
	1.000000f,
	// 553
	0.770354f, 0.515204f,
	0.542483f, 0.268674f, 0.795943f,
	0.064075f, 1.081811f, 0.085673f,
	1.000000f,
	// 554
	0.774697f, 0.489094f,
	0.491664f, 0.278830f, 0.824937f,
	0.068443f, 1.051890f, 0.092796f,
	1.000000f,
	// 555
	0.742497f, 0.483723f,
	0.165197f, 0.275558f, 0.946984f,
	0.027001f, 1.046316f, 0.108369f,
	1.000000f,
	// 556
	0.737549f, 0.515204f,
	0.150959f, 0.276288f, 0.949145f,
	0.024007f, 1.074653f, 0.100597f,
	1.000000f,
	// 557
	0.645177f, 0.514954f,
	0.657370f, 0.491659f, -0.571083f,
	0.077814f, 1.091864f, -0.024352f,
	1.000000f,
	// 558
	0.628475f, 0.514954f,
	0.886486f, 0.416548f, -0.201571f,
	0.086990f, 1.094309f, -0.002782f,
	1.000000f,
	// 559
	0.623040f, 0.492930f,
	0.841268f, 0.446721f, -0.304480f,
	0.098402f, 1.060245f, -0.022988f,
	1.000000f,
	// 560
	0.631437f, 0.480440f,
	0.661610f, 0.458060f, -0.593678f,
	0.097105f, 1.042924f, -0.043930f,
	1.000000f,
	// 561
	0.612348f, 0.514954f,
	0.917519f, 0.396872f, 0.025538f,
	0.089909f, 1.093423f, 0.022922f,
	1.000000f,
	// 562
	0.612839f, 0.484657f,
	0.887281f, 0.404862f, -0.220950f,
	0.107262f, 1.043533f, -0.018557f,
	1.000000f,
	// 563
	0.611893f, 0.440321f,
	0.732600f, 0.340601f, -0.589312f,
	0.119117f, 0.985351f, -0.059139f,
	1.000000f,
	// 564
	0.599618f, 0.498350f,
	0.923272f, 0.383701f, 0.018515f,
	0.111759f, 1.043930f, 0.014227f,
	1.000000f,
	// 565
	0.603802f, 0.481861f,
	0.909010f, 0.381706f, -0.167337f,
	0.116391f, 1.027285f, -0.010551f,
	1.000000f,
	// 566
	0.586889f, 0.481746f,
	0.950259f, 0.309391f, 0.035843f,
	0.133370f, 0.988381f, 0.009724f,
	1.000000f,
	// 567
	0.596096f, 0.458368f,
	0.913843f, 0.347140f, -0.210677f,
	0.128026f, 0.991114f, -0.025176f,
	1.000000f,
	// 568
	0.544857f, 0.337779f,
	0.945460f, 0.076265f, -0.316684f,
	0.159201f, 0.864939f, -0.049487f,
	31.000000f,
	// 569
	0.579161f, 0.392040f,
	0.893374f, 0.270257f, -0.358949f,
	0.141508f, 0.926940f, -0.054331f,
	1.000000f,
	// 570
	0.581524f, 0.420983f,
	0.928209f, 0.302107f, -0.217163f,
	0.139569f, 0.949799f, -0.035790f,
	1.000000f,
	// 571
	0.565088f, 0.408089f,
	0.951191f, 0.269822f, -0.149770f,
	0.147864f, 0.928747f, -0.024553f,
	1.000000f,
	// 572
	0.577438f, 0.365972f,
	0.802256f, 0.211183f, -0.558379f,
	0.142673f, 0.903818f, -0.065128f,
	1.000000f,
	// 573
	0.592630f, 0.371577f,
	0.615806f, 0.230632f, -0.753387f,
	0.133282f, 0.913542f, -0.071951f,
	45.000000f,
	// 574
	0.563694f, 0.329328f,
	0.803356f, 0.077305f, -0.590460f,
	0.149772f, 0.868205f, -0.066930f,
	31.000000f,
	// 575
	0.579073f, 0.324094f,
	0.648818f, 0.058914f, -0.758659f,
	0.139906f, 0.865509f, -0.076775f,
	31.000000f,
	// 576
	0.552793f, 0.259108f,
	0.670306f, -0.230499f, -0.705380f,
	0.126464f, 0.736838f, -0.071723f,
	7.000000f,
	// 577
	0.567322f, 0.291993f,
	0.688496f, -0.128238f, -0.713812f,
	0.137984f, 0.809381f, -0.076524f,
	7.000000f,
	// 578
	0.557191f, 0.302306f,
	0.791290f, -0.041142f, -0.610055f,
	0.145422f, 0.825360f, -0.068561f,
	7.000000f,
	// 579
	0.547444f, 0.296040f,
	0.712543f, -0.059111f, -0.699134f,
	0.147858f, 0.796815f, -0.064153f,
	7.000000f,
	// 580
	0.629479f, 0.302742f,
	0.484327f, 0.063643f, -0.872569f,
	0.107384f, 0.857589f, -0.097675f,
	31.000000f,
	// 581
	0.599753f, 0.315287f,
	0.536938f, 0.069876f, -0.840723f,
	0.127687f, 0.864584f, -0.085893f,
	31.000000f,
	// 582
	0.586039f, 0.291073f,
	0.552640f, -0.038812f, -0.832516f,
	0.128250f, 0.822464f, -0.083306f,
	7.000000f,
	// 583
	0.591321f, 0.278338f,
	0.683469f, -0.057867f, -0.727682f,
	0.121856f, 0.793195f, -0.086963f,
	7.000000f,
	// 584
	0.606285f, 0.354740f,
	0.504009f, 0.182749f, -0.844143f,
	0.125005f, 0.900922f, -0.080299f,
	45.000000f,
	// 585
	0.623067f, 0.373782f,
	0.477260f, 0.214019f, -0.852302f,
	0.113294f, 0.922828f, -0.081672f,
	45.000000f,
	// 586
	0.680117f, 0.427228f,
	0.229856f, 0.331612f, -0.914986f,
	0.059673f, 0.985686f, -0.088916f,
	1.000000f,
	// 587
	0.645225f, 0.434476f,
	0.429945f, 0.304350f, -0.850011f,
	0.091953f, 0.987902f, -0.075103f,
	1.000000f,
	// 588
	0.641756f, 0.392883f,
	0.429844f, 0.232495f, -0.872457f,
	0.097383f, 0.944936f, -0.084469f,
	45.000000f,
	// 589
	0.653811f, 0.365867f,
	0.409351f, 0.212512f, -0.887282f,
	0.087201f, 0.921372f, -0.094517f,
	45.000000f,
	// 590
	0.645937f, 0.464994f,
	0.433421f, 0.412626f, -0.801178f,
	0.087845f, 1.025201f, -0.061054f,
	1.000000f,
	// 591
	0.660153f, 0.474527f,
	0.315535f, 0.454595f, -0.832935f,
	0.073047f, 1.040432f, -0.059174f,
	1.000000f,
	// 592
	0.669030f, 0.487017f,
	0.236265f, 0.476461f, -0.846855f,
	0.062032f, 1.053041f, -0.055881f,
	1.000000f,
	// 593
	0.663024f, 0.514954f,
	0.376640f, 0.449033f, -0.810254f,
	0.062368f, 1.084884f, -0.038077f,
	1.000000f,
	// 594
	0.681713f, 0.480033f,
	0.078933f, 0.435017f, -0.896956f,
	0.050557f, 1.040708f, -0.064333f,
	1.000000f,
	// 595
	0.682101f, 0.514954f,
	0.065894f, 0.474517f, -0.877776f,
	0.042959f, 1.077171f, -0.045305f,
	1.000000f,
	// 596
	0.695339f, 0.487017f,
	-0.012210f, 0.452328f, -0.891768f,
	0.035049f, 1.044803f, -0.062086f,
	1.000000f,
	// 597
	0.702488f, 0.514954f,
	-0.034469f, 0.455365f, -0.889637f,
	0.021893f, 1.072528f, -0.047385f,
	1.000000f,
	// 598
	0.702430f, 0.472707f,
	0.063031f, 0.474226f, -0.878144f,
	0.029216f, 1.029840f, -0.069832f,
	1.000000f,
	// 599
	0.723530f, 0.514954f,
	-0.019151f, 0.469663f, -0.882638f,
	-0.000007f, 1.070970f, -0.046964f,
	1.000000f,
	// 600
	0.457307f, 0.318876f,
	0.986924f, -0.152616f, -0.051862f,
	0.154763f, 0.730170f, 0.004499f,
	7.000000f,
	// 601
	0.502579f, 0.326549f,
	0.999387f, -0.034516f, -0.005816f,
	0.162016f, 0.797577f, -0.023651f,
	7.000000f,
	// 602
	0.503228f, 0.343015f,
	0.998552f, -0.007978f, -0.053192f,
	0.162320f, 0.828407f, -0.018641f,
	7.000000f,
	// 603
	0.482085f, 0.348362f,
	0.996527f, -0.062450f, 0.055090f,
	0.162898f, 0.814396f, -0.002600f,
	7.000000f,
	// 604
	0.525507f, 0.362622f,
	0.988291f, 0.125735f, -0.086442f,
	0.162425f, 0.872275f, -0.025523f,
	31.000000f,
	// 605
	0.506862f, 0.377848f,
	0.992758f, 0.107102f, 0.054409f,
	0.161942f, 0.872674f, -0.005971f,
	31.000000f,
	// 606
	0.546875f, 0.429797f,
	0.970115f, 0.239403f, 0.039530f,
	0.151845f, 0.919863f, -0.001750f,
	1.000000f,
	// 607
	0.546422f, 0.397305f,
	0.966849f, 0.238131f, -0.092174f,
	0.154402f, 0.907910f, -0.018452f,
	1.000000f,
	// 608
	0.726136f, 0.286706f,
	-0.007623f, 0.114935f, -0.993344f,
	-0.000018f, 0.859958f, -0.125820f,
	40.000000f,
	// 609
	0.689962f, 0.258303f,
	0.206412f, -0.024462f, -0.978159f,
	0.030548f, 0.791228f, -0.123983f,
	7.000000f,
	// 610
	0.692396f, 0.255588f,
	0.097690f, -0.154428f, -0.983163f,
	0.019866f, 0.763442f, -0.125465f,
	44.000000f,
	// 611
	0.709878f, 0.271711f,
	0.000006f, -0.062959f, -0.998016f,
	-0.000001f, 0.777293f, -0.126078f,
	42.000000f,
	// 612
	0.655251f, 0.229698f,
	0.265968f, -0.157662f, -0.951001f,
	0.053424f, 0.740431f, -0.112792f,
	39.000000f,
	// 613
	0.675526f, 0.240029f,
	0.109147f, -0.310885f, -0.944160f,
	0.027879f, 0.740807f, -0.117086f,
	48.000000f,
	// 614
	0.693620f, 0.256717f,
	-0.000000f, -0.281360f, -0.959602f,
	0.000000f, 0.740906f, -0.118219f,
	41.000000f,
	// 615
	0.665479f, 0.263787f,
	0.300767f, -0.084258f, -0.949968f,
	0.062286f, 0.805699f, -0.118570f,
	7.000000f,
	// 616
	0.652523f, 0.271549f,
	0.406109f, -0.020733f, -0.913589f,
	0.078226f, 0.820327f, -0.112006f,
	7.000000f,
	// 617
	0.643277f, 0.261944f,
	0.333099f, -0.032055f, -0.942347f,
	0.083189f, 0.792660f, -0.109297f,
	7.000000f,
	// 618
	0.670615f, 0.299878f,
	0.273761f, 0.098181f, -0.956773f,
	0.065358f, 0.860217f, -0.116892f,
	31.000000f,
	// 619
	0.653263f, 0.300917f,
	0.417585f, 0.100200f, -0.903096f,
	0.085279f, 0.861682f, -0.109548f,
	31.000000f,
	// 620
	0.660392f, 0.340816f,
	0.407449f, 0.203639f, -0.890234f,
	0.080498f, 0.897863f, -0.103593f,
	45.000000f,
	// 621
	0.675316f, 0.350371f,
	0.266657f, 0.223900f, -0.937424f,
	0.064101f, 0.908708f, -0.107418f,
	45.000000f,
	// 622
	0.702402f, 0.359081f,
	0.125486f, 0.223261f, -0.966648f,
	0.031447f, 0.919644f, -0.110201f,
	45.000000f,
	// 623
	0.691752f, 0.336844f,
	0.145379f, 0.211326f, -0.966543f,
	0.043976f, 0.896717f, -0.113819f,
	45.000000f,
	// 624
	0.692462f, 0.295952f,
	0.142151f, 0.106008f, -0.984152f,
	0.039627f, 0.860250f, -0.122331f,
	31.000000f,
	// 625
	0.710679f, 0.381630f,
	0.076342f, 0.254390f, -0.964084f,
	0.020453f, 0.942609f, -0.106299f,
	45.000000f,
	// 626
	0.706597f, 0.424381f,
	0.062755f, 0.356559f, -0.932163f,
	0.025567f, 0.984079f, -0.093715f,
	1.000000f,
	// 627
	0.725498f, 0.356872f,
	-0.028319f, 0.242328f, -0.969781f,
	-0.000021f, 0.930854f, -0.109718f,
	1.000000f,
	// 628
	0.724859f, 0.427039f,
	-0.028174f, 0.355138f, -0.934389f,
	-0.000025f, 0.982627f, -0.094337f,
	1.000000f,
	// 629
	0.724195f, 0.470996f,
	-0.027380f, 0.475849f, -0.879101f,
	-0.000020f, 1.022321f, -0.075423f,
	1.000000f,
	// 630
	0.709810f, 0.457712f,
	0.057628f, 0.464822f, -0.883527f,
	0.020454f, 1.015782f, -0.078863f,
	1.000000f,
	// 631
	0.859493f, 0.322382f,
	0.790827f, 0.049172f, 0.610062f,
	0.138329f, 0.872120f, 0.083673f,
	31.000000f,
	// 632
	0.869422f, 0.285201f,
	0.801892f, -0.088101f, 0.590937f,
	0.138738f, 0.813946f, 0.082155f,
	7.000000f,
	// 633
	0.883811f, 0.297962f,
	0.911620f, -0.014928f, 0.410764f,
	0.145162f, 0.830254f, 0.069386f,
	7.000000f,
	// 634
	0.879844f, 0.329409f,
	0.919736f, 0.057873f, 0.388248f,
	0.147417f, 0.874601f, 0.067270f,
	31.000000f,
	// 635
	0.846090f, 0.246280f,
	0.680976f, -0.156764f, 0.715330f,
	0.132045f, 0.724137f, 0.073454f,
	7.000000f,
	// 636
	0.873091f, 0.290875f,
	0.823562f, -0.010368f, 0.567131f,
	0.148371f, 0.799964f, 0.062552f,
	7.000000f,
	// 637
	0.894139f, 0.339665f,
	0.968754f, 0.084331f, 0.233245f,
	0.154928f, 0.869756f, 0.043354f,
	31.000000f,
	// 638
	0.852797f, 0.285250f,
	0.625195f, -0.041107f, 0.779385f,
	0.126292f, 0.826923f, 0.093674f,
	7.000000f,
	// 639
	0.847547f, 0.271036f,
	0.641894f, -0.069742f, 0.763615f,
	0.119984f, 0.795799f, 0.097024f,
	7.000000f,
	// 640
	0.841076f, 0.313519f,
	0.606404f, 0.047803f, 0.793718f,
	0.123149f, 0.870437f, 0.098508f,
	31.000000f,
	// 641
	0.832331f, 0.355707f,
	0.490869f, 0.230239f, 0.840261f,
	0.120635f, 0.925360f, 0.091786f,
	1.000000f,
	// 642
	0.843839f, 0.373272f,
	0.752982f, 0.267664f, 0.601144f,
	0.131114f, 0.938366f, 0.078803f,
	1.000000f,
	// 643
	0.862932f, 0.395682f,
	0.954465f, 0.279896f, 0.103225f,
	0.138342f, 0.931485f, 0.055179f,
	1.000000f,
	// 644
	0.863345f, 0.368419f,
	0.939338f, 0.253501f, 0.231044f,
	0.140049f, 0.928692f, 0.066796f,
	1.000000f,
	// 645
	0.860209f, 0.424013f,
	0.937884f, 0.247950f, 0.242682f,
	0.137059f, 0.952842f, 0.040739f,
	1.000000f,
	// 646
	0.880937f, 0.409339f,
	0.957163f, 0.226040f, 0.180954f,
	0.145173f, 0.931433f, 0.026834f,
	1.000000f,
	// 647
	0.900731f, 0.395304f,
	0.966637f, 0.212548f, 0.142958f,
	0.152339f, 0.909836f, 0.013802f,
	1.000000f,
	// 648
	0.895919f, 0.424810f,
	0.970115f, 0.239403f, 0.039530f,
	0.151845f, 0.919863f, -0.001750f,
	1.000000f,
	// 649
	0.923653f, 0.359309f,
	0.983420f, 0.116255f, 0.139175f,
	0.159846f, 0.874682f, 0.014795f,
	31.000000f,
	// 650
	0.939384f, 0.367873f,
	0.992758f, 0.107102f, 0.054409f,
	0.161942f, 0.872674f, -0.005971f,
	31.000000f,
	// 651
	0.982677f, 0.309128f,
	0.986924f, -0.152616f, -0.051862f,
	0.154763f, 0.730170f, 0.004499f,
	7.000000f,
	// 652
	0.961031f, 0.338501f,
	0.996527f, -0.062450f, 0.055090f,
	0.162898f, 0.814396f, -0.002600f,
	7.000000f,
	// 653
	0.944139f, 0.337765f,
	0.991703f, 0.010936f, 0.128084f,
	0.160315f, 0.830333f, 0.012709f,
	7.000000f,
	// 654
	0.946517f, 0.322710f,
	0.999955f, 0.002379f, -0.009144f,
	0.160238f, 0.799983f, 0.023648f,
	7.000000f,
	// 655
	0.796499f, 0.228473f,
	0.233185f, -0.281494f, 0.930798f,
	0.075008f, 0.722005f, 0.097825f,
	7.000000f,
	// 656
	0.803437f, 0.251701f,
	0.233416f, -0.189252f, 0.953782f,
	0.085243f, 0.766078f, 0.108590f,
	7.000000f,
	// 657
	0.825315f, 0.233405f,
	0.325867f, -0.281308f, 0.902594f,
	0.096845f, 0.722594f, 0.091085f,
	7.000000f,
	// 658
	0.821919f, 0.260374f,
	0.330873f, -0.133441f, 0.934193f,
	0.100017f, 0.780588f, 0.105185f,
	7.000000f,
	// 659
	0.760862f, 0.256719f,
	0.040400f, -0.167375f, 0.985065f,
	0.034907f, 0.764172f, 0.115098f,
	7.000000f,
	// 660
	0.756737f, 0.239236f,
	0.021399f, -0.259235f, 0.965577f,
	0.025972f, 0.721479f, 0.103834f,
	44.000000f,
	// 661
	0.773291f, 0.261774f,
	0.830459f, -0.144267f, 0.538075f,
	0.143171f, 0.725283f, 0.060347f,
	7.000000f,
	// 662
	0.818979f, 0.286613f,
	0.861762f, -0.067361f, 0.502821f,
	0.152687f, 0.769409f, 0.057492f,
	7.000000f,
	// 663
	0.667590f, 0.280875f,
	0.937932f, -0.163827f, 0.305685f,
	0.150396f, 0.726684f, 0.044341f,
	7.000000f,
	// 664
	0.768761f, 0.303962f,
	0.949813f, -0.001596f, 0.312814f,
	0.156966f, 0.784753f, 0.045497f,
	7.000000f,
	// 665
	0.483641f, 0.301811f,
	0.916331f, -0.322721f, -0.237042f,
	0.150418f, 0.732278f, -0.019596f,
	7.000000f,
	// 666
	0.504266f, 0.311981f,
	0.959768f, -0.176980f, -0.217998f,
	0.159857f, 0.767484f, -0.031043f,
	7.000000f,
	// 667
	0.508574f, 0.285654f,
	0.882087f, -0.326401f, -0.339684f,
	0.143611f, 0.734250f, -0.042143f,
	7.000000f,
	// 668
	0.523849f, 0.305174f,
	0.936995f, -0.103665f, -0.333608f,
	0.155366f, 0.782346f, -0.047442f,
	7.000000f,
	// 669
	0.577610f, 0.249351f,
	0.515536f, -0.310330f, -0.798698f,
	0.111011f, 0.737847f, -0.083250f,
	7.000000f,
	// 670
	0.595759f, 0.265775f,
	0.572979f, -0.156673f, -0.804455f,
	0.114602f, 0.764588f, -0.091322f,
	7.000000f,
	// 671
	0.603951f, 0.240768f,
	0.474865f, -0.287431f, -0.831797f,
	0.092747f, 0.738783f, -0.093955f,
	7.000000f,
	// 672
	0.615676f, 0.264870f,
	0.497646f, -0.072847f, -0.864316f,
	0.102192f, 0.778726f, -0.098558f,
	7.000000f,
	// 673
	0.630612f, 0.232081f,
	0.389985f, -0.293132f, -0.872918f,
	0.074299f, 0.739701f, -0.104442f,
	7.000000f,
	// 674
	0.631094f, 0.254262f,
	0.451128f, -0.160968f, -0.877823f,
	0.088441f, 0.764588f, -0.106481f,
	7.000000f,
	// 675
	0.530702f, 0.271314f,
	0.792288f, -0.339896f, -0.506705f,
	0.136478f, 0.735705f, -0.058769f,
	7.000000f,
	// 676
	0.535640f, 0.291650f,
	0.836591f, -0.189856f, -0.513878f,
	0.149923f, 0.767484f, -0.059065f,
	7.000000f,
	// 677
	0.562337f, 0.299896f,
	0.981642f, -0.165555f, 0.094708f,
	0.154508f, 0.728309f, 0.025768f,
	7.000000f,
	// 678
	0.678343f, 0.312028f,
	0.989526f, -0.069020f, 0.126783f,
	0.160765f, 0.769409f, 0.032757f,
	7.000000f,
	// 679
	0.683831f, 0.327584f,
	0.999955f, 0.002379f, -0.009144f,
	0.160238f, 0.799983f, 0.023648f,
	7.000000f,
	// 680
	0.852638f, 0.238082f,
	0.451437f, -0.277965f, 0.847903f,
	0.116230f, 0.723273f, 0.083331f,
	7.000000f,
	// 681
	0.840863f, 0.258107f,
	0.486344f, -0.173073f, 0.856455f,
	0.114619f, 0.766078f, 0.098222f,
	7.000000f,
	// 682
	0.683882f, 0.267576f,
	0.154349f, -0.006827f, -0.987993f,
	0.042729f, 0.819181f, -0.121945f,
	7.000000f,
	// 683
	0.789672f, 0.515204f,
	-0.753089f, 0.347438f, 0.558698f,
	-0.077780f, 1.086154f, 0.072003f,
	1.000000f,
	// 684
	0.811609f, 0.515204f,
	-0.876965f, 0.380889f, 0.293011f,
	-0.086612f, 1.090379f, 0.049422f,
	1.000000f,
	// 685
	0.825224f, 0.504051f,
	-0.890409f, 0.395474f, 0.225329f,
	-0.102630f, 1.058739f, 0.042612f,
	1.000000f,
	// 686
	0.821396f, 0.496163f,
	-0.883807f, 0.385849f, 0.264586f,
	-0.107254f, 1.041505f, 0.052254f,
	1.000000f,
	// 687
	0.834856f, 0.515204f,
	-0.916130f, 0.400717f, 0.011463f,
	-0.089917f, 1.093415f, 0.023023f,
	1.000000f,
	// 688
	0.843655f, 0.498475f,
	-0.923112f, 0.383844f, 0.022969f,
	-0.111681f, 1.043941f, 0.023655f,
	1.000000f,
	// 689
	0.852453f, 0.481746f,
	-0.949310f, 0.309112f, 0.057089f,
	-0.133146f, 0.988473f, 0.027908f,
	1.000000f,
	// 690
	0.837506f, 0.460853f,
	-0.904172f, 0.301317f, 0.302788f,
	-0.125659f, 0.992170f, 0.056286f,
	1.000000f,
	// 691
	0.819544f, 0.483651f,
	-0.876177f, 0.352039f, 0.329214f,
	-0.111526f, 1.025548f, 0.061283f,
	1.000000f,
	// 692
	0.822763f, 0.438226f,
	-0.751751f, 0.248083f, 0.611004f,
	-0.118376f, 0.980828f, 0.079413f,
	1.000000f,
	// 693
	0.805561f, 0.480388f,
	-0.754898f, 0.340203f, 0.560706f,
	-0.100947f, 1.032743f, 0.076031f,
	1.000000f,
	// 694
	0.783247f, 0.431030f,
	-0.427334f, 0.157973f, 0.890185f,
	-0.075593f, 0.987292f, 0.107507f,
	1.000000f,
	// 695
	0.785741f, 0.477466f,
	-0.517594f, 0.280090f, 0.808484f,
	-0.079532f, 1.038419f, 0.091780f,
	1.000000f,
	// 696
	0.796521f, 0.468693f,
	-0.588900f, 0.265448f, 0.763370f,
	-0.092348f, 1.024237f, 0.087983f,
	1.000000f,
	// 697
	0.800973f, 0.438978f,
	-0.558461f, 0.174342f, 0.811003f,
	-0.096873f, 0.989692f, 0.094530f,
	1.000000f,
	// 698
	0.818408f, 0.376052f,
	-0.200590f, 0.260268f, 0.944470f,
	-0.109114f, 0.926791f, 0.099297f,
	1.000000f,
	// 699
	0.806171f, 0.396344f,
	-0.454940f, 0.193219f, 0.869308f,
	-0.098294f, 0.923305f, 0.102321f,
	1.000000f,
	// 700
	0.816742f, 0.301898f,
	-0.352434f, -0.013059f, 0.935745f,
	-0.098627f, 0.861527f, 0.114783f,
	37.000000f,
	// 701
	0.799201f, 0.368403f,
	-0.541423f, 0.148113f, 0.827601f,
	-0.087178f, 0.924483f, 0.112124f,
	1.000000f,
	// 702
	0.766825f, 0.301494f,
	-0.118112f, -0.046990f, 0.991888f,
	-0.047584f, 0.866993f, 0.124239f,
	37.000000f,
	// 703
	0.777683f, 0.363476f,
	-0.131919f, 0.092251f, 0.986959f,
	-0.064143f, 0.922115f, 0.118060f,
	1.000000f,
	// 704
	0.789937f, 0.342238f,
	-0.214731f, 0.120392f, 0.969225f,
	-0.075257f, 0.921520f, 0.117938f,
	1.000000f,
	// 705
	0.790205f, 0.300791f,
	-0.178699f, -0.040397f, 0.983074f,
	-0.073122f, 0.864233f, 0.120643f,
	37.000000f,
	// 706
	0.793036f, 0.261089f,
	-0.078697f, -0.112277f, 0.990556f,
	-0.075670f, 0.794632f, 0.113261f,
	3.000000f,
	// 707
	0.784455f, 0.271085f,
	-0.156390f, -0.099221f, 0.982699f,
	-0.066665f, 0.822222f, 0.116609f,
	3.000000f,
	// 708
	0.771778f, 0.228634f,
	-0.122501f, -0.238457f, 0.963396f,
	-0.051217f, 0.721600f, 0.102444f,
	3.000000f,
	// 709
	0.770342f, 0.260726f,
	-0.220679f, -0.142774f, 0.964840f,
	-0.051571f, 0.792719f, 0.116419f,
	3.000000f,
	// 710
	0.746537f, 0.255060f,
	0.000058f, -0.206229f, 0.978504f,
	-0.000000f, 0.721489f, 0.103722f,
	41.000000f,
	// 711
	0.736336f, 0.270883f,
	0.000255f, -0.166406f, 0.986057f,
	-0.000000f, 0.805361f, 0.118754f,
	42.000000f,
	// 712
	0.747262f, 0.277817f,
	-0.030831f, -0.130593f, 0.990957f,
	-0.016398f, 0.819577f, 0.119429f,
	46.000000f,
	// 713
	0.755944f, 0.270320f,
	0.094812f, -0.108308f, 0.989586f,
	-0.025124f, 0.792057f, 0.117004f,
	46.000000f,
	// 714
	0.726136f, 0.286706f,
	0.000267f, -0.101673f, 0.994818f,
	-0.000000f, 0.859699f, 0.126431f,
	42.000000f,
	// 715
	0.745549f, 0.296351f,
	-0.061017f, -0.107785f, 0.992300f,
	-0.021089f, 0.860720f, 0.126124f,
	37.000000f,
	// 716
	0.723804f, 0.409193f,
	0.002812f, 0.087149f, 0.996191f,
	0.000001f, 0.973807f, 0.127366f,
	1.000000f,
	// 717
	0.745260f, 0.350988f,
	-0.091286f, 0.010593f, 0.995768f,
	-0.023837f, 0.920418f, 0.127278f,
	1.000000f,
	// 718
	0.739685f, 0.329195f,
	-0.053459f, -0.018957f, 0.998390f,
	-0.016871f, 0.897009f, 0.127766f,
	1.000000f,
	// 719
	0.724970f, 0.347949f,
	0.000268f, -0.002234f, 0.999997f,
	-0.000000f, 0.908239f, 0.128311f,
	1.000000f,
	// 720
	0.722750f, 0.515204f,
	0.004897f, 0.285450f, 0.958381f,
	-0.000004f, 1.073321f, 0.102984f,
	1.000000f,
	// 721
	0.737656f, 0.467019f,
	-0.155255f, 0.268280f, 0.950748f,
	-0.017747f, 1.031136f, 0.114431f,
	1.000000f,
	// 722
	0.732983f, 0.448387f,
	-0.109462f, 0.225386f, 0.968101f,
	-0.010995f, 1.016845f, 0.119611f,
	1.000000f,
	// 723
	0.723277f, 0.462198f,
	0.003763f, 0.258673f, 0.965958f,
	0.000000f, 1.023705f, 0.118432f,
	1.000000f,
	// 724
	0.751690f, 0.425053f,
	-0.227151f, 0.156919f, 0.961134f,
	-0.033709f, 0.991764f, 0.120536f,
	1.000000f,
	// 725
	0.739405f, 0.413056f,
	-0.132738f, 0.131691f, 0.982363f,
	-0.017961f, 0.984721f, 0.124901f,
	1.000000f,
	// 726
	0.748437f, 0.373880f,
	-0.158726f, 0.052390f, 0.985932f,
	-0.027865f, 0.943532f, 0.126393f,
	1.000000f,
	// 727
	0.759561f, 0.367359f,
	-0.249448f, 0.044343f, 0.967372f,
	-0.041259f, 0.932362f, 0.123956f,
	1.000000f,
	// 728
	0.768297f, 0.383107f,
	-0.293004f, 0.078761f, 0.952862f,
	-0.053575f, 0.944361f, 0.119631f,
	1.000000f,
	// 729
	0.766696f, 0.424590f,
	-0.305011f, 0.125791f, 0.944005f,
	-0.054102f, 0.986181f, 0.115722f,
	1.000000f,
	// 730
	0.752487f, 0.469326f,
	-0.213213f, 0.248543f, 0.944863f,
	-0.040191f, 1.033036f, 0.109835f,
	1.000000f,
	// 731
	0.762709f, 0.457614f,
	-0.308252f, 0.216769f, 0.926279f,
	-0.052721f, 1.019368f, 0.109944f,
	1.000000f,
	// 732
	0.753149f, 0.515204f,
	-0.297545f, 0.279485f, 0.912883f,
	-0.046061f, 1.077620f, 0.095058f,
	1.000000f,
	// 733
	0.768284f, 0.474696f,
	-0.394827f, 0.250245f, 0.884019f,
	-0.061589f, 1.034910f, 0.102366f,
	1.000000f,
	// 734
	0.774697f, 0.489094f,
	-0.471547f, 0.292804f, 0.831811f,
	-0.068457f, 1.051636f, 0.093913f,
	1.000000f,
	// 735
	0.770354f, 0.515204f,
	-0.537608f, 0.278530f, 0.795863f,
	-0.064121f, 1.081691f, 0.086324f,
	1.000000f,
	// 736
	0.737549f, 0.515204f,
	-0.141327f, 0.275743f, 0.950785f,
	-0.024024f, 1.074570f, 0.100874f,
	1.000000f,
	// 737
	0.742497f, 0.483723f,
	-0.153760f, 0.276157f, 0.948733f,
	-0.027011f, 1.046202f, 0.108657f,
	1.000000f,
	// 738
	0.645177f, 0.514954f,
	-0.676507f, 0.451339f, -0.581921f,
	-0.077824f, 1.091863f, -0.024133f,
	1.000000f,
	// 739
	0.631437f, 0.480440f,
	-0.708189f, 0.406969f, -0.576927f,
	-0.097241f, 1.042517f, -0.038360f,
	1.000000f,
	// 740
	0.623040f, 0.492930f,
	-0.858812f, 0.414576f, -0.300947f,
	-0.098494f, 1.059974f, -0.018760f,
	1.000000f,
	// 741
	0.628475f, 0.514954f,
	-0.892112f, 0.398291f, -0.213309f,
	-0.086992f, 1.094311f, -0.002752f,
	1.000000f,
	// 742
	0.611893f, 0.440321f,
	-0.784894f, 0.318639f, -0.531423f,
	-0.119390f, 0.984538f, -0.047595f,
	1.000000f,
	// 743
	0.612839f, 0.484657f,
	-0.903005f, 0.376757f, -0.206488f,
	-0.107356f, 1.043210f, -0.011629f,
	1.000000f,
	// 744
	0.612348f, 0.514954f,
	-0.916130f, 0.400717f, 0.011463f,
	-0.089917f, 1.093415f, 0.023023f,
	1.000000f,
	// 745
	0.603802f, 0.481861f,
	-0.920594f, 0.359797f, -0.151828f,
	-0.116398f, 1.027082f, 0.000309f,
	1.000000f,
	// 746
	0.599618f, 0.498350f,
	-0.923112f, 0.383844f, 0.022969f,
	-0.111681f, 1.043941f, 0.023655f,
	1.000000f,
	// 747
	0.596096f, 0.458368f,
	-0.926871f, 0.324699f, -0.188366f,
	-0.128042f, 0.990792f, -0.009881f,
	1.000000f,
	// 748
	0.586889f, 0.481746f,
	-0.949310f, 0.309112f, 0.057089f,
	-0.133146f, 0.988473f, 0.027908f,
	1.000000f,
	// 749
	0.544857f, 0.337779f,
	-0.962321f, 0.094741f, -0.254876f,
	-0.159281f, 0.864237f, -0.031390f,
	37.000000f,
	// 750
	0.565088f, 0.408089f,
	-0.956544f, 0.262586f, -0.126779f,
	-0.147769f, 0.928450f, -0.004304f,
	1.000000f,
	// 751
	0.581524f, 0.420983f,
	-0.937804f, 0.290102f, -0.190696f,
	-0.139607f, 0.949325f, -0.018045f,
	1.000000f,
	// 752
	0.579161f, 0.392040f,
	-0.918096f, 0.264434f, -0.295254f,
	-0.141715f, 0.926101f, -0.038011f,
	1.000000f,
	// 753
	0.592630f, 0.371577f,
	-0.728630f, 0.241144f, -0.641052f,
	-0.133855f, 0.912070f, -0.060763f,
	47.000000f,
	// 754
	0.577438f, 0.365972f,
	-0.866530f, 0.221801f, -0.447135f,
	-0.143095f, 0.902561f, -0.050871f,
	1.000000f,
	// 755
	0.579072f, 0.324094f,
	-0.762152f, 0.092698f, -0.640728f,
	-0.140564f, 0.863875f, -0.067458f,
	37.000000f,
	// 756
	0.563694f, 0.329328f,
	-0.876848f, 0.095848f, -0.471117f,
	-0.150209f, 0.866906f, -0.053317f,
	37.000000f,
	// 757
	0.552793f, 0.259108f,
	-0.706251f, -0.171664f, -0.686834f,
	-0.126464f, 0.736838f, -0.071723f,
	3.000000f,
	// 758
	0.547444f, 0.296040f,
	-0.794181f, -0.011902f, -0.607564f,
	-0.147969f, 0.796299f, -0.055020f,
	3.000000f,
	// 759
	0.557191f, 0.302306f,
	-0.870720f, -0.016243f, -0.491511f,
	-0.145745f, 0.824376f, -0.058794f,
	3.000000f,
	// 760
	0.567322f, 0.291993f,
	-0.789590f, -0.092569f, -0.606613f,
	-0.138430f, 0.808250f, -0.070763f,
	3.000000f,
	// 761
	0.629479f, 0.302742f,
	-0.542955f, 0.089524f, -0.834976f,
	-0.108125f, 0.855862f, -0.094493f,
	37.000000f,
	// 762
	0.591321f, 0.278338f,
	-0.709145f, -0.035070f, -0.704190f,
	-0.122291f, 0.792160f, -0.084970f,
	3.000000f,
	// 763
	0.586039f, 0.291073f,
	-0.647200f, -0.002784f, -0.762315f,
	-0.128832f, 0.821065f, -0.079252f,
	3.000000f,
	// 764
	0.599753f, 0.315287f,
	-0.630198f, 0.110706f, -0.768501f,
	-0.128458f, 0.862767f, -0.079628f,
	37.000000f,
	// 765
	0.606285f, 0.354740f,
	-0.607389f, 0.213341f, -0.765222f,
	-0.125694f, 0.899250f, -0.071920f,
	47.000000f,
	// 766
	0.623067f, 0.373782f,
	-0.564471f, 0.239107f, -0.790063f,
	-0.113874f, 0.921385f, -0.074078f,
	47.000000f,
	// 767
	0.680117f, 0.427228f,
	-0.291059f, 0.327691f, -0.898835f,
	-0.059903f, 0.984937f, -0.085764f,
	1.000000f,
	// 768
	0.653811f, 0.365867f,
	-0.487112f, 0.237984f, -0.840289f,
	-0.087727f, 0.920025f, -0.090756f,
	47.000000f,
	// 769
	0.641756f, 0.392883f,
	-0.517919f, 0.254901f, -0.816569f,
	-0.097850f, 0.943706f, -0.078118f,
	47.000000f,
	// 770
	0.645225f, 0.434476f,
	-0.519514f, 0.289112f, -0.804064f,
	-0.092240f, 0.987050f, -0.068166f,
	1.000000f,
	// 771
	0.645937f, 0.464994f,
	-0.521509f, 0.361922f, -0.772684f,
	-0.088016f, 1.024658f, -0.055690f,
	1.000000f,
	// 772
	0.660153f, 0.474527f,
	-0.387749f, 0.412087f, -0.824521f,
	-0.073174f, 1.040022f, -0.056562f,
	1.000000f,
	// 773
	0.663024f, 0.514954f,
	-0.370408f, 0.430388f, -0.823143f,
	-0.062399f, 1.084868f, -0.037351f,
	1.000000f,
	// 774
	0.669030f, 0.487017f,
	-0.251860f, 0.450041f, -0.856755f,
	-0.062131f, 1.052757f, -0.054261f,
	1.000000f,
	// 775
	0.682101f, 0.514954f,
	-0.073845f, 0.453931f, -0.887971f,
	-0.043002f, 1.077144f, -0.044254f,
	1.000000f,
	// 776
	0.681713f, 0.480033f,
	-0.086529f, 0.416860f, -0.904843f,
	-0.050680f, 1.040352f, -0.062329f,
	1.000000f,
	// 777
	0.702488f, 0.514954f,
	0.008577f, 0.438835f, -0.898527f,
	-0.021922f, 1.072510f, -0.046689f,
	1.000000f,
	// 778
	0.695339f, 0.487017f,
	-0.014980f, 0.438247f, -0.898730f,
	-0.035147f, 1.044518f, -0.060486f,
	1.000000f,
	// 779
	0.723530f, 0.514954f,
	-0.019151f, 0.469663f, -0.882638f,
	-0.000007f, 1.070970f, -0.046964f,
	1.000000f,
	// 780
	0.702430f, 0.472707f,
	-0.104456f, 0.466904f, -0.878117f,
	-0.029319f, 1.029496f, -0.068296f,
	1.000000f,
	// 781
	0.457307f, 0.318876f,
	-0.987644f, -0.147827f, -0.052030f,
	-0.154763f, 0.730169f, 0.004499f,
	3.000000f,
	// 782
	0.482085f, 0.348362f,
	-0.993643f, -0.070910f, 0.087435f,
	-0.162615f, 0.814452f, 0.011510f,
	3.000000f,
	// 783
	0.503228f, 0.343015f,
	-0.999169f, -0.001083f, -0.040740f,
	-0.162156f, 0.828229f, -0.003098f,
	3.000000f,
	// 784
	0.502579f, 0.326549f,
	-0.999388f, -0.034923f, 0.002159f,
	-0.162005f, 0.797262f, -0.013074f,
	3.000000f,
	// 785
	0.506862f, 0.377848f,
	-0.992530f, 0.102007f, 0.066921f,
	-0.161513f, 0.872784f, 0.015963f,
	37.000000f,
	// 786
	0.525507f, 0.362622f,
	-0.989631f, 0.128191f, -0.064785f,
	-0.162192f, 0.872070f, -0.003871f,
	37.000000f,
	// 787
	0.546422f, 0.397305f,
	-0.969897f, 0.233537f, -0.068992f,
	-0.154148f, 0.907801f, 0.004191f,
	1.000000f,
	// 788
	0.546875f, 0.429797f,
	-0.969840f, 0.237599f, 0.054381f,
	-0.151448f, 0.920005f, 0.021083f,
	1.000000f,
	// 789
	0.726136f, 0.286706f,
	-0.007623f, 0.114935f, -0.993344f,
	-0.000018f, 0.859958f, -0.125820f,
	40.000000f,
	// 790
	0.709878f, 0.271711f,
	0.000006f, -0.062959f, -0.998016f,
	-0.000001f, 0.777293f, -0.126078f,
	42.000000f,
	// 791
	0.692396f, 0.255588f,
	-0.097846f, -0.154274f, -0.983171f,
	-0.019868f, 0.763442f, -0.125465f,
	46.000000f,
	// 792
	0.689962f, 0.258303f,
	-0.207878f, -0.023757f, -0.977866f,
	-0.030584f, 0.791146f, -0.123953f,
	3.000000f,
	// 793
	0.693620f, 0.256717f,
	-0.000000f, -0.281360f, -0.959602f,
	0.000000f, 0.740906f, -0.118219f,
	41.000000f,
	// 794
	0.675526f, 0.240029f,
	-0.109143f, -0.310896f, -0.944156f,
	-0.027879f, 0.740807f, -0.117086f,
	49.000000f,
	// 795
	0.655251f, 0.229698f,
	-0.273395f, -0.149712f, -0.950180f,
	-0.053424f, 0.740431f, -0.112792f,
	43.000000f,
	// 796
	0.643277f, 0.261944f,
	-0.361857f, -0.024779f, -0.931904f,
	-0.083583f, 0.791722f, -0.108043f,
	3.000000f,
	// 797
	0.652523f, 0.271549f,
	-0.439483f, -0.017368f, -0.898083f,
	-0.078646f, 0.819314f, -0.110907f,
	3.000000f,
	// 798
	0.665479f, 0.263787f,
	-0.320282f, -0.080784f, -0.943871f,
	-0.062523f, 0.805118f, -0.118176f,
	3.000000f,
	// 799
	0.653263f, 0.300917f,
	-0.454703f, 0.109797f, -0.883849f,
	-0.085838f, 0.860349f, -0.107852f,
	37.000000f,
	// 800
	0.670615f, 0.299878f,
	-0.297304f, 0.110556f, -0.948361f,
	-0.065711f, 0.859345f, -0.116007f,
	37.000000f,
	// 801
	0.660392f, 0.340816f,
	-0.450734f, 0.221957f, -0.864623f,
	-0.081008f, 0.896578f, -0.101327f,
	47.000000f,
	// 802
	0.675316f, 0.350371f,
	-0.291091f, 0.239083f, -0.926340f,
	-0.064442f, 0.907786f, -0.105593f,
	47.000000f,
	// 803
	0.692462f, 0.295952f,
	-0.155843f, 0.119886f, -0.980480f,
	-0.039817f, 0.859772f, -0.121894f,
	37.000000f,
	// 804
	0.691752f, 0.336844f,
	-0.161710f, 0.228111f, -0.960112f,
	-0.044191f, 0.896117f, -0.112561f,
	47.000000f,
	// 805
	0.702402f, 0.359081f,
	-0.153839f, 0.232846f, -0.960269f,
	-0.031581f, 0.919221f, -0.108751f,
	47.000000f,
	// 806
	0.706597f, 0.424381f,
	-0.115424f, 0.354904f, -0.927750f,
	-0.025665f, 0.983738f, -0.092296f,
	1.000000f,
	// 807
	0.710679f, 0.381630f,
	-0.125746f, 0.255629f, -0.958562f,
	-0.020533f, 0.942336f, -0.105163f,
	47.000000f,
	// 808
	0.724859f, 0.427039f,
	-0.028174f, 0.355138f, -0.934389f,
	-0.000025f, 0.982627f, -0.094337f,
	1.000000f,
	// 809
	0.725498f, 0.356872f,
	-0.028319f, 0.242328f, -0.969781f,
	-0.000021f, 0.930854f, -0.109718f,
	1.000000f,
	// 810
	0.709810f, 0.457712f,
	-0.108624f, 0.461976f, -0.880215f,
	-0.020532f, 1.015510f, -0.077727f,
	1.000000f,
	// 811
	0.724195f, 0.470996f,
	-0.027380f, 0.475849f, -0.879101f,
	-0.000020f, 1.022321f, -0.075423f,
	1.000000f,
	// 812
	0.859493f, 0.322382f,
	-0.719431f, 0.023612f, 0.694163f,
	-0.138000f, 0.872097f, 0.089905f,
	37.000000f,
	// 813
	0.879844f, 0.329409f,
	-0.879560f, 0.044809f, 0.473673f,
	-0.146984f, 0.874617f, 0.077581f,
	37.000000f,
	// 814
	0.883811f, 0.297962f,
	-0.868812f, -0.035121f, 0.493896f,
	-0.144837f, 0.830303f, 0.076800f,
	3.000000f,
	// 815
	0.869422f, 0.285201f,
	-0.739975f, -0.119056f, 0.662014f,
	-0.138516f, 0.813972f, 0.085959f,
	3.000000f,
	// 816
	0.894139f, 0.339665f,
	-0.956881f, 0.065270f, 0.283053f,
	-0.154427f, 0.869841f, 0.058407f,
	37.000000f,
	// 817
	0.873091f, 0.290875f,
	-0.763912f, -0.048801f, 0.643472f,
	-0.148098f, 0.800014f, 0.069903f,
	3.000000f,
	// 818
	0.846090f, 0.246280f,
	-0.661330f, -0.193092f, 0.724816f,
	-0.132045f, 0.724137f, 0.073454f,
	3.000000f,
	// 819
	0.847547f, 0.271036f,
	-0.618211f, -0.085691f, 0.781327f,
	-0.119911f, 0.795813f, 0.097672f,
	3.000000f,
	// 820
	0.852797f, 0.285250f,
	-0.559226f, -0.070478f, 0.826014f,
	-0.126127f, 0.826943f, 0.095727f,
	3.000000f,
	// 821
	0.841076f, 0.313519f,
	-0.540681f, 0.018461f, 0.841025f,
	-0.122921f, 0.870416f, 0.101922f,
	37.000000f,
	// 822
	0.832331f, 0.355707f,
	-0.429163f, 0.193813f, 0.882188f,
	-0.120409f, 0.925195f, 0.096998f,
	1.000000f,
	// 823
	0.843839f, 0.373272f,
	-0.688830f, 0.252978f, 0.679350f,
	-0.130817f, 0.938160f, 0.086593f,
	1.000000f,
	// 824
	0.863345f, 0.368419f,
	-0.925827f, 0.248213f, 0.285018f,
	-0.139660f, 0.928555f, 0.077525f,
	1.000000f,
	// 825
	0.862932f, 0.395682f,
	-0.952496f, 0.280638f, 0.118297f,
	-0.137971f, 0.931320f, 0.068281f,
	1.000000f,
	// 826
	0.860209f, 0.424013f,
	-0.922871f, 0.251613f, 0.291548f,
	-0.136723f, 0.952762f, 0.056147f,
	1.000000f,
	// 827
	0.880937f, 0.409339f,
	-0.948408f, 0.226528f, 0.221829f,
	-0.144757f, 0.931542f, 0.045270f,
	1.000000f,
	// 828
	0.895919f, 0.424810f,
	-0.969840f, 0.237599f, 0.054381f,
	-0.151448f, 0.920005f, 0.021083f,
	1.000000f,
	// 829
	0.900731f, 0.395304f,
	-0.962194f, 0.209253f, 0.174344f,
	-0.151857f, 0.910034f, 0.035216f,
	1.000000f,
	// 830
	0.939384f, 0.367873f,
	-0.992530f, 0.102007f, 0.066921f,
	-0.161513f, 0.872784f, 0.015963f,
	37.000000f,
	// 831
	0.923653f, 0.359309f,
	-0.980673f, 0.105258f, 0.164926f,
	-0.159327f, 0.874860f, 0.034911f,
	37.000000f,
	// 832
	0.982677f, 0.309128f,
	-0.987644f, -0.147827f, -0.052030f,
	-0.154763f, 0.730169f, 0.004499f,
	3.000000f,
	// 833
	0.946517f, 0.322710f,
	-0.999915f, 0.008646f, -0.009716f,
	-0.159950f, 0.800053f, 0.032732f,
	3.000000f,
	// 834
	0.944139f, 0.337765f,
	-0.989089f, -0.002208f, 0.147303f,
	-0.159929f, 0.830462f, 0.027057f,
	3.000000f,
	// 835
	0.961031f, 0.338501f,
	-0.993643f, -0.070910f, 0.087435f,
	-0.162615f, 0.814452f, 0.011510f,
	3.000000f,
	// 836
	0.803437f, 0.251701f,
	-0.232488f, -0.192262f, 0.953407f,
	-0.085211f, 0.766086f, 0.108725f,
	3.000000f,
	// 837
	0.796499f, 0.228473f,
	-0.233113f, -0.283931f, 0.930076f,
	-0.075008f, 0.722004f, 0.097825f,
	3.000000f,
	// 838
	0.821919f, 0.260374f,
	-0.330507f, -0.140114f, 0.933345f,
	-0.099977f, 0.780598f, 0.105354f,
	3.000000f,
	// 839
	0.825315f, 0.233405f,
	-0.325716f, -0.283599f, 0.901932f,
	-0.096845f, 0.722594f, 0.091085f,
	3.000000f,
	// 840
	0.756737f, 0.239236f,
	-0.021399f, -0.259419f, 0.965528f,
	-0.025972f, 0.721479f, 0.103834f,
	46.000000f,
	// 841
	0.760862f, 0.256719f,
	-0.039862f, -0.167774f, 0.985019f,
	-0.034905f, 0.764172f, 0.115107f,
	3.000000f,
	// 842
	0.818979f, 0.286613f,
	-0.844399f, -0.111009f, 0.524087f,
	-0.152495f, 0.769447f, 0.062989f,
	3.000000f,
	// 843
	0.773291f, 0.261774f,
	-0.828746f, -0.206095f, 0.520292f,
	-0.143171f, 0.725283f, 0.060347f,
	3.000000f,
	// 844
	0.768761f, 0.303962f,
	-0.950253f, -0.029518f, 0.310076f,
	-0.156726f, 0.784799f, 0.052368f,
	3.000000f,
	// 845
	0.667590f, 0.280875f,
	-0.934982f, -0.196355f, 0.295386f,
	-0.150396f, 0.726684f, 0.044341f,
	3.000000f,
	// 846
	0.504266f, 0.311981f,
	-0.967574f, -0.143222f, -0.208056f,
	-0.159887f, 0.767214f, -0.024351f,
	3.000000f,
	// 847
	0.483641f, 0.301811f,
	-0.927565f, -0.284376f, -0.242390f,
	-0.150418f, 0.732277f, -0.019596f,
	3.000000f,
	// 848
	0.523849f, 0.305174f,
	-0.938764f, -0.061412f, -0.339044f,
	-0.155403f, 0.782008f, -0.039077f,
	3.000000f,
	// 849
	0.508574f, 0.285654f,
	-0.899105f, -0.269666f, -0.344806f,
	-0.143611f, 0.734250f, -0.042143f,
	3.000000f,
	// 850
	0.595759f, 0.265775f,
	-0.579338f, -0.139392f, -0.803080f,
	-0.114892f, 0.763903f, -0.090343f,
	3.000000f,
	// 851
	0.577610f, 0.249351f,
	-0.517971f, -0.295654f, -0.802680f,
	-0.111011f, 0.737846f, -0.083250f,
	3.000000f,
	// 852
	0.615676f, 0.264870f,
	-0.497710f, -0.054560f, -0.865626f,
	-0.102553f, 0.777870f, -0.097335f,
	3.000000f,
	// 853
	0.603951f, 0.240768f,
	-0.478501f, -0.270721f, -0.835312f,
	-0.092747f, 0.738783f, -0.093955f,
	3.000000f,
	// 854
	0.631094f, 0.254262f,
	-0.457622f, -0.147202f, -0.876877f,
	-0.088731f, 0.763903f, -0.105502f,
	3.000000f,
	// 855
	0.630612f, 0.232081f,
	-0.391956f, -0.272219f, -0.878788f,
	-0.074299f, 0.739701f, -0.104442f,
	3.000000f,
	// 856
	0.535640f, 0.291650f,
	-0.868105f, -0.131878f, -0.478541f,
	-0.149953f, 0.767214f, -0.052373f,
	3.000000f,
	// 857
	0.530702f, 0.271314f,
	-0.814757f, -0.241412f, -0.527154f,
	-0.136478f, 0.735705f, -0.058769f,
	3.000000f,
	// 858
	0.678343f, 0.312028f,
	-0.987592f, -0.080981f, 0.134549f,
	-0.160574f, 0.769447f, 0.038254f,
	3.000000f,
	// 859
	0.562337f, 0.299896f,
	-0.981542f, -0.170826f, 0.085988f,
	-0.154508f, 0.728309f, 0.025768f,
	3.000000f,
	// 860
	0.683831f, 0.327584f,
	-0.999915f, 0.008646f, -0.009716f,
	-0.159950f, 0.800053f, 0.032732f,
	3.000000f,
	// 861
	0.840863f, 0.258107f,
	-0.480997f, -0.179172f, 0.858219f,
	-0.114587f, 0.766086f, 0.098357f,
	3.000000f,
	// 862
	0.852638f, 0.238082f,
	-0.451326f, -0.280036f, 0.847281f,
	-0.116230f, 0.723273f, 0.083331f,
	3.000000f,
	// 863
	0.683882f, 0.267576f,
	-0.164989f, -0.002248f, -0.986293f,
	-0.042862f, 0.818853f, -0.121826f,
	3.000000f,
	// 864
	0.789672f, 0.515204f,
	-0.775369f, -0.312584f, -0.548721f,
	0.077733f, 1.086230f, 0.071373f,
	1.000000f,
	// 865
	0.811609f, 0.515204f,
	-0.894515f, -0.325480f, -0.306441f,
	0.086584f, 1.090416f, 0.049048f,
	1.000000f,
	// 866
	0.825224f, 0.504051f,
	-0.904474f, -0.364878f, -0.220885f,
	0.102695f, 1.058696f, 0.035711f,
	1.000000f,
	// 867
	0.821396f, 0.496163f,
	-0.900481f, -0.360294f, -0.243560f,
	0.107349f, 1.041497f, 0.042854f,
	1.000000f,
	// 868
	0.852453f, 0.481746f,
	-0.950259f, -0.309391f, -0.035843f,
	0.133370f, 0.988381f, 0.009724f,
	1.000000f,
	// 869
	0.843655f, 0.498475f,
	-0.923272f, -0.383701f, -0.018515f,
	0.111759f, 1.043930f, 0.014227f,
	1.000000f,
	// 870
	0.834856f, 0.515204f,
	-0.917519f, -0.396872f, -0.025538f,
	0.089909f, 1.093423f, 0.022922f,
	1.000000f,
	// 871
	0.837506f, 0.460853f,
	-0.921618f, -0.293467f, -0.253963f,
	0.125876f, 0.992314f, 0.042620f,
	1.000000f,
	// 872
	0.819544f, 0.483651f,
	-0.897835f, -0.338089f, -0.282113f,
	0.111646f, 1.025690f, 0.051282f,
	1.000000f,
	// 873
	0.805561f, 0.480388f,
	-0.810144f, -0.318340f, -0.492266f,
	0.101016f, 1.033032f, 0.070011f,
	1.000000f,
	// 874
	0.822763f, 0.438226f,
	-0.805119f, -0.251842f, -0.536990f,
	0.118556f, 0.981240f, 0.070564f,
	1.000000f,
	// 875
	0.783247f, 0.431030f,
	-0.481593f, -0.157183f, -0.862184f,
	0.075637f, 0.987712f, 0.105501f,
	1.000000f,
	// 876
	0.785741f, 0.477466f,
	-0.573157f, -0.258273f, -0.777680f,
	0.079539f, 1.038727f, 0.089793f,
	1.000000f,
	// 877
	0.796521f, 0.468693f,
	-0.664496f, -0.244964f, -0.706001f,
	0.092400f, 1.024622f, 0.083951f,
	1.000000f,
	// 878
	0.800973f, 0.438978f,
	-0.636070f, -0.166734f, -0.753402f,
	0.096965f, 0.990145f, 0.089704f,
	1.000000f,
	// 879
	0.818408f, 0.376052f,
	-0.245110f, -0.306754f, -0.919686f,
	0.109262f, 0.927053f, 0.094584f,
	1.000000f,
	// 880
	0.806171f, 0.396344f,
	-0.518930f, -0.220558f, -0.825873f,
	0.098398f, 0.923656f, 0.098398f,
	1.000000f,
	// 881
	0.799201f, 0.368403f,
	-0.602452f, -0.162762f, -0.781383f,
	0.087255f, 0.924736f, 0.110319f,
	1.000000f,
	// 882
	0.816742f, 0.301898f,
	-0.390865f, -0.005358f, -0.920432f,
	0.098725f, 0.861543f, 0.113877f,
	31.000000f,
	// 883
	0.766825f, 0.301494f,
	-0.125442f, 0.043747f, -0.991136f,
	0.047596f, 0.867015f, 0.124124f,
	31.000000f,
	// 884
	0.777683f, 0.363476f,
	-0.140784f, -0.104292f, -0.984532f,
	0.064176f, 0.922345f, 0.117134f,
	1.000000f,
	// 885
	0.789937f, 0.342238f,
	-0.238081f, -0.136186f, -0.961650f,
	0.075310f, 0.921685f, 0.117107f,
	1.000000f,
	// 886
	0.790205f, 0.300791f,
	-0.193598f, 0.035259f, -0.980447f,
	0.073173f, 0.864265f, 0.120287f,
	31.000000f,
	// 887
	0.793036f, 0.261089f,
	-0.088014f, 0.109011f, -0.990136f,
	0.075711f, 0.794622f, 0.113090f,
	7.000000f,
	// 888
	0.784455f, 0.271085f,
	-0.166689f, 0.096558f, -0.981270f,
	0.066700f, 0.822213f, 0.116465f,
	7.000000f,
	// 889
	0.770342f, 0.260726f,
	-0.222927f, 0.141907f, -0.964451f,
	0.051583f, 0.792716f, 0.116374f,
	7.000000f,
	// 890
	0.771778f, 0.228634f,
	-0.123265f, 0.237282f, -0.963589f,
	0.051217f, 0.721600f, 0.102444f,
	7.000000f,
	// 891
	0.746537f, 0.255060f,
	-0.000058f, 0.206229f, -0.978504f,
	-0.000000f, 0.721489f, 0.103722f,
	41.000000f,
	// 892
	0.736336f, 0.270883f,
	-0.000255f, 0.166406f, -0.986057f,
	-0.000000f, 0.805361f, 0.118754f,
	42.000000f,
	// 893
	0.747262f, 0.277817f,
	-0.032286f, 0.130372f, -0.990939f,
	0.016399f, 0.819577f, 0.119420f,
	44.000000f,
	// 894
	0.755944f, 0.270320f,
	0.093611f, 0.107913f, -0.989743f,
	0.025126f, 0.792057f, 0.116993f,
	44.000000f,
	// 895
	0.745549f, 0.296351f,
	-0.063361f, 0.107804f, -0.992151f,
	0.021091f, 0.860719f, 0.126113f,
	31.000000f,
	// 896
	0.726136f, 0.286706f,
	-0.000267f, 0.101673f, -0.994818f,
	-0.000000f, 0.859699f, 0.126431f,
	42.000000f,
	// 897
	0.723804f, 0.409193f,
	-0.002812f, -0.087149f, -0.996191f,
	0.000001f, 0.973807f, 0.127366f,
	1.000000f,
	// 898
	0.745260f, 0.350988f,
	-0.096204f, -0.011738f, -0.995292f,
	0.023841f, 0.920432f, 0.127241f,
	1.000000f,
	// 899
	0.739685f, 0.329195f,
	-0.055480f, 0.018836f, -0.998282f,
	0.016873f, 0.897009f, 0.127757f,
	1.000000f,
	// 900
	0.724970f, 0.347949f,
	-0.000268f, 0.002234f, -0.999997f,
	-0.000000f, 0.908239f, 0.128311f,
	1.000000f,
	// 901
	0.722750f, 0.515204f,
	-0.004897f, -0.285450f, -0.958381f,
	-0.000004f, 1.073321f, 0.102984f,
	1.000000f,
	// 902
	0.737656f, 0.467019f,
	-0.164744f, -0.268011f, -0.949226f,
	0.017747f, 1.031223f, 0.114256f,
	1.000000f,
	// 903
	0.732983f, 0.448387f,
	-0.118330f, -0.225326f, -0.967071f,
	0.010997f, 1.016904f, 0.119507f,
	1.000000f,
	// 904
	0.723277f, 0.462198f,
	-0.003763f, -0.258673f, -0.965958f,
	0.000000f, 1.023705f, 0.118432f,
	1.000000f,
	// 905
	0.739405f, 0.413056f,
	-0.142041f, -0.133468f, -0.980821f,
	0.017964f, 0.984794f, 0.124769f,
	1.000000f,
	// 906
	0.751690f, 0.425053f,
	-0.246533f, -0.158057f, -0.956159f,
	0.033714f, 0.991927f, 0.120153f,
	1.000000f,
	// 907
	0.748437f, 0.373880f,
	-0.169591f, -0.054986f, -0.983979f,
	0.027870f, 0.943590f, 0.126280f,
	1.000000f,
	// 908
	0.759561f, 0.367359f,
	-0.272170f, -0.049022f, -0.961000f,
	0.041269f, 0.932479f, 0.123645f,
	1.000000f,
	// 909
	0.768297f, 0.383107f,
	-0.321275f, -0.084688f, -0.943192f,
	0.053596f, 0.944593f, 0.118835f,
	1.000000f,
	// 910
	0.766696f, 0.424590f,
	-0.336516f, -0.126973f, -0.933078f,
	0.054123f, 0.986485f, 0.114691f,
	1.000000f,
	// 911
	0.752487f, 0.469326f,
	-0.233772f, -0.245951f, -0.940669f,
	0.040183f, 1.033222f, 0.109304f,
	1.000000f,
	// 912
	0.762709f, 0.457613f,
	-0.335321f, -0.212049f, -0.917930f,
	0.052727f, 1.019655f, 0.108972f,
	1.000000f,
	// 913
	0.768284f, 0.474696f,
	-0.413652f, -0.242257f, -0.877612f,
	0.061590f, 1.035217f, 0.101193f,
	1.000000f,
	// 914
	0.753149f, 0.515204f,
	-0.309923f, -0.273691f, -0.910517f,
	0.046027f, 1.077753f, 0.094548f,
	1.000000f,
	// 915
	0.774697f, 0.489094f,
	-0.491664f, -0.278830f, -0.824937f,
	0.068443f, 1.051890f, 0.092796f,
	1.000000f,
	// 916
	0.770354f, 0.515204f,
	-0.542483f, -0.268674f, -0.795943f,
	0.064075f, 1.081811f, 0.085673f,
	1.000000f,
	// 917
	0.737549f, 0.515204f,
	-0.150959f, -0.276288f, -0.949145f,
	0.024007f, 1.074653f, 0.100597f,
	1.000000f,
	// 918
	0.742497f, 0.483723f,
	-0.165197f, -0.275558f, -0.946984f,
	0.027001f, 1.046316f, 0.108369f,
	1.000000f,
	// 919
	0.645177f, 0.514954f,
	-0.657370f, -0.491659f, 0.571083f,
	0.077814f, 1.091864f, -0.024352f,
	1.000000f,
	// 920
	0.631437f, 0.480440f,
	-0.661610f, -0.458060f, 0.593678f,
	0.097105f, 1.042924f, -0.043930f,
	1.000000f,
	// 921
	0.623040f, 0.492930f,
	-0.841268f, -0.446721f, 0.304480f,
	0.098402f, 1.060245f, -0.022988f,
	1.000000f,
	// 922
	0.628475f, 0.514954f,
	-0.886486f, -0.416548f, 0.201571f,
	0.086990f, 1.094309f, -0.002782f,
	1.000000f,
	// 923
	0.612348f, 0.514954f,
	-0.917519f, -0.396872f, -0.025538f,
	0.089909f, 1.093423f, 0.022922f,
	1.000000f,
	// 924
	0.612839f, 0.484657f,
	-0.887281f, -0.404862f, 0.220950f,
	0.107262f, 1.043533f, -0.018557f,
	1.000000f,
	// 925
	0.611893f, 0.440321f,
	-0.732600f, -0.340601f, 0.589312f,
	0.119117f, 0.985351f, -0.059139f,
	1.000000f,
	// 926
	0.603802f, 0.481861f,
	-0.909010f, -0.381706f, 0.167337f,
	0.116391f, 1.027285f, -0.010551f,
	1.000000f,
	// 927
	0.599618f, 0.498350f,
	-0.923272f, -0.383701f, -0.018515f,
	0.111759f, 1.043930f, 0.014227f,
	1.000000f,
	// 928
	0.586889f, 0.481746f,
	-0.950259f, -0.309391f, -0.035843f,
	0.133370f, 0.988381f, 0.009724f,
	1.000000f,
	// 929
	0.596096f, 0.458368f,
	-0.913843f, -0.347140f, 0.210677f,
	0.128026f, 0.991114f, -0.025176f,
	1.000000f,
	// 930
	0.544857f, 0.337779f,
	-0.945460f, -0.076265f, 0.316683f,
	0.159201f, 0.864939f, -0.049487f,
	31.000000f,
	// 931
	0.565088f, 0.408089f,
	-0.951191f, -0.269822f, 0.149770f,
	0.147864f, 0.928747f, -0.024553f,
	1.000000f,
	// 932
	0.581524f, 0.420983f,
	-0.928209f, -0.302107f, 0.217163f,
	0.139569f, 0.949799f, -0.035790f,
	1.000000f,
	// 933
	0.579161f, 0.392040f,
	-0.893374f, -0.270257f, 0.358949f,
	0.141508f, 0.926940f, -0.054331f,
	1.000000f,
	// 934
	0.592630f, 0.371577f,
	-0.615806f, -0.230632f, 0.753387f,
	0.133282f, 0.913542f, -0.071951f,
	45.000000f,
	// 935
	0.577438f, 0.365972f,
	-0.802256f, -0.211183f, 0.558379f,
	0.142673f, 0.903818f, -0.065128f,
	1.000000f,
	// 936
	0.563694f, 0.329328f,
	-0.803356f, -0.077305f, 0.590460f,
	0.149772f, 0.868205f, -0.066930f,
	31.000000f,
	// 937
	0.579073f, 0.324094f,
	-0.648818f, -0.058914f, 0.758659f,
	0.139906f, 0.865509f, -0.076775f,
	31.000000f,
	// 938
	0.552793f, 0.259108f,
	-0.670306f, 0.230499f, 0.705380f,
	0.126464f, 0.736838f, -0.071723f,
	7.000000f,
	// 939
	0.547444f, 0.296040f,
	-0.712543f, 0.059111f, 0.699134f,
	0.147858f, 0.796815f, -0.064153f,
	7.000000f,
	// 940
	0.557191f, 0.302306f,
	-0.791290f, 0.041142f, 0.610055f,
	0.145422f, 0.825360f, -0.068561f,
	7.000000f,
	// 941
	0.567322f, 0.291993f,
	-0.688496f, 0.128238f, 0.713812f,
	0.137984f, 0.809381f, -0.076524f,
	7.000000f,
	// 942
	0.629479f, 0.302742f,
	-0.484327f, -0.063643f, 0.872569f,
	0.107384f, 0.857589f, -0.097675f,
	31.000000f,
	// 943
	0.591321f, 0.278338f,
	-0.683469f, 0.057867f, 0.727682f,
	0.121856f, 0.793195f, -0.086963f,
	7.000000f,
	// 944
	0.586039f, 0.291073f,
	-0.552639f, 0.038812f, 0.832516f,
	0.128250f, 0.822464f, -0.083306f,
	7.000000f,
	// 945
	0.599753f, 0.315287f,
	-0.536938f, -0.069876f, 0.840723f,
	0.127687f, 0.864584f, -0.085893f,
	31.000000f,
	// 946
	0.606285f, 0.354740f,
	-0.504009f, -0.182749f, 0.844143f,
	0.125005f, 0.900922f, -0.080299f,
	45.000000f,
	// 947
	0.623067f, 0.373782f,
	-0.477260f, -0.214019f, 0.852302f,
	0.113294f, 0.922828f, -0.081672f,
	45.000000f,
	// 948
	0.680117f, 0.427228f,
	-0.229856f, -0.331612f, 0.914986f,
	0.059673f, 0.985686f, -0.088916f,
	1.000000f,
	// 949
	0.653811f, 0.365867f,
	-0.409351f, -0.212512f, 0.887282f,
	0.087201f, 0.921372f, -0.094517f,
	45.000000f,
	// 950
	0.641756f, 0.392883f,
	-0.429844f, -0.232495f, 0.872457f,
	0.097383f, 0.944936f, -0.084469f,
	45.000000f,
	// 951
	0.645225f, 0.434476f,
	-0.429945f, -0.304350f, 0.850011f,
	0.091953f, 0.987902f, -0.075103f,
	1.000000f,
	// 952
	0.645937f, 0.464994f,
	-0.433421f, -0.412626f, 0.801178f,
	0.087845f, 1.025201f, -0.061054f,
	1.000000f,
	// 953
	0.660153f, 0.474527f,
	-0.315535f, -0.454595f, 0.832935f,
	0.073047f, 1.040432f, -0.059174f,
	1.000000f,
	// 954
	0.663024f, 0.514954f,
	-0.376640f, -0.449033f, 0.810254f,
	0.062368f, 1.084884f, -0.038077f,
	1.000000f,
	// 955
	0.669030f, 0.487017f,
	-0.236265f, -0.476461f, 0.846855f,
	0.062032f, 1.053041f, -0.055881f,
	1.000000f,
	// 956
	0.681713f, 0.480033f,
	-0.078933f, -0.435017f, 0.896956f,
	0.050557f, 1.040708f, -0.064333f,
	1.000000f,
	// 957
	0.682101f, 0.514954f,
	-0.065894f, -0.474517f, 0.877776f,
	0.042959f, 1.077171f, -0.045305f,
	1.000000f,
	// 958
	0.702488f, 0.514954f,
	0.034469f, -0.455365f, 0.889637f,
	0.021893f, 1.072528f, -0.047385f,
	1.000000f,
	// 959
	0.695339f, 0.487017f,
	0.012210f, -0.452328f, 0.891768f,
	0.035049f, 1.044803f, -0.062086f,
	1.000000f,
	// 960
	0.702430f, 0.472707f,
	-0.063031f, -0.474226f, 0.878144f,
	0.029216f, 1.029840f, -0.069832f,
	1.000000f,
	// 961
	0.723530f, 0.514954f,
	0.019151f, -0.469663f, 0.882638f,
	-0.000007f, 1.070970f, -0.046964f,
	1.000000f,
	// 962
	0.457307f, 0.318876f,
	-0.986924f, 0.152616f, 0.051862f,
	0.154763f, 0.730170f, 0.004499f,
	7.000000f,
	// 963
	0.482085f, 0.348362f,
	-0.996527f, 0.062450f, -0.055090f,
	0.162898f, 0.814396f, -0.002600f,
	7.000000f,
	// 964
	0.503228f, 0.343015f,
	-0.998552f, 0.007978f, 0.053192f,
	0.162320f, 0.828407f, -0.018641f,
	7.000000f,
	// 965
	0.502579f, 0.326549f,
	-0.999387f, 0.034516f, 0.005816f,
	0.162016f, 0.797577f, -0.023651f,
	7.000000f,
	// 966
	0.525507f, 0.362622f,
	-0.988291f, -0.125735f, 0.086442f,
	0.162425f, 0.872275f, -0.025523f,
	31.000000f,
	// 967
	0.506862f, 0.377848f,
	-0.992758f, -0.107102f, -0.054409f,
	0.161942f, 0.872674f, -0.005971f,
	31.000000f,
	// 968
	0.546422f, 0.397305f,
	-0.966849f, -0.238131f, 0.092174f,
	0.154402f, 0.907910f, -0.018452f,
	1.000000f,
	// 969
	0.546875f, 0.429797f,
	-0.970115f, -0.239403f, -0.039530f,
	0.151845f, 0.919863f, -0.001750f,
	1.000000f,
	// 970
	0.726136f, 0.286706f,
	0.007623f, -0.114935f, 0.993344f,
	-0.000018f, 0.859958f, -0.125820f,
	40.000000f,
	// 971
	0.709878f, 0.271711f,
	-0.000006f, 0.062959f, 0.998016f,
	-0.000001f, 0.777293f, -0.126078f,
	42.000000f,
	// 972
	0.692396f, 0.255588f,
	-0.097690f, 0.154428f, 0.983163f,
	0.019866f, 0.763442f, -0.125465f,
	44.000000f,
	// 973
	0.689962f, 0.258303f,
	-0.206412f, 0.024462f, 0.978159f,
	0.030548f, 0.791228f, -0.123983f,
	7.000000f,
	// 974
	0.655251f, 0.229698f,
	-0.265968f, 0.157662f, 0.951001f,
	0.053424f, 0.740431f, -0.112792f,
	39.000000f,
	// 975
	0.675526f, 0.240029f,
	-0.109147f, 0.310885f, 0.944160f,
	0.027879f, 0.740807f, -0.117086f,
	48.000000f,
	// 976
	0.693620f, 0.256717f,
	0.000000f, 0.281360f, 0.959602f,
	0.000000f, 0.740906f, -0.118219f,
	41.000000f,
	// 977
	0.643277f, 0.261944f,
	-0.333099f, 0.032055f, 0.942347f,
	0.083189f, 0.792660f, -0.109297f,
	7.000000f,
	// 978
	0.652523f, 0.271549f,
	-0.406109f, 0.020733f, 0.913589f,
	0.078226f, 0.820327f, -0.112006f,
	7.000000f,
	// 979
	0.665479f, 0.263787f,
	-0.300767f, 0.084258f, 0.949968f,
	0.062286f, 0.805699f, -0.118570f,
	7.000000f,
	// 980
	0.670615f, 0.299878f,
	-0.273761f, -0.098181f, 0.956773f,
	0.065358f, 0.860217f, -0.116892f,
	31.000000f,
	// 981
	0.653263f, 0.300917f,
	-0.417585f, -0.100200f, 0.903096f,
	0.085279f, 0.861682f, -0.109548f,
	31.000000f,
	// 982
	0.660392f, 0.340816f,
	-0.407449f, -0.203639f, 0.890234f,
	0.080498f, 0.897863f, -0.103593f,
	45.000000f,
	// 983
	0.675316f, 0.350371f,
	-0.266657f, -0.223900f, 0.937424f,
	0.064101f, 0.908708f, -0.107418f,
	45.000000f,
	// 984
	0.692462f, 0.295952f,
	-0.142151f, -0.106008f, 0.984152f,
	0.039627f, 0.860250f, -0.122331f,
	31.000000f,
	// 985
	0.691752f, 0.336844f,
	-0.145379f, -0.211326f, 0.966543f,
	0.043976f, 0.896717f, -0.113819f,
	45.000000f,
	// 986
	0.702402f, 0.359081f,
	-0.125486f, -0.223261f, 0.966648f,
	0.031447f, 0.919644f, -0.110201f,
	45.000000f,
	// 987
	0.706597f, 0.424381f,
	-0.062755f, -0.356559f, 0.932163f,
	0.025567f, 0.984079f, -0.093715f,
	1.000000f,
	// 988
	0.710679f, 0.381630f,
	-0.076342f, -0.254390f, 0.964084f,
	0.020453f, 0.942609f, -0.106299f,
	45.000000f,
	// 989
	0.725498f, 0.356872f,
	0.028319f, -0.242328f, 0.969781f,
	-0.000021f, 0.930854f, -0.109718f,
	1.000000f,
	// 990
	0.724859f, 0.427039f,
	0.028174f, -0.355138f, 0.934389f,
	-0.000025f, 0.982627f, -0.094337f,
	1.000000f,
	// 991
	0.709810f, 0.457712f,
	-0.057628f, -0.464822f, 0.883527f,
	0.020454f, 1.015782f, -0.078863f,
	1.000000f,
	// 992
	0.724195f, 0.470996f,
	0.027380f, -0.475849f, 0.879101f,
	-0.000020f, 1.022321f, -0.075423f,
	1.000000f,
	// 993
	0.859493f, 0.322382f,
	-0.790827f, -0.049172f, -0.610062f,
	0.138329f, 0.872120f, 0.083673f,
	31.000000f,
	// 994
	0.879844f, 0.329409f,
	-0.919736f, -0.057873f, -0.388248f,
	0.147417f, 0.874601f, 0.067270f,
	31.000000f,
	// 995
	0.883811f, 0.297962f,
	-0.911620f, 0.014928f, -0.410764f,
	0.145162f, 0.830254f, 0.069386f,
	7.000000f,
	// 996
	0.869422f, 0.285201f,
	-0.801892f, 0.088101f, -0.590937f,
	0.138738f, 0.813946f, 0.082155f,
	7.000000f,
	// 997
	0.846090f, 0.246280f,
	-0.680976f, 0.156764f, -0.715330f,
	0.132045f, 0.724137f, 0.073454f,
	7.000000f,
	// 998
	0.873091f, 0.290875f,
	-0.823562f, 0.010368f, -0.567131f,
	0.148371f, 0.799964f, 0.062552f,
	7.000000f,
	// 999
	0.894139f, 0.339665f,
	-0.968754f, -0.084331f, -0.233245f,
	0.154928f, 0.869756f, 0.043354f,
	31.000000f,
	// 1000
	0.847547f, 0.271036f,
	-0.641894f, 0.069742f, -0.763615f,
	0.119984f, 0.795799f, 0.097024f,
	7.000000f,
	// 1001
	0.852797f, 0.285250f,
	-0.625195f, 0.041107f, -0.779385f,
	0.126292f, 0.826923f, 0.093674f,
	7.000000f,
	// 1002
	0.841076f, 0.313519f,
	-0.606404f, -0.047803f, -0.793718f,
	0.123149f, 0.870437f, 0.098508f,
	31.000000f,
	// 1003
	0.832331f, 0.355707f,
	-0.490869f, -0.230239f, -0.840261f,
	0.120635f, 0.925360f, 0.091786f,
	1.000000f,
	// 1004
	0.843839f, 0.373272f,
	-0.752982f, -0.267664f, -0.601144f,
	0.131114f, 0.938366f, 0.078803f,
	1.000000f,
	// 1005
	0.863345f, 0.368419f,
	-0.939338f, -0.253501f, -0.231044f,
	0.140049f, 0.928692f, 0.066796f,
	1.000000f,
	// 1006
	0.862932f, 0.395682f,
	-0.954465f, -0.279896f, -0.103225f,
	0.138342f, 0.931485f, 0.055179f,
	1.000000f,
	// 1007
	0.860209f, 0.424013f,
	-0.937884f, -0.247950f, -0.242682f,
	0.137059f, 0.952842f, 0.040739f,
	1.000000f,
	// 1008
	0.880937f, 0.409339f,
	-0.957163f, -0.226040f, -0.180954f,
	0.145173f, 0.931433f, 0.026834f,
	1.000000f,
	// 1009
	0.895919f, 0.424810f,
	-0.970115f, -0.239403f, -0.039530f,
	0.151845f, 0.919863f, -0.001750f,
	1.000000f,
	// 1010
	0.900731f, 0.395304f,
	-0.966637f, -0.212548f, -0.142958f,
	0.152339f, 0.909836f, 0.013802f,
	1.000000f,
	// 1011
	0.923653f, 0.359309f,
	-0.983420f, -0.116255f, -0.139175f,
	0.159846f, 0.874682f, 0.014795f,
	31.000000f,
	// 1012
	0.939384f, 0.367873f,
	-0.992758f, -0.107102f, -0.054409f,
	0.161942f, 0.872674f, -0.005971f,
	31.000000f,
	// 1013
	0.982677f, 0.309128f,
	-0.986924f, 0.152616f, 0.051862f,
	0.154763f, 0.730170f, 0.004499f,
	7.000000f,
	// 1014
	0.946517f, 0.322710f,
	-0.999955f, -0.002379f, 0.009144f,
	0.160238f, 0.799983f, 0.023648f,
	7.000000f,
	// 1015
	0.944139f, 0.337765f,
	-0.991703f, -0.010936f, -0.128084f,
	0.160315f, 0.830333f, 0.012709f,
	7.000000f,
	// 1016
	0.961031f, 0.338501f,
	-0.996527f, 0.062450f, -0.055090f,
	0.162898f, 0.814396f, -0.002600f,
	7.000000f,
	// 1017
	0.803437f, 0.251701f,
	-0.233416f, 0.189252f, -0.953782f,
	0.085243f, 0.766078f, 0.108590f,
	7.000000f,
	// 1018
	0.796499f, 0.228473f,
	-0.233185f, 0.281494f, -0.930798f,
	0.075008f, 0.722005f, 0.097825f,
	7.000000f,
	// 1019
	0.825315f, 0.233405f,
	-0.325867f, 0.281308f, -0.902594f,
	0.096845f, 0.722594f, 0.091085f,
	7.000000f,
	// 1020
	0.821919f, 0.260374f,
	-0.330873f, 0.133441f, -0.934193f,
	0.100017f, 0.780588f, 0.105185f,
	7.000000f,
	// 1021
	0.756737f, 0.239236f,
	-0.021399f, 0.259235f, -0.965577f,
	0.025972f, 0.721479f, 0.103834f,
	44.000000f,
	// 1022
	0.760862f, 0.256719f,
	-0.040400f, 0.167375f, -0.985065f,
	0.034907f, 0.764172f, 0.115098f,
	7.000000f,
	// 1023
	0.818979f, 0.286613f,
	-0.861762f, 0.067361f, -0.502821f,
	0.152687f, 0.769409f, 0.057492f,
	7.000000f,
	// 1024
	0.773291f, 0.261774f,
	-0.830459f, 0.144267f, -0.538075f,
	0.143171f, 0.725283f, 0.060347f,
	7.000000f,
	// 1025
	0.667590f, 0.280875f,
	-0.937932f, 0.163827f, -0.305685f,
	0.150396f, 0.726684f, 0.044341f,
	7.000000f,
	// 1026
	0.768761f, 0.303962f,
	-0.949813f, 0.001596f, -0.312814f,
	0.156966f, 0.784753f, 0.045497f,
	7.000000f,
	// 1027
	0.504266f, 0.311981f,
	-0.959768f, 0.176980f, 0.217998f,
	0.159857f, 0.767484f, -0.031043f,
	7.000000f,
	// 1028
	0.483641f, 0.301811f,
	-0.916331f, 0.322721f, 0.237042f,
	0.150418f, 0.732278f, -0.019596f,
	7.000000f,
	// 1029
	0.508574f, 0.285654f,
	-0.882087f, 0.326401f, 0.339684f,
	0.143611f, 0.734250f, -0.042143f,
	7.000000f,
	// 1030
	0.523849f, 0.305174f,
	-0.936995f, 0.103665f, 0.333608f,
	0.155366f, 0.782346f, -0.047442f,
	7.000000f,
	// 1031
	0.595759f, 0.265775f,
	-0.572980f, 0.156673f, 0.804455f,
	0.114602f, 0.764588f, -0.091322f,
	7.000000f,
	// 1032
	0.577610f, 0.249351f,
	-0.515536f, 0.310330f, 0.798698f,
	0.111011f, 0.737847f, -0.083250f,
	7.000000f,
	// 1033
	0.603951f, 0.240768f,
	-0.474865f, 0.287431f, 0.831797f,
	0.092747f, 0.738783f, -0.093955f,
	7.000000f,
	// 1034
	0.615676f, 0.264870f,
	-0.497646f, 0.072847f, 0.864316f,
	0.102192f, 0.778726f, -0.098558f,
	7.000000f,
	// 1035
	0.631094f, 0.254262f,
	-0.451128f, 0.160968f, 0.877823f,
	0.088441f, 0.764588f, -0.106481f,
	7.000000f,
	// 1036
	0.630612f, 0.232081f,
	-0.389985f, 0.293132f, 0.872918f,
	0.074299f, 0.739701f, -0.104442f,
	7.000000f,
	// 1037
	0.535640f, 0.291650f,
	-0.836591f, 0.189856f, 0.513878f,
	0.149923f, 0.767484f, -0.059065f,
	7.000000f,
	// 1038
	0.530702f, 0.271314f,
	-0.792288f, 0.339896f, 0.506705f,
	0.136478f, 0.735705f, -0.058769f,
	7.000000f,
	// 1039
	0.678343f, 0.312028f,
	-0.989526f, 0.069020f, -0.126783f,
	0.160765f, 0.769409f, 0.032757f,
	7.000000f,
	// 1040
	0.562337f, 0.299896f,
	-0.981642f, 0.165555f, -0.094708f,
	0.154508f, 0.728309f, 0.025768f,
	7.000000f,
	// 1041
	0.683831f, 0.327584f,
	-0.999955f, -0.002379f, 0.009144f,
	0.160238f, 0.799983f, 0.023648f,
	7.000000f,
	// 1042
	0.840863f, 0.258107f,
	-0.486344f, 0.173073f, -0.856455f,
	0.114619f, 0.766078f, 0.098222f,
	7.000000f,
	// 1043
	0.852638f, 0.238082f,
	-0.451437f, 0.277965f, -0.847903f,
	0.116230f, 0.723273f, 0.083331f,
	7.000000f,
	// 1044
	0.683882f, 0.267576f,
	-0.154349f, 0.006827f, 0.987993f,
	0.042729f, 0.819181f, -0.121945f,
	7.000000f,
	// 1045
	0.789672f, 0.515204f,
	0.753089f, -0.347438f, -0.558698f,
	-0.077780f, 1.086154f, 0.072003f,
	1.000000f,
	// 1046
	0.821396f, 0.496163f,
	0.883807f, -0.385849f, -0.264586f,
	-0.107254f, 1.041505f, 0.052254f,
	1.000000f,
	// 1047
	0.825224f, 0.504051f,
	0.890409f, -0.395474f, -0.225329f,
	-0.102630f, 1.058739f, 0.042612f,
	1.000000f,
	// 1048
	0.811609f, 0.515204f,
	0.876965f, -0.380889f, -0.293011f,
	-0.086612f, 1.090379f, 0.049422f,
	1.000000f,
	// 1049
	0.834856f, 0.515204f,
	0.916130f, -0.400717f, -0.011463f,
	-0.089917f, 1.093415f, 0.023023f,
	1.000000f,
	// 1050
	0.843655f, 0.498475f,
	0.923112f, -0.383844f, -0.022969f,
	-0.111681f, 1.043941f, 0.023655f,
	1.000000f,
	// 1051
	0.852453f, 0.481746f,
	0.949310f, -0.309112f, -0.057089f,
	-0.133146f, 0.988473f, 0.027908f,
	1.000000f,
	// 1052
	0.819544f, 0.483651f,
	0.876177f, -0.352039f, -0.329214f,
	-0.111526f, 1.025548f, 0.061283f,
	1.000000f,
	// 1053
	0.837506f, 0.460853f,
	0.904172f, -0.301317f, -0.302788f,
	-0.125659f, 0.992170f, 0.056286f,
	1.000000f,
	// 1054
	0.822763f, 0.438226f,
	0.751751f, -0.248083f, -0.611004f,
	-0.118376f, 0.980828f, 0.079413f,
	1.000000f,
	// 1055
	0.805561f, 0.480388f,
	0.754898f, -0.340203f, -0.560706f,
	-0.100947f, 1.032743f, 0.076031f,
	1.000000f,
	// 1056
	0.783247f, 0.431030f,
	0.427334f, -0.157973f, -0.890185f,
	-0.075593f, 0.987292f, 0.107507f,
	1.000000f,
	// 1057
	0.800973f, 0.438978f,
	0.558461f, -0.174342f, -0.811003f,
	-0.096873f, 0.989692f, 0.094530f,
	1.000000f,
	// 1058
	0.796521f, 0.468693f,
	0.588900f, -0.265448f, -0.763370f,
	-0.092348f, 1.024237f, 0.087983f,
	1.000000f,
	// 1059
	0.785741f, 0.477466f,
	0.517594f, -0.280090f, -0.808484f,
	-0.079532f, 1.038419f, 0.091780f,
	1.000000f,
	// 1060
	0.806171f, 0.396344f,
	0.454940f, -0.193219f, -0.869308f,
	-0.098294f, 0.923305f, 0.102321f,
	1.000000f,
	// 1061
	0.818408f, 0.376052f,
	0.200590f, -0.260268f, -0.944470f,
	-0.109114f, 0.926791f, 0.099297f,
	1.000000f,
	// 1062
	0.816742f, 0.301898f,
	0.352434f, 0.013059f, -0.935745f,
	-0.098627f, 0.861527f, 0.114783f,
	37.000000f,
	// 1063
	0.799201f, 0.368403f,
	0.541423f, -0.148113f, -0.827601f,
	-0.087178f, 0.924483f, 0.112124f,
	1.000000f,
	// 1064
	0.766825f, 0.301494f,
	0.118112f, 0.046990f, -0.991888f,
	-0.047584f, 0.866993f, 0.124239f,
	37.000000f,
	// 1065
	0.790205f, 0.300791f,
	0.178699f, 0.040397f, -0.983074f,
	-0.073122f, 0.864233f, 0.120643f,
	37.000000f,
	// 1066
	0.789937f, 0.342238f,
	0.214731f, -0.120392f, -0.969225f,
	-0.075257f, 0.921520f, 0.117938f,
	1.000000f,
	// 1067
	0.777683f, 0.363476f,
	0.131919f, -0.092251f, -0.986959f,
	-0.064143f, 0.922115f, 0.118060f,
	1.000000f,
	// 1068
	0.784455f, 0.271085f,
	0.156390f, 0.099221f, -0.982699f,
	-0.066665f, 0.822222f, 0.116609f,
	3.000000f,
	// 1069
	0.793036f, 0.261089f,
	0.078697f, 0.112277f, -0.990556f,
	-0.075670f, 0.794632f, 0.113261f,
	3.000000f,
	// 1070
	0.771778f, 0.228634f,
	0.122501f, 0.238457f, -0.963396f,
	-0.051217f, 0.721600f, 0.102444f,
	3.000000f,
	// 1071
	0.770342f, 0.260726f,
	0.220679f, 0.142774f, -0.964840f,
	-0.051571f, 0.792719f, 0.116419f,
	3.000000f,
	// 1072
	0.746537f, 0.255060f,
	-0.000058f, 0.206229f, -0.978504f,
	-0.000000f, 0.721489f, 0.103722f,
	41.000000f,
	// 1073
	0.755944f, 0.270320f,
	-0.094812f, 0.108308f, -0.989586f,
	-0.025124f, 0.792057f, 0.117004f,
	46.000000f,
	// 1074
	0.747262f, 0.277817f,
	0.030831f, 0.130593f, -0.990957f,
	-0.016398f, 0.819577f, 0.119429f,
	46.000000f,
	// 1075
	0.736336f, 0.270883f,
	-0.000255f, 0.166406f, -0.986057f,
	-0.000000f, 0.805361f, 0.118754f,
	42.000000f,
	// 1076
	0.726136f, 0.286706f,
	-0.000267f, 0.101673f, -0.994818f,
	-0.000000f, 0.859699f, 0.126431f,
	42.000000f,
	// 1077
	0.745549f, 0.296351f,
	0.061017f, 0.107785f, -0.992300f,
	-0.021089f, 0.860720f, 0.126124f,
	37.000000f,
	// 1078
	0.723804f, 0.409193f,
	-0.002812f, -0.087149f, -0.996191f,
	0.000001f, 0.973807f, 0.127366f,
	1.000000f,
	// 1079
	0.724970f, 0.347949f,
	-0.000268f, 0.002234f, -0.999997f,
	-0.000000f, 0.908239f, 0.128311f,
	1.000000f,
	// 1080
	0.739685f, 0.329195f,
	0.053459f, 0.018957f, -0.998390f,
	-0.016871f, 0.897009f, 0.127766f,
	1.000000f,
	// 1081
	0.745260f, 0.350988f,
	0.091286f, -0.010593f, -0.995768f,
	-0.023837f, 0.920418f, 0.127278f,
	1.000000f,
	// 1082
	0.722750f, 0.515204f,
	-0.004897f, -0.285450f, -0.958381f,
	-0.000004f, 1.073321f, 0.102984f,
	1.000000f,
	// 1083
	0.723277f, 0.462198f,
	-0.003763f, -0.258673f, -0.965958f,
	0.000000f, 1.023705f, 0.118432f,
	1.000000f,
	// 1084
	0.732983f, 0.448387f,
	0.109462f, -0.225386f, -0.968101f,
	-0.010995f, 1.016845f, 0.119611f,
	1.000000f,
	// 1085
	0.737656f, 0.467019f,
	0.155255f, -0.268280f, -0.950748f,
	-0.017747f, 1.031136f, 0.114431f,
	1.000000f,
	// 1086
	0.751690f, 0.425053f,
	0.227151f, -0.156919f, -0.961134f,
	-0.033709f, 0.991764f, 0.120536f,
	1.000000f,
	// 1087
	0.739405f, 0.413056f,
	0.132738f, -0.131691f, -0.982363f,
	-0.017961f, 0.984721f, 0.124901f,
	1.000000f,
	// 1088
	0.759561f, 0.367359f,
	0.249448f, -0.044343f, -0.967372f,
	-0.041259f, 0.932362f, 0.123956f,
	1.000000f,
	// 1089
	0.748437f, 0.373880f,
	0.158726f, -0.052390f, -0.985932f,
	-0.027865f, 0.943532f, 0.126393f,
	1.000000f,
	// 1090
	0.766696f, 0.424590f,
	0.305011f, -0.125791f, -0.944005f,
	-0.054102f, 0.986181f, 0.115722f,
	1.000000f,
	// 1091
	0.768297f, 0.383107f,
	0.293004f, -0.078761f, -0.952862f,
	-0.053575f, 0.944361f, 0.119631f,
	1.000000f,
	// 1092
	0.762709f, 0.457614f,
	0.308252f, -0.216769f, -0.926279f,
	-0.052721f, 1.019368f, 0.109944f,
	1.000000f,
	// 1093
	0.752487f, 0.469326f,
	0.213213f, -0.248543f, -0.944863f,
	-0.040191f, 1.033036f, 0.109835f,
	1.000000f,
	// 1094
	0.753149f, 0.515204f,
	0.297545f, -0.279485f, -0.912883f,
	-0.046061f, 1.077620f, 0.095058f,
	1.000000f,
	// 1095
	0.768284f, 0.474696f,
	0.394827f, -0.250245f, -0.884019f,
	-0.061589f, 1.034910f, 0.102366f,
	1.000000f,
	// 1096
	0.770354f, 0.515204f,
	0.537608f, -0.278530f, -0.795863f,
	-0.064121f, 1.081691f, 0.086324f,
	1.000000f,
	// 1097
	0.774697f, 0.489094f,
	0.471547f, -0.292804f, -0.831811f,
	-0.068457f, 1.051636f, 0.093913f,
	1.000000f,
	// 1098
	0.742497f, 0.483723f,
	0.153760f, -0.276157f, -0.948733f,
	-0.027011f, 1.046202f, 0.108657f,
	1.000000f,
	// 1099
	0.737549f, 0.515204f,
	0.141327f, -0.275743f, -0.950785f,
	-0.024024f, 1.074570f, 0.100874f,
	1.000000f,
	// 1100
	0.645177f, 0.514954f,
	0.676507f, -0.451339f, 0.581921f,
	-0.077824f, 1.091863f, -0.024133f,
	1.000000f,
	// 1101
	0.628475f, 0.514954f,
	0.892112f, -0.398291f, 0.213309f,
	-0.086992f, 1.094311f, -0.002752f,
	1.000000f,
	// 1102
	0.623040f, 0.492930f,
	0.858812f, -0.414576f, 0.300947f,
	-0.098494f, 1.059974f, -0.018760f,
	1.000000f,
	// 1103
	0.631437f, 0.480440f,
	0.708189f, -0.406969f, 0.576927f,
	-0.097241f, 1.042517f, -0.038360f,
	1.000000f,
	// 1104
	0.611893f, 0.440321f,
	0.784894f, -0.318639f, 0.531423f,
	-0.119390f, 0.984538f, -0.047595f,
	1.000000f,
	// 1105
	0.612839f, 0.484657f,
	0.903005f, -0.376757f, 0.206488f,
	-0.107356f, 1.043210f, -0.011629f,
	1.000000f,
	// 1106
	0.612348f, 0.514954f,
	0.916130f, -0.400717f, -0.011463f,
	-0.089917f, 1.093415f, 0.023023f,
	1.000000f,
	// 1107
	0.599618f, 0.498350f,
	0.923112f, -0.383844f, -0.022969f,
	-0.111681f, 1.043941f, 0.023655f,
	1.000000f,
	// 1108
	0.603802f, 0.481861f,
	0.920594f, -0.359797f, 0.151828f,
	-0.116398f, 1.027082f, 0.000309f,
	1.000000f,
	// 1109
	0.596096f, 0.458368f,
	0.926871f, -0.324699f, 0.188366f,
	-0.128042f, 0.990792f, -0.009881f,
	1.000000f,
	// 1110
	0.586889f, 0.481746f,
	0.949310f, -0.309112f, -0.057089f,
	-0.133146f, 0.988473f, 0.027908f,
	1.000000f,
	// 1111
	0.544857f, 0.337779f,
	0.962321f, -0.094741f, 0.254876f,
	-0.159281f, 0.864237f, -0.031390f,
	37.000000f,
	// 1112
	0.579161f, 0.392040f,
	0.918096f, -0.264434f, 0.295254f,
	-0.141715f, 0.926101f, -0.038011f,
	1.000000f,
	// 1113
	0.581524f, 0.420983f,
	0.937804f, -0.290102f, 0.190696f,
	-0.139607f, 0.949325f, -0.018045f,
	1.000000f,
	// 1114
	0.565088f, 0.408089f,
	0.956544f, -0.262586f, 0.126779f,
	-0.147769f, 0.928450f, -0.004304f,
	1.000000f,
	// 1115
	0.577438f, 0.365972f,
	0.866530f, -0.221801f, 0.447135f,
	-0.143095f, 0.902561f, -0.050871f,
	1.000000f,
	// 1116
	0.592630f, 0.371577f,
	0.728630f, -0.241144f, 0.641052f,
	-0.133855f, 0.912070f, -0.060763f,
	47.000000f,
	// 1117
	0.579072f, 0.324094f,
	0.762152f, -0.092698f, 0.640728f,
	-0.140564f, 0.863875f, -0.067458f,
	37.000000f,
	// 1118
	0.563694f, 0.329328f,
	0.876848f, -0.095848f, 0.471117f,
	-0.150209f, 0.866906f, -0.053317f,
	37.000000f,
	// 1119
	0.552793f, 0.259108f,
	0.706251f, 0.171664f, 0.686834f,
	-0.126464f, 0.736838f, -0.071723f,
	3.000000f,
	// 1120
	0.567322f, 0.291993f,
	0.789590f, 0.092569f, 0.606613f,
	-0.138430f, 0.808250f, -0.070763f,
	3.000000f,
	// 1121
	0.557191f, 0.302306f,
	0.870720f, 0.016243f, 0.491511f,
	-0.145745f, 0.824376f, -0.058794f,
	3.000000f,
	// 1122
	0.547444f, 0.296040f,
	0.794181f, 0.011902f, 0.607564f,
	-0.147969f, 0.796299f, -0.055020f,
	3.000000f,
	// 1123
	0.629479f, 0.302742f,
	0.542955f, -0.089524f, 0.834976f,
	-0.108125f, 0.855862f, -0.094493f,
	37.000000f,
	// 1124
	0.599753f, 0.315287f,
	0.630198f, -0.110706f, 0.768501f,
	-0.128458f, 0.862767f, -0.079628f,
	37.000000f,
	// 1125
	0.586039f, 0.291073f,
	0.647200f, 0.002784f, 0.762315f,
	-0.128832f, 0.821065f, -0.079252f,
	3.000000f,
	// 1126
	0.591321f, 0.278338f,
	0.709145f, 0.035070f, 0.704190f,
	-0.122291f, 0.792160f, -0.084970f,
	3.000000f,
	// 1127
	0.606285f, 0.354740f,
	0.607389f, -0.213341f, 0.765222f,
	-0.125694f, 0.899250f, -0.071920f,
	47.000000f,
	// 1128
	0.623067f, 0.373782f,
	0.564471f, -0.239107f, 0.790063f,
	-0.113874f, 0.921385f, -0.074078f,
	47.000000f,
	// 1129
	0.680117f, 0.427228f,
	0.291059f, -0.327691f, 0.898835f,
	-0.059903f, 0.984937f, -0.085764f,
	1.000000f,
	// 1130
	0.645225f, 0.434476f,
	0.519514f, -0.289112f, 0.804064f,
	-0.092240f, 0.987050f, -0.068166f,
	1.000000f,
	// 1131
	0.641756f, 0.392883f,
	0.517919f, -0.254901f, 0.816569f,
	-0.097850f, 0.943706f, -0.078118f,
	47.000000f,
	// 1132
	0.653811f, 0.365867f,
	0.487112f, -0.237984f, 0.840289f,
	-0.087727f, 0.920025f, -0.090756f,
	47.000000f,
	// 1133
	0.645937f, 0.464994f,
	0.521509f, -0.361922f, 0.772684f,
	-0.088016f, 1.024658f, -0.055690f,
	1.000000f,
	// 1134
	0.660153f, 0.474527f,
	0.387749f, -0.412087f, 0.824521f,
	-0.073174f, 1.040022f, -0.056562f,
	1.000000f,
	// 1135
	0.669030f, 0.487017f,
	0.251860f, -0.450041f, 0.856755f,
	-0.062131f, 1.052757f, -0.054261f,
	1.000000f,
	// 1136
	0.663024f, 0.514954f,
	0.370408f, -0.430388f, 0.823143f,
	-0.062399f, 1.084868f, -0.037351f,
	1.000000f,
	// 1137
	0.682101f, 0.514954f,
	0.073845f, -0.453931f, 0.887971f,
	-0.043002f, 1.077144f, -0.044254f,
	1.000000f,
	// 1138
	0.681713f, 0.480033f,
	0.086529f, -0.416860f, 0.904843f,
	-0.050680f, 1.040352f, -0.062329f,
	1.000000f,
	// 1139
	0.695339f, 0.487017f,
	0.014980f, -0.438247f, 0.898730f,
	-0.035147f, 1.044518f, -0.060486f,
	1.000000f,
	// 1140
	0.702488f, 0.514954f,
	-0.008577f, -0.438835f, 0.898527f,
	-0.021922f, 1.072510f, -0.046689f,
	1.000000f,
	// 1141
	0.723530f, 0.514954f,
	0.019151f, -0.469663f, 0.882638f,
	-0.000007f, 1.070970f, -0.046964f,
	1.000000f,
	// 1142
	0.702430f, 0.472707f,
	0.104456f, -0.466904f, 0.878117f,
	-0.029319f, 1.029496f, -0.068296f,
	1.000000f,
	// 1143
	0.457307f, 0.318876f,
	0.987644f, 0.147827f, 0.052030f,
	-0.154763f, 0.730169f, 0.004499f,
	3.000000f,
	// 1144
	0.502579f, 0.326549f,
	0.999388f, 0.034923f, -0.002159f,
	-0.162005f, 0.797262f, -0.013074f,
	3.000000f,
	// 1145
	0.503228f, 0.343015f,
	0.999169f, 0.001083f, 0.040740f,
	-0.162156f, 0.828229f, -0.003098f,
	3.000000f,
	// 1146
	0.482085f, 0.348362f,
	0.993643f, 0.070910f, -0.087435f,
	-0.162615f, 0.814452f, 0.011510f,
	3.000000f,
	// 1147
	0.506862f, 0.377848f,
	0.992530f, -0.102007f, -0.066921f,
	-0.161513f, 0.872784f, 0.015963f,
	37.000000f,
	// 1148
	0.525507f, 0.362622f,
	0.989631f, -0.128191f, 0.064785f,
	-0.162192f, 0.872070f, -0.003871f,
	37.000000f,
	// 1149
	0.546875f, 0.429797f,
	0.969840f, -0.237599f, -0.054381f,
	-0.151448f, 0.920005f, 0.021083f,
	1.000000f,
	// 1150
	0.546422f, 0.397305f,
	0.969897f, -0.233537f, 0.068992f,
	-0.154148f, 0.907801f, 0.004191f,
	1.000000f,
	// 1151
	0.726136f, 0.286706f,
	0.007623f, -0.114935f, 0.993344f,
	-0.000018f, 0.859958f, -0.125820f,
	40.000000f,
	// 1152
	0.689962f, 0.258303f,
	0.207878f, 0.023757f, 0.977866f,
	-0.030584f, 0.791146f, -0.123953f,
	3.000000f,
	// 1153
	0.692396f, 0.255588f,
	0.097846f, 0.154274f, 0.983171f,
	-0.019868f, 0.763442f, -0.125465f,
	46.000000f,
	// 1154
	0.709878f, 0.271711f,
	-0.000006f, 0.062959f, 0.998016f,
	-0.000001f, 0.777293f, -0.126078f,
	42.000000f,
	// 1155
	0.693620f, 0.256717f,
	0.000000f, 0.281360f, 0.959602f,
	0.000000f, 0.740906f, -0.118219f,
	41.000000f,
	// 1156
	0.675526f, 0.240029f,
	0.109143f, 0.310896f, 0.944156f,
	-0.027879f, 0.740807f, -0.117086f,
	49.000000f,
	// 1157
	0.655251f, 0.229698f,
	0.273395f, 0.149712f, 0.950180f,
	-0.053424f, 0.740431f, -0.112792f,
	43.000000f,
	// 1158
	0.665479f, 0.263787f,
	0.320282f, 0.080784f, 0.943871f,
	-0.062523f, 0.805118f, -0.118176f,
	3.000000f,
	// 1159
	0.652523f, 0.271549f,
	0.439483f, 0.017368f, 0.898083f,
	-0.078646f, 0.819314f, -0.110907f,
	3.000000f,
	// 1160
	0.643277f, 0.261944f,
	0.361857f, 0.024779f, 0.931904f,
	-0.083583f, 0.791722f, -0.108043f,
	3.000000f,
	// 1161
	0.653263f, 0.300917f,
	0.454703f, -0.109797f, 0.883849f,
	-0.085838f, 0.860349f, -0.107852f,
	37.000000f,
	// 1162
	0.670615f, 0.299878f,
	0.297304f, -0.110556f, 0.948361f,
	-0.065711f, 0.859345f, -0.116007f,
	37.000000f,
	// 1163
	0.660392f, 0.340816f,
	0.450734f, -0.221957f, 0.864623f,
	-0.081008f, 0.896578f, -0.101327f,
	47.000000f,
	// 1164
	0.675316f, 0.350371f,
	0.291091f, -0.239083f, 0.926340f,
	-0.064442f, 0.907786f, -0.105593f,
	47.000000f,
	// 1165
	0.702402f, 0.359081f,
	0.153839f, -0.232846f, 0.960269f,
	-0.031581f, 0.919221f, -0.108751f,
	47.000000f,
	// 1166
	0.691752f, 0.336844f,
	0.161710f, -0.228111f, 0.960112f,
	-0.044191f, 0.896117f, -0.112561f,
	47.000000f,
	// 1167
	0.692462f, 0.295952f,
	0.155843f, -0.119886f, 0.980480f,
	-0.039817f, 0.859772f, -0.121894f,
	37.000000f,
	// 1168
	0.710679f, 0.381630f,
	0.125746f, -0.255629f, 0.958562f,
	-0.020533f, 0.942336f, -0.105163f,
	47.000000f,
	// 1169
	0.706597f, 0.424381f,
	0.115424f, -0.354904f, 0.927750f,
	-0.025665f, 0.983738f, -0.092296f,
	1.000000f,
	// 1170
	0.724859f, 0.427039f,
	0.028174f, -0.355138f, 0.934389f,
	-0.000025f, 0.982627f, -0.094337f,
	1.000000f,
	// 1171
	0.725498f, 0.356872f,
	0.028319f, -0.242328f, 0.969781f,
	-0.000021f, 0.930854f, -0.109718f,
	1.000000f,
	// 1172
	0.724195f, 0.470996f,
	0.027380f, -0.475849f, 0.879101f,
	-0.000020f, 1.022321f, -0.075423f,
	1.000000f,
	// 1173
	0.709810f, 0.457712f,
	0.108624f, -0.461976f, 0.880215f,
	-0.020532f, 1.015510f, -0.077727f,
	1.000000f,
	// 1174
	0.859493f, 0.322382f,
	0.719431f, -0.023612f, -0.694163f,
	-0.138000f, 0.872097f, 0.089905f,
	37.000000f,
	// 1175
	0.869422f, 0.285201f,
	0.739975f, 0.119056f, -0.662014f,
	-0.138516f, 0.813972f, 0.085959f,
	3.000000f,
	// 1176
	0.883811f, 0.297962f,
	0.868812f, 0.035121f, -0.493896f,
	-0.144837f, 0.830303f, 0.076800f,
	3.000000f,
	// 1177
	0.879844f, 0.329409f,
	0.879560f, -0.044809f, -0.473673f,
	-0.146984f, 0.874617f, 0.077581f,
	37.000000f,
	// 1178
	0.894139f, 0.339665f,
	0.956881f, -0.065270f, -0.283053f,
	-0.154427f, 0.869841f, 0.058407f,
	37.000000f,
	// 1179
	0.873091f, 0.290875f,
	0.763912f, 0.048801f, -0.643472f,
	-0.148098f, 0.800014f, 0.069903f,
	3.000000f,
	// 1180
	0.846090f, 0.246280f,
	0.661330f, 0.193092f, -0.724816f,
	-0.132045f, 0.724137f, 0.073454f,
	3.000000f,
	// 1181
	0.852797f, 0.285250f,
	0.559226f, 0.070478f, -0.826014f,
	-0.126127f, 0.826943f, 0.095727f,
	3.000000f,
	// 1182
	0.847547f, 0.271036f,
	0.618211f, 0.085691f, -0.781327f,
	-0.119911f, 0.795813f, 0.097672f,
	3.000000f,
	// 1183
	0.841076f, 0.313519f,
	0.540681f, -0.018461f, -0.841025f,
	-0.122921f, 0.870416f, 0.101922f,
	37.000000f,
	// 1184
	0.832331f, 0.355707f,
	0.429163f, -0.193813f, -0.882188f,
	-0.120409f, 0.925195f, 0.096998f,
	1.000000f,
	// 1185
	0.843839f, 0.373272f,
	0.688830f, -0.252978f, -0.679350f,
	-0.130817f, 0.938160f, 0.086593f,
	1.000000f,
	// 1186
	0.862932f, 0.395682f,
	0.952496f, -0.280638f, -0.118297f,
	-0.137971f, 0.931320f, 0.068281f,
	1.000000f,
	// 1187
	0.863345f, 0.368419f,
	0.925827f, -0.248213f, -0.285018f,
	-0.139660f, 0.928555f, 0.077525f,
	1.000000f,
	// 1188
	0.860209f, 0.424013f,
	0.922871f, -0.251613f, -0.291548f,
	-0.136723f, 0.952762f, 0.056147f,
	1.000000f,
	// 1189
	0.880937f, 0.409339f,
	0.948408f, -0.226528f, -0.221829f,
	-0.144757f, 0.931542f, 0.045270f,
	1.000000f,
	// 1190
	0.900731f, 0.395304f,
	0.962194f, -0.209253f, -0.174344f,
	-0.151857f, 0.910034f, 0.035216f,
	1.000000f,
	// 1191
	0.895919f, 0.424810f,
	0.969840f, -0.237599f, -0.054381f,
	-0.151448f, 0.920005f, 0.021083f,
	1.000000f,
	// 1192
	0.939384f, 0.367873f,
	0.992530f, -0.102007f, -0.066921f,
	-0.161513f, 0.872784f, 0.015963f,
	37.000000f,
	// 1193
	0.923653f, 0.359309f,
	0.980673f, -0.105258f, -0.164926f,
	-0.159327f, 0.874860f, 0.034911f,
	37.000000f,
	// 1194
	0.982677f, 0.309128f,
	0.987644f, 0.147827f, 0.052030f,
	-0.154763f, 0.730169f, 0.004499f,
	3.000000f,
	// 1195
	0.961031f, 0.338501f,
	0.993643f, 0.070910f, -0.087435f,
	-0.162615f, 0.814452f, 0.011510f,
	3.000000f,
	// 1196
	0.944139f, 0.337765f,
	0.989089f, 0.002208f, -0.147303f,
	-0.159929f, 0.830462f, 0.027057f,
	3.000000f,
	// 1197
	0.946517f, 0.322710f,
	0.999915f, -0.008646f, 0.009716f,
	-0.159950f, 0.800053f, 0.032732f,
	3.000000f,
	// 1198
	0.796499f, 0.228473f,
	0.233113f, 0.283931f, -0.930076f,
	-0.075008f, 0.722004f, 0.097825f,
	3.000000f,
	// 1199
	0.803437f, 0.251701f,
	0.232488f, 0.192262f, -0.953407f,
	-0.085211f, 0.766086f, 0.108725f,
	3.000000f,
	// 1200
	0.821919f, 0.260374f,
	0.330507f, 0.140114f, -0.933345f,
	-0.099977f, 0.780598f, 0.105354f,
	3.000000f,
	// 1201
	0.825315f, 0.233405f,
	0.325716f, 0.283599f, -0.901932f,
	-0.096845f, 0.722594f, 0.091085f,
	3.000000f,
	// 1202
	0.760862f, 0.256719f,
	0.039862f, 0.167774f, -0.985019f,
	-0.034905f, 0.764172f, 0.115107f,
	3.000000f,
	// 1203
	0.756737f, 0.239236f,
	0.021399f, 0.259419f, -0.965528f,
	-0.025972f, 0.721479f, 0.103834f,
	46.000000f,
	// 1204
	0.773291f, 0.261774f,
	0.828746f, 0.206095f, -0.520292f,
	-0.143171f, 0.725283f, 0.060347f,
	3.000000f,
	// 1205
	0.818979f, 0.286613f,
	0.844399f, 0.111009f, -0.524087f,
	-0.152495f, 0.769447f, 0.062989f,
	3.000000f,
	// 1206
	0.768761f, 0.303962f,
	0.950253f, 0.029518f, -0.310076f,
	-0.156726f, 0.784799f, 0.052368f,
	3.000000f,
	// 1207
	0.667590f, 0.280875f,
	0.934982f, 0.196355f, -0.295386f,
	-0.150396f, 0.726684f, 0.044341f,
	3.000000f,
	// 1208
	0.483641f, 0.301811f,
	0.927565f, 0.284376f, 0.242390f,
	-0.150418f, 0.732277f, -0.019596f,
	3.000000f,
	// 1209
	0.504266f, 0.311981f,
	0.967574f, 0.143222f, 0.208056f,
	-0.159887f, 0.767214f, -0.024351f,
	3.000000f,
	// 1210
	0.523849f, 0.305174f,
	0.938764f, 0.061412f, 0.339044f,
	-0.155403f, 0.782008f, -0.039077f,
	3.000000f,
	// 1211
	0.508574f, 0.285654f,
	0.899105f, 0.269666f, 0.344806f,
	-0.143611f, 0.734250f, -0.042143f,
	3.000000f,
	// 1212
	0.577610f, 0.249351f,
	0.517971f, 0.295654f, 0.802680f,
	-0.111011f, 0.737846f, -0.083250f,
	3.000000f,
	// 1213
	0.595759f, 0.265775f,
	0.579338f, 0.139392f, 0.803080f,
	-0.114892f, 0.763903f, -0.090343f,
	3.000000f,
	// 1214
	0.615676f, 0.264870f,
	0.497710f, 0.054560f, 0.865626f,
	-0.102553f, 0.777870f, -0.097335f,
	3.000000f,
	// 1215
	0.603951f, 0.240768f,
	0.478501f, 0.270721f, 0.835312f,
	-0.092747f, 0.738783f, -0.093955f,
	3.000000f,
	// 1216
	0.630612f, 0.232081f,
	0.391956f, 0.272219f, 0.878788f,
	-0.074299f, 0.739701f, -0.104442f,
	3.000000f,
	// 1217
	0.631094f, 0.254262f,
	0.457622f, 0.147202f, 0.876877f,
	-0.088731f, 0.763903f, -0.105502f,
	3.000000f,
	// 1218
	0.530702f, 0.271314f,
	0.814757f, 0.241412f, 0.527154f,
	-0.136478f, 0.735705f, -0.058769f,
	3.000000f,
	// 1219
	0.535640f, 0.291650f,
	0.868105f, 0.131878f, 0.478541f,
	-0.149953f, 0.767214f, -0.052373f,
	3.000000f,
	// 1220
	0.562337f, 0.299896f,
	0.981542f, 0.170826f, -0.085988f,
	-0.154508f, 0.728309f, 0.025768f,
	3.000000f,
	// 1221
	0.678343f, 0.312028f,
	0.987592f, 0.080981f, -0.134549f,
	-0.160574f, 0.769447f, 0.038254f,
	3.000000f,
	// 1222
	0.683831f, 0.327584f,
	0.999915f, -0.008646f, 0.009716f,
	-0.159950f, 0.800053f, 0.032732f,
	3.000000f,
	// 1223
	0.852638f, 0.238082f,
	0.451326f, 0.280036f, -0.847281f,
	-0.116230f, 0.723273f, 0.083331f,
	3.000000f,
	// 1224
	0.840863f, 0.258107f,
	0.480997f, 0.179172f, -0.858219f,
	-0.114587f, 0.766086f, 0.098357f,
	3.000000f,
	// 1225
	0.683882f, 0.267576f,
	0.164989f, 0.002248f, 0.986293f,
	-0.042862f, 0.818853f, -0.121826f,
	3.000000f,
};

//-----------------------------------------------------------------------------
//	_obt@
//-----------------------------------------------------------------------------
static float april_vertex_buf1[] = {
	// 0
	0.777566f, 0.889048f,
	0.965926f, -0.036015f, 0.256299f,
	0.048684f, 1.540907f, 0.076844f,
	28.000000f,
	// 1
	0.766516f, 0.889048f,
	0.912269f, -0.057011f, 0.405605f,
	0.046520f, 1.539783f, 0.084842f,
	28.000000f,
	// 2
	0.753408f, 0.841191f,
	0.683008f, -0.712389f, 0.161252f,
	0.043953f, 1.529596f, 0.075254f,
	28.000000f,
	// 3
	0.695086f, 0.821368f,
	0.000005f, -0.992546f, 0.121868f,
	0.032531f, 1.524911f, 0.074596f,
	28.000000f,
	// 4
	0.720340f, 0.839019f,
	0.350756f, -0.894202f, 0.278161f,
	0.037477f, 1.527959f, 0.083180f,
	28.000000f,
	// 5
	0.695086f, 0.830435f,
	0.000006f, -0.960393f, 0.278651f,
	0.032531f, 1.525930f, 0.082895f,
	28.000000f,
	// 6
	0.745594f, 0.847602f,
	0.645068f, -0.695797f, 0.315837f,
	0.042423f, 1.529988f, 0.083465f,
	28.000000f,
	// 7
	0.756055f, 0.868325f,
	0.846787f, -0.402998f, 0.347196f,
	0.044471f, 1.534885f, 0.084154f,
	28.000000f,
	// 8
	0.751421f, 0.889048f,
	0.738238f, -0.093877f, 0.667976f,
	0.044066f, 1.539302f, 0.088267f,
	28.000000f,
	// 9
	0.756055f, 0.909770f,
	0.846793f, 0.291682f, 0.444819f,
	0.044471f, 1.544681f, 0.085530f,
	28.000000f,
	// 10
	0.734921f, 0.921735f,
	0.522011f, 0.423059f, 0.740625f,
	0.040688f, 1.547379f, 0.089402f,
	28.000000f,
	// 11
	0.745594f, 0.930493f,
	0.645072f, 0.581794f, 0.495377f,
	0.042423f, 1.549578f, 0.086219f,
	28.000000f,
	// 12
	0.720340f, 0.939077f,
	0.350746f, 0.782901f, 0.513852f,
	0.037477f, 1.551607f, 0.086504f,
	28.000000f,
	// 13
	0.695086f, 0.870778f,
	0.000000f, -0.376938f, 0.926239f,
	0.032531f, 1.534189f, 0.091241f,
	28.000000f,
	// 14
	0.695086f, 0.855208f,
	0.000000f, -0.591596f, 0.806234f,
	0.032531f, 1.531032f, 0.089664f,
	28.000000f,
	// 15
	0.710830f, 0.857859f,
	0.188895f, -0.572632f, 0.797754f,
	0.035521f, 1.531800f, 0.089772f,
	28.000000f,
	// 16
	0.695086f, 0.842822f,
	0.000000f, -0.824928f, 0.565238f,
	0.032531f, 1.527879f, 0.086662f,
	28.000000f,
	// 17
	0.734921f, 0.856361f,
	0.522015f, -0.610809f, 0.595326f,
	0.040688f, 1.531224f, 0.087132f,
	28.000000f,
	// 18
	0.733095f, 0.876129f,
	0.456029f, -0.308092f, 0.834935f,
	0.039750f, 1.535988f, 0.090361f,
	28.000000f,
	// 19
	0.736326f, 0.889048f,
	0.473627f, -0.122575f, 0.872154f,
	0.040526f, 1.538949f, 0.090777f,
	28.000000f,
	// 20
	0.717351f, 0.889048f,
	0.244360f, -0.134954f, 0.960248f,
	0.037180f, 1.538793f, 0.091888f,
	28.000000f,
	// 21
	0.710830f, 0.901967f,
	0.172788f, 0.036153f, 0.984295f,
	0.035818f, 1.542048f, 0.092346f,
	28.000000f,
	// 22
	0.695086f, 0.889048f,
	0.000000f, -0.139173f, 0.990268f,
	0.032531f, 1.538691f, 0.092613f,
	28.000000f,
	// 23
	0.710830f, 0.876129f,
	0.172790f, -0.306060f, 0.936200f,
	0.035818f, 1.535537f, 0.091431f,
	28.000000f,
	// 24
	0.724247f, 0.865119f,
	0.334907f, -0.454226f, 0.825540f,
	0.038184f, 1.533351f, 0.089990f,
	28.000000f,
	// 25
	0.679342f, 0.876129f,
	-0.172790f, -0.306060f, 0.936200f,
	0.029244f, 1.535537f, 0.091431f,
	28.000000f,
	// 26
	0.733095f, 0.901967f,
	0.456026f, 0.066019f, 0.887515f,
	0.039750f, 1.541910f, 0.091193f,
	28.000000f,
	// 27
	0.724247f, 0.912976f,
	0.334903f, 0.209063f, 0.918767f,
	0.038184f, 1.544547f, 0.091564f,
	28.000000f,
	// 28
	0.710830f, 0.920237f,
	0.188894f, 0.330551f, 0.924692f,
	0.035521f, 1.546097f, 0.091782f,
	28.000000f,
	// 29
	0.695086f, 0.935274f,
	0.000000f, 0.637179f, 0.770716f,
	0.032531f, 1.550725f, 0.089873f,
	28.000000f,
	// 30
	0.695086f, 0.922888f,
	0.000000f, 0.346448f, 0.938069f,
	0.032531f, 1.546866f, 0.091890f,
	28.000000f,
	// 31
	0.695086f, 0.907318f,
	0.000000f, 0.107024f, 0.994256f,
	0.032531f, 1.543396f, 0.092535f,
	28.000000f,
	// 32
	0.679342f, 0.920237f,
	-0.188894f, 0.330551f, 0.924692f,
	0.029541f, 1.546097f, 0.091782f,
	28.000000f,
	// 33
	0.679342f, 0.901967f,
	-0.172788f, 0.036153f, 0.984295f,
	0.029244f, 1.542048f, 0.092346f,
	28.000000f,
	// 34
	0.665925f, 0.912976f,
	-0.334904f, 0.209063f, 0.918767f,
	0.026878f, 1.544547f, 0.091564f,
	28.000000f,
	// 35
	0.657076f, 0.901967f,
	-0.456026f, 0.066019f, 0.887515f,
	0.025312f, 1.541910f, 0.091193f,
	28.000000f,
	// 36
	0.655251f, 0.921735f,
	-0.522011f, 0.423059f, 0.740626f,
	0.024374f, 1.547379f, 0.089402f,
	28.000000f,
	// 37
	0.638751f, 0.889048f,
	-0.738238f, -0.093877f, 0.667976f,
	0.020996f, 1.539302f, 0.088267f,
	28.000000f,
	// 38
	0.672820f, 0.889048f,
	-0.244360f, -0.134954f, 0.960248f,
	0.027882f, 1.538793f, 0.091888f,
	28.000000f,
	// 39
	0.657076f, 0.876129f,
	-0.456029f, -0.308093f, 0.834935f,
	0.025312f, 1.535988f, 0.090361f,
	28.000000f,
	// 40
	0.653846f, 0.889048f,
	-0.473627f, -0.122575f, 0.872154f,
	0.024536f, 1.538949f, 0.090777f,
	28.000000f,
	// 41
	0.634117f, 0.909770f,
	-0.846793f, 0.291683f, 0.444816f,
	0.020591f, 1.544681f, 0.085530f,
	28.000000f,
	// 42
	0.623656f, 0.889048f,
	-0.912270f, -0.057013f, 0.405602f,
	0.018542f, 1.539783f, 0.084842f,
	28.000000f,
	// 43
	0.634117f, 0.868325f,
	-0.846790f, -0.402995f, 0.347190f,
	0.020591f, 1.534885f, 0.084154f,
	28.000000f,
	// 44
	0.655251f, 0.856361f,
	-0.522015f, -0.610809f, 0.595326f,
	0.024374f, 1.531224f, 0.087132f,
	28.000000f,
	// 45
	0.665925f, 0.865119f,
	-0.334907f, -0.454226f, 0.825540f,
	0.026878f, 1.533351f, 0.089990f,
	28.000000f,
	// 46
	0.679342f, 0.857859f,
	-0.188895f, -0.572632f, 0.797754f,
	0.029541f, 1.531800f, 0.089772f,
	28.000000f,
	// 47
	0.636764f, 0.936905f,
	-0.683013f, 0.640344f, 0.351357f,
	0.021109f, 1.552218f, 0.078434f,
	28.000000f,
	// 48
	0.644577f, 0.930493f,
	-0.645073f, 0.581792f, 0.495378f,
	0.022639f, 1.549578f, 0.086219f,
	28.000000f,
	// 49
	0.612606f, 0.889048f,
	-0.965925f, -0.036018f, 0.256304f,
	0.016378f, 1.540907f, 0.076844f,
	28.000000f,
	// 50
	0.644577f, 0.847602f,
	-0.645068f, -0.695797f, 0.315837f,
	0.022639f, 1.529988f, 0.083465f,
	28.000000f,
	// 51
	0.669832f, 0.839019f,
	-0.350760f, -0.894196f, 0.278173f,
	0.027585f, 1.527959f, 0.083180f,
	28.000000f,
	// 52
	0.636764f, 0.841191f,
	-0.683011f, -0.712386f, 0.161251f,
	0.021109f, 1.529596f, 0.075254f,
	28.000000f,
	// 53
	0.753408f, 0.936905f,
	0.683011f, 0.640346f, 0.351358f,
	0.043953f, 1.552218f, 0.078434f,
	28.000000f,
	// 54
	0.695086f, 0.947660f,
	0.000001f, 0.846387f, 0.532569f,
	0.032531f, 1.553636f, 0.086789f,
	28.000000f,
	// 55
	0.669832f, 0.939077f,
	-0.350745f, 0.782898f, 0.513856f,
	0.027585f, 1.551607f, 0.086504f,
	28.000000f,
	// 56
	0.695086f, 0.956727f,
	0.000002f, 0.920503f, 0.390736f,
	0.032531f, 1.556903f, 0.079092f,
	28.000000f,
	// 57
	0.010478f, 0.766484f,
	0.271423f, 0.039491f, 0.961650f,
	0.004620f, 1.489390f, 0.104946f,
	28.000000f,
	// 58
	0.002178f, 0.757057f,
	-0.000000f, -0.130966f, 0.991387f,
	-0.000000f, 1.484046f, 0.106418f,
	28.000000f,
	// 59
	0.008715f, 0.758240f,
	0.374059f, -0.119049f, 0.919732f,
	0.005930f, 1.484808f, 0.105217f,
	28.000000f,
	// 60
	0.002178f, 0.752583f,
	-0.000000f, -0.586086f, 0.810249f,
	-0.000000f, 1.480493f, 0.104816f,
	28.000000f,
	// 61
	0.008728f, 0.753720f,
	0.301526f, -0.578906f, 0.757595f,
	0.005310f, 1.480813f, 0.103404f,
	28.000000f,
	// 62
	0.002178f, 0.748600f,
	-0.000000f, -0.924936f, 0.380123f,
	-0.000000f, 1.477090f, 0.101026f,
	28.000000f,
	// 63
	0.008766f, 0.749286f,
	0.214325f, -0.901284f, 0.376500f,
	0.004889f, 1.477928f, 0.100237f,
	28.000000f,
	// 64
	0.002178f, 0.748529f,
	0.000000f, -0.906447f, -0.422319f,
	-0.000000f, 1.477043f, 0.098577f,
	28.000000f,
	// 65
	0.008824f, 0.748769f,
	-0.215421f, -0.783218f, -0.583235f,
	0.004270f, 1.477624f, 0.096032f,
	28.000000f,
	// 66
	0.002178f, 0.748381f,
	0.000000f, -0.180791f, -0.983522f,
	-0.000000f, 1.488114f, 0.096102f,
	28.000000f,
	// 67
	0.022552f, 0.748104f,
	-0.215327f, -0.762725f, -0.609824f,
	0.012199f, 1.478719f, 0.092208f,
	28.000000f,
	// 68
	0.022723f, 0.748529f,
	0.286061f, -0.912035f, 0.293873f,
	0.011709f, 1.478536f, 0.097586f,
	28.000000f,
	// 69
	0.015287f, 0.783327f,
	0.605356f, -0.776109f, 0.176633f,
	0.005917f, 1.497435f, 0.109720f,
	28.000000f,
	// 70
	0.015181f, 0.780980f,
	0.200994f, -0.815656f, 0.542501f,
	0.006517f, 1.499052f, 0.103736f,
	28.000000f,
	// 71
	0.021102f, 0.782805f,
	0.125319f, -0.949294f, 0.288333f,
	0.008971f, 1.497249f, 0.105815f,
	28.000000f,
	// 72
	0.023807f, 0.776865f,
	0.480031f, -0.353003f, 0.803094f,
	0.009877f, 1.496101f, 0.102898f,
	28.000000f,
	// 73
	0.012563f, 0.774416f,
	0.377206f, 0.051937f, 0.924672f,
	0.006515f, 1.495015f, 0.104248f,
	28.000000f,
	// 74
	0.029704f, 0.765589f,
	0.530517f, -0.012135f, 0.847588f,
	0.012048f, 1.489432f, 0.100698f,
	28.000000f,
	// 75
	0.026620f, 0.755268f,
	0.570795f, -0.201278f, 0.796040f,
	0.013299f, 1.483004f, 0.100299f,
	28.000000f,
	// 76
	0.025328f, 0.752323f,
	0.468488f, -0.591644f, 0.656107f,
	0.012621f, 1.480193f, 0.099341f,
	28.000000f,
	// 77
	0.033183f, 0.777567f,
	0.655632f, -0.158027f, 0.738359f,
	0.013102f, 1.498773f, 0.100964f,
	28.000000f,
	// 78
	0.042754f, 0.764074f,
	0.525775f, -0.116516f, 0.842606f,
	0.017032f, 1.488888f, 0.097574f,
	28.000000f,
	// 79
	0.036946f, 0.753826f,
	0.598945f, -0.310960f, 0.737949f,
	0.017820f, 1.482276f, 0.096070f,
	28.000000f,
	// 80
	0.036369f, 0.750263f,
	0.434483f, -0.745100f, 0.506015f,
	0.017156f, 1.479726f, 0.094864f,
	28.000000f,
	// 81
	0.035648f, 0.748988f,
	0.171821f, -0.976148f, 0.132713f,
	0.015900f, 1.479016f, 0.093659f,
	28.000000f,
	// 82
	0.034322f, 0.748435f,
	-0.346267f, -0.640723f, -0.685254f,
	0.016072f, 1.479180f, 0.089423f,
	28.000000f,
	// 83
	0.045176f, 0.748609f,
	0.524178f, -0.442193f, 0.727807f,
	0.019104f, 1.479340f, 0.091956f,
	28.000000f,
	// 84
	0.047495f, 0.753770f,
	0.576860f, -0.477092f, 0.663035f,
	0.020947f, 1.481670f, 0.093110f,
	28.000000f,
	// 85
	0.058058f, 0.761762f,
	0.534245f, -0.293982f, 0.792563f,
	0.023801f, 1.485442f, 0.092378f,
	28.000000f,
	// 86
	0.051693f, 0.772834f,
	0.478104f, -0.205628f, 0.853893f,
	0.023548f, 1.493501f, 0.095359f,
	28.000000f,
	// 87
	0.044924f, 0.748395f,
	-0.499086f, 0.100007f, -0.860763f,
	0.019767f, 1.479539f, 0.088368f,
	28.000000f,
	// 88
	0.043773f, 0.748515f,
	-0.559839f, -0.007504f, -0.828567f,
	0.023727f, 1.488114f, 0.085577f,
	28.000000f,
	// 89
	0.043878f, 0.748672f,
	-0.547579f, 0.347780f, -0.761056f,
	0.024084f, 1.470597f, 0.081310f,
	28.000000f,
	// 90
	0.043878f, 0.748672f,
	-0.547579f, 0.347780f, -0.761056f,
	0.024084f, 1.470597f, 0.081310f,
	28.000000f,
	// 91
	0.026817f, 0.748329f,
	-0.280057f, 0.856266f, -0.434024f,
	0.013140f, 1.478872f, 0.091570f,
	28.000000f,
	// 92
	0.027240f, 0.785693f,
	0.826223f, -0.258747f, 0.500406f,
	0.011297f, 1.500294f, 0.106987f,
	28.000000f,
	// 93
	0.036452f, 0.789919f,
	0.694600f, 0.039314f, 0.718321f,
	0.013074f, 1.504332f, 0.100921f,
	28.000000f,
	// 94
	0.002178f, 0.747679f,
	0.000000f, 0.449695f, -0.893182f,
	-0.000000f, 1.470597f, 0.093187f,
	28.000000f,
	// 95
	0.026817f, 0.748329f,
	-0.280057f, 0.856266f, -0.434024f,
	0.013140f, 1.478872f, 0.091570f,
	28.000000f,
	// 96
	0.015757f, 0.786846f,
	0.805528f, -0.350952f, 0.477449f,
	0.006751f, 1.500230f, 0.111847f,
	28.000000f,
	// 97
	0.009221f, 0.785303f,
	0.665848f, -0.405816f, 0.626067f,
	0.004443f, 1.500252f, 0.117516f,
	28.000000f,
	// 98
	0.008277f, 0.778637f,
	0.563445f, -0.752475f, 0.341044f,
	0.003756f, 1.495649f, 0.111798f,
	28.000000f,
	// 99
	0.017278f, 0.794297f,
	0.865016f, 0.167160f, 0.473080f,
	0.007834f, 1.506127f, 0.111259f,
	28.000000f,
	// 100
	0.028180f, 0.792762f,
	0.894047f, 0.219486f, 0.390519f,
	0.011710f, 1.505435f, 0.104063f,
	28.000000f,
	// 101
	0.029076f, 0.800448f,
	0.722998f, 0.119851f, 0.680375f,
	0.011643f, 1.508724f, 0.101840f,
	28.000000f,
	// 102
	0.010274f, 0.794307f,
	0.642952f, 0.229509f, 0.730711f,
	0.004904f, 1.505852f, 0.118395f,
	28.000000f,
	// 103
	0.010635f, 0.803090f,
	0.607977f, 0.470184f, 0.639758f,
	0.004335f, 1.510814f, 0.113806f,
	28.000000f,
	// 104
	0.002178f, 0.783102f,
	-0.000000f, -0.508180f, 0.861251f,
	-0.000000f, 1.499323f, 0.119446f,
	28.000000f,
	// 105
	0.002178f, 0.776244f,
	-0.000000f, -0.883330f, 0.468752f,
	-0.000000f, 1.494957f, 0.112904f,
	28.000000f,
	// 106
	0.002178f, 0.771257f,
	-0.000000f, -0.681562f, 0.731761f,
	-0.000000f, 1.492352f, 0.106067f,
	28.000000f,
	// 107
	0.007226f, 0.772578f,
	0.535255f, -0.436235f, 0.723327f,
	0.003500f, 1.493627f, 0.105656f,
	28.000000f,
	// 108
	0.002178f, 0.765731f,
	-0.000000f, 0.024748f, 0.999694f,
	-0.000000f, 1.489214f, 0.104912f,
	28.000000f,
	// 109
	0.002294f, 0.859087f,
	-0.000000f, -0.142729f, 0.989762f,
	-0.000000f, 1.547008f, 0.104507f,
	28.000000f,
	// 110
	0.002294f, 0.840254f,
	-0.000000f, 0.163238f, 0.986587f,
	-0.000000f, 1.535450f, 0.104186f,
	28.000000f,
	// 111
	0.012745f, 0.840217f,
	0.601488f, 0.076159f, 0.795243f,
	0.004922f, 1.535032f, 0.102137f,
	28.000000f,
	// 112
	0.011829f, 0.820129f,
	0.501338f, 0.333727f, 0.798302f,
	0.004746f, 1.523406f, 0.106795f,
	28.000000f,
	// 113
	0.002294f, 0.820265f,
	-0.000000f, 0.414799f, 0.909913f,
	-0.000000f, 1.523589f, 0.107956f,
	28.000000f,
	// 114
	0.002294f, 0.804043f,
	-0.000000f, 0.598603f, 0.801046f,
	-0.000000f, 1.511047f, 0.115444f,
	28.000000f,
	// 115
	0.002294f, 0.794435f,
	-0.000000f, 0.294800f, 0.955559f,
	-0.000000f, 1.505870f, 0.119951f,
	28.000000f,
	// 116
	0.026386f, 0.885728f,
	0.142206f, -0.060530f, 0.987985f,
	0.011505f, 1.558972f, 0.105362f,
	28.000000f,
	// 117
	0.002294f, 0.886054f,
	-0.000000f, -0.051035f, 0.998697f,
	-0.000000f, 1.558651f, 0.106122f,
	28.000000f,
	// 118
	0.023690f, 0.859507f,
	0.282247f, -0.330685f, 0.900546f,
	0.008608f, 1.547669f, 0.103232f,
	28.000000f,
	// 119
	0.031319f, 0.850041f,
	0.398376f, -0.423210f, 0.813751f,
	0.014197f, 1.540142f, 0.092853f,
	28.000000f,
	// 120
	0.026065f, 0.838696f,
	0.693881f, 0.076404f, 0.716025f,
	0.010392f, 1.533260f, 0.093696f,
	28.000000f,
	// 121
	0.024046f, 0.818705f,
	0.668532f, 0.265378f, 0.694722f,
	0.011984f, 1.520775f, 0.100793f,
	28.000000f,
	// 122
	0.020095f, 0.802069f,
	0.832199f, 0.230184f, 0.504440f,
	0.008237f, 1.510185f, 0.107866f,
	28.000000f,
	// 123
	0.039673f, 0.816903f,
	0.450603f, 0.285041f, 0.845996f,
	0.018051f, 1.518098f, 0.097270f,
	28.000000f,
	// 124
	0.040151f, 0.837469f,
	0.475922f, 0.133468f, 0.869301f,
	0.017124f, 1.532540f, 0.090234f,
	28.000000f,
	// 125
	0.047303f, 0.843828f,
	0.385151f, -0.592254f, 0.707739f,
	0.020545f, 1.536924f, 0.091566f,
	28.000000f,
	// 126
	0.050759f, 0.857897f,
	0.129655f, -0.543742f, 0.829177f,
	0.022303f, 1.545019f, 0.094420f,
	28.000000f,
	// 127
	0.054885f, 0.849581f,
	0.177913f, -0.595009f, 0.783780f,
	0.024652f, 1.541175f, 0.093813f,
	28.000000f,
	// 128
	0.068231f, 0.853290f,
	0.148882f, -0.631947f, 0.760577f,
	0.030619f, 1.543884f, 0.094359f,
	28.000000f,
	// 129
	0.056006f, 0.825124f,
	0.188057f, 0.218596f, 0.957523f,
	0.025664f, 1.525104f, 0.090737f,
	28.000000f,
	// 130
	0.051835f, 0.836245f,
	0.064806f, 0.710078f, 0.701135f,
	0.023749f, 1.531457f, 0.089780f,
	28.000000f,
	// 131
	0.062155f, 0.846670f,
	0.414169f, -0.870271f, 0.266631f,
	0.027990f, 1.540446f, 0.085634f,
	28.000000f,
	// 132
	0.059412f, 0.845366f,
	0.619136f, -0.736021f, 0.273757f,
	0.025051f, 1.537863f, 0.082985f,
	28.000000f,
	// 133
	0.059032f, 0.844016f,
	0.860415f, -0.074142f, 0.504172f,
	0.022659f, 1.534599f, 0.080831f,
	28.000000f,
	// 134
	0.060952f, 0.843434f,
	0.349484f, 0.871537f, 0.343925f,
	0.023667f, 1.533118f, 0.081262f,
	28.000000f,
	// 135
	0.062818f, 0.835294f,
	-0.022118f, 0.594806f, 0.803565f,
	0.028930f, 1.530871f, 0.090962f,
	28.000000f,
	// 136
	0.076247f, 0.836136f,
	0.069908f, 0.464157f, 0.882990f,
	0.035767f, 1.530972f, 0.090758f,
	28.000000f,
	// 137
	0.065538f, 0.842823f,
	0.069107f, 0.984422f, 0.161672f,
	0.029433f, 1.532566f, 0.082016f,
	28.000000f,
	// 138
	0.069885f, 0.843444f,
	-0.065591f, 0.987498f, 0.143337f,
	0.033270f, 1.532002f, 0.082522f,
	28.000000f,
	// 139
	0.074899f, 0.844324f,
	-0.429549f, 0.760877f, 0.486367f,
	0.037676f, 1.533751f, 0.082890f,
	28.000000f,
	// 140
	0.087511f, 0.840817f,
	0.217116f, 0.337955f, 0.915777f,
	0.041352f, 1.532511f, 0.089262f,
	28.000000f,
	// 141
	0.095260f, 0.846991f,
	0.521285f, -0.253216f, 0.814950f,
	0.046051f, 1.538219f, 0.086639f,
	28.000000f,
	// 142
	0.080837f, 0.846356f,
	-0.281075f, -0.396056f, 0.874149f,
	0.039159f, 1.537298f, 0.084005f,
	28.000000f,
	// 143
	0.084580f, 0.848242f,
	-0.298302f, -0.750868f, 0.589248f,
	0.038119f, 1.538919f, 0.085227f,
	28.000000f,
	// 144
	0.068960f, 0.849149f,
	0.094483f, -0.953894f, 0.284883f,
	0.032274f, 1.542120f, 0.086719f,
	28.000000f,
	// 145
	0.081699f, 0.852569f,
	0.136260f, -0.604128f, 0.785152f,
	0.038171f, 1.543665f, 0.092925f,
	28.000000f,
	// 146
	0.077548f, 0.848802f,
	-0.367274f, -0.842987f, 0.393042f,
	0.035335f, 1.541252f, 0.085100f,
	28.000000f,
	// 147
	0.092706f, 0.850638f,
	0.330354f, -0.513352f, 0.792045f,
	0.043839f, 1.541334f, 0.089677f,
	28.000000f,
	// 148
	0.097744f, 0.859069f,
	0.689786f, -0.184723f, 0.700052f,
	0.046194f, 1.545394f, 0.088643f,
	28.000000f,
	// 149
	0.114145f, 0.848944f,
	0.861600f, -0.084053f, 0.500581f,
	0.053124f, 1.538638f, 0.075296f,
	28.000000f,
	// 150
	0.104263f, 0.872056f,
	0.744803f, -0.111222f, 0.657950f,
	0.048927f, 1.552853f, 0.088182f,
	28.000000f,
	// 151
	0.048633f, 0.866463f,
	0.274923f, -0.398505f, 0.874992f,
	0.021889f, 1.551552f, 0.102615f,
	28.000000f,
	// 152
	0.068332f, 0.862081f,
	0.204950f, -0.494306f, 0.844782f,
	0.030569f, 1.548579f, 0.095636f,
	28.000000f,
	// 153
	0.083502f, 0.861945f,
	0.416917f, -0.263818f, 0.869816f,
	0.039505f, 1.548397f, 0.093630f,
	28.000000f,
	// 154
	0.078441f, 0.873569f,
	0.421995f, -0.249233f, 0.871667f,
	0.036076f, 1.554184f, 0.097963f,
	28.000000f,
	// 155
	0.105486f, 0.888837f,
	0.770705f, 0.022903f, 0.636780f,
	0.049151f, 1.562714f, 0.087995f,
	28.000000f,
	// 156
	0.080507f, 0.891113f,
	0.459865f, 0.048021f, 0.886690f,
	0.036094f, 1.563377f, 0.098539f,
	28.000000f,
	// 157
	0.050699f, 0.888406f,
	0.276243f, 0.021154f, 0.960855f,
	0.021952f, 1.561665f, 0.102703f,
	28.000000f,
	// 158
	0.132551f, 0.874915f,
	0.912400f, -0.060661f, 0.404779f,
	0.056855f, 1.554376f, 0.074223f,
	28.000000f,
	// 159
	0.109521f, 0.905895f,
	0.744579f, 0.136579f, 0.653412f,
	0.048226f, 1.575005f, 0.088189f,
	28.000000f,
	// 160
	0.072228f, 0.906771f,
	0.372900f, 0.121926f, 0.919826f,
	0.029564f, 1.574471f, 0.099324f,
	28.000000f,
	// 161
	0.037231f, 0.906516f,
	0.194114f, 0.094094f, 0.976456f,
	0.013757f, 1.573841f, 0.104432f,
	28.000000f,
	// 162
	0.002582f, 0.906956f,
	-0.000000f, 0.077424f, 0.996998f,
	-0.000000f, 1.573151f, 0.105564f,
	28.000000f,
	// 163
	0.081768f, 0.947204f,
	0.431594f, 0.388851f, 0.813954f,
	0.031680f, 1.601894f, 0.095742f,
	28.000000f,
	// 164
	0.042796f, 0.950387f,
	0.204990f, 0.397803f, 0.894277f,
	0.016139f, 1.601879f, 0.099265f,
	28.000000f,
	// 165
	0.150370f, 0.857434f,
	0.958161f, -0.046078f, 0.282497f,
	0.063230f, 1.544278f, 0.053775f,
	28.000000f,
	// 166
	0.138885f, 0.896757f,
	0.917350f, 0.123945f, 0.378294f,
	0.057958f, 1.574449f, 0.069728f,
	28.000000f,
	// 167
	0.119610f, 0.944579f,
	0.769848f, 0.362575f, 0.525236f,
	0.045521f, 1.601046f, 0.080715f,
	28.000000f,
	// 168
	0.091523f, 0.969988f,
	0.411473f, 0.702800f, 0.580312f,
	0.029557f, 1.627186f, 0.073801f,
	28.000000f,
	// 169
	0.031639f, 0.984873f,
	-0.000000f, 0.729999f, 0.683449f,
	-0.000000f, 1.628723f, 0.081616f,
	28.000000f,
	// 170
	0.005593f, 0.952808f,
	-0.000000f, 0.383052f, 0.923727f,
	-0.000000f, 1.601910f, 0.102329f,
	28.000000f,
	// 171
	0.070789f, 0.998988f,
	-0.000000f, 0.937557f, 0.347832f,
	-0.000000f, 1.647379f, 0.054029f,
	28.000000f,
	// 172
	0.158258f, 0.832706f,
	0.975620f, -0.134827f, 0.173167f,
	0.062980f, 1.525316f, 0.046574f,
	28.000000f,
	// 173
	0.202051f, 0.846576f,
	0.927476f, -0.099252f, 0.360467f,
	0.071779f, 1.539895f, 0.015215f,
	28.000000f,
	// 174
	0.185490f, 0.880265f,
	0.968709f, 0.065947f, 0.239277f,
	0.066971f, 1.571639f, 0.041277f,
	28.000000f,
	// 175
	0.166909f, 0.917852f,
	0.921954f, 0.241942f, 0.302431f,
	0.060965f, 1.595573f, 0.048844f,
	28.000000f,
	// 176
	0.143247f, 0.956272f,
	0.747166f, 0.531750f, 0.398729f,
	0.048025f, 1.621052f, 0.059296f,
	28.000000f,
	// 177
	0.112802f, 0.981492f,
	0.372257f, 0.892635f, 0.254218f,
	0.028127f, 1.644093f, 0.044506f,
	28.000000f,
	// 178
	0.206988f, 0.999479f,
	-0.000000f, 0.984745f, -0.174003f,
	0.000000f, 1.651813f, -0.000109f,
	28.000000f,
	// 179
	0.225358f, 0.859401f,
	0.530598f, 0.826628f, -0.187486f,
	0.074366f, 1.547514f, -0.000636f,
	28.000000f,
	// 180
	0.226033f, 0.856219f,
	0.530874f, 0.516485f, 0.671875f,
	0.083021f, 1.548956f, 0.008234f,
	28.000000f,
	// 181
	0.225436f, 0.853909f,
	0.940537f, 0.313681f, 0.130363f,
	0.087177f, 1.545781f, -0.004428f,
	28.000000f,
	// 182
	0.226033f, 0.856219f,
	0.530874f, 0.516485f, 0.671875f,
	0.083021f, 1.548956f, 0.008234f,
	28.000000f,
	// 183
	0.202051f, 0.846576f,
	0.927476f, -0.099252f, 0.360467f,
	0.071779f, 1.539895f, 0.015215f,
	28.000000f,
	// 184
	0.287730f, 0.956738f,
	0.453907f, 0.601497f, -0.657396f,
	0.035698f, 1.624987f, -0.040722f,
	28.000000f,
	// 185
	0.264144f, 0.938890f,
	0.813245f, 0.470096f, -0.342990f,
	0.056826f, 1.617741f, -0.018297f,
	28.000000f,
	// 186
	0.326634f, 0.911744f,
	0.542716f, 0.190129f, -0.818114f,
	0.040455f, 1.590206f, -0.052289f,
	28.000000f,
	// 187
	0.288283f, 0.902987f,
	0.864443f, 0.123625f, -0.487293f,
	0.063427f, 1.583560f, -0.028067f,
	28.000000f,
	// 188
	0.335287f, 0.856357f,
	0.549880f, -0.227783f, -0.803584f,
	0.038562f, 1.543754f, -0.055196f,
	28.000000f,
	// 189
	0.298872f, 0.854147f,
	0.813439f, -0.222608f, -0.537366f,
	0.060379f, 1.542745f, -0.026312f,
	28.000000f,
	// 190
	0.233966f, 0.891784f,
	0.986425f, 0.123748f, -0.107947f,
	0.073984f, 1.578940f, 0.001443f,
	28.000000f,
	// 191
	0.250808f, 0.851097f,
	0.363761f, 0.426268f, -0.828235f,
	0.070808f, 1.542422f, -0.007564f,
	28.000000f,
	// 192
	0.237069f, 0.853306f,
	0.107590f, 0.899755f, -0.422925f,
	0.082134f, 1.549355f, -0.007586f,
	28.000000f,
	// 193
	0.246466f, 0.844326f,
	0.985432f, 0.116171f, -0.124211f,
	0.088964f, 1.539399f, -0.010889f,
	28.000000f,
	// 194
	0.248982f, 0.847182f,
	0.320292f, 0.308859f, -0.895555f,
	0.084793f, 1.539529f, -0.016229f,
	28.000000f,
	// 195
	0.204146f, 0.816758f,
	0.908310f, -0.237249f, 0.344508f,
	0.064780f, 1.518729f, 0.015127f,
	28.000000f,
	// 196
	0.245592f, 0.816206f,
	0.856856f, -0.411820f, -0.310164f,
	0.085602f, 1.517929f, -0.010718f,
	28.000000f,
	// 197
	0.249702f, 0.815630f,
	0.121672f, -0.289262f, -0.949486f,
	0.080681f, 1.519275f, -0.011763f,
	28.000000f,
	// 198
	0.256072f, 0.814235f,
	0.273314f, -0.340901f, -0.899492f,
	0.059157f, 1.524035f, -0.016426f,
	28.000000f,
	// 199
	0.318549f, 0.772181f,
	0.630262f, -0.247442f, -0.735895f,
	0.033580f, 1.505041f, -0.031958f,
	28.000000f,
	// 200
	0.270935f, 0.774733f,
	0.524205f, -0.363406f, -0.770159f,
	0.050102f, 1.505469f, -0.009189f,
	28.000000f,
	// 201
	0.231266f, 0.764289f,
	0.142595f, -0.689357f, -0.710249f,
	0.055040f, 1.497771f, -0.005618f,
	28.000000f,
	// 202
	0.242974f, 0.801547f,
	0.022079f, -0.392303f, -0.919571f,
	0.073095f, 1.504296f, -0.007549f,
	28.000000f,
	// 203
	0.229875f, 0.788858f,
	0.719251f, -0.568448f, -0.399431f,
	0.077329f, 1.503830f, -0.007351f,
	28.000000f,
	// 204
	0.219740f, 0.778820f,
	0.619802f, -0.777868f, -0.103760f,
	0.073065f, 1.497079f, -0.002762f,
	28.000000f,
	// 205
	0.200173f, 0.781885f,
	0.779954f, -0.625162f, 0.029061f,
	0.060108f, 1.496660f, 0.014581f,
	28.000000f,
	// 206
	0.201616f, 0.717922f,
	0.949194f, -0.278671f, 0.146198f,
	0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 207
	0.184433f, 0.776087f,
	0.939607f, -0.337402f, 0.057433f,
	0.057398f, 1.489930f, 0.026147f,
	28.000000f,
	// 208
	0.168046f, 0.749486f,
	0.757082f, -0.577963f, -0.304606f,
	0.051194f, 1.476383f, 0.026648f,
	28.000000f,
	// 209
	0.197621f, 0.760719f,
	0.650270f, -0.664324f, -0.368543f,
	0.049326f, 1.491296f, 0.015505f,
	28.000000f,
	// 210
	0.061109f, 0.692459f,
	0.475515f, -0.871263f, 0.121602f,
	0.014664f, 1.446085f, 0.074857f,
	28.000000f,
	// 211
	0.075941f, 0.675423f,
	0.507311f, -0.861550f, 0.019149f,
	0.019276f, 1.450072f, 0.042029f,
	28.000000f,
	// 212
	0.097909f, 0.713892f,
	0.666709f, -0.737677f, 0.106454f,
	0.030944f, 1.456564f, 0.057067f,
	28.000000f,
	// 213
	0.141834f, 0.717568f,
	0.649695f, -0.750054f, -0.123753f,
	0.041502f, 1.464653f, 0.034518f,
	28.000000f,
	// 214
	0.139872f, 0.740287f,
	0.806262f, -0.573744f, 0.144082f,
	0.044479f, 1.469835f, 0.043873f,
	28.000000f,
	// 215
	0.164571f, 0.770071f,
	0.919707f, -0.370038f, 0.131193f,
	0.055422f, 1.486962f, 0.033158f,
	28.000000f,
	// 216
	0.162794f, 0.808171f,
	0.972920f, -0.200674f, 0.114704f,
	0.061937f, 1.513236f, 0.041662f,
	28.000000f,
	// 217
	0.096738f, 0.728117f,
	0.764510f, -0.572696f, 0.295878f,
	0.034400f, 1.464446f, 0.065489f,
	28.000000f,
	// 218
	0.139494f, 0.784808f,
	0.925837f, -0.324119f, 0.194353f,
	0.054561f, 1.495669f, 0.053943f,
	28.000000f,
	// 219
	0.139772f, 0.761836f,
	0.893188f, -0.413063f, 0.177748f,
	0.051433f, 1.482561f, 0.048373f,
	28.000000f,
	// 220
	0.116808f, 0.753060f,
	0.823687f, -0.479437f, 0.302788f,
	0.044819f, 1.477757f, 0.064087f,
	28.000000f,
	// 221
	0.094339f, 0.743898f,
	0.741974f, -0.467854f, 0.480195f,
	0.038147f, 1.475518f, 0.073954f,
	28.000000f,
	// 222
	0.069835f, 0.721948f,
	0.731724f, -0.496707f, 0.466756f,
	0.026714f, 1.462104f, 0.077798f,
	28.000000f,
	// 223
	0.072398f, 0.738941f,
	0.646642f, -0.384309f, 0.658909f,
	0.030274f, 1.473674f, 0.082116f,
	28.000000f,
	// 224
	0.050876f, 0.718774f,
	0.662985f, -0.389229f, 0.639493f,
	0.020495f, 1.460970f, 0.085223f,
	28.000000f,
	// 225
	0.050413f, 0.737088f,
	0.592587f, -0.278123f, 0.755968f,
	0.019920f, 1.472998f, 0.089575f,
	28.000000f,
	// 226
	0.050771f, 0.703499f,
	0.713568f, -0.602934f, 0.356780f,
	0.022071f, 1.453712f, 0.075280f,
	28.000000f,
	// 227
	0.117053f, 0.777486f,
	0.842428f, -0.366535f, 0.394927f,
	0.048536f, 1.491442f, 0.071196f,
	28.000000f,
	// 228
	0.093988f, 0.770286f,
	0.706089f, -0.362917f, 0.608054f,
	0.040752f, 1.488759f, 0.080244f,
	28.000000f,
	// 229
	0.115283f, 0.796185f,
	0.828437f, -0.244564f, 0.503866f,
	0.051020f, 1.505407f, 0.076727f,
	28.000000f,
	// 230
	0.137743f, 0.803884f,
	0.941443f, -0.243929f, 0.232773f,
	0.058053f, 1.508626f, 0.060304f,
	28.000000f,
	// 231
	0.132137f, 0.822995f,
	0.935662f, -0.078005f, 0.344168f,
	0.058677f, 1.522137f, 0.066137f,
	28.000000f,
	// 232
	0.026857f, 0.689651f,
	0.406993f, -0.822149f, 0.398030f,
	0.009395f, 1.445120f, 0.084509f,
	28.000000f,
	// 233
	0.029225f, 0.701420f,
	0.512626f, -0.441786f, 0.736233f,
	0.011188f, 1.452530f, 0.089666f,
	28.000000f,
	// 234
	0.031614f, 0.715829f,
	0.453205f, -0.218039f, 0.864329f,
	0.012796f, 1.460537f, 0.091052f,
	28.000000f,
	// 235
	0.005529f, 0.664618f,
	0.000000f, -0.999501f, 0.031577f,
	-0.000000f, 1.442838f, 0.054540f,
	28.000000f,
	// 236
	0.004724f, 0.674682f,
	-0.000000f, -0.999624f, 0.027410f,
	-0.000000f, 1.443432f, 0.073039f,
	28.000000f,
	// 237
	0.005400f, 0.685455f,
	-0.000000f, -0.865696f, 0.500569f,
	-0.000000f, 1.444109f, 0.087414f,
	28.000000f,
	// 238
	0.002957f, 0.698082f,
	-0.000000f, -0.358143f, 0.933667f,
	-0.000000f, 1.452652f, 0.094276f,
	28.000000f,
	// 239
	0.003270f, 0.712935f,
	-0.000000f, -0.141784f, 0.989898f,
	-0.000000f, 1.460233f, 0.094562f,
	28.000000f,
	// 240
	0.033473f, 0.726151f,
	0.447646f, -0.351843f, 0.822082f,
	0.012427f, 1.465789f, 0.092374f,
	28.000000f,
	// 241
	0.003270f, 0.725698f,
	-0.000000f, -0.507849f, 0.861446f,
	-0.000000f, 1.464479f, 0.095649f,
	28.000000f,
	// 242
	0.201616f, 0.717922f,
	0.949194f, -0.278671f, 0.146198f,
	0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 243
	0.153115f, 0.690763f,
	0.825851f, -0.563580f, 0.018641f,
	0.035251f, 1.465074f, 0.023798f,
	28.000000f,
	// 244
	0.092161f, 0.663788f,
	0.684846f, -0.507998f, 0.522421f,
	0.019190f, 1.448975f, 0.035394f,
	28.000000f,
	// 245
	0.008028f, 0.651059f,
	-0.000000f, -0.740648f, 0.671893f,
	-0.000000f, 1.440963f, 0.044507f,
	13.000000f,
	// 246
	0.373046f, 0.724401f,
	0.294698f, 0.952424f, 0.077729f,
	0.070473f, 1.419354f, -0.013455f,
	13.000000f,
	// 247
	0.385675f, 0.710690f,
	0.045259f, 0.830534f, 0.555126f,
	0.063790f, 1.402228f, 0.011871f,
	13.000000f,
	// 248
	0.374394f, 0.752150f,
	-0.106994f, 0.993272f, 0.044303f,
	0.088672f, 1.416274f, -0.009552f,
	29.000000f,
	// 249
	0.380314f, 0.696810f,
	0.644673f, 0.497181f, 0.580695f,
	0.044275f, 1.419515f, 0.003267f,
	13.000000f,
	// 250
	0.369036f, 0.708312f,
	0.738910f, 0.664000f, -0.114524f,
	0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 251
	0.387850f, 0.678168f,
	0.339309f, 0.334258f, 0.879284f,
	0.022776f, 1.402154f, 0.031851f,
	13.000000f,
	// 252
	0.407841f, 0.658511f,
	-0.053152f, 0.663334f, 0.746433f,
	0.015962f, 1.380349f, 0.045197f,
	13.000000f,
	// 253
	0.410038f, 0.641463f,
	-0.000000f, 0.671180f, 0.741295f,
	-0.000000f, 1.375417f, 0.044863f,
	12.000000f,
	// 254
	0.395101f, 0.641194f,
	-0.000000f, 0.233411f, 0.972378f,
	-0.000000f, 1.395421f, 0.037360f,
	13.000000f,
	// 255
	0.397003f, 0.748952f,
	-0.162334f, 0.733059f, 0.660509f,
	0.088524f, 1.399766f, 0.032618f,
	29.000000f,
	// 256
	0.400259f, 0.706496f,
	-0.076308f, 0.771432f, 0.631720f,
	0.060831f, 1.388081f, 0.036465f,
	13.000000f,
	// 257
	0.374394f, 0.859625f,
	-0.106994f, 0.993272f, 0.044303f,
	0.088672f, 1.416274f, -0.009552f,
	29.000000f,
	// 258
	0.399296f, 0.857681f,
	-0.056043f, 0.809799f, -0.584025f,
	0.089427f, 1.403596f, -0.041083f,
	29.000000f,
	// 259
	0.374394f, 0.891412f,
	0.294698f, 0.952424f, 0.077729f,
	0.070473f, 1.419354f, -0.013455f,
	13.000000f,
	// 260
	0.397343f, 0.895498f,
	0.229858f, 0.669763f, -0.706104f,
	0.062372f, 1.402144f, -0.048034f,
	13.000000f,
	// 261
	0.381230f, 0.934960f,
	0.401950f, 0.393587f, -0.826756f,
	0.029350f, 1.431976f, -0.041187f,
	13.000000f,
	// 262
	0.397343f, 0.966419f,
	0.000000f, 0.412948f, -0.910755f,
	0.000000f, 1.404656f, -0.058341f,
	13.000000f,
	// 263
	0.384159f, 0.966394f,
	0.000000f, 0.292506f, -0.956264f,
	0.000000f, 1.430311f, -0.047610f,
	13.000000f,
	// 264
	0.367857f, 0.915590f,
	0.738910f, 0.664000f, -0.114524f,
	0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 265
	0.043773f, 0.748515f,
	-0.559839f, -0.007504f, -0.828567f,
	0.023727f, 1.488114f, 0.085577f,
	28.000000f,
	// 266
	0.022552f, 0.748104f,
	-0.215327f, -0.762725f, -0.609824f,
	0.012199f, 1.478719f, 0.092208f,
	28.000000f,
	// 267
	0.002178f, 0.748381f,
	0.000000f, -0.180791f, -0.983522f,
	-0.000000f, 1.488114f, 0.096102f,
	28.000000f,
	// 268
	0.319392f, 0.771957f,
	0.630262f, -0.247442f, -0.735895f,
	0.033580f, 1.505041f, -0.031958f,
	28.000000f,
	// 269
	0.357479f, 0.722159f,
	-0.000000f, -0.011049f, -0.999939f,
	0.000000f, 1.481433f, -0.045267f,
	28.000000f,
	// 270
	0.357808f, 0.765626f,
	0.000000f, -0.304984f, -0.952357f,
	0.000000f, 1.502195f, -0.046762f,
	28.000000f,
	// 271
	0.310718f, 0.722950f,
	0.573787f, 0.028594f, -0.818505f,
	0.031212f, 1.483043f, -0.035700f,
	28.000000f,
	// 272
	0.271654f, 0.774930f,
	0.524205f, -0.363406f, -0.770159f,
	0.050102f, 1.505469f, -0.009189f,
	28.000000f,
	// 273
	0.259374f, 0.721149f,
	0.963536f, -0.079340f, -0.255544f,
	0.046484f, 1.480277f, -0.012894f,
	28.000000f,
	// 274
	0.202607f, 0.717985f,
	0.949194f, -0.278671f, 0.146198f,
	0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 275
	0.103566f, 0.635924f,
	0.641771f, -0.040282f, 0.765837f,
	0.023326f, 1.426565f, 0.027269f,
	13.000000f,
	// 276
	0.152406f, 0.690167f,
	0.825851f, -0.563580f, 0.018641f,
	0.035251f, 1.465074f, 0.023798f,
	28.000000f,
	// 277
	0.092445f, 0.664074f,
	0.684846f, -0.507998f, 0.522421f,
	0.019190f, 1.448975f, 0.035394f,
	28.000000f,
	// 278
	0.179421f, 0.651324f,
	0.935194f, -0.010266f, 0.353986f,
	0.041178f, 1.442391f, 0.004507f,
	13.000000f,
	// 279
	0.247662f, 0.665648f,
	0.941584f, 0.062053f, -0.331011f,
	0.042549f, 1.450929f, -0.019461f,
	13.000000f,
	// 280
	0.306050f, 0.677284f,
	0.518907f, 0.102838f, -0.848623f,
	0.027262f, 1.451135f, -0.036622f,
	13.000000f,
	// 281
	0.358411f, 0.680345f,
	0.000000f, 0.090825f, -0.995867f,
	0.000000f, 1.449897f, -0.044012f,
	13.000000f,
	// 282
	0.008093f, 0.623140f,
	-0.000000f, -0.152551f, 0.988296f,
	-0.000000f, 1.419328f, 0.039430f,
	13.000000f,
	// 283
	0.007879f, 0.650412f,
	-0.000000f, -0.740648f, 0.671893f,
	-0.000000f, 1.440963f, 0.044507f,
	13.000000f,
	// 284
	0.007284f, 0.587682f,
	-0.000000f, 0.233411f, 0.972378f,
	-0.000000f, 1.395421f, 0.037360f,
	13.000000f,
	// 285
	0.062943f, 0.596395f,
	0.339309f, 0.334258f, 0.879284f,
	0.022776f, 1.402154f, 0.031851f,
	13.000000f,
	// 286
	0.163388f, 0.619196f,
	0.644673f, 0.497181f, 0.580695f,
	0.044275f, 1.419515f, 0.003267f,
	13.000000f,
	// 287
	0.240921f, 0.635854f,
	0.738910f, 0.664000f, -0.114524f,
	0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 288
	0.304226f, 0.645742f,
	0.401950f, 0.393587f, -0.826756f,
	0.029350f, 1.431976f, -0.041187f,
	13.000000f,
	// 289
	0.357551f, 0.649052f,
	0.000000f, 0.292506f, -0.956264f,
	0.000000f, 1.430311f, -0.047610f,
	13.000000f,
	// 290
	0.053295f, 0.752274f,
	0.516518f, -0.400429f, 0.756879f,
	0.022524f, 1.480799f, 0.091147f,
	28.000000f,
	// 291
	0.071814f, 0.763646f,
	0.576748f, -0.321363f, 0.751057f,
	0.031834f, 1.487014f, 0.087940f,
	28.000000f,
	// 292
	0.091302f, 0.789881f,
	0.639931f, -0.224844f, 0.734802f,
	0.042432f, 1.503265f, 0.085564f,
	28.000000f,
	// 293
	0.111866f, 0.815154f,
	0.778149f, -0.040506f, 0.626772f,
	0.051283f, 1.517655f, 0.079941f,
	28.000000f,
	// 294
	0.122827f, 0.839519f,
	0.861461f, 0.054660f, 0.504874f,
	0.055342f, 1.533473f, 0.072327f,
	28.000000f,
	// 295
	0.101607f, 0.833013f,
	0.725512f, -0.040332f, 0.687027f,
	0.047592f, 1.528899f, 0.082163f,
	28.000000f,
	// 296
	0.081701f, 0.826563f,
	0.442356f, -0.060426f, 0.894802f,
	0.039575f, 1.525729f, 0.088342f,
	28.000000f,
	// 297
	0.088895f, 0.807856f,
	0.552643f, -0.016824f, 0.833248f,
	0.041712f, 1.514733f, 0.088160f,
	28.000000f,
	// 298
	0.069956f, 0.787007f,
	0.501876f, -0.142180f, 0.853173f,
	0.031623f, 1.501205f, 0.092059f,
	28.000000f,
	// 299
	0.065791f, 0.805571f,
	0.394728f, 0.094456f, 0.913930f,
	0.029772f, 1.512211f, 0.093583f,
	28.000000f,
	// 300
	0.048947f, 0.785712f,
	0.429551f, -0.085731f, 0.898964f,
	0.021859f, 1.499944f, 0.097236f,
	28.000000f,
	// 301
	0.045541f, 0.803159f,
	0.392381f, 0.086199f, 0.915755f,
	0.019898f, 1.509892f, 0.098452f,
	28.000000f,
	// 302
	0.017623f, 0.731133f,
	0.305663f, -0.513314f, 0.801922f,
	0.006405f, 1.469030f, 0.098491f,
	28.000000f,
	// 303
	0.002612f, 0.730031f,
	-0.000000f, -0.529761f, 0.848147f,
	-0.000000f, 1.468585f, 0.099418f,
	28.000000f,
	// 304
	0.002178f, 0.737395f,
	-0.000000f, -0.103706f, 0.994608f,
	-0.000000f, 1.472861f, 0.101116f,
	28.000000f,
	// 305
	0.016520f, 0.737587f,
	0.284405f, -0.072883f, 0.955930f,
	0.005741f, 1.473118f, 0.100200f,
	28.000000f,
	// 306
	0.013871f, 0.746798f,
	0.130300f, 0.726997f, 0.674165f,
	0.004945f, 1.477630f, 0.099404f,
	28.000000f,
	// 307
	0.027098f, 0.747732f,
	0.220960f, 0.758423f, 0.613165f,
	0.011336f, 1.478486f, 0.096787f,
	28.000000f,
	// 308
	0.045572f, 0.748080f,
	0.524178f, -0.442193f, 0.727807f,
	0.019104f, 1.479340f, 0.091956f,
	28.000000f,
	// 309
	0.044924f, 0.748395f,
	-0.499086f, 0.100007f, -0.860763f,
	0.019767f, 1.479539f, 0.088368f,
	28.000000f,
	// 310
	0.002178f, 0.746463f,
	-0.000000f, 0.664261f, 0.747500f,
	-0.000000f, 1.477281f, 0.100417f,
	28.000000f,
	// 311
	0.013658f, 0.747610f,
	-0.211682f, 0.874333f, -0.436730f,
	0.004575f, 1.478055f, 0.095081f,
	28.000000f,
	// 312
	0.002178f, 0.747072f,
	0.000000f, 0.905049f, -0.425306f,
	-0.000000f, 1.478019f, 0.096065f,
	28.000000f,
	// 313
	0.002178f, 0.747679f,
	0.000000f, 0.449695f, -0.893182f,
	-0.000000f, 1.470597f, 0.093187f,
	28.000000f,
	// 314
	0.206237f, 0.981917f,
	0.362754f, 0.909604f, -0.202560f,
	0.030480f, 1.646196f, -0.003927f,
	28.000000f,
	// 315
	0.300596f, 0.968778f,
	0.000000f, 0.693131f, -0.720812f,
	0.000000f, 1.628367f, -0.047176f,
	28.000000f,
	// 316
	0.348228f, 0.916473f,
	0.000000f, 0.250398f, -0.968143f,
	0.000000f, 1.594277f, -0.064399f,
	28.000000f,
	// 317
	0.357712f, 0.857922f,
	0.000000f, -0.184393f, -0.982853f,
	0.000000f, 1.545264f, -0.068599f,
	28.000000f,
	// 318
	0.357609f, 0.765976f,
	0.000000f, -0.304984f, -0.952357f,
	0.000000f, 1.502195f, -0.046762f,
	28.000000f,
	// 319
	0.218064f, 0.930488f,
	0.930430f, 0.364531f, 0.037651f,
	0.066870f, 1.608470f, 0.015148f,
	28.000000f,
	// 320
	0.207244f, 0.959316f,
	0.721183f, 0.680879f, 0.127667f,
	0.051116f, 1.632316f, 0.028854f,
	28.000000f,
	// 321
	0.239208f, 0.960403f,
	0.653548f, 0.721487f, -0.228763f,
	0.044956f, 1.633310f, -0.009864f,
	28.000000f,
	// 322
	0.035717f, 0.734357f,
	0.579403f, -0.398177f, 0.711159f,
	0.013122f, 1.470567f, 0.095099f,
	28.000000f,
	// 323
	0.030592f, 0.739924f,
	0.541163f, -0.090669f, 0.836015f,
	0.012903f, 1.474181f, 0.096860f,
	28.000000f,
	// 324
	0.971078f, 0.076035f,
	0.370426f, -0.593213f, 0.714761f,
	0.707296f, 1.392466f, 0.030173f,
	25.000000f,
	// 325
	0.974227f, 0.071950f,
	0.752515f, -0.109478f, -0.649412f,
	0.698664f, 1.383706f, 0.032218f,
	25.000000f,
	// 326
	0.960181f, 0.085601f,
	0.586667f, -0.754149f, -0.295095f,
	0.690888f, 1.383347f, 0.019969f,
	25.000000f,
	// 327
	0.769588f, 0.156796f,
	0.094379f, 0.575135f, 0.812596f,
	0.515369f, 1.405852f, 0.027132f,
	24.000000f,
	// 328
	0.719216f, 0.157453f,
	0.117862f, -0.510808f, 0.851577f,
	0.513420f, 1.374205f, 0.029058f,
	24.000000f,
	// 329
	0.719216f, 0.138011f,
	0.111674f, -0.557697f, 0.822498f,
	0.562814f, 1.377393f, 0.022787f,
	24.000000f,
	// 330
	0.744402f, 0.181899f,
	-0.025480f, 0.001324f, 0.999674f,
	0.459116f, 1.387538f, 0.030423f,
	24.000000f,
	// 331
	0.769588f, 0.183142f,
	-0.007033f, 0.622573f, 0.782530f,
	0.455391f, 1.410682f, 0.026603f,
	24.000000f,
	// 332
	0.719215f, 0.180967f,
	0.007629f, -0.663183f, 0.748419f,
	0.462535f, 1.364126f, 0.026715f,
	24.000000f,
	// 333
	0.769588f, 0.207690f,
	-0.103319f, 0.562482f, 0.820329f,
	0.400113f, 1.407023f, 0.025007f,
	23.000000f,
	// 334
	0.807368f, 0.185090f,
	-0.009333f, 0.999891f, 0.011409f,
	0.450508f, 1.424242f, -0.003850f,
	24.000000f,
	// 335
	0.807368f, 0.157202f,
	0.101921f, 0.994774f, 0.006035f,
	0.514998f, 1.417181f, -0.002414f,
	24.000000f,
	// 336
	0.769588f, 0.138011f,
	0.087814f, 0.581863f, 0.808532f,
	0.565024f, 1.403519f, 0.021657f,
	24.000000f,
	// 337
	0.719216f, 0.113888f,
	0.012559f, -0.572391f, 0.819885f,
	0.613570f, 1.379048f, 0.019694f,
	24.000000f,
	// 338
	0.807368f, 0.208118f,
	-0.107188f, 0.993416f, -0.040439f,
	0.398155f, 1.418580f, -0.004171f,
	23.000000f,
	// 339
	0.848295f, 0.210380f,
	-0.133595f, 0.569546f, -0.811030f,
	0.397244f, 1.406158f, -0.030717f,
	23.000000f,
	// 340
	0.848295f, 0.186538f,
	-0.017382f, 0.708824f, -0.705171f,
	0.450242f, 1.413431f, -0.031636f,
	24.000000f,
	// 341
	0.848295f, 0.158827f,
	0.128797f, 0.597130f, -0.791737f,
	0.511653f, 1.406677f, -0.031726f,
	24.000000f,
	// 342
	0.848295f, 0.138011f,
	0.115467f, 0.567528f, -0.815218f,
	0.561790f, 1.403725f, -0.026116f,
	24.000000f,
	// 343
	0.807368f, 0.138011f,
	0.073928f, 0.997207f, 0.010645f,
	0.564056f, 1.412353f, -0.001415f,
	24.000000f,
	// 344
	0.769588f, 0.113888f,
	0.032436f, 0.571983f, 0.819624f,
	0.613484f, 1.402371f, 0.019076f,
	24.000000f,
	// 345
	0.719216f, 0.106810f,
	-0.454290f, -0.662889f, 0.595146f,
	0.631123f, 1.374796f, 0.019374f,
	24.000000f,
	// 346
	0.675140f, 0.106810f,
	-0.099483f, -0.992129f, -0.076050f,
	0.631135f, 1.373466f, -0.000062f,
	24.000000f,
	// 347
	0.898668f, 0.138011f,
	0.139778f, -0.538495f, -0.830954f,
	0.560428f, 1.379709f, -0.026289f,
	24.000000f,
	// 348
	0.898668f, 0.159078f,
	0.170682f, -0.492408f, -0.853465f,
	0.510991f, 1.375554f, -0.034825f,
	24.000000f,
	// 349
	0.873482f, 0.185921f,
	-0.014137f, 0.074551f, -0.997117f,
	0.452296f, 1.389552f, -0.039935f,
	24.000000f,
	// 350
	0.898668f, 0.185568f,
	-0.003864f, -0.637716f, -0.770262f,
	0.453645f, 1.366853f, -0.035803f,
	24.000000f,
	// 351
	0.898668f, 0.114596f,
	0.076654f, -0.525991f, -0.847028f,
	0.613158f, 1.381456f, -0.020284f,
	24.000000f,
	// 352
	0.942744f, 0.138011f,
	0.110015f, -0.993201f, -0.038067f,
	0.561749f, 1.369116f, -0.000921f,
	24.000000f,
	// 353
	0.942744f, 0.159078f,
	0.160101f, -0.987099f, 0.001555f,
	0.510397f, 1.361350f, -0.001052f,
	24.000000f,
	// 354
	0.942744f, 0.180629f,
	0.057924f, -0.997698f, -0.035266f,
	0.464720f, 1.353057f, -0.003912f,
	24.000000f,
	// 355
	0.898668f, 0.211020f,
	-0.113793f, -0.506092f, -0.854940f,
	0.397873f, 1.371518f, -0.032999f,
	23.000000f,
	// 356
	0.942744f, 0.207802f,
	-0.054475f, -0.997423f, -0.046684f,
	0.399387f, 1.356640f, -0.004235f,
	23.000000f,
	// 357
	0.732979f, 0.097338f,
	-0.410922f, 0.216609f, 0.885564f,
	0.653337f, 1.386843f, 0.038121f,
	25.000000f,
	// 358
	0.706622f, 0.085981f,
	-0.313826f, -0.605585f, 0.731286f,
	0.686370f, 1.369939f, 0.049416f,
	25.000000f,
	// 359
	0.728660f, 0.085981f,
	-0.306133f, 0.276074f, 0.911079f,
	0.686350f, 1.382898f, 0.051461f,
	25.000000f,
	// 360
	0.709771f, 0.098575f,
	-0.394624f, -0.653709f, 0.645706f,
	0.654097f, 1.370592f, 0.034380f,
	25.000000f,
	// 361
	0.735451f, 0.101723f,
	-0.595091f, 0.037761f, 0.802770f,
	0.641173f, 1.385907f, 0.030383f,
	25.000000f,
	// 362
	0.764462f, 0.101723f,
	-0.238931f, 0.739458f, 0.629376f,
	0.640583f, 1.403313f, 0.019895f,
	25.000000f,
	// 363
	0.769588f, 0.106810f,
	-0.146776f, 0.662421f, 0.734612f,
	0.631124f, 1.402915f, 0.018480f,
	24.000000f,
	// 364
	0.807368f, 0.106810f,
	-0.176408f, 0.983900f, 0.028645f,
	0.631823f, 1.410114f, -0.000505f,
	24.000000f,
	// 365
	0.807368f, 0.113623f,
	0.020307f, 0.999723f, 0.011903f,
	0.613266f, 1.409971f, -0.000506f,
	24.000000f,
	// 366
	0.848295f, 0.106810f,
	-0.258774f, 0.598125f, -0.758474f,
	0.631835f, 1.403122f, -0.019437f,
	24.000000f,
	// 367
	0.848295f, 0.113888f,
	0.082217f, 0.553167f, -0.829004f,
	0.613488f, 1.402639f, -0.020789f,
	24.000000f,
	// 368
	0.898668f, 0.106810f,
	-0.328333f, -0.670997f, -0.664801f,
	0.631146f, 1.378128f, -0.017394f,
	24.000000f,
	// 369
	0.942744f, 0.114109f,
	0.034821f, -0.998294f, -0.046876f,
	0.613071f, 1.372759f, -0.000828f,
	24.000000f,
	// 370
	0.942744f, 0.106810f,
	-0.099483f, -0.992129f, -0.076050f,
	0.631135f, 1.373466f, -0.000062f,
	24.000000f,
	// 371
	0.986820f, 0.098575f,
	0.003475f, -0.999115f, -0.041926f,
	0.660179f, 1.366724f, 0.024612f,
	25.000000f,
	// 372
	0.986820f, 0.101723f,
	-0.388933f, -0.862900f, 0.322699f,
	0.641620f, 1.369130f, 0.021948f,
	25.000000f,
	// 373
	0.939596f, 0.101723f,
	0.010401f, -0.986885f, -0.161087f,
	0.641474f, 1.372968f, -0.000765f,
	25.000000f,
	// 374
	0.893607f, 0.101723f,
	-0.304329f, -0.725481f, -0.617302f,
	0.641482f, 1.375607f, -0.025171f,
	24.000000f,
	// 375
	0.871322f, 0.101723f,
	-0.475512f, 0.037505f, -0.878909f,
	0.641793f, 1.390439f, -0.028676f,
	24.000000f,
	// 376
	0.845147f, 0.101723f,
	-0.273048f, 0.712635f, -0.646217f,
	0.640599f, 1.405342f, -0.021912f,
	24.000000f,
	// 377
	0.807368f, 0.101723f,
	-0.252127f, 0.967659f, 0.008222f,
	0.640591f, 1.413547f, -0.001158f,
	25.000000f,
	// 378
	0.760477f, 0.094040f,
	-0.199656f, 0.782516f, 0.589751f,
	0.664224f, 1.407807f, 0.024932f,
	25.000000f,
	// 379
	0.766440f, 0.077914f,
	-0.083294f, 0.928423f, 0.362067f,
	0.707291f, 1.415953f, 0.023095f,
	25.000000f,
	// 380
	0.794774f, 0.078809f,
	-0.085514f, 0.996176f, -0.017934f,
	0.707535f, 1.416539f, 0.004410f,
	25.000000f,
	// 381
	0.819961f, 0.078809f,
	-0.058310f, 0.983451f, -0.171536f,
	0.706489f, 1.415562f, -0.012943f,
	25.000000f,
	// 382
	0.848295f, 0.079685f,
	-0.100503f, 0.886835f, -0.451024f,
	0.701798f, 1.410947f, -0.027772f,
	25.000000f,
	// 383
	0.860888f, 0.076537f,
	-0.098198f, 0.616851f, -0.780930f,
	0.713385f, 1.408452f, -0.033400f,
	25.000000f,
	// 384
	0.851444f, 0.075274f,
	-0.068352f, 0.912392f, -0.403571f,
	0.714317f, 1.411433f, -0.028812f,
	25.000000f,
	// 385
	0.820466f, 0.073915f,
	-0.068114f, 0.983256f, -0.169020f,
	0.715757f, 1.416067f, -0.013105f,
	25.000000f,
	// 386
	0.793863f, 0.073388f,
	-0.124005f, 0.992022f, -0.022688f,
	0.715702f, 1.417679f, 0.004664f,
	25.000000f,
	// 387
	0.766440f, 0.073388f,
	-0.019829f, 0.955440f, 0.294519f,
	0.716017f, 1.416403f, 0.022223f,
	25.000000f,
	// 388
	0.755419f, 0.073388f,
	0.011845f, 0.552473f, 0.833447f,
	0.716847f, 1.411924f, 0.029693f,
	25.000000f,
	// 389
	0.748123f, 0.082447f,
	0.042709f, 0.554960f, 0.830780f,
	0.693986f, 1.404788f, 0.033031f,
	25.000000f,
	// 390
	0.741253f, 0.076035f,
	0.370426f, -0.593213f, 0.714761f,
	0.707296f, 1.392466f, 0.030173f,
	25.000000f,
	// 391
	0.738296f, 0.077789f,
	0.615051f, 0.768684f, 0.175607f,
	0.699409f, 1.389204f, 0.038781f,
	25.000000f,
	// 392
	0.738338f, 0.076597f,
	0.752515f, -0.109478f, -0.649412f,
	0.698664f, 1.383706f, 0.032218f,
	25.000000f,
	// 393
	0.748924f, 0.071108f,
	0.096950f, -0.029318f, 0.994857f,
	0.717572f, 1.402400f, 0.030768f,
	25.000000f,
	// 394
	0.741253f, 0.071108f,
	-0.141912f, -0.804940f, 0.576137f,
	0.718248f, 1.389433f, 0.028633f,
	25.000000f,
	// 395
	0.738220f, 0.085248f,
	-0.013605f, 0.716386f, 0.697572f,
	0.688382f, 1.391956f, 0.042791f,
	25.000000f,
	// 396
	0.734185f, 0.066691f,
	0.356687f, 0.896814f, -0.261722f,
	0.704794f, 1.388378f, 0.040899f,
	25.000000f,
	// 397
	0.738338f, 0.063944f,
	0.445998f, 0.080363f, -0.891419f,
	0.707547f, 1.377564f, 0.032840f,
	25.000000f,
	// 398
	0.723660f, 0.070979f,
	-0.092387f, 0.555761f, 0.826192f,
	0.700144f, 1.385332f, 0.054600f,
	25.000000f,
	// 399
	0.706622f, 0.070979f,
	-0.214877f, -0.675134f, 0.705706f,
	0.699271f, 1.368064f, 0.052952f,
	25.000000f,
	// 400
	0.697178f, 0.085981f,
	-0.043651f, -0.993228f, -0.107670f,
	0.687884f, 1.365771f, 0.037776f,
	25.000000f,
	// 401
	0.697178f, 0.098575f,
	0.003475f, -0.999115f, -0.041926f,
	0.660179f, 1.366724f, 0.024612f,
	25.000000f,
	// 402
	0.697178f, 0.067092f,
	0.142828f, -0.903144f, -0.404884f,
	0.703870f, 1.365240f, 0.038449f,
	25.000000f,
	// 403
	0.712919f, 0.101723f,
	-0.388933f, -0.862900f, 0.322699f,
	0.641620f, 1.369130f, 0.021948f,
	25.000000f,
	// 404
	0.974227f, 0.085981f,
	0.436348f, -0.635103f, -0.637374f,
	0.689318f, 1.374315f, 0.025712f,
	25.000000f,
	// 405
	0.993116f, 0.085981f,
	-0.043651f, -0.993228f, -0.107670f,
	0.687884f, 1.365771f, 0.037776f,
	25.000000f,
	// 406
	0.934612f, 0.096568f,
	0.218138f, -0.961067f, -0.169606f,
	0.664398f, 1.375866f, -0.000909f,
	25.000000f,
	// 407
	0.888329f, 0.096044f,
	0.048697f, -0.786111f, -0.616164f,
	0.665472f, 1.376869f, -0.030158f,
	25.000000f,
	// 408
	0.870076f, 0.097814f,
	-0.198212f, 0.130323f, -0.971456f,
	0.654331f, 1.392483f, -0.033148f,
	25.000000f,
	// 409
	0.867185f, 0.076537f,
	-0.045930f, 0.036063f, -0.998294f,
	0.714037f, 1.398635f, -0.036602f,
	25.000000f,
	// 410
	0.877360f, 0.083451f,
	0.098281f, -0.785949f, -0.610430f,
	0.694768f, 1.382909f, -0.032629f,
	25.000000f,
	// 411
	0.927002f, 0.081309f,
	0.189838f, -0.980321f, 0.054148f,
	0.697909f, 1.386194f, -0.002440f,
	25.000000f,
	// 412
	0.960181f, 0.085601f,
	0.586667f, -0.754149f, -0.295095f,
	0.690888f, 1.383347f, 0.019969f,
	25.000000f,
	// 413
	0.974227f, 0.071950f,
	0.752515f, -0.109478f, -0.649412f,
	0.698664f, 1.383706f, 0.032218f,
	25.000000f,
	// 414
	0.980523f, 0.063944f,
	0.445998f, 0.080363f, -0.891419f,
	0.707547f, 1.377564f, 0.032840f,
	25.000000f,
	// 415
	0.993116f, 0.067092f,
	0.142828f, -0.903144f, -0.404884f,
	0.703870f, 1.365240f, 0.038449f,
	25.000000f,
	// 416
	0.971078f, 0.076035f,
	0.370426f, -0.593213f, 0.714761f,
	0.707296f, 1.392466f, 0.030173f,
	25.000000f,
	// 417
	0.871796f, 0.072454f,
	0.134667f, -0.745287f, -0.653003f,
	0.714925f, 1.387217f, -0.033388f,
	25.000000f,
	// 418
	0.895520f, 0.069984f,
	0.122240f, -0.991980f, 0.032138f,
	0.715798f, 1.386395f, -0.019484f,
	25.000000f,
	// 419
	0.927002f, 0.068701f,
	0.057039f, -0.996408f, 0.062587f,
	0.716870f, 1.387217f, -0.003442f,
	25.000000f,
	// 420
	0.952189f, 0.069012f,
	-0.058641f, -0.988181f, 0.141634f,
	0.717931f, 1.388612f, 0.013665f,
	25.000000f,
	// 421
	0.971078f, 0.071108f,
	-0.141912f, -0.804940f, 0.576137f,
	0.718248f, 1.389433f, 0.028633f,
	25.000000f,
	// 422
	0.675140f, 0.114109f,
	0.034821f, -0.998294f, -0.046876f,
	0.613071f, 1.372759f, -0.000828f,
	24.000000f,
	// 423
	0.675140f, 0.138011f,
	0.110015f, -0.993201f, -0.038067f,
	0.561749f, 1.369116f, -0.000921f,
	24.000000f,
	// 424
	0.675140f, 0.159078f,
	0.160101f, -0.987099f, 0.001555f,
	0.510397f, 1.361350f, -0.001052f,
	24.000000f,
	// 425
	0.675140f, 0.180629f,
	0.057924f, -0.997698f, -0.035266f,
	0.464720f, 1.353057f, -0.003912f,
	24.000000f,
	// 426
	0.719216f, 0.207810f,
	-0.087497f, -0.566189f, 0.819618f,
	0.400686f, 1.369121f, 0.024524f,
	23.000000f,
	// 427
	0.675140f, 0.207802f,
	-0.054475f, -0.997423f, -0.046684f,
	0.399387f, 1.356640f, -0.004235f,
	23.000000f,
	// 428
	0.986820f, 0.106810f,
	-0.454290f, -0.662889f, 0.595146f,
	0.631123f, 1.374796f, 0.019374f,
	24.000000f,
	// 429
	0.901289f, 0.037442f,
	0.028462f, -0.017041f, -0.999450f,
	0.748269f, 1.399778f, -0.018814f,
	25.000000f,
	// 430
	0.898092f, 0.048360f,
	0.192867f, -0.980054f, -0.047933f,
	0.726221f, 1.390583f, -0.017615f,
	25.000000f,
	// 431
	0.898092f, 0.046475f,
	0.291377f, 0.927165f, -0.235511f,
	0.721657f, 1.406231f, -0.018627f,
	25.000000f,
	// 432
	0.894950f, 0.042210f,
	0.137333f, 0.064712f, 0.988409f,
	0.737408f, 1.399087f, -0.020038f,
	25.000000f,
	// 433
	0.898092f, 0.046475f,
	0.291377f, 0.927165f, -0.235511f,
	0.721657f, 1.406231f, -0.018627f,
	25.000000f,
	// 434
	0.929502f, 0.059888f,
	0.123770f, -0.988344f, 0.088638f,
	0.697380f, 1.387749f, -0.001510f,
	25.000000f,
	// 435
	0.879974f, 0.062069f,
	0.178125f, -0.941621f, -0.285694f,
	0.694412f, 1.384645f, -0.030034f,
	25.000000f,
	// 436
	0.898092f, 0.048360f,
	0.192867f, -0.980054f, -0.047933f,
	0.726221f, 1.390583f, -0.017615f,
	25.000000f,
	// 437
	0.874422f, 0.050874f,
	0.122234f, -0.747172f, -0.653293f,
	0.716901f, 1.391359f, -0.030752f,
	25.000000f,
	// 438
	0.891628f, 0.043593f,
	0.201606f, -0.832916f, 0.515370f,
	0.734368f, 1.391846f, -0.021242f,
	25.000000f,
	// 439
	0.894950f, 0.028856f,
	0.061301f, -0.042381f, 0.997219f,
	0.761228f, 1.397686f, -0.021112f,
	25.000000f,
	// 440
	0.869822f, 0.055030f,
	0.043010f, -0.099273f, -0.994130f,
	0.707927f, 1.398226f, -0.033789f,
	25.000000f,
	// 441
	0.883245f, 0.016316f,
	0.918855f, 0.394266f, -0.016139f,
	0.784773f, 1.398212f, -0.027238f,
	25.000000f,
	// 442
	0.876104f, 0.021039f,
	0.385910f, -0.762749f, -0.518929f,
	0.780301f, 1.393173f, -0.030193f,
	25.000000f,
	// 443
	0.869822f, 0.019521f,
	0.566183f, 0.388846f, -0.726798f,
	0.782239f, 1.398223f, -0.031554f,
	25.000000f,
	// 444
	0.890385f, 0.021039f,
	0.389144f, -0.748574f, 0.536846f,
	0.780293f, 1.393173f, -0.023627f,
	25.000000f,
	// 445
	0.894950f, 0.019521f,
	0.595820f, 0.375598f, 0.709876f,
	0.782315f, 1.398076f, -0.022594f,
	25.000000f,
	// 446
	0.890385f, 0.028856f,
	0.049648f, -0.820751f, 0.569125f,
	0.759570f, 1.392459f, -0.023136f,
	25.000000f,
	// 447
	0.875449f, 0.043593f,
	0.022880f, -0.842609f, -0.538039f,
	0.732755f, 1.391846f, -0.030875f,
	25.000000f,
	// 448
	0.869822f, 0.042210f,
	0.026388f, -0.051830f, -0.998307f,
	0.735766f, 1.397420f, -0.033505f,
	25.000000f,
	// 449
	0.869822f, 0.028856f,
	0.037238f, -0.042108f, -0.998419f,
	0.760238f, 1.397335f, -0.032816f,
	25.000000f,
	// 450
	0.876104f, 0.028856f,
	0.028449f, -0.866760f, -0.497914f,
	0.759174f, 1.392074f, -0.030208f,
	25.000000f,
	// 451
	0.860616f, 0.028627f,
	0.117659f, 0.786353f, -0.606470f,
	0.760935f, 1.402717f, -0.030710f,
	25.000000f,
	// 452
	0.860616f, 0.040152f,
	0.123542f, 0.754632f, -0.644413f,
	0.740809f, 1.404190f, -0.030726f,
	25.000000f,
	// 453
	0.860616f, 0.042210f,
	0.134991f, 0.768241f, -0.625766f,
	0.737744f, 1.405001f, -0.030732f,
	25.000000f,
	// 454
	0.864544f, 0.051289f,
	0.097882f, 0.720885f, -0.686108f,
	0.713231f, 1.406776f, -0.030755f,
	25.000000f,
	// 455
	0.863540f, 0.055030f,
	0.129965f, 0.767657f, -0.627545f,
	0.709433f, 1.407502f, -0.030762f,
	25.000000f,
	// 456
	0.845380f, 0.048620f,
	0.367972f, 0.892848f, -0.259652f,
	0.717042f, 1.408586f, -0.021257f,
	25.000000f,
	// 457
	0.845380f, 0.042210f,
	0.215564f, 0.846735f, 0.486387f,
	0.738622f, 1.406132f, -0.022362f,
	25.000000f,
	// 458
	0.845380f, 0.040152f,
	0.148595f, 0.829365f, 0.538585f,
	0.741606f, 1.405320f, -0.022418f,
	25.000000f,
	// 459
	0.845380f, 0.028627f,
	0.168566f, 0.835227f, 0.523432f,
	0.761912f, 1.403607f, -0.022874f,
	25.000000f,
	// 460
	0.860616f, 0.027052f,
	0.157475f, 0.782386f, -0.602557f,
	0.764358f, 1.401931f, -0.030707f,
	25.000000f,
	// 461
	0.860665f, 0.019521f,
	0.566183f, 0.388846f, -0.726798f,
	0.782239f, 1.398223f, -0.031554f,
	25.000000f,
	// 462
	0.845380f, 0.027052f,
	0.208621f, 0.802625f, 0.558811f,
	0.764765f, 1.402725f, -0.022871f,
	25.000000f,
	// 463
	0.845382f, 0.019521f,
	0.595820f, 0.375598f, 0.709876f,
	0.782315f, 1.398076f, -0.022594f,
	25.000000f,
	// 464
	0.841553f, 0.028856f,
	0.061301f, -0.042381f, 0.997219f,
	0.761228f, 1.397686f, -0.021112f,
	25.000000f,
	// 465
	0.841553f, 0.042210f,
	0.137333f, 0.064712f, 0.988409f,
	0.737408f, 1.399087f, -0.020038f,
	25.000000f,
	// 466
	0.840153f, 0.046475f,
	0.291377f, 0.927165f, -0.235511f,
	0.721657f, 1.406231f, -0.018627f,
	25.000000f,
	// 467
	0.853003f, 0.016316f,
	0.918855f, 0.394266f, -0.016139f,
	0.784773f, 1.398212f, -0.027238f,
	25.000000f,
	// 468
	0.860616f, 0.027052f,
	0.157475f, 0.782386f, -0.602557f,
	0.764358f, 1.401931f, -0.030707f,
	25.000000f,
	// 469
	0.838411f, 0.051654f,
	0.262629f, 0.902683f, -0.340866f,
	0.714273f, 1.411844f, -0.018730f,
	25.000000f,
	// 470
	0.850976f, 0.058235f,
	0.026424f, 0.943332f, -0.330797f,
	0.701054f, 1.409859f, -0.025445f,
	25.000000f,
	// 471
	0.822706f, 0.057343f,
	0.089108f, 0.980908f, -0.172858f,
	0.705486f, 1.414219f, -0.011434f,
	25.000000f,
	// 472
	0.810142f, 0.051295f,
	0.317508f, 0.945196f, -0.076114f,
	0.718862f, 1.413359f, -0.002972f,
	25.000000f,
	// 473
	0.797578f, 0.057343f,
	0.092002f, 0.995351f, -0.028485f,
	0.706475f, 1.415142f, 0.004962f,
	25.000000f,
	// 474
	0.784118f, 0.050765f,
	0.302110f, 0.951050f, 0.065061f,
	0.719275f, 1.414135f, 0.013698f,
	25.000000f,
	// 475
	0.769308f, 0.056432f,
	0.130800f, 0.981303f, 0.141197f,
	0.706243f, 1.414589f, 0.022617f,
	25.000000f,
	// 476
	0.758312f, 0.051825f,
	0.254835f, 0.627769f, 0.735503f,
	0.717540f, 1.410782f, 0.028850f,
	25.000000f,
	// 477
	0.814752f, 0.039006f,
	0.173994f, 0.853713f, 0.490816f,
	0.748980f, 1.409234f, -0.006980f,
	25.000000f,
	// 478
	0.811640f, 0.038133f,
	0.090176f, 0.019256f, 0.995740f,
	0.749093f, 1.400913f, -0.004081f,
	25.000000f,
	// 479
	0.814752f, 0.036693f,
	0.124817f, 0.833457f, 0.538304f,
	0.752540f, 1.408351f, -0.006974f,
	25.000000f,
	// 480
	0.810142f, 0.045170f,
	0.378892f, 0.924434f, 0.043145f,
	0.724316f, 1.407395f, -0.002963f,
	25.000000f,
	// 481
	0.813671f, 0.048620f,
	0.325638f, 0.905558f, 0.271890f,
	0.722943f, 1.411807f, -0.005489f,
	25.000000f,
	// 482
	0.832231f, 0.036693f,
	0.105642f, 0.756597f, -0.645292f,
	0.752022f, 1.407187f, -0.016067f,
	25.000000f,
	// 483
	0.832231f, 0.022981f,
	0.115651f, 0.782297f, -0.612075f,
	0.776231f, 1.406050f, -0.016554f,
	25.000000f,
	// 484
	0.832231f, 0.039006f,
	0.145550f, 0.773255f, -0.617165f,
	0.748726f, 1.408069f, -0.016074f,
	25.000000f,
	// 485
	0.832231f, 0.048620f,
	0.252175f, 0.822621f, -0.509609f,
	0.721208f, 1.409984f, -0.016101f,
	25.000000f,
	// 486
	0.840153f, 0.046475f,
	0.291377f, 0.927165f, -0.235511f,
	0.721657f, 1.406231f, -0.018627f,
	25.000000f,
	// 487
	0.837742f, 0.037442f,
	0.028462f, -0.017041f, -0.999450f,
	0.748269f, 1.399778f, -0.018814f,
	25.000000f,
	// 488
	0.837742f, 0.022981f,
	0.019712f, -0.040787f, -0.998973f,
	0.775500f, 1.398961f, -0.018936f,
	25.000000f,
	// 489
	0.832231f, 0.020668f,
	0.159807f, 0.773718f, -0.613043f,
	0.779376f, 1.405240f, -0.016550f,
	25.000000f,
	// 490
	0.832240f, 0.006957f,
	0.514239f, 0.395476f, -0.761023f,
	0.803460f, 1.400363f, -0.017941f,
	25.000000f,
	// 491
	0.814752f, 0.020668f,
	0.199608f, 0.808327f, 0.553863f,
	0.779523f, 1.406010f, -0.007457f,
	25.000000f,
	// 492
	0.814735f, 0.006957f,
	0.517271f, 0.388928f, 0.762342f,
	0.803453f, 1.400616f, -0.006595f,
	25.000000f,
	// 493
	0.811640f, 0.022981f,
	0.055817f, -0.034378f, 0.997849f,
	0.775953f, 1.400058f, -0.005225f,
	25.000000f,
	// 494
	0.814752f, 0.022981f,
	0.159243f, 0.838803f, 0.520625f,
	0.776478f, 1.406991f, -0.007461f,
	25.000000f,
	// 495
	0.823420f, 0.003752f,
	0.929693f, 0.367923f, 0.017451f,
	0.807191f, 1.400538f, -0.012110f,
	25.000000f,
	// 496
	0.709628f, 0.045184f,
	-0.229140f, -0.591584f, 0.772996f,
	0.716882f, 1.368365f, 0.057440f,
	25.000000f,
	// 497
	0.718047f, 0.032053f,
	0.370125f, -0.142120f, 0.918047f,
	0.738910f, 1.370416f, 0.061658f,
	25.000000f,
	// 498
	0.726627f, 0.045184f,
	-0.103203f, 0.447846f, 0.888135f,
	0.717698f, 1.378374f, 0.058993f,
	25.000000f,
	// 499
	0.709628f, 0.064645f,
	-0.307239f, -0.648443f, 0.696510f,
	0.686476f, 1.371112f, 0.047486f,
	25.000000f,
	// 500
	0.709628f, 0.049372f,
	-0.284128f, -0.586824f, 0.758227f,
	0.708472f, 1.369459f, 0.055649f,
	25.000000f,
	// 501
	0.731616f, 0.064645f,
	-0.251266f, 0.356595f, 0.899836f,
	0.686458f, 1.383357f, 0.049418f,
	25.000000f,
	// 502
	0.700205f, 0.064645f,
	0.031251f, -0.970628f, -0.238547f,
	0.687907f, 1.367174f, 0.036488f,
	25.000000f,
	// 503
	0.700205f, 0.045415f,
	0.073352f, -0.959002f, -0.273741f,
	0.717278f, 1.364875f, 0.048901f,
	25.000000f,
	// 504
	0.709628f, 0.033093f,
	0.159599f, -0.757829f, 0.632632f,
	0.736844f, 1.364500f, 0.059512f,
	25.000000f,
	// 505
	0.718047f, 0.029391f,
	0.971176f, -0.117641f, 0.207310f,
	0.742320f, 1.370296f, 0.057889f,
	25.000000f,
	// 506
	0.726627f, 0.033093f,
	0.327027f, 0.528724f, 0.783265f,
	0.738129f, 1.376358f, 0.061041f,
	25.000000f,
	// 507
	0.737127f, 0.045007f,
	0.309144f, 0.950109f, -0.041517f,
	0.718152f, 1.382650f, 0.051217f,
	25.000000f,
	// 508
	0.726627f, 0.049372f,
	-0.154290f, 0.407703f, 0.899985f,
	0.709298f, 1.379465f, 0.057207f,
	25.000000f,
	// 509
	0.734757f, 0.034712f,
	0.675329f, 0.736136f, -0.045114f,
	0.740328f, 1.377434f, 0.057121f,
	25.000000f,
	// 510
	0.700205f, 0.032596f,
	0.567491f, -0.799086f, -0.198535f,
	0.739444f, 1.364207f, 0.055893f,
	25.000000f,
	// 511
	0.741271f, 0.032596f,
	0.660458f, 0.052287f, -0.749040f,
	0.740392f, 1.371642f, 0.052249f,
	25.000000f,
	// 512
	0.741271f, 0.042210f,
	0.482851f, 0.082004f, -0.871854f,
	0.720753f, 1.374344f, 0.044475f,
	25.000000f,
	// 513
	0.741271f, 0.055030f,
	0.545931f, 0.298179f, -0.782974f,
	0.697315f, 1.383751f, 0.031943f,
	25.000000f,
	// 514
	0.741229f, 0.056304f,
	0.456471f, 0.838728f, -0.296932f,
	0.698086f, 1.388782f, 0.037692f,
	25.000000f,
	// 515
	0.741153f, 0.063898f,
	0.056945f, 0.876275f, 0.478435f,
	0.688378f, 1.391915f, 0.041226f,
	25.000000f,
	// 516
	0.948348f, 0.039917f,
	0.122438f, -0.815936f, 0.565029f,
	0.746033f, 1.394174f, 0.009987f,
	25.000000f,
	// 517
	0.954630f, 0.047370f,
	0.120550f, -0.990155f, 0.071137f,
	0.728689f, 1.392677f, 0.013707f,
	25.000000f,
	// 518
	0.929502f, 0.047053f,
	0.145919f, -0.987941f, 0.051776f,
	0.728345f, 1.391359f, -0.002457f,
	25.000000f,
	// 519
	0.951489f, 0.035801f,
	0.082739f, -0.002688f, 0.996568f,
	0.750467f, 1.401925f, 0.012219f,
	25.000000f,
	// 520
	0.951489f, 0.017662f,
	0.044713f, -0.005636f, 0.998984f,
	0.782651f, 1.400530f, 0.011451f,
	25.000000f,
	// 521
	0.954500f, 0.046366f,
	0.331215f, 0.943098f, -0.029364f,
	0.725377f, 1.408559f, 0.013706f,
	25.000000f,
	// 522
	0.929502f, 0.017737f,
	0.034485f, -0.073525f, -0.996697f,
	0.782668f, 1.399706f, -0.002462f,
	25.000000f,
	// 523
	0.929502f, 0.003752f,
	0.536248f, 0.417306f, -0.733685f,
	0.809009f, 1.402169f, -0.001238f,
	25.000000f,
	// 524
	0.933673f, 0.006577f,
	0.438773f, -0.741749f, -0.507234f,
	0.807684f, 1.396406f, 0.000645f,
	25.000000f,
	// 525
	0.940471f, 0.000547f,
	0.920550f, 0.390625f, -0.000114f,
	0.812130f, 1.401975f, 0.004215f,
	25.000000f,
	// 526
	0.947268f, 0.006577f,
	0.443584f, -0.727596f, 0.523295f,
	0.807675f, 1.396406f, 0.008222f,
	25.000000f,
	// 527
	0.951489f, 0.003752f,
	0.535020f, 0.420003f, 0.733042f,
	0.808929f, 1.402007f, 0.009784f,
	25.000000f,
	// 528
	0.947268f, 0.019776f,
	0.055137f, -0.813409f, 0.579074f,
	0.781652f, 1.393512f, 0.009211f,
	25.000000f,
	// 529
	0.933673f, 0.039917f,
	0.097500f, -0.832584f, -0.545249f,
	0.746043f, 1.393786f, -0.000491f,
	25.000000f,
	// 530
	0.929502f, 0.037038f,
	0.045172f, -0.025495f, -0.998654f,
	0.749142f, 1.400897f, -0.002935f,
	25.000000f,
	// 531
	0.933673f, 0.019776f,
	0.051321f, -0.838183f, -0.542970f,
	0.781663f, 1.393512f, 0.000119f,
	25.000000f,
	// 532
	0.929502f, 0.047053f,
	0.145919f, -0.987941f, 0.051776f,
	0.728345f, 1.391359f, -0.002457f,
	25.000000f,
	// 533
	0.929137f, 0.045170f,
	0.378892f, 0.924434f, 0.043145f,
	0.724316f, 1.407395f, -0.002963f,
	25.000000f,
	// 534
	0.973477f, 0.054520f,
	0.098529f, -0.650244f, 0.753309f,
	0.706249f, 1.392397f, 0.029304f,
	25.000000f,
	// 535
	0.973477f, 0.049504f,
	0.077743f, -0.754492f, 0.651689f,
	0.723095f, 1.393453f, 0.027849f,
	25.000000f,
	// 536
	0.920733f, 0.041228f,
	0.143563f, -0.827304f, 0.543100f,
	0.745478f, 1.393398f, -0.006351f,
	25.000000f,
	// 537
	0.905306f, 0.041228f,
	0.093951f, -0.828232f, -0.552454f,
	0.744607f, 1.393398f, -0.016366f,
	25.000000f,
	// 538
	0.920733f, 0.022981f,
	0.057423f, -0.833097f, 0.550139f,
	0.775407f, 1.393178f, -0.007929f,
	25.000000f,
	// 539
	0.906828f, 0.022981f,
	0.033860f, -0.839385f, -0.542482f,
	0.775168f, 1.393143f, -0.016460f,
	25.000000f,
	// 540
	0.920733f, 0.009709f,
	0.391157f, -0.766903f, 0.508779f,
	0.802232f, 1.395713f, -0.008656f,
	25.000000f,
	// 541
	0.906828f, 0.009709f,
	0.401649f, -0.768461f, -0.498143f,
	0.802241f, 1.395325f, -0.016232f,
	25.000000f,
	// 542
	0.913781f, 0.003752f,
	0.929693f, 0.367923f, 0.017451f,
	0.807191f, 1.400538f, -0.012110f,
	25.000000f,
	// 543
	0.901289f, 0.006957f,
	0.514239f, 0.395476f, -0.761023f,
	0.803460f, 1.400363f, -0.017941f,
	25.000000f,
	// 544
	0.901289f, 0.022981f,
	0.019712f, -0.040787f, -0.998973f,
	0.775500f, 1.398961f, -0.018936f,
	25.000000f,
	// 545
	0.926217f, 0.006957f,
	0.517271f, 0.388928f, 0.762342f,
	0.803453f, 1.400616f, -0.006595f,
	25.000000f,
	// 546
	0.926217f, 0.022981f,
	0.055817f, -0.034378f, 0.997849f,
	0.775953f, 1.400058f, -0.005225f,
	25.000000f,
	// 547
	0.926217f, 0.038133f,
	0.090176f, 0.019256f, 0.995740f,
	0.749093f, 1.400913f, -0.004081f,
	25.000000f,
	// 548
	0.929137f, 0.045170f,
	0.378892f, 0.924434f, 0.043145f,
	0.724316f, 1.407395f, -0.002963f,
	25.000000f,
	// 549
	0.788349f, 0.017662f,
	0.083526f, 0.802662f, 0.590557f,
	0.782886f, 1.407270f, 0.009215f,
	25.000000f,
	// 550
	0.804905f, 0.017662f,
	0.083373f, 0.811070f, -0.578977f,
	0.783029f, 1.407658f, -0.000282f,
	25.000000f,
	// 551
	0.788349f, 0.032596f,
	0.137326f, 0.765943f, 0.628070f,
	0.757422f, 1.408491f, 0.009700f,
	25.000000f,
	// 552
	0.804905f, 0.015515f,
	0.136267f, 0.806475f, -0.575351f,
	0.786963f, 1.407065f, -0.000277f,
	25.000000f,
	// 553
	0.788349f, 0.015515f,
	0.137122f, 0.794968f, 0.590951f,
	0.786954f, 1.406677f, 0.009220f,
	25.000000f,
	// 554
	0.804905f, 0.032596f,
	0.108746f, 0.792933f, -0.599526f,
	0.757432f, 1.408879f, -0.000224f,
	25.000000f,
	// 555
	0.809573f, 0.037038f,
	0.045172f, -0.025495f, -0.998654f,
	0.749142f, 1.400897f, -0.002935f,
	25.000000f,
	// 556
	0.809573f, 0.017737f,
	0.034485f, -0.073525f, -0.996697f,
	0.782668f, 1.399706f, -0.002462f,
	25.000000f,
	// 557
	0.804905f, 0.003752f,
	0.536248f, 0.417306f, -0.733685f,
	0.809009f, 1.402169f, -0.001238f,
	25.000000f,
	// 558
	0.788349f, 0.003752f,
	0.535020f, 0.420003f, 0.733042f,
	0.808929f, 1.402007f, 0.009784f,
	25.000000f,
	// 559
	0.784550f, 0.017662f,
	0.044713f, -0.005636f, 0.998984f,
	0.782651f, 1.400530f, 0.011451f,
	25.000000f,
	// 560
	0.784550f, 0.035801f,
	0.082739f, -0.002688f, 0.996568f,
	0.750467f, 1.401925f, 0.012219f,
	25.000000f,
	// 561
	0.796487f, 0.000547f,
	0.920550f, 0.390625f, -0.000114f,
	0.812130f, 1.401975f, 0.004215f,
	25.000000f,
	// 562
	0.788349f, 0.035224f,
	0.179095f, 0.801545f, 0.570483f,
	0.753617f, 1.409736f, 0.009693f,
	25.000000f,
	// 563
	0.784087f, 0.046366f,
	0.331215f, 0.943098f, -0.029364f,
	0.725377f, 1.408559f, 0.013706f,
	25.000000f,
	// 564
	0.804905f, 0.035224f,
	0.135861f, 0.799535f, -0.585052f,
	0.753759f, 1.409736f, -0.000231f,
	25.000000f,
	// 565
	0.810142f, 0.045170f,
	0.378892f, 0.924434f, 0.043145f,
	0.724316f, 1.407395f, -0.002963f,
	25.000000f,
	// 566
	0.804905f, 0.048620f,
	0.330834f, 0.886354f, -0.323923f,
	0.723065f, 1.411807f, 0.000573f,
	25.000000f,
	// 567
	0.804905f, 0.048620f,
	0.330834f, 0.886354f, -0.323923f,
	0.723065f, 1.411807f, 0.000573f,
	25.000000f,
	// 568
	0.788349f, 0.048620f,
	0.361445f, 0.904178f, 0.227637f,
	0.723287f, 1.412195f, 0.010676f,
	25.000000f,
	// 569
	0.778856f, 0.048620f,
	0.334623f, 0.933922f, -0.125763f,
	0.723347f, 1.412195f, 0.016473f,
	25.000000f,
	// 570
	0.784087f, 0.046366f,
	0.331215f, 0.943098f, -0.029364f,
	0.725377f, 1.408559f, 0.013706f,
	25.000000f,
	// 571
	0.776624f, 0.035801f,
	0.180753f, 0.828259f, -0.530392f,
	0.752233f, 1.409348f, 0.016254f,
	25.000000f,
	// 572
	0.782177f, 0.039006f,
	0.055746f, -0.017220f, -0.998296f,
	0.748799f, 1.401674f, 0.014046f,
	25.000000f,
	// 573
	0.776624f, 0.032596f,
	0.139204f, 0.793322f, -0.592674f,
	0.756019f, 1.408080f, 0.016261f,
	25.000000f,
	// 574
	0.782177f, 0.019776f,
	0.030627f, 0.017585f, -0.999376f,
	0.776448f, 1.400495f, 0.014571f,
	25.000000f,
	// 575
	0.776624f, 0.020127f,
	0.118532f, 0.817788f, -0.563181f,
	0.776917f, 1.406867f, 0.016443f,
	25.000000f,
	// 576
	0.776624f, 0.017674f,
	0.173094f, 0.804458f, -0.568230f,
	0.779947f, 1.406156f, 0.016446f,
	25.000000f,
	// 577
	0.776710f, 0.006957f,
	0.517547f, 0.407388f, -0.752449f,
	0.801780f, 1.400897f, 0.015260f,
	25.000000f,
	// 578
	0.758395f, 0.048620f,
	0.215105f, 0.720189f, 0.659589f,
	0.722835f, 1.409623f, 0.027104f,
	25.000000f,
	// 579
	0.758395f, 0.035801f,
	0.158071f, 0.735933f, 0.658343f,
	0.752223f, 1.408155f, 0.026361f,
	25.000000f,
	// 580
	0.758395f, 0.032596f,
	0.123506f, 0.770239f, 0.625682f,
	0.756009f, 1.407456f, 0.025863f,
	25.000000f,
	// 581
	0.758395f, 0.020127f,
	0.126144f, 0.815489f, 0.564858f,
	0.776909f, 1.406478f, 0.024868f,
	25.000000f,
	// 582
	0.758395f, 0.017674f,
	0.177075f, 0.797847f, 0.576267f,
	0.779940f, 1.405768f, 0.024871f,
	25.000000f,
	// 583
	0.758441f, 0.006957f,
	0.533745f, 0.396641f, 0.746855f,
	0.802001f, 1.400387f, 0.025801f,
	25.000000f,
	// 584
	0.767417f, 0.003752f,
	0.938976f, 0.343982f, -0.000343f,
	0.805195f, 1.400409f, 0.020650f,
	25.000000f,
	// 585
	0.752079f, 0.039006f,
	0.057922f, -0.076477f, 0.995388f,
	0.748213f, 1.400698f, 0.028382f,
	25.000000f,
	// 586
	0.752079f, 0.019776f,
	0.049032f, -0.007335f, 0.998770f,
	0.776537f, 1.399829f, 0.027400f,
	25.000000f,
	// 587
	0.744180f, 0.008748f,
	0.416419f, -0.752609f, 0.510074f,
	0.800661f, 1.395270f, 0.024375f,
	25.000000f,
	// 588
	0.767417f, 0.003752f,
	0.938976f, 0.343982f, -0.000343f,
	0.805195f, 1.400409f, 0.020650f,
	25.000000f,
	// 589
	0.744180f, 0.019776f,
	0.037097f, -0.830277f, 0.556114f,
	0.775512f, 1.393107f, 0.024865f,
	25.000000f,
	// 590
	0.744180f, 0.042210f,
	0.057382f, -0.845141f, 0.531454f,
	0.742926f, 1.393786f, 0.025564f,
	25.000000f,
	// 591
	0.744180f, 0.049504f,
	0.077743f, -0.754492f, 0.651689f,
	0.723095f, 1.393453f, 0.027849f,
	25.000000f,
	// 592
	0.751833f, 0.049504f,
	0.098690f, 0.010377f, 0.995064f,
	0.720586f, 1.401783f, 0.029867f,
	25.000000f,
	// 593
	0.744180f, 0.054520f,
	0.098529f, -0.650244f, 0.753309f,
	0.706249f, 1.392397f, 0.029304f,
	25.000000f,
	// 594
	0.751033f, 0.061047f,
	0.074627f, -0.053196f, 0.995792f,
	0.693673f, 1.404039f, 0.032004f,
	25.000000f,
	// 595
	0.954630f, 0.019776f,
	0.030627f, 0.017585f, -0.999376f,
	0.776448f, 1.400495f, 0.014571f,
	25.000000f,
	// 596
	0.957772f, 0.008575f,
	0.406409f, -0.746777f, -0.526456f,
	0.800667f, 1.395658f, 0.017303f,
	25.000000f,
	// 597
	0.957772f, 0.019776f,
	0.036934f, -0.785815f, -0.617358f,
	0.775540f, 1.393144f, 0.016287f,
	25.000000f,
	// 598
	0.954630f, 0.006957f,
	0.517547f, 0.407388f, -0.752449f,
	0.801780f, 1.400897f, 0.015260f,
	25.000000f,
	// 599
	0.967195f, 0.003752f,
	0.938976f, 0.343982f, -0.000343f,
	0.805195f, 1.400409f, 0.020650f,
	25.000000f,
	// 600
	0.973477f, 0.008748f,
	0.416419f, -0.752609f, 0.510074f,
	0.800661f, 1.395270f, 0.024375f,
	25.000000f,
	// 601
	0.973477f, 0.019776f,
	0.037097f, -0.830277f, 0.556114f,
	0.775512f, 1.393107f, 0.024865f,
	25.000000f,
	// 602
	0.957772f, 0.042210f,
	0.101260f, -0.836901f, -0.537907f,
	0.742935f, 1.393786f, 0.016381f,
	25.000000f,
	// 603
	0.973477f, 0.042210f,
	0.057382f, -0.845141f, 0.531454f,
	0.742926f, 1.393786f, 0.025564f,
	25.000000f,
	// 604
	0.954630f, 0.039006f,
	0.055746f, -0.017220f, -0.998296f,
	0.748799f, 1.401674f, 0.014046f,
	25.000000f,
	// 605
	0.954630f, 0.047370f,
	0.120550f, -0.990155f, 0.071137f,
	0.728689f, 1.392677f, 0.013707f,
	25.000000f,
	// 606
	0.954500f, 0.046366f,
	0.331215f, 0.943098f, -0.029364f,
	0.725377f, 1.408559f, 0.013706f,
	25.000000f,
	// 607
	0.976618f, 0.064645f,
	0.375026f, -0.474061f, -0.796631f,
	0.688546f, 1.375042f, 0.026031f,
	25.000000f,
	// 608
	0.995464f, 0.045415f,
	0.073352f, -0.959002f, -0.273741f,
	0.717278f, 1.364875f, 0.048901f,
	25.000000f,
	// 609
	0.995464f, 0.064645f,
	0.031251f, -0.970628f, -0.238547f,
	0.687907f, 1.367174f, 0.036488f,
	25.000000f,
	// 610
	0.989182f, 0.029391f,
	0.971176f, -0.117641f, 0.207310f,
	0.742320f, 1.370296f, 0.057889f,
	25.000000f,
	// 611
	0.995464f, 0.032596f,
	0.567491f, -0.799086f, -0.198535f,
	0.739444f, 1.364207f, 0.055893f,
	25.000000f,
	// 612
	0.982900f, 0.032596f,
	0.660458f, 0.052287f, -0.749040f,
	0.740392f, 1.371642f, 0.052249f,
	25.000000f,
	// 613
	0.982900f, 0.042210f,
	0.482851f, 0.082004f, -0.871854f,
	0.720753f, 1.374344f, 0.044475f,
	25.000000f,
	// 614
	0.976618f, 0.055030f,
	0.545931f, 0.298179f, -0.782974f,
	0.697315f, 1.383751f, 0.031943f,
	25.000000f,
	// 615
	0.777566f, 0.889048f,
	-0.965926f, -0.036015f, 0.256299f,
	-0.048684f, 1.540907f, 0.076844f,
	28.000000f,
	// 616
	0.753408f, 0.841191f,
	-0.683008f, -0.712389f, 0.161252f,
	-0.043953f, 1.529596f, 0.075254f,
	28.000000f,
	// 617
	0.766516f, 0.889048f,
	-0.912269f, -0.057011f, 0.405605f,
	-0.046520f, 1.539783f, 0.084842f,
	28.000000f,
	// 618
	0.695086f, 0.821368f,
	-0.000005f, -0.992546f, 0.121868f,
	-0.032531f, 1.524911f, 0.074596f,
	28.000000f,
	// 619
	0.695086f, 0.830435f,
	-0.000006f, -0.960393f, 0.278651f,
	-0.032531f, 1.525930f, 0.082895f,
	28.000000f,
	// 620
	0.720340f, 0.839019f,
	-0.350756f, -0.894202f, 0.278161f,
	-0.037477f, 1.527959f, 0.083180f,
	28.000000f,
	// 621
	0.745594f, 0.847602f,
	-0.645068f, -0.695797f, 0.315837f,
	-0.042423f, 1.529988f, 0.083465f,
	28.000000f,
	// 622
	0.756055f, 0.868325f,
	-0.846787f, -0.402998f, 0.347196f,
	-0.044471f, 1.534885f, 0.084154f,
	28.000000f,
	// 623
	0.751421f, 0.889048f,
	-0.738238f, -0.093877f, 0.667976f,
	-0.044066f, 1.539302f, 0.088267f,
	28.000000f,
	// 624
	0.756055f, 0.909770f,
	-0.846793f, 0.291682f, 0.444819f,
	-0.044471f, 1.544681f, 0.085530f,
	28.000000f,
	// 625
	0.734921f, 0.921735f,
	-0.522011f, 0.423059f, 0.740625f,
	-0.040688f, 1.547379f, 0.089402f,
	28.000000f,
	// 626
	0.745594f, 0.930493f,
	-0.645072f, 0.581794f, 0.495377f,
	-0.042423f, 1.549578f, 0.086219f,
	28.000000f,
	// 627
	0.720340f, 0.939077f,
	-0.350746f, 0.782901f, 0.513852f,
	-0.037477f, 1.551607f, 0.086504f,
	28.000000f,
	// 628
	0.695086f, 0.870778f,
	-0.000000f, -0.376938f, 0.926239f,
	-0.032531f, 1.534189f, 0.091241f,
	28.000000f,
	// 629
	0.710830f, 0.857859f,
	-0.188895f, -0.572632f, 0.797754f,
	-0.035521f, 1.531800f, 0.089772f,
	28.000000f,
	// 630
	0.695086f, 0.855208f,
	-0.000000f, -0.591596f, 0.806234f,
	-0.032531f, 1.531032f, 0.089664f,
	28.000000f,
	// 631
	0.695086f, 0.842822f,
	-0.000000f, -0.824928f, 0.565238f,
	-0.032531f, 1.527879f, 0.086662f,
	28.000000f,
	// 632
	0.734921f, 0.856361f,
	-0.522015f, -0.610809f, 0.595325f,
	-0.040688f, 1.531224f, 0.087132f,
	28.000000f,
	// 633
	0.733095f, 0.876129f,
	-0.456029f, -0.308092f, 0.834935f,
	-0.039750f, 1.535988f, 0.090361f,
	28.000000f,
	// 634
	0.736326f, 0.889048f,
	-0.473627f, -0.122575f, 0.872154f,
	-0.040526f, 1.538949f, 0.090777f,
	28.000000f,
	// 635
	0.717351f, 0.889048f,
	-0.244360f, -0.134954f, 0.960248f,
	-0.037180f, 1.538793f, 0.091888f,
	28.000000f,
	// 636
	0.710830f, 0.901967f,
	-0.172788f, 0.036153f, 0.984295f,
	-0.035818f, 1.542048f, 0.092346f,
	28.000000f,
	// 637
	0.695086f, 0.889048f,
	-0.000000f, -0.139173f, 0.990268f,
	-0.032531f, 1.538691f, 0.092613f,
	28.000000f,
	// 638
	0.710830f, 0.876129f,
	-0.172790f, -0.306060f, 0.936200f,
	-0.035818f, 1.535537f, 0.091431f,
	28.000000f,
	// 639
	0.724247f, 0.865119f,
	-0.334907f, -0.454226f, 0.825540f,
	-0.038184f, 1.533351f, 0.089990f,
	28.000000f,
	// 640
	0.679342f, 0.876129f,
	0.172790f, -0.306060f, 0.936200f,
	-0.029244f, 1.535537f, 0.091431f,
	28.000000f,
	// 641
	0.733095f, 0.901967f,
	-0.456026f, 0.066019f, 0.887515f,
	-0.039750f, 1.541910f, 0.091193f,
	28.000000f,
	// 642
	0.724247f, 0.912976f,
	-0.334904f, 0.209063f, 0.918767f,
	-0.038184f, 1.544547f, 0.091564f,
	28.000000f,
	// 643
	0.710830f, 0.920237f,
	-0.188894f, 0.330551f, 0.924692f,
	-0.035521f, 1.546097f, 0.091782f,
	28.000000f,
	// 644
	0.695086f, 0.935274f,
	-0.000000f, 0.637179f, 0.770716f,
	-0.032531f, 1.550725f, 0.089873f,
	28.000000f,
	// 645
	0.695086f, 0.922888f,
	-0.000000f, 0.346448f, 0.938069f,
	-0.032531f, 1.546866f, 0.091890f,
	28.000000f,
	// 646
	0.695086f, 0.907318f,
	-0.000000f, 0.107024f, 0.994256f,
	-0.032531f, 1.543396f, 0.092535f,
	28.000000f,
	// 647
	0.679342f, 0.920237f,
	0.188894f, 0.330551f, 0.924692f,
	-0.029541f, 1.546097f, 0.091782f,
	28.000000f,
	// 648
	0.679342f, 0.901967f,
	0.172788f, 0.036153f, 0.984295f,
	-0.029244f, 1.542048f, 0.092346f,
	28.000000f,
	// 649
	0.665925f, 0.912976f,
	0.334904f, 0.209063f, 0.918767f,
	-0.026878f, 1.544547f, 0.091564f,
	28.000000f,
	// 650
	0.657076f, 0.901967f,
	0.456026f, 0.066019f, 0.887515f,
	-0.025312f, 1.541910f, 0.091193f,
	28.000000f,
	// 651
	0.655251f, 0.921735f,
	0.522011f, 0.423059f, 0.740626f,
	-0.024374f, 1.547379f, 0.089402f,
	28.000000f,
	// 652
	0.638751f, 0.889048f,
	0.738238f, -0.093877f, 0.667976f,
	-0.020996f, 1.539302f, 0.088267f,
	28.000000f,
	// 653
	0.672820f, 0.889048f,
	0.244360f, -0.134954f, 0.960248f,
	-0.027882f, 1.538793f, 0.091888f,
	28.000000f,
	// 654
	0.657076f, 0.876129f,
	0.456029f, -0.308093f, 0.834935f,
	-0.025312f, 1.535988f, 0.090361f,
	28.000000f,
	// 655
	0.653846f, 0.889048f,
	0.473627f, -0.122575f, 0.872154f,
	-0.024536f, 1.538949f, 0.090777f,
	28.000000f,
	// 656
	0.634117f, 0.909770f,
	0.846793f, 0.291683f, 0.444816f,
	-0.020591f, 1.544681f, 0.085530f,
	28.000000f,
	// 657
	0.623656f, 0.889048f,
	0.912270f, -0.057013f, 0.405602f,
	-0.018542f, 1.539783f, 0.084842f,
	28.000000f,
	// 658
	0.634117f, 0.868325f,
	0.846790f, -0.402995f, 0.347190f,
	-0.020591f, 1.534885f, 0.084154f,
	28.000000f,
	// 659
	0.655251f, 0.856361f,
	0.522015f, -0.610809f, 0.595326f,
	-0.024374f, 1.531224f, 0.087132f,
	28.000000f,
	// 660
	0.665925f, 0.865119f,
	0.334907f, -0.454226f, 0.825540f,
	-0.026878f, 1.533351f, 0.089990f,
	28.000000f,
	// 661
	0.679342f, 0.857859f,
	0.188895f, -0.572632f, 0.797754f,
	-0.029541f, 1.531800f, 0.089772f,
	28.000000f,
	// 662
	0.636764f, 0.936905f,
	0.683013f, 0.640344f, 0.351357f,
	-0.021109f, 1.552218f, 0.078434f,
	28.000000f,
	// 663
	0.644577f, 0.930493f,
	0.645073f, 0.581792f, 0.495378f,
	-0.022639f, 1.549578f, 0.086219f,
	28.000000f,
	// 664
	0.612606f, 0.889048f,
	0.965925f, -0.036018f, 0.256304f,
	-0.016378f, 1.540907f, 0.076844f,
	28.000000f,
	// 665
	0.644577f, 0.847602f,
	0.645068f, -0.695797f, 0.315837f,
	-0.022639f, 1.529988f, 0.083465f,
	28.000000f,
	// 666
	0.669832f, 0.839019f,
	0.350760f, -0.894196f, 0.278173f,
	-0.027585f, 1.527959f, 0.083180f,
	28.000000f,
	// 667
	0.636764f, 0.841191f,
	0.683011f, -0.712386f, 0.161251f,
	-0.021109f, 1.529596f, 0.075254f,
	28.000000f,
	// 668
	0.753408f, 0.936905f,
	-0.683011f, 0.640346f, 0.351358f,
	-0.043953f, 1.552218f, 0.078434f,
	28.000000f,
	// 669
	0.695086f, 0.947660f,
	-0.000001f, 0.846387f, 0.532569f,
	-0.032531f, 1.553636f, 0.086789f,
	28.000000f,
	// 670
	0.669832f, 0.939077f,
	0.350745f, 0.782898f, 0.513856f,
	-0.027585f, 1.551607f, 0.086504f,
	28.000000f,
	// 671
	0.695086f, 0.956727f,
	-0.000002f, 0.920503f, 0.390736f,
	-0.032531f, 1.556903f, 0.079092f,
	28.000000f,
	// 672
	0.010478f, 0.766484f,
	-0.271423f, 0.039491f, 0.961650f,
	-0.004620f, 1.489390f, 0.104946f,
	28.000000f,
	// 673
	0.008715f, 0.758240f,
	-0.374059f, -0.119049f, 0.919732f,
	-0.005930f, 1.484808f, 0.105217f,
	28.000000f,
	// 674
	0.002178f, 0.757057f,
	-0.000000f, -0.130966f, 0.991387f,
	-0.000000f, 1.484046f, 0.106418f,
	28.000000f,
	// 675
	0.002178f, 0.752583f,
	-0.000000f, -0.586086f, 0.810249f,
	-0.000000f, 1.480493f, 0.104816f,
	28.000000f,
	// 676
	0.008728f, 0.753720f,
	-0.301526f, -0.578906f, 0.757595f,
	-0.005310f, 1.480813f, 0.103404f,
	28.000000f,
	// 677
	0.002178f, 0.748600f,
	-0.000000f, -0.924936f, 0.380123f,
	-0.000000f, 1.477090f, 0.101026f,
	28.000000f,
	// 678
	0.008766f, 0.749286f,
	-0.214325f, -0.901284f, 0.376500f,
	-0.004889f, 1.477928f, 0.100237f,
	28.000000f,
	// 679
	0.002178f, 0.748529f,
	0.000000f, -0.906447f, -0.422319f,
	-0.000000f, 1.477043f, 0.098577f,
	28.000000f,
	// 680
	0.008824f, 0.748769f,
	0.215421f, -0.783218f, -0.583235f,
	-0.004270f, 1.477624f, 0.096032f,
	28.000000f,
	// 681
	0.002178f, 0.748381f,
	0.000000f, -0.180791f, -0.983522f,
	-0.000000f, 1.488114f, 0.096102f,
	28.000000f,
	// 682
	0.022552f, 0.748104f,
	0.215327f, -0.762725f, -0.609824f,
	-0.012199f, 1.478719f, 0.092208f,
	28.000000f,
	// 683
	0.022723f, 0.748529f,
	-0.286061f, -0.912035f, 0.293873f,
	-0.011709f, 1.478536f, 0.097586f,
	28.000000f,
	// 684
	0.015287f, 0.783327f,
	-0.605356f, -0.776109f, 0.176633f,
	-0.005917f, 1.497435f, 0.109720f,
	28.000000f,
	// 685
	0.021102f, 0.782805f,
	-0.125319f, -0.949294f, 0.288333f,
	-0.008971f, 1.497249f, 0.105815f,
	28.000000f,
	// 686
	0.015181f, 0.780980f,
	-0.200994f, -0.815656f, 0.542501f,
	-0.006517f, 1.499052f, 0.103736f,
	28.000000f,
	// 687
	0.023807f, 0.776865f,
	-0.480031f, -0.353003f, 0.803094f,
	-0.009877f, 1.496101f, 0.102898f,
	28.000000f,
	// 688
	0.012563f, 0.774416f,
	-0.377206f, 0.051937f, 0.924672f,
	-0.006515f, 1.495015f, 0.104248f,
	28.000000f,
	// 689
	0.029704f, 0.765589f,
	-0.530517f, -0.012135f, 0.847588f,
	-0.012048f, 1.489432f, 0.100698f,
	28.000000f,
	// 690
	0.026620f, 0.755268f,
	-0.570795f, -0.201278f, 0.796040f,
	-0.013299f, 1.483004f, 0.100299f,
	28.000000f,
	// 691
	0.025328f, 0.752323f,
	-0.468488f, -0.591644f, 0.656107f,
	-0.012621f, 1.480193f, 0.099341f,
	28.000000f,
	// 692
	0.033183f, 0.777567f,
	-0.655632f, -0.158027f, 0.738359f,
	-0.013102f, 1.498773f, 0.100964f,
	28.000000f,
	// 693
	0.042754f, 0.764074f,
	-0.525775f, -0.116516f, 0.842606f,
	-0.017032f, 1.488888f, 0.097574f,
	28.000000f,
	// 694
	0.036946f, 0.753826f,
	-0.598945f, -0.310960f, 0.737949f,
	-0.017820f, 1.482276f, 0.096070f,
	28.000000f,
	// 695
	0.036369f, 0.750263f,
	-0.434483f, -0.745100f, 0.506014f,
	-0.017156f, 1.479726f, 0.094864f,
	28.000000f,
	// 696
	0.035648f, 0.748988f,
	-0.171821f, -0.976148f, 0.132713f,
	-0.015900f, 1.479016f, 0.093659f,
	28.000000f,
	// 697
	0.034322f, 0.748435f,
	0.346267f, -0.640723f, -0.685254f,
	-0.016072f, 1.479180f, 0.089423f,
	28.000000f,
	// 698
	0.045176f, 0.748609f,
	-0.524178f, -0.442193f, 0.727807f,
	-0.019104f, 1.479340f, 0.091956f,
	28.000000f,
	// 699
	0.047495f, 0.753770f,
	-0.576860f, -0.477092f, 0.663035f,
	-0.020947f, 1.481670f, 0.093110f,
	28.000000f,
	// 700
	0.058058f, 0.761762f,
	-0.534245f, -0.293982f, 0.792563f,
	-0.023801f, 1.485442f, 0.092378f,
	28.000000f,
	// 701
	0.051693f, 0.772834f,
	-0.478104f, -0.205628f, 0.853893f,
	-0.023548f, 1.493501f, 0.095359f,
	28.000000f,
	// 702
	0.044924f, 0.748395f,
	0.499086f, 0.100007f, -0.860763f,
	-0.019767f, 1.479539f, 0.088368f,
	28.000000f,
	// 703
	0.043773f, 0.748515f,
	0.559839f, -0.007504f, -0.828567f,
	-0.023727f, 1.488114f, 0.085577f,
	28.000000f,
	// 704
	0.043878f, 0.748672f,
	0.547579f, 0.347780f, -0.761056f,
	-0.024084f, 1.470597f, 0.081310f,
	28.000000f,
	// 705
	0.026817f, 0.748329f,
	0.280057f, 0.856266f, -0.434024f,
	-0.013140f, 1.478872f, 0.091570f,
	28.000000f,
	// 706
	0.043878f, 0.748672f,
	0.547579f, 0.347780f, -0.761056f,
	-0.024084f, 1.470597f, 0.081310f,
	28.000000f,
	// 707
	0.027240f, 0.785693f,
	-0.826223f, -0.258748f, 0.500406f,
	-0.011297f, 1.500294f, 0.106987f,
	28.000000f,
	// 708
	0.036452f, 0.789919f,
	-0.694600f, 0.039314f, 0.718321f,
	-0.013074f, 1.504332f, 0.100921f,
	28.000000f,
	// 709
	0.026817f, 0.748329f,
	0.280057f, 0.856266f, -0.434024f,
	-0.013140f, 1.478872f, 0.091570f,
	28.000000f,
	// 710
	0.002178f, 0.747679f,
	0.000000f, 0.449695f, -0.893182f,
	-0.000000f, 1.470597f, 0.093187f,
	28.000000f,
	// 711
	0.015757f, 0.786846f,
	-0.805528f, -0.350952f, 0.477449f,
	-0.006751f, 1.500230f, 0.111847f,
	28.000000f,
	// 712
	0.008277f, 0.778637f,
	-0.563445f, -0.752475f, 0.341044f,
	-0.003756f, 1.495649f, 0.111798f,
	28.000000f,
	// 713
	0.009221f, 0.785303f,
	-0.665848f, -0.405816f, 0.626067f,
	-0.004443f, 1.500252f, 0.117516f,
	28.000000f,
	// 714
	0.017278f, 0.794297f,
	-0.865016f, 0.167160f, 0.473080f,
	-0.007834f, 1.506127f, 0.111259f,
	28.000000f,
	// 715
	0.028180f, 0.792762f,
	-0.894047f, 0.219486f, 0.390519f,
	-0.011710f, 1.505435f, 0.104063f,
	28.000000f,
	// 716
	0.029076f, 0.800448f,
	-0.722998f, 0.119851f, 0.680375f,
	-0.011643f, 1.508724f, 0.101840f,
	28.000000f,
	// 717
	0.010274f, 0.794307f,
	-0.642952f, 0.229509f, 0.730711f,
	-0.004904f, 1.505852f, 0.118395f,
	28.000000f,
	// 718
	0.010635f, 0.803090f,
	-0.607977f, 0.470184f, 0.639758f,
	-0.004335f, 1.510814f, 0.113806f,
	28.000000f,
	// 719
	0.002178f, 0.783102f,
	-0.000000f, -0.508180f, 0.861251f,
	-0.000000f, 1.499323f, 0.119446f,
	28.000000f,
	// 720
	0.002178f, 0.776244f,
	-0.000000f, -0.883330f, 0.468752f,
	-0.000000f, 1.494957f, 0.112904f,
	28.000000f,
	// 721
	0.002178f, 0.771257f,
	-0.000000f, -0.681562f, 0.731761f,
	-0.000000f, 1.492352f, 0.106067f,
	28.000000f,
	// 722
	0.007226f, 0.772578f,
	-0.535255f, -0.436235f, 0.723327f,
	-0.003500f, 1.493627f, 0.105656f,
	28.000000f,
	// 723
	0.002178f, 0.765731f,
	-0.000000f, 0.024748f, 0.999694f,
	-0.000000f, 1.489214f, 0.104912f,
	28.000000f,
	// 724
	0.002294f, 0.859087f,
	-0.000000f, -0.142729f, 0.989762f,
	-0.000000f, 1.547008f, 0.104507f,
	28.000000f,
	// 725
	0.012745f, 0.840217f,
	-0.601488f, 0.076159f, 0.795243f,
	-0.004922f, 1.535032f, 0.102137f,
	28.000000f,
	// 726
	0.002294f, 0.840254f,
	-0.000000f, 0.163238f, 0.986587f,
	-0.000000f, 1.535450f, 0.104186f,
	28.000000f,
	// 727
	0.011829f, 0.820129f,
	-0.501338f, 0.333727f, 0.798302f,
	-0.004746f, 1.523406f, 0.106795f,
	28.000000f,
	// 728
	0.002294f, 0.820265f,
	-0.000000f, 0.414799f, 0.909913f,
	-0.000000f, 1.523589f, 0.107956f,
	28.000000f,
	// 729
	0.002294f, 0.804043f,
	-0.000000f, 0.598603f, 0.801046f,
	-0.000000f, 1.511047f, 0.115444f,
	28.000000f,
	// 730
	0.002294f, 0.794435f,
	-0.000000f, 0.294800f, 0.955559f,
	-0.000000f, 1.505870f, 0.119951f,
	28.000000f,
	// 731
	0.002294f, 0.886054f,
	-0.000000f, -0.051035f, 0.998697f,
	-0.000000f, 1.558651f, 0.106122f,
	28.000000f,
	// 732
	0.026386f, 0.885728f,
	-0.142206f, -0.060530f, 0.987985f,
	-0.011505f, 1.558972f, 0.105362f,
	28.000000f,
	// 733
	0.023690f, 0.859507f,
	-0.282247f, -0.330685f, 0.900546f,
	-0.008608f, 1.547669f, 0.103232f,
	28.000000f,
	// 734
	0.031319f, 0.850041f,
	-0.398376f, -0.423210f, 0.813751f,
	-0.014197f, 1.540142f, 0.092853f,
	28.000000f,
	// 735
	0.026065f, 0.838696f,
	-0.693881f, 0.076404f, 0.716025f,
	-0.010392f, 1.533260f, 0.093696f,
	28.000000f,
	// 736
	0.024046f, 0.818705f,
	-0.668532f, 0.265378f, 0.694722f,
	-0.011984f, 1.520775f, 0.100793f,
	28.000000f,
	// 737
	0.020095f, 0.802069f,
	-0.832199f, 0.230184f, 0.504440f,
	-0.008237f, 1.510185f, 0.107866f,
	28.000000f,
	// 738
	0.039673f, 0.816903f,
	-0.450603f, 0.285041f, 0.845996f,
	-0.018051f, 1.518098f, 0.097270f,
	28.000000f,
	// 739
	0.040151f, 0.837469f,
	-0.475922f, 0.133468f, 0.869301f,
	-0.017124f, 1.532540f, 0.090234f,
	28.000000f,
	// 740
	0.047303f, 0.843828f,
	-0.385151f, -0.592254f, 0.707739f,
	-0.020545f, 1.536924f, 0.091566f,
	28.000000f,
	// 741
	0.050759f, 0.857897f,
	-0.129656f, -0.543742f, 0.829177f,
	-0.022303f, 1.545019f, 0.094420f,
	28.000000f,
	// 742
	0.054885f, 0.849581f,
	-0.177913f, -0.595009f, 0.783780f,
	-0.024652f, 1.541175f, 0.093813f,
	28.000000f,
	// 743
	0.068231f, 0.853290f,
	-0.148882f, -0.631947f, 0.760577f,
	-0.030619f, 1.543884f, 0.094359f,
	28.000000f,
	// 744
	0.056006f, 0.825124f,
	-0.188057f, 0.218596f, 0.957523f,
	-0.025664f, 1.525104f, 0.090737f,
	28.000000f,
	// 745
	0.051835f, 0.836245f,
	-0.064806f, 0.710078f, 0.701135f,
	-0.023749f, 1.531457f, 0.089780f,
	28.000000f,
	// 746
	0.062155f, 0.846670f,
	-0.414169f, -0.870271f, 0.266631f,
	-0.027990f, 1.540446f, 0.085634f,
	28.000000f,
	// 747
	0.059412f, 0.845366f,
	-0.619136f, -0.736021f, 0.273757f,
	-0.025051f, 1.537863f, 0.082985f,
	28.000000f,
	// 748
	0.059032f, 0.844016f,
	-0.860415f, -0.074142f, 0.504172f,
	-0.022659f, 1.534599f, 0.080831f,
	28.000000f,
	// 749
	0.060952f, 0.843434f,
	-0.349484f, 0.871537f, 0.343925f,
	-0.023667f, 1.533118f, 0.081262f,
	28.000000f,
	// 750
	0.062818f, 0.835294f,
	0.022118f, 0.594806f, 0.803565f,
	-0.028930f, 1.530871f, 0.090962f,
	28.000000f,
	// 751
	0.076247f, 0.836136f,
	-0.069908f, 0.464157f, 0.882990f,
	-0.035767f, 1.530972f, 0.090758f,
	28.000000f,
	// 752
	0.065538f, 0.842823f,
	-0.069107f, 0.984422f, 0.161672f,
	-0.029433f, 1.532566f, 0.082016f,
	28.000000f,
	// 753
	0.069885f, 0.843444f,
	0.065591f, 0.987498f, 0.143337f,
	-0.033270f, 1.532002f, 0.082522f,
	28.000000f,
	// 754
	0.074899f, 0.844324f,
	0.429549f, 0.760877f, 0.486367f,
	-0.037676f, 1.533751f, 0.082890f,
	28.000000f,
	// 755
	0.087511f, 0.840817f,
	-0.217116f, 0.337955f, 0.915777f,
	-0.041352f, 1.532511f, 0.089262f,
	28.000000f,
	// 756
	0.095260f, 0.846991f,
	-0.521285f, -0.253216f, 0.814950f,
	-0.046051f, 1.538219f, 0.086639f,
	28.000000f,
	// 757
	0.080837f, 0.846356f,
	0.281075f, -0.396056f, 0.874149f,
	-0.039159f, 1.537298f, 0.084005f,
	28.000000f,
	// 758
	0.084580f, 0.848242f,
	0.298302f, -0.750868f, 0.589248f,
	-0.038119f, 1.538919f, 0.085227f,
	28.000000f,
	// 759
	0.068960f, 0.849149f,
	-0.094483f, -0.953894f, 0.284883f,
	-0.032274f, 1.542120f, 0.086719f,
	28.000000f,
	// 760
	0.081699f, 0.852569f,
	-0.136260f, -0.604128f, 0.785152f,
	-0.038171f, 1.543665f, 0.092925f,
	28.000000f,
	// 761
	0.077548f, 0.848802f,
	0.367274f, -0.842987f, 0.393042f,
	-0.035335f, 1.541252f, 0.085100f,
	28.000000f,
	// 762
	0.092706f, 0.850638f,
	-0.330354f, -0.513352f, 0.792045f,
	-0.043839f, 1.541334f, 0.089677f,
	28.000000f,
	// 763
	0.097744f, 0.859069f,
	-0.689786f, -0.184723f, 0.700052f,
	-0.046194f, 1.545394f, 0.088643f,
	28.000000f,
	// 764
	0.114145f, 0.848944f,
	-0.861600f, -0.084053f, 0.500581f,
	-0.053124f, 1.538638f, 0.075296f,
	28.000000f,
	// 765
	0.104263f, 0.872056f,
	-0.744803f, -0.111222f, 0.657950f,
	-0.048927f, 1.552853f, 0.088182f,
	28.000000f,
	// 766
	0.048633f, 0.866463f,
	-0.274923f, -0.398505f, 0.874992f,
	-0.021889f, 1.551552f, 0.102615f,
	28.000000f,
	// 767
	0.068332f, 0.862081f,
	-0.204950f, -0.494306f, 0.844782f,
	-0.030569f, 1.548579f, 0.095636f,
	28.000000f,
	// 768
	0.083502f, 0.861945f,
	-0.416917f, -0.263818f, 0.869816f,
	-0.039505f, 1.548397f, 0.093630f,
	28.000000f,
	// 769
	0.078441f, 0.873569f,
	-0.421995f, -0.249233f, 0.871667f,
	-0.036076f, 1.554184f, 0.097963f,
	28.000000f,
	// 770
	0.105486f, 0.888837f,
	-0.770705f, 0.022903f, 0.636780f,
	-0.049151f, 1.562714f, 0.087995f,
	28.000000f,
	// 771
	0.080507f, 0.891113f,
	-0.459865f, 0.048021f, 0.886690f,
	-0.036094f, 1.563377f, 0.098539f,
	28.000000f,
	// 772
	0.050699f, 0.888406f,
	-0.276243f, 0.021154f, 0.960855f,
	-0.021952f, 1.561665f, 0.102703f,
	28.000000f,
	// 773
	0.132551f, 0.874915f,
	-0.912400f, -0.060661f, 0.404779f,
	-0.056855f, 1.554376f, 0.074223f,
	28.000000f,
	// 774
	0.109521f, 0.905895f,
	-0.744579f, 0.136579f, 0.653412f,
	-0.048226f, 1.575005f, 0.088189f,
	28.000000f,
	// 775
	0.072228f, 0.906771f,
	-0.372900f, 0.121926f, 0.919826f,
	-0.029564f, 1.574471f, 0.099324f,
	28.000000f,
	// 776
	0.037231f, 0.906516f,
	-0.194114f, 0.094094f, 0.976456f,
	-0.013757f, 1.573841f, 0.104432f,
	28.000000f,
	// 777
	0.002582f, 0.906956f,
	-0.000000f, 0.077424f, 0.996998f,
	-0.000000f, 1.573151f, 0.105564f,
	28.000000f,
	// 778
	0.081768f, 0.947204f,
	-0.431594f, 0.388851f, 0.813954f,
	-0.031680f, 1.601894f, 0.095742f,
	28.000000f,
	// 779
	0.042796f, 0.950387f,
	-0.204990f, 0.397803f, 0.894277f,
	-0.016139f, 1.601879f, 0.099265f,
	28.000000f,
	// 780
	0.150370f, 0.857434f,
	-0.958161f, -0.046078f, 0.282497f,
	-0.063230f, 1.544278f, 0.053775f,
	28.000000f,
	// 781
	0.138885f, 0.896757f,
	-0.917350f, 0.123945f, 0.378294f,
	-0.057958f, 1.574449f, 0.069728f,
	28.000000f,
	// 782
	0.119610f, 0.944579f,
	-0.769848f, 0.362575f, 0.525236f,
	-0.045521f, 1.601046f, 0.080715f,
	28.000000f,
	// 783
	0.091523f, 0.969988f,
	-0.411473f, 0.702800f, 0.580312f,
	-0.029557f, 1.627186f, 0.073801f,
	28.000000f,
	// 784
	0.031639f, 0.984873f,
	-0.000000f, 0.729999f, 0.683449f,
	-0.000000f, 1.628723f, 0.081616f,
	28.000000f,
	// 785
	0.005593f, 0.952808f,
	-0.000000f, 0.383052f, 0.923727f,
	-0.000000f, 1.601910f, 0.102329f,
	28.000000f,
	// 786
	0.070789f, 0.998988f,
	-0.000000f, 0.937557f, 0.347832f,
	-0.000000f, 1.647379f, 0.054029f,
	28.000000f,
	// 787
	0.158258f, 0.832706f,
	-0.975620f, -0.134827f, 0.173167f,
	-0.062980f, 1.525316f, 0.046574f,
	28.000000f,
	// 788
	0.202051f, 0.846576f,
	-0.927476f, -0.099252f, 0.360467f,
	-0.071779f, 1.539895f, 0.015215f,
	28.000000f,
	// 789
	0.185490f, 0.880265f,
	-0.968709f, 0.065947f, 0.239277f,
	-0.066971f, 1.571639f, 0.041277f,
	28.000000f,
	// 790
	0.166909f, 0.917852f,
	-0.921954f, 0.241943f, 0.302431f,
	-0.060965f, 1.595573f, 0.048844f,
	28.000000f,
	// 791
	0.143247f, 0.956272f,
	-0.747166f, 0.531750f, 0.398729f,
	-0.048025f, 1.621052f, 0.059296f,
	28.000000f,
	// 792
	0.112802f, 0.981492f,
	-0.372257f, 0.892635f, 0.254218f,
	-0.028127f, 1.644093f, 0.044506f,
	28.000000f,
	// 793
	0.206988f, 0.999479f,
	-0.000000f, 0.984745f, -0.174003f,
	0.000000f, 1.651813f, -0.000109f,
	28.000000f,
	// 794
	0.225358f, 0.859401f,
	-0.530598f, 0.826628f, -0.187486f,
	-0.074366f, 1.547514f, -0.000636f,
	28.000000f,
	// 795
	0.226033f, 0.856219f,
	-0.530874f, 0.516485f, 0.671875f,
	-0.083021f, 1.548956f, 0.008234f,
	28.000000f,
	// 796
	0.225436f, 0.853909f,
	-0.940537f, 0.313681f, 0.130363f,
	-0.087177f, 1.545781f, -0.004428f,
	28.000000f,
	// 797
	0.226033f, 0.856219f,
	-0.530874f, 0.516485f, 0.671875f,
	-0.083021f, 1.548956f, 0.008234f,
	28.000000f,
	// 798
	0.202051f, 0.846576f,
	-0.927476f, -0.099252f, 0.360467f,
	-0.071779f, 1.539895f, 0.015215f,
	28.000000f,
	// 799
	0.287730f, 0.956738f,
	-0.453907f, 0.601497f, -0.657396f,
	-0.035698f, 1.624987f, -0.040722f,
	28.000000f,
	// 800
	0.326634f, 0.911744f,
	-0.542716f, 0.190129f, -0.818114f,
	-0.040455f, 1.590206f, -0.052289f,
	28.000000f,
	// 801
	0.264144f, 0.938890f,
	-0.813245f, 0.470096f, -0.342990f,
	-0.056826f, 1.617741f, -0.018297f,
	28.000000f,
	// 802
	0.288283f, 0.902987f,
	-0.864443f, 0.123625f, -0.487293f,
	-0.063427f, 1.583560f, -0.028067f,
	28.000000f,
	// 803
	0.335287f, 0.856357f,
	-0.549880f, -0.227783f, -0.803584f,
	-0.038562f, 1.543754f, -0.055196f,
	28.000000f,
	// 804
	0.298872f, 0.854147f,
	-0.813439f, -0.222608f, -0.537366f,
	-0.060379f, 1.542745f, -0.026312f,
	28.000000f,
	// 805
	0.233966f, 0.891784f,
	-0.986425f, 0.123748f, -0.107947f,
	-0.073984f, 1.578940f, 0.001443f,
	28.000000f,
	// 806
	0.250808f, 0.851097f,
	-0.363761f, 0.426268f, -0.828235f,
	-0.070808f, 1.542422f, -0.007564f,
	28.000000f,
	// 807
	0.237069f, 0.853306f,
	-0.107590f, 0.899755f, -0.422925f,
	-0.082134f, 1.549355f, -0.007586f,
	28.000000f,
	// 808
	0.246466f, 0.844326f,
	-0.985432f, 0.116171f, -0.124211f,
	-0.088964f, 1.539399f, -0.010889f,
	28.000000f,
	// 809
	0.248982f, 0.847182f,
	-0.320292f, 0.308859f, -0.895555f,
	-0.084793f, 1.539529f, -0.016229f,
	28.000000f,
	// 810
	0.204146f, 0.816758f,
	-0.908310f, -0.237249f, 0.344508f,
	-0.064780f, 1.518729f, 0.015127f,
	28.000000f,
	// 811
	0.245592f, 0.816206f,
	-0.856856f, -0.411820f, -0.310164f,
	-0.085602f, 1.517929f, -0.010718f,
	28.000000f,
	// 812
	0.249702f, 0.815630f,
	-0.121672f, -0.289262f, -0.949486f,
	-0.080681f, 1.519275f, -0.011763f,
	28.000000f,
	// 813
	0.256072f, 0.814235f,
	-0.273314f, -0.340901f, -0.899492f,
	-0.059157f, 1.524035f, -0.016426f,
	28.000000f,
	// 814
	0.318549f, 0.772181f,
	-0.630262f, -0.247442f, -0.735895f,
	-0.033580f, 1.505041f, -0.031958f,
	28.000000f,
	// 815
	0.270935f, 0.774733f,
	-0.524205f, -0.363406f, -0.770159f,
	-0.050102f, 1.505469f, -0.009189f,
	28.000000f,
	// 816
	0.231266f, 0.764289f,
	-0.142595f, -0.689357f, -0.710249f,
	-0.055040f, 1.497771f, -0.005618f,
	28.000000f,
	// 817
	0.242974f, 0.801547f,
	-0.022079f, -0.392303f, -0.919571f,
	-0.073095f, 1.504296f, -0.007549f,
	28.000000f,
	// 818
	0.229875f, 0.788858f,
	-0.719251f, -0.568448f, -0.399431f,
	-0.077329f, 1.503830f, -0.007351f,
	28.000000f,
	// 819
	0.219740f, 0.778820f,
	-0.619802f, -0.777868f, -0.103760f,
	-0.073065f, 1.497079f, -0.002762f,
	28.000000f,
	// 820
	0.200173f, 0.781885f,
	-0.779954f, -0.625162f, 0.029061f,
	-0.060108f, 1.496660f, 0.014581f,
	28.000000f,
	// 821
	0.201616f, 0.717922f,
	-0.949194f, -0.278671f, 0.146198f,
	-0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 822
	0.184433f, 0.776087f,
	-0.939607f, -0.337402f, 0.057433f,
	-0.057398f, 1.489930f, 0.026147f,
	28.000000f,
	// 823
	0.168046f, 0.749486f,
	-0.757082f, -0.577963f, -0.304606f,
	-0.051194f, 1.476383f, 0.026648f,
	28.000000f,
	// 824
	0.197621f, 0.760719f,
	-0.650269f, -0.664324f, -0.368543f,
	-0.049326f, 1.491296f, 0.015505f,
	28.000000f,
	// 825
	0.061109f, 0.692459f,
	-0.475515f, -0.871263f, 0.121602f,
	-0.014664f, 1.446085f, 0.074857f,
	28.000000f,
	// 826
	0.097909f, 0.713892f,
	-0.666709f, -0.737677f, 0.106454f,
	-0.030944f, 1.456564f, 0.057067f,
	28.000000f,
	// 827
	0.075941f, 0.675423f,
	-0.507311f, -0.861550f, 0.019149f,
	-0.019276f, 1.450072f, 0.042029f,
	28.000000f,
	// 828
	0.141834f, 0.717568f,
	-0.649695f, -0.750054f, -0.123753f,
	-0.041502f, 1.464653f, 0.034518f,
	28.000000f,
	// 829
	0.139872f, 0.740287f,
	-0.806262f, -0.573744f, 0.144082f,
	-0.044479f, 1.469835f, 0.043873f,
	28.000000f,
	// 830
	0.164571f, 0.770071f,
	-0.919707f, -0.370038f, 0.131193f,
	-0.055422f, 1.486962f, 0.033158f,
	28.000000f,
	// 831
	0.162794f, 0.808171f,
	-0.972920f, -0.200674f, 0.114704f,
	-0.061937f, 1.513236f, 0.041662f,
	28.000000f,
	// 832
	0.096738f, 0.728117f,
	-0.764510f, -0.572696f, 0.295878f,
	-0.034400f, 1.464446f, 0.065489f,
	28.000000f,
	// 833
	0.139494f, 0.784808f,
	-0.925837f, -0.324119f, 0.194353f,
	-0.054561f, 1.495669f, 0.053943f,
	28.000000f,
	// 834
	0.139772f, 0.761836f,
	-0.893188f, -0.413063f, 0.177748f,
	-0.051433f, 1.482561f, 0.048373f,
	28.000000f,
	// 835
	0.116808f, 0.753060f,
	-0.823687f, -0.479437f, 0.302788f,
	-0.044819f, 1.477757f, 0.064087f,
	28.000000f,
	// 836
	0.094339f, 0.743898f,
	-0.741974f, -0.467854f, 0.480195f,
	-0.038147f, 1.475518f, 0.073954f,
	28.000000f,
	// 837
	0.069835f, 0.721948f,
	-0.731724f, -0.496707f, 0.466756f,
	-0.026714f, 1.462104f, 0.077798f,
	28.000000f,
	// 838
	0.072398f, 0.738941f,
	-0.646642f, -0.384309f, 0.658909f,
	-0.030274f, 1.473674f, 0.082116f,
	28.000000f,
	// 839
	0.050876f, 0.718774f,
	-0.662985f, -0.389229f, 0.639493f,
	-0.020495f, 1.460970f, 0.085223f,
	28.000000f,
	// 840
	0.050413f, 0.737088f,
	-0.592587f, -0.278122f, 0.755968f,
	-0.019920f, 1.472998f, 0.089575f,
	28.000000f,
	// 841
	0.050771f, 0.703499f,
	-0.713568f, -0.602934f, 0.356780f,
	-0.022071f, 1.453712f, 0.075280f,
	28.000000f,
	// 842
	0.117053f, 0.777486f,
	-0.842428f, -0.366535f, 0.394927f,
	-0.048536f, 1.491442f, 0.071196f,
	28.000000f,
	// 843
	0.093988f, 0.770286f,
	-0.706089f, -0.362917f, 0.608054f,
	-0.040752f, 1.488759f, 0.080244f,
	28.000000f,
	// 844
	0.115283f, 0.796185f,
	-0.828437f, -0.244564f, 0.503866f,
	-0.051020f, 1.505407f, 0.076727f,
	28.000000f,
	// 845
	0.137743f, 0.803884f,
	-0.941443f, -0.243929f, 0.232773f,
	-0.058053f, 1.508626f, 0.060304f,
	28.000000f,
	// 846
	0.132137f, 0.822995f,
	-0.935662f, -0.078005f, 0.344168f,
	-0.058677f, 1.522137f, 0.066137f,
	28.000000f,
	// 847
	0.026857f, 0.689651f,
	-0.406993f, -0.822149f, 0.398030f,
	-0.009395f, 1.445120f, 0.084509f,
	28.000000f,
	// 848
	0.029225f, 0.701420f,
	-0.512626f, -0.441786f, 0.736233f,
	-0.011188f, 1.452530f, 0.089666f,
	28.000000f,
	// 849
	0.031614f, 0.715829f,
	-0.453205f, -0.218039f, 0.864329f,
	-0.012796f, 1.460537f, 0.091052f,
	28.000000f,
	// 850
	0.005529f, 0.664618f,
	0.000000f, -0.999501f, 0.031577f,
	-0.000000f, 1.442838f, 0.054540f,
	28.000000f,
	// 851
	0.004724f, 0.674682f,
	-0.000000f, -0.999624f, 0.027410f,
	-0.000000f, 1.443432f, 0.073039f,
	28.000000f,
	// 852
	0.005400f, 0.685455f,
	-0.000000f, -0.865696f, 0.500569f,
	-0.000000f, 1.444109f, 0.087414f,
	28.000000f,
	// 853
	0.002957f, 0.698082f,
	-0.000000f, -0.358143f, 0.933667f,
	-0.000000f, 1.452652f, 0.094276f,
	28.000000f,
	// 854
	0.003270f, 0.712935f,
	-0.000000f, -0.141784f, 0.989898f,
	-0.000000f, 1.460233f, 0.094562f,
	28.000000f,
	// 855
	0.033473f, 0.726151f,
	-0.447646f, -0.351843f, 0.822082f,
	-0.012427f, 1.465789f, 0.092374f,
	28.000000f,
	// 856
	0.003270f, 0.725698f,
	-0.000000f, -0.507849f, 0.861446f,
	-0.000000f, 1.464479f, 0.095649f,
	28.000000f,
	// 857
	0.201616f, 0.717922f,
	-0.949194f, -0.278671f, 0.146198f,
	-0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 858
	0.153115f, 0.690763f,
	-0.825851f, -0.563580f, 0.018641f,
	-0.035251f, 1.465074f, 0.023798f,
	28.000000f,
	// 859
	0.092161f, 0.663788f,
	-0.684846f, -0.507998f, 0.522421f,
	-0.019190f, 1.448975f, 0.035394f,
	28.000000f,
	// 860
	0.008028f, 0.651059f,
	-0.000000f, -0.740648f, 0.671893f,
	-0.000000f, 1.440963f, 0.044507f,
	13.000000f,
	// 861
	0.373046f, 0.724401f,
	-0.294699f, 0.952424f, 0.077730f,
	-0.070473f, 1.419354f, -0.013455f,
	14.000000f,
	// 862
	0.374394f, 0.752150f,
	0.106992f, 0.993272f, 0.044303f,
	-0.088672f, 1.416274f, -0.009552f,
	34.000000f,
	// 863
	0.385675f, 0.710690f,
	-0.045259f, 0.830534f, 0.555126f,
	-0.063790f, 1.402228f, 0.011871f,
	13.000000f,
	// 864
	0.380314f, 0.696810f,
	-0.644673f, 0.497182f, 0.580696f,
	-0.044275f, 1.419515f, 0.003267f,
	13.000000f,
	// 865
	0.369036f, 0.708312f,
	-0.738909f, 0.664002f, -0.114523f,
	-0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 866
	0.387850f, 0.678168f,
	-0.339309f, 0.334258f, 0.879284f,
	-0.022776f, 1.402154f, 0.031851f,
	13.000000f,
	// 867
	0.407841f, 0.658511f,
	0.053152f, 0.663334f, 0.746433f,
	-0.015962f, 1.380349f, 0.045197f,
	13.000000f,
	// 868
	0.410038f, 0.641463f,
	-0.000000f, 0.671180f, 0.741295f,
	-0.000000f, 1.375417f, 0.044863f,
	12.000000f,
	// 869
	0.395101f, 0.641194f,
	-0.000000f, 0.233411f, 0.972378f,
	-0.000000f, 1.395421f, 0.037360f,
	13.000000f,
	// 870
	0.397003f, 0.748952f,
	0.162334f, 0.733059f, 0.660509f,
	-0.088524f, 1.399766f, 0.032618f,
	34.000000f,
	// 871
	0.400259f, 0.706496f,
	0.076308f, 0.771432f, 0.631720f,
	-0.060831f, 1.388081f, 0.036465f,
	13.000000f,
	// 872
	0.374394f, 0.859625f,
	0.106992f, 0.993272f, 0.044303f,
	-0.088672f, 1.416274f, -0.009552f,
	34.000000f,
	// 873
	0.374394f, 0.891412f,
	-0.294699f, 0.952424f, 0.077730f,
	-0.070473f, 1.419354f, -0.013455f,
	14.000000f,
	// 874
	0.399296f, 0.857681f,
	0.056043f, 0.809799f, -0.584025f,
	-0.089427f, 1.403596f, -0.041083f,
	34.000000f,
	// 875
	0.397343f, 0.895498f,
	-0.229858f, 0.669763f, -0.706104f,
	-0.062372f, 1.402144f, -0.048034f,
	13.000000f,
	// 876
	0.381230f, 0.934960f,
	-0.401949f, 0.393587f, -0.826756f,
	-0.029350f, 1.431976f, -0.041187f,
	13.000000f,
	// 877
	0.397343f, 0.966419f,
	0.000000f, 0.412948f, -0.910755f,
	0.000000f, 1.404656f, -0.058341f,
	13.000000f,
	// 878
	0.384159f, 0.966394f,
	0.000000f, 0.292506f, -0.956264f,
	0.000000f, 1.430311f, -0.047610f,
	13.000000f,
	// 879
	0.367857f, 0.915590f,
	-0.738909f, 0.664002f, -0.114523f,
	-0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 880
	0.043773f, 0.748515f,
	0.559839f, -0.007504f, -0.828567f,
	-0.023727f, 1.488114f, 0.085577f,
	28.000000f,
	// 881
	0.002178f, 0.748381f,
	0.000000f, -0.180791f, -0.983522f,
	-0.000000f, 1.488114f, 0.096102f,
	28.000000f,
	// 882
	0.022552f, 0.748104f,
	0.215327f, -0.762725f, -0.609824f,
	-0.012199f, 1.478719f, 0.092208f,
	28.000000f,
	// 883
	0.319392f, 0.771957f,
	-0.630262f, -0.247442f, -0.735895f,
	-0.033580f, 1.505041f, -0.031958f,
	28.000000f,
	// 884
	0.357808f, 0.765626f,
	0.000000f, -0.304984f, -0.952357f,
	0.000000f, 1.502195f, -0.046762f,
	28.000000f,
	// 885
	0.357479f, 0.722159f,
	-0.000000f, -0.011049f, -0.999939f,
	0.000000f, 1.481433f, -0.045267f,
	28.000000f,
	// 886
	0.310718f, 0.722950f,
	-0.573787f, 0.028594f, -0.818505f,
	-0.031212f, 1.483043f, -0.035700f,
	28.000000f,
	// 887
	0.271654f, 0.774930f,
	-0.524205f, -0.363406f, -0.770159f,
	-0.050102f, 1.505469f, -0.009189f,
	28.000000f,
	// 888
	0.259374f, 0.721149f,
	-0.963536f, -0.079340f, -0.255544f,
	-0.046484f, 1.480277f, -0.012894f,
	28.000000f,
	// 889
	0.202607f, 0.717985f,
	-0.949194f, -0.278671f, 0.146198f,
	-0.044574f, 1.477082f, 0.006704f,
	28.000000f,
	// 890
	0.103566f, 0.635924f,
	-0.641771f, -0.040282f, 0.765837f,
	-0.023326f, 1.426565f, 0.027269f,
	13.000000f,
	// 891
	0.092445f, 0.664074f,
	-0.684846f, -0.507998f, 0.522421f,
	-0.019190f, 1.448975f, 0.035394f,
	28.000000f,
	// 892
	0.152406f, 0.690167f,
	-0.825851f, -0.563580f, 0.018641f,
	-0.035251f, 1.465074f, 0.023798f,
	28.000000f,
	// 893
	0.179421f, 0.651324f,
	-0.935194f, -0.010266f, 0.353986f,
	-0.041178f, 1.442391f, 0.004507f,
	13.000000f,
	// 894
	0.247662f, 0.665648f,
	-0.941584f, 0.062053f, -0.331011f,
	-0.042549f, 1.450929f, -0.019461f,
	13.000000f,
	// 895
	0.306050f, 0.677284f,
	-0.518907f, 0.102838f, -0.848623f,
	-0.027262f, 1.451135f, -0.036622f,
	13.000000f,
	// 896
	0.358411f, 0.680345f,
	0.000000f, 0.090825f, -0.995867f,
	0.000000f, 1.449897f, -0.044012f,
	13.000000f,
	// 897
	0.008093f, 0.623140f,
	-0.000000f, -0.152551f, 0.988296f,
	-0.000000f, 1.419328f, 0.039430f,
	13.000000f,
	// 898
	0.007879f, 0.650412f,
	-0.000000f, -0.740648f, 0.671893f,
	-0.000000f, 1.440963f, 0.044507f,
	13.000000f,
	// 899
	0.007284f, 0.587682f,
	-0.000000f, 0.233411f, 0.972378f,
	-0.000000f, 1.395421f, 0.037360f,
	13.000000f,
	// 900
	0.062943f, 0.596395f,
	-0.339309f, 0.334258f, 0.879284f,
	-0.022776f, 1.402154f, 0.031851f,
	13.000000f,
	// 901
	0.163388f, 0.619196f,
	-0.644673f, 0.497182f, 0.580696f,
	-0.044275f, 1.419515f, 0.003267f,
	13.000000f,
	// 902
	0.240921f, 0.635854f,
	-0.738909f, 0.664002f, -0.114523f,
	-0.048741f, 1.429980f, -0.019958f,
	13.000000f,
	// 903
	0.304226f, 0.645742f,
	-0.401949f, 0.393587f, -0.826756f,
	-0.029350f, 1.431976f, -0.041187f,
	13.000000f,
	// 904
	0.357551f, 0.649052f,
	0.000000f, 0.292506f, -0.956264f,
	0.000000f, 1.430311f, -0.047610f,
	13.000000f,
	// 905
	0.053295f, 0.752274f,
	-0.516518f, -0.400429f, 0.756879f,
	-0.022524f, 1.480799f, 0.091147f,
	28.000000f,
	// 906
	0.071814f, 0.763646f,
	-0.576748f, -0.321363f, 0.751057f,
	-0.031834f, 1.487014f, 0.087940f,
	28.000000f,
	// 907
	0.091302f, 0.789881f,
	-0.639931f, -0.224844f, 0.734802f,
	-0.042432f, 1.503265f, 0.085564f,
	28.000000f,
	// 908
	0.111866f, 0.815154f,
	-0.778149f, -0.040506f, 0.626772f,
	-0.051283f, 1.517655f, 0.079941f,
	28.000000f,
	// 909
	0.122827f, 0.839519f,
	-0.861461f, 0.054660f, 0.504874f,
	-0.055342f, 1.533473f, 0.072327f,
	28.000000f,
	// 910
	0.101607f, 0.833013f,
	-0.725512f, -0.040332f, 0.687027f,
	-0.047592f, 1.528899f, 0.082163f,
	28.000000f,
	// 911
	0.081701f, 0.826563f,
	-0.442356f, -0.060426f, 0.894802f,
	-0.039575f, 1.525729f, 0.088342f,
	28.000000f,
	// 912
	0.088895f, 0.807856f,
	-0.552643f, -0.016824f, 0.833248f,
	-0.041712f, 1.514733f, 0.088160f,
	28.000000f,
	// 913
	0.069956f, 0.787007f,
	-0.501876f, -0.142180f, 0.853173f,
	-0.031623f, 1.501205f, 0.092059f,
	28.000000f,
	// 914
	0.065791f, 0.805571f,
	-0.394728f, 0.094456f, 0.913930f,
	-0.029772f, 1.512211f, 0.093583f,
	28.000000f,
	// 915
	0.048947f, 0.785712f,
	-0.429551f, -0.085731f, 0.898964f,
	-0.021859f, 1.499944f, 0.097236f,
	28.000000f,
	// 916
	0.045541f, 0.803159f,
	-0.392381f, 0.086199f, 0.915755f,
	-0.019898f, 1.509892f, 0.098452f,
	28.000000f,
	// 917
	0.017623f, 0.731133f,
	-0.305663f, -0.513314f, 0.801922f,
	-0.006405f, 1.469030f, 0.098491f,
	28.000000f,
	// 918
	0.002612f, 0.730031f,
	-0.000000f, -0.529761f, 0.848147f,
	-0.000000f, 1.468585f, 0.099418f,
	28.000000f,
	// 919
	0.002178f, 0.737395f,
	-0.000000f, -0.103706f, 0.994608f,
	-0.000000f, 1.472861f, 0.101116f,
	28.000000f,
	// 920
	0.016520f, 0.737587f,
	-0.284405f, -0.072884f, 0.955930f,
	-0.005741f, 1.473118f, 0.100200f,
	28.000000f,
	// 921
	0.013871f, 0.746798f,
	-0.130300f, 0.726997f, 0.674165f,
	-0.004945f, 1.477630f, 0.099404f,
	28.000000f,
	// 922
	0.027098f, 0.747732f,
	-0.220960f, 0.758423f, 0.613165f,
	-0.011336f, 1.478486f, 0.096787f,
	28.000000f,
	// 923
	0.045572f, 0.748080f,
	-0.524178f, -0.442193f, 0.727807f,
	-0.019104f, 1.479340f, 0.091956f,
	28.000000f,
	// 924
	0.044924f, 0.748395f,
	0.499086f, 0.100007f, -0.860763f,
	-0.019767f, 1.479539f, 0.088368f,
	28.000000f,
	// 925
	0.002178f, 0.746463f,
	-0.000000f, 0.664261f, 0.747500f,
	-0.000000f, 1.477281f, 0.100417f,
	28.000000f,
	// 926
	0.002178f, 0.747072f,
	0.000000f, 0.905049f, -0.425306f,
	-0.000000f, 1.478019f, 0.096065f,
	28.000000f,
	// 927
	0.013658f, 0.747610f,
	0.211682f, 0.874333f, -0.436730f,
	-0.004575f, 1.478055f, 0.095081f,
	28.000000f,
	// 928
	0.002178f, 0.747679f,
	0.000000f, 0.449695f, -0.893182f,
	-0.000000f, 1.470597f, 0.093187f,
	28.000000f,
	// 929
	0.206237f, 0.981917f,
	-0.362754f, 0.909604f, -0.202560f,
	-0.030480f, 1.646196f, -0.003927f,
	28.000000f,
	// 930
	0.300596f, 0.968778f,
	0.000000f, 0.693131f, -0.720812f,
	0.000000f, 1.628367f, -0.047176f,
	28.000000f,
	// 931
	0.348228f, 0.916473f,
	0.000000f, 0.250398f, -0.968143f,
	0.000000f, 1.594277f, -0.064399f,
	28.000000f,
	// 932
	0.357712f, 0.857922f,
	0.000000f, -0.184393f, -0.982853f,
	0.000000f, 1.545264f, -0.068599f,
	28.000000f,
	// 933
	0.357609f, 0.765976f,
	0.000000f, -0.304984f, -0.952357f,
	0.000000f, 1.502195f, -0.046762f,
	28.000000f,
	// 934
	0.218064f, 0.930488f,
	-0.930430f, 0.364531f, 0.037651f,
	-0.066870f, 1.608470f, 0.015148f,
	28.000000f,
	// 935
	0.207244f, 0.959316f,
	-0.721183f, 0.680879f, 0.127667f,
	-0.051116f, 1.632316f, 0.028854f,
	28.000000f,
	// 936
	0.239208f, 0.960403f,
	-0.653548f, 0.721487f, -0.228763f,
	-0.044956f, 1.633310f, -0.009864f,
	28.000000f,
	// 937
	0.035717f, 0.734357f,
	-0.579403f, -0.398177f, 0.711159f,
	-0.013122f, 1.470567f, 0.095099f,
	28.000000f,
	// 938
	0.030592f, 0.739924f,
	-0.541163f, -0.090669f, 0.836015f,
	-0.012903f, 1.474181f, 0.096860f,
	28.000000f,
	// 939
	0.971078f, 0.076035f,
	-0.370426f, -0.593213f, 0.714761f,
	-0.707296f, 1.392466f, 0.030173f,
	18.000000f,
	// 940
	0.960181f, 0.085601f,
	-0.586667f, -0.754149f, -0.295095f,
	-0.690888f, 1.383347f, 0.019969f,
	18.000000f,
	// 941
	0.974227f, 0.071950f,
	-0.752515f, -0.109478f, -0.649412f,
	-0.698664f, 1.383706f, 0.032218f,
	18.000000f,
	// 942
	0.769588f, 0.156796f,
	-0.094379f, 0.575135f, 0.812596f,
	-0.515369f, 1.405852f, 0.027132f,
	17.000000f,
	// 943
	0.719216f, 0.138011f,
	-0.111675f, -0.557697f, 0.822498f,
	-0.562814f, 1.377393f, 0.022787f,
	17.000000f,
	// 944
	0.719216f, 0.157453f,
	-0.117862f, -0.510808f, 0.851577f,
	-0.513420f, 1.374205f, 0.029058f,
	17.000000f,
	// 945
	0.744402f, 0.181899f,
	0.025480f, 0.001324f, 0.999674f,
	-0.459116f, 1.387538f, 0.030423f,
	17.000000f,
	// 946
	0.769588f, 0.183142f,
	0.007033f, 0.622573f, 0.782530f,
	-0.455391f, 1.410682f, 0.026603f,
	17.000000f,
	// 947
	0.719215f, 0.180967f,
	-0.007629f, -0.663183f, 0.748419f,
	-0.462534f, 1.364126f, 0.026715f,
	17.000000f,
	// 948
	0.769588f, 0.207690f,
	0.103319f, 0.562482f, 0.820329f,
	-0.400113f, 1.407023f, 0.025007f,
	16.000000f,
	// 949
	0.807368f, 0.185090f,
	0.009333f, 0.999891f, 0.011409f,
	-0.450507f, 1.424242f, -0.003850f,
	17.000000f,
	// 950
	0.807368f, 0.157202f,
	-0.101921f, 0.994774f, 0.006035f,
	-0.514998f, 1.417181f, -0.002414f,
	17.000000f,
	// 951
	0.769588f, 0.138011f,
	-0.087814f, 0.581863f, 0.808532f,
	-0.565024f, 1.403519f, 0.021657f,
	17.000000f,
	// 952
	0.719216f, 0.113888f,
	-0.012559f, -0.572391f, 0.819885f,
	-0.613570f, 1.379048f, 0.019694f,
	17.000000f,
	// 953
	0.807368f, 0.208118f,
	0.107188f, 0.993416f, -0.040440f,
	-0.398155f, 1.418580f, -0.004171f,
	16.000000f,
	// 954
	0.848295f, 0.210380f,
	0.133595f, 0.569546f, -0.811030f,
	-0.397244f, 1.406158f, -0.030717f,
	16.000000f,
	// 955
	0.848295f, 0.186538f,
	0.017382f, 0.708824f, -0.705171f,
	-0.450242f, 1.413431f, -0.031636f,
	17.000000f,
	// 956
	0.848295f, 0.158827f,
	-0.128797f, 0.597130f, -0.791737f,
	-0.511653f, 1.406677f, -0.031726f,
	17.000000f,
	// 957
	0.848295f, 0.138011f,
	-0.115467f, 0.567528f, -0.815218f,
	-0.561790f, 1.403725f, -0.026116f,
	17.000000f,
	// 958
	0.807368f, 0.138011f,
	-0.073928f, 0.997207f, 0.010645f,
	-0.564056f, 1.412353f, -0.001415f,
	17.000000f,
	// 959
	0.769588f, 0.113888f,
	-0.032436f, 0.571983f, 0.819624f,
	-0.613484f, 1.402371f, 0.019076f,
	17.000000f,
	// 960
	0.719216f, 0.106810f,
	0.454290f, -0.662888f, 0.595147f,
	-0.631123f, 1.374796f, 0.019374f,
	17.000000f,
	// 961
	0.675140f, 0.106810f,
	0.099483f, -0.992129f, -0.076050f,
	-0.631135f, 1.373466f, -0.000062f,
	17.000000f,
	// 962
	0.898668f, 0.138011f,
	-0.139778f, -0.538495f, -0.830954f,
	-0.560428f, 1.379709f, -0.026289f,
	17.000000f,
	// 963
	0.898668f, 0.159078f,
	-0.170682f, -0.492408f, -0.853465f,
	-0.510991f, 1.375554f, -0.034825f,
	17.000000f,
	// 964
	0.873482f, 0.185921f,
	0.014137f, 0.074551f, -0.997117f,
	-0.452296f, 1.389552f, -0.039935f,
	17.000000f,
	// 965
	0.898668f, 0.185568f,
	0.003864f, -0.637716f, -0.770262f,
	-0.453645f, 1.366853f, -0.035803f,
	17.000000f,
	// 966
	0.898668f, 0.114596f,
	-0.076654f, -0.525991f, -0.847028f,
	-0.613158f, 1.381456f, -0.020284f,
	17.000000f,
	// 967
	0.942744f, 0.138011f,
	-0.110015f, -0.993201f, -0.038067f,
	-0.561749f, 1.369116f, -0.000921f,
	17.000000f,
	// 968
	0.942744f, 0.159078f,
	-0.160101f, -0.987099f, 0.001555f,
	-0.510397f, 1.361350f, -0.001052f,
	17.000000f,
	// 969
	0.942744f, 0.180629f,
	-0.057923f, -0.997698f, -0.035266f,
	-0.464720f, 1.353057f, -0.003912f,
	17.000000f,
	// 970
	0.898668f, 0.211020f,
	0.113793f, -0.506092f, -0.854940f,
	-0.397873f, 1.371518f, -0.032999f,
	16.000000f,
	// 971
	0.942744f, 0.207802f,
	0.054475f, -0.997423f, -0.046684f,
	-0.399387f, 1.356640f, -0.004235f,
	16.000000f,
	// 972
	0.732979f, 0.097338f,
	0.410922f, 0.216609f, 0.885564f,
	-0.653337f, 1.386843f, 0.038121f,
	18.000000f,
	// 973
	0.728660f, 0.085981f,
	0.306133f, 0.276074f, 0.911079f,
	-0.686350f, 1.382898f, 0.051461f,
	18.000000f,
	// 974
	0.706622f, 0.085981f,
	0.313826f, -0.605585f, 0.731287f,
	-0.686370f, 1.369939f, 0.049416f,
	18.000000f,
	// 975
	0.709771f, 0.098575f,
	0.394624f, -0.653709f, 0.645706f,
	-0.654097f, 1.370592f, 0.034380f,
	18.000000f,
	// 976
	0.735451f, 0.101723f,
	0.595092f, 0.037761f, 0.802770f,
	-0.641173f, 1.385907f, 0.030383f,
	18.000000f,
	// 977
	0.764462f, 0.101723f,
	0.238932f, 0.739458f, 0.629376f,
	-0.640583f, 1.403313f, 0.019895f,
	18.000000f,
	// 978
	0.769588f, 0.106810f,
	0.146776f, 0.662421f, 0.734612f,
	-0.631124f, 1.402915f, 0.018480f,
	17.000000f,
	// 979
	0.807368f, 0.106810f,
	0.176408f, 0.983900f, 0.028645f,
	-0.631823f, 1.410114f, -0.000505f,
	17.000000f,
	// 980
	0.807368f, 0.113623f,
	-0.020307f, 0.999723f, 0.011904f,
	-0.613266f, 1.409971f, -0.000506f,
	17.000000f,
	// 981
	0.848295f, 0.106810f,
	0.258773f, 0.598126f, -0.758474f,
	-0.631835f, 1.403122f, -0.019437f,
	17.000000f,
	// 982
	0.848295f, 0.113888f,
	-0.082217f, 0.553167f, -0.829004f,
	-0.613488f, 1.402639f, -0.020789f,
	17.000000f,
	// 983
	0.898668f, 0.106810f,
	0.328332f, -0.670997f, -0.664801f,
	-0.631146f, 1.378128f, -0.017394f,
	17.000000f,
	// 984
	0.942744f, 0.114109f,
	-0.034821f, -0.998294f, -0.046876f,
	-0.613071f, 1.372759f, -0.000828f,
	17.000000f,
	// 985
	0.942744f, 0.106810f,
	0.099483f, -0.992129f, -0.076050f,
	-0.631135f, 1.373466f, -0.000062f,
	17.000000f,
	// 986
	0.986820f, 0.098575f,
	-0.003475f, -0.999115f, -0.041926f,
	-0.660179f, 1.366724f, 0.024612f,
	18.000000f,
	// 987
	0.939596f, 0.101723f,
	-0.010401f, -0.986885f, -0.161087f,
	-0.641474f, 1.372968f, -0.000765f,
	18.000000f,
	// 988
	0.986820f, 0.101723f,
	0.388934f, -0.862900f, 0.322699f,
	-0.641620f, 1.369130f, 0.021948f,
	18.000000f,
	// 989
	0.893607f, 0.101723f,
	0.304328f, -0.725481f, -0.617302f,
	-0.641482f, 1.375607f, -0.025171f,
	17.000000f,
	// 990
	0.871322f, 0.101723f,
	0.475511f, 0.037505f, -0.878910f,
	-0.641793f, 1.390439f, -0.028676f,
	17.000000f,
	// 991
	0.845147f, 0.101723f,
	0.273047f, 0.712636f, -0.646217f,
	-0.640599f, 1.405342f, -0.021912f,
	17.000000f,
	// 992
	0.807368f, 0.101723f,
	0.252127f, 0.967659f, 0.008222f,
	-0.640591f, 1.413547f, -0.001158f,
	18.000000f,
	// 993
	0.760477f, 0.094040f,
	0.199656f, 0.782516f, 0.589751f,
	-0.664224f, 1.407807f, 0.024932f,
	18.000000f,
	// 994
	0.766440f, 0.077914f,
	0.083294f, 0.928423f, 0.362067f,
	-0.707291f, 1.415953f, 0.023095f,
	18.000000f,
	// 995
	0.794774f, 0.078809f,
	0.085514f, 0.996176f, -0.017934f,
	-0.707535f, 1.416539f, 0.004410f,
	18.000000f,
	// 996
	0.819961f, 0.078809f,
	0.058310f, 0.983451f, -0.171536f,
	-0.706489f, 1.415562f, -0.012943f,
	18.000000f,
	// 997
	0.848295f, 0.079685f,
	0.100503f, 0.886835f, -0.451024f,
	-0.701798f, 1.410947f, -0.027772f,
	18.000000f,
	// 998
	0.860888f, 0.076537f,
	0.098198f, 0.616851f, -0.780930f,
	-0.713385f, 1.408452f, -0.033400f,
	18.000000f,
	// 999
	0.851444f, 0.075274f,
	0.068352f, 0.912392f, -0.403571f,
	-0.714317f, 1.411433f, -0.028812f,
	18.000000f,
	// 1000
	0.820466f, 0.073915f,
	0.068114f, 0.983256f, -0.169020f,
	-0.715757f, 1.416067f, -0.013105f,
	18.000000f,
	// 1001
	0.793863f, 0.073388f,
	0.124005f, 0.992022f, -0.022688f,
	-0.715702f, 1.417679f, 0.004664f,
	18.000000f,
	// 1002
	0.766440f, 0.073388f,
	0.019829f, 0.955440f, 0.294519f,
	-0.716017f, 1.416403f, 0.022223f,
	18.000000f,
	// 1003
	0.755419f, 0.073388f,
	-0.011845f, 0.552473f, 0.833447f,
	-0.716847f, 1.411924f, 0.029693f,
	18.000000f,
	// 1004
	0.748123f, 0.082447f,
	-0.042709f, 0.554960f, 0.830780f,
	-0.693986f, 1.404788f, 0.033031f,
	18.000000f,
	// 1005
	0.741253f, 0.076035f,
	-0.370426f, -0.593213f, 0.714761f,
	-0.707296f, 1.392466f, 0.030173f,
	18.000000f,
	// 1006
	0.738338f, 0.076597f,
	-0.752515f, -0.109478f, -0.649412f,
	-0.698664f, 1.383706f, 0.032218f,
	18.000000f,
	// 1007
	0.738296f, 0.077789f,
	-0.615051f, 0.768684f, 0.175606f,
	-0.699409f, 1.389204f, 0.038781f,
	18.000000f,
	// 1008
	0.748924f, 0.071108f,
	-0.096950f, -0.029318f, 0.994857f,
	-0.717572f, 1.402400f, 0.030768f,
	18.000000f,
	// 1009
	0.741253f, 0.071108f,
	0.141912f, -0.804940f, 0.576137f,
	-0.718248f, 1.389433f, 0.028633f,
	18.000000f,
	// 1010
	0.738220f, 0.085248f,
	0.013605f, 0.716385f, 0.697572f,
	-0.688382f, 1.391956f, 0.042791f,
	18.000000f,
	// 1011
	0.734185f, 0.066691f,
	-0.356687f, 0.896814f, -0.261722f,
	-0.704794f, 1.388378f, 0.040899f,
	18.000000f,
	// 1012
	0.738338f, 0.063944f,
	-0.445998f, 0.080363f, -0.891419f,
	-0.707547f, 1.377564f, 0.032840f,
	18.000000f,
	// 1013
	0.723660f, 0.070979f,
	0.092387f, 0.555761f, 0.826192f,
	-0.700144f, 1.385332f, 0.054600f,
	18.000000f,
	// 1014
	0.706622f, 0.070979f,
	0.214877f, -0.675134f, 0.705706f,
	-0.699271f, 1.368064f, 0.052952f,
	18.000000f,
	// 1015
	0.697178f, 0.085981f,
	0.043651f, -0.993228f, -0.107670f,
	-0.687884f, 1.365771f, 0.037776f,
	18.000000f,
	// 1016
	0.697178f, 0.098575f,
	-0.003475f, -0.999115f, -0.041926f,
	-0.660179f, 1.366724f, 0.024612f,
	18.000000f,
	// 1017
	0.697178f, 0.067092f,
	-0.142828f, -0.903144f, -0.404883f,
	-0.703870f, 1.365240f, 0.038449f,
	18.000000f,
	// 1018
	0.712919f, 0.101723f,
	0.388934f, -0.862900f, 0.322699f,
	-0.641620f, 1.369130f, 0.021948f,
	18.000000f,
	// 1019
	0.993116f, 0.085981f,
	0.043651f, -0.993228f, -0.107670f,
	-0.687884f, 1.365771f, 0.037776f,
	18.000000f,
	// 1020
	0.974227f, 0.085981f,
	-0.436348f, -0.635103f, -0.637374f,
	-0.689318f, 1.374315f, 0.025712f,
	18.000000f,
	// 1021
	0.934612f, 0.096568f,
	-0.218138f, -0.961067f, -0.169606f,
	-0.664398f, 1.375866f, -0.000909f,
	18.000000f,
	// 1022
	0.888329f, 0.096044f,
	-0.048697f, -0.786111f, -0.616164f,
	-0.665472f, 1.376869f, -0.030158f,
	18.000000f,
	// 1023
	0.870076f, 0.097814f,
	0.198212f, 0.130323f, -0.971457f,
	-0.654331f, 1.392483f, -0.033148f,
	18.000000f,
	// 1024
	0.867185f, 0.076537f,
	0.045930f, 0.036063f, -0.998294f,
	-0.714037f, 1.398635f, -0.036602f,
	18.000000f,
	// 1025
	0.877360f, 0.083451f,
	-0.098281f, -0.785949f, -0.610430f,
	-0.694768f, 1.382909f, -0.032629f,
	18.000000f,
	// 1026
	0.927002f, 0.081309f,
	-0.189838f, -0.980321f, 0.054148f,
	-0.697909f, 1.386194f, -0.002440f,
	18.000000f,
	// 1027
	0.960181f, 0.085601f,
	-0.586667f, -0.754149f, -0.295095f,
	-0.690888f, 1.383347f, 0.019969f,
	18.000000f,
	// 1028
	0.974227f, 0.071950f,
	-0.752515f, -0.109478f, -0.649412f,
	-0.698664f, 1.383706f, 0.032218f,
	18.000000f,
	// 1029
	0.980523f, 0.063944f,
	-0.445998f, 0.080363f, -0.891419f,
	-0.707547f, 1.377564f, 0.032840f,
	18.000000f,
	// 1030
	0.993116f, 0.067092f,
	-0.142828f, -0.903144f, -0.404883f,
	-0.703870f, 1.365240f, 0.038449f,
	18.000000f,
	// 1031
	0.971078f, 0.076035f,
	-0.370426f, -0.593213f, 0.714761f,
	-0.707296f, 1.392466f, 0.030173f,
	18.000000f,
	// 1032
	0.871796f, 0.072454f,
	-0.134667f, -0.745287f, -0.653003f,
	-0.714925f, 1.387217f, -0.033388f,
	18.000000f,
	// 1033
	0.895520f, 0.069984f,
	-0.122240f, -0.991980f, 0.032138f,
	-0.715798f, 1.386395f, -0.019484f,
	18.000000f,
	// 1034
	0.927002f, 0.068701f,
	-0.057039f, -0.996408f, 0.062587f,
	-0.716870f, 1.387217f, -0.003442f,
	18.000000f,
	// 1035
	0.952189f, 0.069012f,
	0.058641f, -0.988181f, 0.141634f,
	-0.717931f, 1.388612f, 0.013665f,
	18.000000f,
	// 1036
	0.971078f, 0.071108f,
	0.141912f, -0.804940f, 0.576137f,
	-0.718248f, 1.389433f, 0.028633f,
	18.000000f,
	// 1037
	0.675140f, 0.114109f,
	-0.034821f, -0.998294f, -0.046876f,
	-0.613071f, 1.372759f, -0.000828f,
	17.000000f,
	// 1038
	0.675140f, 0.138011f,
	-0.110015f, -0.993201f, -0.038067f,
	-0.561749f, 1.369116f, -0.000921f,
	17.000000f,
	// 1039
	0.675140f, 0.159078f,
	-0.160101f, -0.987099f, 0.001555f,
	-0.510397f, 1.361350f, -0.001052f,
	17.000000f,
	// 1040
	0.675140f, 0.180629f,
	-0.057923f, -0.997698f, -0.035266f,
	-0.464720f, 1.353057f, -0.003912f,
	17.000000f,
	// 1041
	0.719216f, 0.207810f,
	0.087497f, -0.566189f, 0.819618f,
	-0.400686f, 1.369121f, 0.024524f,
	16.000000f,
	// 1042
	0.675140f, 0.207802f,
	0.054475f, -0.997423f, -0.046684f,
	-0.399387f, 1.356640f, -0.004235f,
	16.000000f,
	// 1043
	0.986820f, 0.106810f,
	0.454290f, -0.662888f, 0.595147f,
	-0.631123f, 1.374796f, 0.019374f,
	17.000000f,
	// 1044
	0.901289f, 0.037442f,
	-0.028462f, -0.017041f, -0.999450f,
	-0.748269f, 1.399778f, -0.018814f,
	18.000000f,
	// 1045
	0.898092f, 0.046475f,
	-0.291377f, 0.927165f, -0.235511f,
	-0.721657f, 1.406231f, -0.018627f,
	18.000000f,
	// 1046
	0.898092f, 0.048360f,
	-0.192867f, -0.980053f, -0.047933f,
	-0.726221f, 1.390583f, -0.017615f,
	18.000000f,
	// 1047
	0.898092f, 0.046475f,
	-0.291377f, 0.927165f, -0.235511f,
	-0.721657f, 1.406231f, -0.018627f,
	18.000000f,
	// 1048
	0.894950f, 0.042210f,
	-0.137333f, 0.064712f, 0.988409f,
	-0.737408f, 1.399087f, -0.020038f,
	18.000000f,
	// 1049
	0.929502f, 0.059888f,
	-0.123770f, -0.988344f, 0.088638f,
	-0.697380f, 1.387749f, -0.001510f,
	18.000000f,
	// 1050
	0.898092f, 0.048360f,
	-0.192867f, -0.980053f, -0.047933f,
	-0.726221f, 1.390583f, -0.017615f,
	18.000000f,
	// 1051
	0.879974f, 0.062069f,
	-0.178125f, -0.941621f, -0.285694f,
	-0.694412f, 1.384645f, -0.030034f,
	18.000000f,
	// 1052
	0.874422f, 0.050874f,
	-0.122234f, -0.747172f, -0.653294f,
	-0.716901f, 1.391359f, -0.030752f,
	18.000000f,
	// 1053
	0.891628f, 0.043593f,
	-0.201606f, -0.832916f, 0.515370f,
	-0.734368f, 1.391846f, -0.021242f,
	18.000000f,
	// 1054
	0.894950f, 0.028856f,
	-0.061301f, -0.042381f, 0.997219f,
	-0.761228f, 1.397686f, -0.021112f,
	18.000000f,
	// 1055
	0.869822f, 0.055030f,
	-0.043010f, -0.099273f, -0.994130f,
	-0.707927f, 1.398226f, -0.033789f,
	18.000000f,
	// 1056
	0.883245f, 0.016316f,
	-0.918855f, 0.394266f, -0.016138f,
	-0.784773f, 1.398212f, -0.027238f,
	18.000000f,
	// 1057
	0.869822f, 0.019521f,
	-0.566183f, 0.388846f, -0.726798f,
	-0.782239f, 1.398223f, -0.031554f,
	18.000000f,
	// 1058
	0.876104f, 0.021039f,
	-0.385910f, -0.762749f, -0.518929f,
	-0.780301f, 1.393173f, -0.030193f,
	18.000000f,
	// 1059
	0.890385f, 0.021039f,
	-0.389144f, -0.748574f, 0.536846f,
	-0.780293f, 1.393173f, -0.023627f,
	18.000000f,
	// 1060
	0.894950f, 0.019521f,
	-0.595820f, 0.375598f, 0.709876f,
	-0.782315f, 1.398076f, -0.022594f,
	18.000000f,
	// 1061
	0.890385f, 0.028856f,
	-0.049648f, -0.820751f, 0.569125f,
	-0.759570f, 1.392459f, -0.023136f,
	18.000000f,
	// 1062
	0.875449f, 0.043593f,
	-0.022880f, -0.842609f, -0.538039f,
	-0.732755f, 1.391846f, -0.030875f,
	18.000000f,
	// 1063
	0.869822f, 0.042210f,
	-0.026388f, -0.051830f, -0.998307f,
	-0.735766f, 1.397420f, -0.033505f,
	18.000000f,
	// 1064
	0.869822f, 0.028856f,
	-0.037238f, -0.042108f, -0.998419f,
	-0.760238f, 1.397335f, -0.032816f,
	18.000000f,
	// 1065
	0.876104f, 0.028856f,
	-0.028449f, -0.866760f, -0.497914f,
	-0.759174f, 1.392074f, -0.030208f,
	18.000000f,
	// 1066
	0.860616f, 0.028627f,
	-0.117659f, 0.786353f, -0.606470f,
	-0.760935f, 1.402717f, -0.030710f,
	18.000000f,
	// 1067
	0.860616f, 0.040152f,
	-0.123542f, 0.754632f, -0.644413f,
	-0.740809f, 1.404190f, -0.030726f,
	18.000000f,
	// 1068
	0.860616f, 0.042210f,
	-0.134991f, 0.768241f, -0.625766f,
	-0.737744f, 1.405001f, -0.030732f,
	18.000000f,
	// 1069
	0.864544f, 0.051289f,
	-0.097882f, 0.720885f, -0.686108f,
	-0.713231f, 1.406776f, -0.030755f,
	18.000000f,
	// 1070
	0.863540f, 0.055030f,
	-0.129964f, 0.767657f, -0.627545f,
	-0.709433f, 1.407502f, -0.030763f,
	18.000000f,
	// 1071
	0.845380f, 0.048620f,
	-0.367972f, 0.892848f, -0.259652f,
	-0.717042f, 1.408586f, -0.021257f,
	18.000000f,
	// 1072
	0.845380f, 0.042210f,
	-0.215564f, 0.846735f, 0.486387f,
	-0.738622f, 1.406132f, -0.022362f,
	18.000000f,
	// 1073
	0.845380f, 0.040152f,
	-0.148595f, 0.829365f, 0.538585f,
	-0.741606f, 1.405320f, -0.022418f,
	18.000000f,
	// 1074
	0.845380f, 0.028627f,
	-0.168566f, 0.835227f, 0.523432f,
	-0.761912f, 1.403607f, -0.022874f,
	18.000000f,
	// 1075
	0.860616f, 0.027052f,
	-0.157475f, 0.782386f, -0.602557f,
	-0.764358f, 1.401931f, -0.030707f,
	18.000000f,
	// 1076
	0.860665f, 0.019521f,
	-0.566183f, 0.388846f, -0.726798f,
	-0.782239f, 1.398223f, -0.031554f,
	18.000000f,
	// 1077
	0.845380f, 0.027052f,
	-0.208621f, 0.802625f, 0.558811f,
	-0.764765f, 1.402725f, -0.022871f,
	18.000000f,
	// 1078
	0.845382f, 0.019521f,
	-0.595820f, 0.375598f, 0.709876f,
	-0.782315f, 1.398076f, -0.022594f,
	18.000000f,
	// 1079
	0.841553f, 0.028856f,
	-0.061301f, -0.042381f, 0.997219f,
	-0.761228f, 1.397686f, -0.021112f,
	18.000000f,
	// 1080
	0.841553f, 0.042210f,
	-0.137333f, 0.064712f, 0.988409f,
	-0.737408f, 1.399087f, -0.020038f,
	18.000000f,
	// 1081
	0.840153f, 0.046475f,
	-0.291377f, 0.927165f, -0.235511f,
	-0.721657f, 1.406231f, -0.018627f,
	18.000000f,
	// 1082
	0.853003f, 0.016316f,
	-0.918855f, 0.394266f, -0.016138f,
	-0.784773f, 1.398212f, -0.027238f,
	18.000000f,
	// 1083
	0.860616f, 0.027052f,
	-0.157475f, 0.782386f, -0.602557f,
	-0.764358f, 1.401931f, -0.030707f,
	18.000000f,
	// 1084
	0.838411f, 0.051654f,
	-0.262629f, 0.902683f, -0.340866f,
	-0.714273f, 1.411844f, -0.018730f,
	18.000000f,
	// 1085
	0.850976f, 0.058235f,
	-0.026423f, 0.943332f, -0.330797f,
	-0.701054f, 1.409859f, -0.025445f,
	18.000000f,
	// 1086
	0.822706f, 0.057343f,
	-0.089108f, 0.980908f, -0.172858f,
	-0.705486f, 1.414219f, -0.011434f,
	18.000000f,
	// 1087
	0.810142f, 0.051295f,
	-0.317508f, 0.945196f, -0.076114f,
	-0.718862f, 1.413359f, -0.002972f,
	18.000000f,
	// 1088
	0.797578f, 0.057343f,
	-0.092002f, 0.995351f, -0.028485f,
	-0.706475f, 1.415142f, 0.004962f,
	18.000000f,
	// 1089
	0.784118f, 0.050765f,
	-0.302110f, 0.951050f, 0.065061f,
	-0.719275f, 1.414135f, 0.013698f,
	18.000000f,
	// 1090
	0.769308f, 0.056432f,
	-0.130800f, 0.981303f, 0.141197f,
	-0.706243f, 1.414589f, 0.022617f,
	18.000000f,
	// 1091
	0.758312f, 0.051825f,
	-0.254835f, 0.627769f, 0.735503f,
	-0.717540f, 1.410782f, 0.028850f,
	18.000000f,
	// 1092
	0.814752f, 0.039006f,
	-0.173994f, 0.853713f, 0.490816f,
	-0.748980f, 1.409234f, -0.006980f,
	18.000000f,
	// 1093
	0.814752f, 0.036693f,
	-0.124817f, 0.833457f, 0.538304f,
	-0.752540f, 1.408351f, -0.006974f,
	18.000000f,
	// 1094
	0.811640f, 0.038133f,
	-0.090176f, 0.019256f, 0.995740f,
	-0.749093f, 1.400913f, -0.004081f,
	18.000000f,
	// 1095
	0.810142f, 0.045170f,
	-0.378892f, 0.924434f, 0.043145f,
	-0.724316f, 1.407395f, -0.002963f,
	18.000000f,
	// 1096
	0.813671f, 0.048620f,
	-0.325638f, 0.905558f, 0.271890f,
	-0.722943f, 1.411807f, -0.005489f,
	18.000000f,
	// 1097
	0.832231f, 0.036693f,
	-0.105642f, 0.756596f, -0.645292f,
	-0.752022f, 1.407187f, -0.016067f,
	18.000000f,
	// 1098
	0.832231f, 0.022981f,
	-0.115651f, 0.782297f, -0.612075f,
	-0.776231f, 1.406050f, -0.016554f,
	18.000000f,
	// 1099
	0.832231f, 0.039006f,
	-0.145550f, 0.773255f, -0.617165f,
	-0.748726f, 1.408069f, -0.016074f,
	18.000000f,
	// 1100
	0.832231f, 0.048620f,
	-0.252175f, 0.822621f, -0.509609f,
	-0.721208f, 1.409984f, -0.016101f,
	18.000000f,
	// 1101
	0.840153f, 0.046475f,
	-0.291377f, 0.927165f, -0.235511f,
	-0.721657f, 1.406231f, -0.018627f,
	18.000000f,
	// 1102
	0.837742f, 0.037442f,
	-0.028462f, -0.017041f, -0.999450f,
	-0.748269f, 1.399778f, -0.018814f,
	18.000000f,
	// 1103
	0.837742f, 0.022981f,
	-0.019712f, -0.040787f, -0.998973f,
	-0.775500f, 1.398961f, -0.018936f,
	18.000000f,
	// 1104
	0.832231f, 0.020668f,
	-0.159807f, 0.773718f, -0.613043f,
	-0.779376f, 1.405240f, -0.016550f,
	18.000000f,
	// 1105
	0.832240f, 0.006957f,
	-0.514239f, 0.395476f, -0.761023f,
	-0.803460f, 1.400363f, -0.017941f,
	18.000000f,
	// 1106
	0.814752f, 0.020668f,
	-0.199608f, 0.808327f, 0.553863f,
	-0.779523f, 1.406010f, -0.007457f,
	18.000000f,
	// 1107
	0.814735f, 0.006957f,
	-0.517271f, 0.388928f, 0.762342f,
	-0.803453f, 1.400616f, -0.006595f,
	18.000000f,
	// 1108
	0.811640f, 0.022981f,
	-0.055817f, -0.034378f, 0.997849f,
	-0.775953f, 1.400058f, -0.005225f,
	18.000000f,
	// 1109
	0.814752f, 0.022981f,
	-0.159243f, 0.838803f, 0.520625f,
	-0.776478f, 1.406991f, -0.007461f,
	18.000000f,
	// 1110
	0.823420f, 0.003752f,
	-0.929693f, 0.367923f, 0.017450f,
	-0.807191f, 1.400538f, -0.012110f,
	18.000000f,
	// 1111
	0.709628f, 0.045184f,
	0.229140f, -0.591584f, 0.772996f,
	-0.716882f, 1.368365f, 0.057440f,
	18.000000f,
	// 1112
	0.726627f, 0.045184f,
	0.103203f, 0.447846f, 0.888135f,
	-0.717698f, 1.378374f, 0.058993f,
	18.000000f,
	// 1113
	0.718047f, 0.032053f,
	-0.370125f, -0.142120f, 0.918047f,
	-0.738910f, 1.370416f, 0.061658f,
	18.000000f,
	// 1114
	0.709628f, 0.064645f,
	0.307238f, -0.648443f, 0.696510f,
	-0.686476f, 1.371112f, 0.047486f,
	18.000000f,
	// 1115
	0.731616f, 0.064645f,
	0.251266f, 0.356595f, 0.899836f,
	-0.686458f, 1.383357f, 0.049418f,
	18.000000f,
	// 1116
	0.709628f, 0.049372f,
	0.284128f, -0.586824f, 0.758227f,
	-0.708472f, 1.369459f, 0.055649f,
	18.000000f,
	// 1117
	0.700205f, 0.064645f,
	-0.031251f, -0.970628f, -0.238547f,
	-0.687907f, 1.367174f, 0.036488f,
	18.000000f,
	// 1118
	0.700205f, 0.045415f,
	-0.073352f, -0.959002f, -0.273741f,
	-0.717278f, 1.364875f, 0.048901f,
	18.000000f,
	// 1119
	0.709628f, 0.033093f,
	-0.159599f, -0.757829f, 0.632632f,
	-0.736844f, 1.364500f, 0.059512f,
	18.000000f,
	// 1120
	0.718047f, 0.029391f,
	-0.971176f, -0.117641f, 0.207310f,
	-0.742320f, 1.370296f, 0.057889f,
	18.000000f,
	// 1121
	0.726627f, 0.033093f,
	-0.327027f, 0.528724f, 0.783265f,
	-0.738129f, 1.376358f, 0.061041f,
	18.000000f,
	// 1122
	0.737127f, 0.045007f,
	-0.309144f, 0.950109f, -0.041517f,
	-0.718152f, 1.382650f, 0.051216f,
	18.000000f,
	// 1123
	0.726627f, 0.049372f,
	0.154290f, 0.407703f, 0.899985f,
	-0.709298f, 1.379465f, 0.057207f,
	18.000000f,
	// 1124
	0.734757f, 0.034712f,
	-0.675329f, 0.736136f, -0.045113f,
	-0.740328f, 1.377434f, 0.057121f,
	18.000000f,
	// 1125
	0.700205f, 0.032596f,
	-0.567491f, -0.799086f, -0.198535f,
	-0.739444f, 1.364207f, 0.055893f,
	18.000000f,
	// 1126
	0.741271f, 0.032596f,
	-0.660458f, 0.052287f, -0.749040f,
	-0.740392f, 1.371642f, 0.052249f,
	18.000000f,
	// 1127
	0.741271f, 0.042210f,
	-0.482851f, 0.082004f, -0.871854f,
	-0.720753f, 1.374344f, 0.044475f,
	18.000000f,
	// 1128
	0.741271f, 0.055030f,
	-0.545931f, 0.298179f, -0.782974f,
	-0.697315f, 1.383751f, 0.031943f,
	18.000000f,
	// 1129
	0.741229f, 0.056304f,
	-0.456471f, 0.838728f, -0.296932f,
	-0.698086f, 1.388782f, 0.037692f,
	18.000000f,
	// 1130
	0.741153f, 0.063898f,
	-0.056945f, 0.876275f, 0.478435f,
	-0.688378f, 1.391915f, 0.041226f,
	18.000000f,
	// 1131
	0.948348f, 0.039917f,
	-0.122438f, -0.815936f, 0.565029f,
	-0.746033f, 1.394174f, 0.009987f,
	18.000000f,
	// 1132
	0.929502f, 0.047053f,
	-0.145919f, -0.987941f, 0.051776f,
	-0.728345f, 1.391359f, -0.002457f,
	18.000000f,
	// 1133
	0.954630f, 0.047370f,
	-0.120550f, -0.990155f, 0.071137f,
	-0.728689f, 1.392677f, 0.013707f,
	18.000000f,
	// 1134
	0.951489f, 0.035801f,
	-0.082739f, -0.002688f, 0.996568f,
	-0.750467f, 1.401925f, 0.012219f,
	18.000000f,
	// 1135
	0.951489f, 0.017662f,
	-0.044713f, -0.005636f, 0.998984f,
	-0.782651f, 1.400530f, 0.011451f,
	18.000000f,
	// 1136
	0.954500f, 0.046366f,
	-0.331215f, 0.943098f, -0.029364f,
	-0.725377f, 1.408559f, 0.013706f,
	18.000000f,
	// 1137
	0.929502f, 0.017737f,
	-0.034485f, -0.073525f, -0.996697f,
	-0.782668f, 1.399706f, -0.002462f,
	18.000000f,
	// 1138
	0.933673f, 0.006577f,
	-0.438773f, -0.741749f, -0.507234f,
	-0.807684f, 1.396406f, 0.000645f,
	18.000000f,
	// 1139
	0.929502f, 0.003752f,
	-0.536248f, 0.417306f, -0.733685f,
	-0.809009f, 1.402169f, -0.001238f,
	18.000000f,
	// 1140
	0.940471f, 0.000547f,
	-0.920550f, 0.390625f, -0.000114f,
	-0.812130f, 1.401975f, 0.004215f,
	18.000000f,
	// 1141
	0.947268f, 0.006577f,
	-0.443584f, -0.727596f, 0.523295f,
	-0.807675f, 1.396406f, 0.008222f,
	18.000000f,
	// 1142
	0.951489f, 0.003752f,
	-0.535020f, 0.420002f, 0.733042f,
	-0.808929f, 1.402007f, 0.009784f,
	18.000000f,
	// 1143
	0.947268f, 0.019776f,
	-0.055137f, -0.813409f, 0.579074f,
	-0.781652f, 1.393512f, 0.009211f,
	18.000000f,
	// 1144
	0.933673f, 0.039917f,
	-0.097500f, -0.832584f, -0.545249f,
	-0.746043f, 1.393786f, -0.000491f,
	18.000000f,
	// 1145
	0.929502f, 0.037038f,
	-0.045172f, -0.025495f, -0.998654f,
	-0.749142f, 1.400897f, -0.002935f,
	18.000000f,
	// 1146
	0.933673f, 0.019776f,
	-0.051321f, -0.838183f, -0.542970f,
	-0.781663f, 1.393512f, 0.000119f,
	18.000000f,
	// 1147
	0.929137f, 0.045170f,
	-0.378892f, 0.924434f, 0.043145f,
	-0.724316f, 1.407395f, -0.002963f,
	18.000000f,
	// 1148
	0.929502f, 0.047053f,
	-0.145919f, -0.987941f, 0.051776f,
	-0.728345f, 1.391359f, -0.002457f,
	18.000000f,
	// 1149
	0.973477f, 0.054520f,
	-0.098529f, -0.650244f, 0.753309f,
	-0.706249f, 1.392397f, 0.029304f,
	18.000000f,
	// 1150
	0.973477f, 0.049504f,
	-0.077743f, -0.754492f, 0.651689f,
	-0.723095f, 1.393453f, 0.027849f,
	18.000000f,
	// 1151
	0.920733f, 0.041228f,
	-0.143563f, -0.827304f, 0.543100f,
	-0.745478f, 1.393398f, -0.006351f,
	18.000000f,
	// 1152
	0.905306f, 0.041228f,
	-0.093951f, -0.828232f, -0.552454f,
	-0.744607f, 1.393398f, -0.016366f,
	18.000000f,
	// 1153
	0.920733f, 0.022981f,
	-0.057423f, -0.833097f, 0.550139f,
	-0.775407f, 1.393178f, -0.007929f,
	18.000000f,
	// 1154
	0.906828f, 0.022981f,
	-0.033860f, -0.839385f, -0.542482f,
	-0.775168f, 1.393143f, -0.016460f,
	18.000000f,
	// 1155
	0.920733f, 0.009709f,
	-0.391157f, -0.766903f, 0.508779f,
	-0.802232f, 1.395713f, -0.008656f,
	18.000000f,
	// 1156
	0.906828f, 0.009709f,
	-0.401649f, -0.768461f, -0.498143f,
	-0.802241f, 1.395325f, -0.016232f,
	18.000000f,
	// 1157
	0.913781f, 0.003752f,
	-0.929693f, 0.367923f, 0.017450f,
	-0.807191f, 1.400538f, -0.012110f,
	18.000000f,
	// 1158
	0.901289f, 0.006957f,
	-0.514239f, 0.395476f, -0.761023f,
	-0.803460f, 1.400363f, -0.017941f,
	18.000000f,
	// 1159
	0.901289f, 0.022981f,
	-0.019712f, -0.040787f, -0.998973f,
	-0.775500f, 1.398961f, -0.018936f,
	18.000000f,
	// 1160
	0.926217f, 0.006957f,
	-0.517271f, 0.388928f, 0.762342f,
	-0.803453f, 1.400616f, -0.006595f,
	18.000000f,
	// 1161
	0.926217f, 0.022981f,
	-0.055817f, -0.034378f, 0.997849f,
	-0.775953f, 1.400058f, -0.005225f,
	18.000000f,
	// 1162
	0.926217f, 0.038133f,
	-0.090176f, 0.019256f, 0.995740f,
	-0.749093f, 1.400913f, -0.004081f,
	18.000000f,
	// 1163
	0.929137f, 0.045170f,
	-0.378892f, 0.924434f, 0.043145f,
	-0.724316f, 1.407395f, -0.002963f,
	18.000000f,
	// 1164
	0.788349f, 0.017662f,
	-0.083526f, 0.802662f, 0.590557f,
	-0.782886f, 1.407270f, 0.009215f,
	18.000000f,
	// 1165
	0.788349f, 0.032596f,
	-0.137326f, 0.765943f, 0.628070f,
	-0.757422f, 1.408491f, 0.009700f,
	18.000000f,
	// 1166
	0.804905f, 0.017662f,
	-0.083373f, 0.811070f, -0.578977f,
	-0.783029f, 1.407658f, -0.000282f,
	18.000000f,
	// 1167
	0.804905f, 0.015515f,
	-0.136267f, 0.806475f, -0.575351f,
	-0.786963f, 1.407065f, -0.000277f,
	18.000000f,
	// 1168
	0.788349f, 0.015515f,
	-0.137122f, 0.794968f, 0.590951f,
	-0.786954f, 1.406677f, 0.009220f,
	18.000000f,
	// 1169
	0.804905f, 0.032596f,
	-0.108746f, 0.792933f, -0.599526f,
	-0.757432f, 1.408879f, -0.000224f,
	18.000000f,
	// 1170
	0.809573f, 0.037038f,
	-0.045172f, -0.025495f, -0.998654f,
	-0.749142f, 1.400897f, -0.002935f,
	18.000000f,
	// 1171
	0.809573f, 0.017737f,
	-0.034485f, -0.073525f, -0.996697f,
	-0.782668f, 1.399706f, -0.002462f,
	18.000000f,
	// 1172
	0.804905f, 0.003752f,
	-0.536248f, 0.417306f, -0.733685f,
	-0.809009f, 1.402169f, -0.001238f,
	18.000000f,
	// 1173
	0.788349f, 0.003752f,
	-0.535020f, 0.420002f, 0.733042f,
	-0.808929f, 1.402007f, 0.009784f,
	18.000000f,
	// 1174
	0.784550f, 0.017662f,
	-0.044713f, -0.005636f, 0.998984f,
	-0.782651f, 1.400530f, 0.011451f,
	18.000000f,
	// 1175
	0.784550f, 0.035801f,
	-0.082739f, -0.002688f, 0.996568f,
	-0.750467f, 1.401925f, 0.012219f,
	18.000000f,
	// 1176
	0.796487f, 0.000547f,
	-0.920550f, 0.390625f, -0.000114f,
	-0.812130f, 1.401975f, 0.004215f,
	18.000000f,
	// 1177
	0.788349f, 0.035224f,
	-0.179095f, 0.801545f, 0.570483f,
	-0.753617f, 1.409736f, 0.009693f,
	18.000000f,
	// 1178
	0.784087f, 0.046366f,
	-0.331215f, 0.943098f, -0.029364f,
	-0.725377f, 1.408559f, 0.013706f,
	18.000000f,
	// 1179
	0.804905f, 0.035224f,
	-0.135861f, 0.799535f, -0.585052f,
	-0.753759f, 1.409736f, -0.000231f,
	18.000000f,
	// 1180
	0.810142f, 0.045170f,
	-0.378892f, 0.924434f, 0.043145f,
	-0.724316f, 1.407395f, -0.002963f,
	18.000000f,
	// 1181
	0.804905f, 0.048620f,
	-0.330834f, 0.886354f, -0.323922f,
	-0.723065f, 1.411807f, 0.000573f,
	18.000000f,
	// 1182
	0.804905f, 0.048620f,
	-0.330834f, 0.886354f, -0.323922f,
	-0.723065f, 1.411807f, 0.000573f,
	18.000000f,
	// 1183
	0.788349f, 0.048620f,
	-0.361445f, 0.904179f, 0.227637f,
	-0.723287f, 1.412195f, 0.010676f,
	18.000000f,
	// 1184
	0.784087f, 0.046366f,
	-0.331215f, 0.943098f, -0.029364f,
	-0.725377f, 1.408559f, 0.013706f,
	18.000000f,
	// 1185
	0.778856f, 0.048620f,
	-0.334623f, 0.933922f, -0.125763f,
	-0.723347f, 1.412195f, 0.016473f,
	18.000000f,
	// 1186
	0.776624f, 0.035801f,
	-0.180753f, 0.828259f, -0.530392f,
	-0.752233f, 1.409348f, 0.016254f,
	18.000000f,
	// 1187
	0.782177f, 0.039006f,
	-0.055746f, -0.017220f, -0.998296f,
	-0.748799f, 1.401674f, 0.014046f,
	18.000000f,
	// 1188
	0.776624f, 0.032596f,
	-0.139204f, 0.793322f, -0.592674f,
	-0.756019f, 1.408080f, 0.016261f,
	18.000000f,
	// 1189
	0.782177f, 0.019776f,
	-0.030627f, 0.017584f, -0.999376f,
	-0.776448f, 1.400495f, 0.014571f,
	18.000000f,
	// 1190
	0.776624f, 0.020127f,
	-0.118532f, 0.817788f, -0.563181f,
	-0.776917f, 1.406867f, 0.016443f,
	18.000000f,
	// 1191
	0.776624f, 0.017674f,
	-0.173094f, 0.804458f, -0.568230f,
	-0.779947f, 1.406156f, 0.016446f,
	18.000000f,
	// 1192
	0.776710f, 0.006957f,
	-0.517547f, 0.407388f, -0.752449f,
	-0.801780f, 1.400897f, 0.015260f,
	18.000000f,
	// 1193
	0.758395f, 0.048620f,
	-0.215105f, 0.720189f, 0.659589f,
	-0.722835f, 1.409623f, 0.027104f,
	18.000000f,
	// 1194
	0.758395f, 0.035801f,
	-0.158071f, 0.735933f, 0.658343f,
	-0.752223f, 1.408155f, 0.026361f,
	18.000000f,
	// 1195
	0.758395f, 0.032596f,
	-0.123506f, 0.770239f, 0.625682f,
	-0.756009f, 1.407456f, 0.025863f,
	18.000000f,
	// 1196
	0.758395f, 0.020127f,
	-0.126144f, 0.815489f, 0.564858f,
	-0.776909f, 1.406478f, 0.024868f,
	18.000000f,
	// 1197
	0.758395f, 0.017674f,
	-0.177075f, 0.797847f, 0.576267f,
	-0.779940f, 1.405768f, 0.024871f,
	18.000000f,
	// 1198
	0.758441f, 0.006957f,
	-0.533745f, 0.396641f, 0.746855f,
	-0.802001f, 1.400387f, 0.025801f,
	18.000000f,
	// 1199
	0.767417f, 0.003752f,
	-0.938976f, 0.343982f, -0.000343f,
	-0.805195f, 1.400409f, 0.020650f,
	18.000000f,
	// 1200
	0.752079f, 0.039006f,
	-0.057922f, -0.076477f, 0.995388f,
	-0.748213f, 1.400698f, 0.028382f,
	18.000000f,
	// 1201
	0.752079f, 0.019776f,
	-0.049032f, -0.007335f, 0.998770f,
	-0.776537f, 1.399829f, 0.027400f,
	18.000000f,
	// 1202
	0.744180f, 0.008748f,
	-0.416419f, -0.752609f, 0.510074f,
	-0.800661f, 1.395270f, 0.024375f,
	18.000000f,
	// 1203
	0.767417f, 0.003752f,
	-0.938976f, 0.343982f, -0.000343f,
	-0.805195f, 1.400409f, 0.020650f,
	18.000000f,
	// 1204
	0.744180f, 0.019776f,
	-0.037097f, -0.830277f, 0.556114f,
	-0.775512f, 1.393107f, 0.024865f,
	18.000000f,
	// 1205
	0.744180f, 0.042210f,
	-0.057382f, -0.845141f, 0.531454f,
	-0.742926f, 1.393786f, 0.025564f,
	18.000000f,
	// 1206
	0.744180f, 0.049504f,
	-0.077743f, -0.754492f, 0.651689f,
	-0.723095f, 1.393453f, 0.027849f,
	18.000000f,
	// 1207
	0.751833f, 0.049504f,
	-0.098690f, 0.010377f, 0.995064f,
	-0.720586f, 1.401783f, 0.029867f,
	18.000000f,
	// 1208
	0.744180f, 0.054520f,
	-0.098529f, -0.650244f, 0.753309f,
	-0.706249f, 1.392397f, 0.029304f,
	18.000000f,
	// 1209
	0.751033f, 0.061047f,
	-0.074627f, -0.053196f, 0.995792f,
	-0.693673f, 1.404039f, 0.032004f,
	18.000000f,
	// 1210
	0.954630f, 0.019776f,
	-0.030627f, 0.017584f, -0.999376f,
	-0.776448f, 1.400495f, 0.014571f,
	18.000000f,
	// 1211
	0.957772f, 0.019776f,
	-0.036934f, -0.785815f, -0.617358f,
	-0.775540f, 1.393144f, 0.016287f,
	18.000000f,
	// 1212
	0.957772f, 0.008575f,
	-0.406409f, -0.746776f, -0.526457f,
	-0.800667f, 1.395658f, 0.017303f,
	18.000000f,
	// 1213
	0.954630f, 0.006957f,
	-0.517547f, 0.407388f, -0.752449f,
	-0.801780f, 1.400897f, 0.015260f,
	18.000000f,
	// 1214
	0.967195f, 0.003752f,
	-0.938976f, 0.343982f, -0.000343f,
	-0.805195f, 1.400409f, 0.020650f,
	18.000000f,
	// 1215
	0.973477f, 0.008748f,
	-0.416419f, -0.752609f, 0.510074f,
	-0.800661f, 1.395270f, 0.024375f,
	18.000000f,
	// 1216
	0.973477f, 0.019776f,
	-0.037097f, -0.830277f, 0.556114f,
	-0.775512f, 1.393107f, 0.024865f,
	18.000000f,
	// 1217
	0.957772f, 0.042210f,
	-0.101260f, -0.836901f, -0.537907f,
	-0.742935f, 1.393786f, 0.016381f,
	18.000000f,
	// 1218
	0.973477f, 0.042210f,
	-0.057382f, -0.845141f, 0.531454f,
	-0.742926f, 1.393786f, 0.025564f,
	18.000000f,
	// 1219
	0.954630f, 0.039006f,
	-0.055746f, -0.017220f, -0.998296f,
	-0.748799f, 1.401674f, 0.014046f,
	18.000000f,
	// 1220
	0.954500f, 0.046366f,
	-0.331215f, 0.943098f, -0.029364f,
	-0.725377f, 1.408559f, 0.013706f,
	18.000000f,
	// 1221
	0.954630f, 0.047370f,
	-0.120550f, -0.990155f, 0.071137f,
	-0.728689f, 1.392677f, 0.013707f,
	18.000000f,
	// 1222
	0.976618f, 0.064645f,
	-0.375026f, -0.474061f, -0.796631f,
	-0.688546f, 1.375042f, 0.026031f,
	18.000000f,
	// 1223
	0.995464f, 0.064645f,
	-0.031251f, -0.970628f, -0.238547f,
	-0.687907f, 1.367174f, 0.036488f,
	18.000000f,
	// 1224
	0.995464f, 0.045415f,
	-0.073352f, -0.959002f, -0.273741f,
	-0.717278f, 1.364875f, 0.048901f,
	18.000000f,
	// 1225
	0.989182f, 0.029391f,
	-0.971176f, -0.117641f, 0.207310f,
	-0.742320f, 1.370296f, 0.057889f,
	18.000000f,
	// 1226
	0.982900f, 0.032596f,
	-0.660458f, 0.052287f, -0.749040f,
	-0.740392f, 1.371642f, 0.052249f,
	18.000000f,
	// 1227
	0.995464f, 0.032596f,
	-0.567491f, -0.799086f, -0.198535f,
	-0.739444f, 1.364207f, 0.055893f,
	18.000000f,
	// 1228
	0.982900f, 0.042210f,
	-0.482851f, 0.082004f, -0.871854f,
	-0.720753f, 1.374344f, 0.044475f,
	18.000000f,
	// 1229
	0.976618f, 0.055030f,
	-0.545931f, 0.298179f, -0.782974f,
	-0.697315f, 1.383751f, 0.031943f,
	18.000000f,
};

//-----------------------------------------------------------------------------
//	_obt@
//-----------------------------------------------------------------------------
static float april_vertex_buf2[] = {
	// 0
	0.869592f, 0.990979f,
	0.713228f, 0.682790f, 0.158439f,
	0.064239f, 1.639690f, 0.040517f,
	28.000000f,
	// 1
	0.921731f, 0.970273f,
	0.354495f, 0.935046f, 0.004590f,
	0.036411f, 1.667820f, -0.001966f,
	28.000000f,
	// 2
	0.923744f, 0.996377f,
	0.360451f, 0.913551f, 0.188416f,
	0.034858f, 1.658563f, 0.045889f,
	28.000000f,
	// 3
	0.969571f, 0.999750f,
	-0.016060f, 0.987944f, 0.153978f,
	0.000000f, 1.664270f, 0.046492f,
	28.000000f,
	// 4
	0.969571f, 0.972984f,
	-0.007867f, 0.999938f, -0.007818f,
	0.000000f, 1.670925f, -0.001724f,
	28.000000f,
	// 5
	0.962996f, 0.942666f,
	0.000000f, 0.985834f, -0.167727f,
	0.000000f, 1.663635f, -0.043877f,
	28.000000f,
	// 6
	0.926751f, 0.941405f,
	0.181174f, 0.965088f, -0.189160f,
	0.025846f, 1.661777f, -0.042916f,
	28.000000f,
	// 7
	0.890506f, 0.940144f,
	0.576440f, 0.805826f, -0.135500f,
	0.051692f, 1.653009f, -0.041954f,
	28.000000f,
	// 8
	0.873611f, 0.968337f,
	0.718637f, 0.695249f, 0.013790f,
	0.064408f, 1.644917f, 0.000619f,
	28.000000f,
	// 9
	0.831476f, 0.943249f,
	0.846253f, 0.513137f, -0.143343f,
	0.076594f, 1.624516f, -0.035733f,
	28.000000f,
	// 10
	0.829616f, 0.967403f,
	0.949083f, 0.313709f, 0.028791f,
	0.088156f, 1.613979f, -0.000836f,
	28.000000f,
	// 11
	0.783246f, 0.950764f,
	0.992369f, 0.030489f, -0.119478f,
	0.087996f, 1.587088f, -0.026021f,
	28.000000f,
	// 12
	0.771910f, 0.967617f,
	0.986584f, -0.144330f, 0.076298f,
	0.088192f, 1.573064f, -0.002085f,
	28.000000f,
	// 13
	0.719562f, 0.971291f,
	0.970505f, -0.236434f, 0.047102f,
	0.079657f, 1.537817f, -0.003151f,
	28.000000f,
	// 14
	0.766217f, 0.978449f,
	0.947735f, -0.176303f, 0.265924f,
	0.083096f, 1.566478f, 0.011712f,
	28.000000f,
	// 15
	0.821016f, 0.985878f,
	0.947866f, 0.195903f, 0.251341f,
	0.082722f, 1.605748f, 0.028127f,
	28.000000f,
	// 16
	0.719562f, 0.971291f,
	-0.970505f, -0.236434f, 0.047101f,
	-0.079657f, 1.537817f, -0.003151f,
	28.000000f,
	// 17
	0.771910f, 0.967617f,
	-0.986627f, -0.124398f, 0.105321f,
	-0.088192f, 1.573064f, -0.002085f,
	28.000000f,
	// 18
	0.783246f, 0.950764f,
	-0.992369f, 0.030489f, -0.119478f,
	-0.087996f, 1.587088f, -0.026021f,
	28.000000f,
	// 19
	0.766217f, 0.978449f,
	-0.957862f, -0.135804f, 0.253095f,
	-0.083096f, 1.566478f, 0.011712f,
	28.000000f,
	// 20
	0.829616f, 0.967403f,
	-0.951804f, 0.304728f, 0.034795f,
	-0.088156f, 1.613979f, -0.000836f,
	28.000000f,
	// 21
	0.821016f, 0.985878f,
	-0.955383f, 0.183547f, 0.231417f,
	-0.082722f, 1.605748f, 0.028127f,
	28.000000f,
	// 22
	0.869592f, 0.990979f,
	-0.698855f, 0.701645f, 0.138910f,
	-0.064239f, 1.639690f, 0.040517f,
	28.000000f,
	// 23
	0.873611f, 0.968337f,
	-0.711183f, 0.702542f, 0.025548f,
	-0.064408f, 1.644917f, 0.000619f,
	28.000000f,
	// 24
	0.923744f, 0.996377f,
	-0.360143f, 0.920258f, 0.153046f,
	-0.034858f, 1.658563f, 0.045889f,
	28.000000f,
	// 25
	0.921731f, 0.970273f,
	-0.353885f, 0.935049f, 0.021188f,
	-0.036411f, 1.667820f, -0.001966f,
	28.000000f,
	// 26
	0.969571f, 0.972984f,
	-0.007867f, 0.999938f, -0.007818f,
	0.000000f, 1.670925f, -0.001724f,
	28.000000f,
	// 27
	0.969571f, 0.999750f,
	-0.016060f, 0.987944f, 0.153978f,
	0.000000f, 1.664270f, 0.046492f,
	28.000000f,
	// 28
	0.962996f, 0.942666f,
	0.000000f, 0.985834f, -0.167727f,
	0.000000f, 1.663635f, -0.043877f,
	28.000000f,
	// 29
	0.926751f, 0.941405f,
	-0.181174f, 0.965088f, -0.189160f,
	-0.025846f, 1.661777f, -0.042916f,
	28.000000f,
	// 30
	0.890506f, 0.940144f,
	-0.576440f, 0.805826f, -0.135500f,
	-0.051692f, 1.653009f, -0.041954f,
	28.000000f,
	// 31
	0.831476f, 0.943249f,
	-0.846253f, 0.513137f, -0.143343f,
	-0.076594f, 1.624516f, -0.035733f,
	28.000000f,
	// 32
	0.800578f, 0.813920f,
	0.057005f, -0.933861f, -0.353064f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 33
	0.800806f, 0.794259f,
	0.136845f, -0.888569f, -0.437857f,
	-0.002615f, 1.651672f, 0.072467f,
	28.000000f,
	// 34
	0.696802f, 0.774050f,
	0.355909f, -0.799627f, -0.483658f,
	-0.035067f, 1.659636f, 0.046165f,
	28.000000f,
	// 35
	0.800389f, 0.774050f,
	0.426076f, -0.746541f, -0.511015f,
	-0.023117f, 1.635137f, 0.091627f,
	28.000000f,
	// 36
	0.634489f, 0.734763f,
	0.652606f, -0.585070f, -0.481453f,
	-0.064624f, 1.640649f, 0.040760f,
	28.000000f,
	// 37
	0.800389f, 0.755838f,
	0.615631f, -0.610752f, -0.497976f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 38
	0.800389f, 0.729003f,
	0.762935f, -0.424176f, -0.487857f,
	-0.066303f, 1.590520f, 0.093414f,
	28.000000f,
	// 39
	0.622858f, 0.627242f,
	0.786447f, -0.397300f, -0.472920f,
	-0.122506f, 1.588865f, 0.001340f,
	28.000000f,
	// 40
	0.801966f, 0.627242f,
	0.836369f, -0.208957f, -0.506777f,
	-0.085011f, 1.555252f, 0.077082f,
	28.000000f,
	// 41
	0.622858f, 0.627242f,
	0.984563f, -0.174285f, -0.016142f,
	-0.098884f, 1.537073f, -0.021402f,
	28.000000f,
	// 42
	0.713423f, 0.703015f,
	0.886280f, -0.059727f, -0.459282f,
	-0.092677f, 1.564189f, 0.064414f,
	28.000000f,
	// 43
	0.695295f, 0.627242f,
	0.949680f, 0.077756f, -0.303416f,
	-0.097092f, 1.522417f, 0.038027f,
	28.000000f,
	// 44
	0.618179f, 0.689436f,
	0.950748f, -0.309310f, -0.020164f,
	-0.085017f, 1.590763f, 0.017928f,
	28.000000f,
	// 45
	0.618179f, 0.756142f,
	0.857168f, -0.410647f, -0.310856f,
	-0.064624f, 1.640649f, 0.040760f,
	28.000000f,
	// 46
	0.800389f, 0.759027f,
	0.758472f, -0.368244f, -0.537696f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 47
	0.800826f, 0.702446f,
	0.656753f, 0.093951f, -0.748230f,
	-0.073998f, 1.560009f, 0.079872f,
	28.000000f,
	// 48
	0.801966f, 0.627242f,
	0.709337f, 0.282886f, -0.645613f,
	-0.076654f, 1.520532f, 0.059656f,
	28.000000f,
	// 49
	0.618179f, 0.774050f,
	0.110383f, -0.599285f, -0.792889f,
	-0.023117f, 1.635137f, 0.091627f,
	28.000000f,
	// 50
	0.713995f, 0.724145f,
	0.425713f, -0.080970f, -0.901228f,
	-0.045530f, 1.580818f, 0.111686f,
	28.000000f,
	// 51
	0.618179f, 0.756832f,
	0.233227f, -0.375872f, -0.896842f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 52
	0.618179f, 0.724693f,
	0.648058f, -0.133201f, -0.749852f,
	-0.064868f, 1.592453f, 0.092548f,
	28.000000f,
	// 53
	0.770862f, 0.769407f,
	-0.059526f, -0.514789f, -0.855248f,
	0.002117f, 1.617986f, 0.109244f,
	28.000000f,
	// 54
	0.618179f, 0.794259f,
	-0.401006f, -0.700631f, -0.590178f,
	-0.002615f, 1.651672f, 0.072467f,
	28.000000f,
	// 55
	0.679834f, 0.814446f,
	-0.372480f, -0.753113f, -0.542291f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 56
	0.802173f, 0.720322f,
	0.214506f, -0.043230f, -0.975766f,
	-0.010065f, 1.573875f, 0.119790f,
	28.000000f,
	// 57
	0.803751f, 0.627242f,
	0.285741f, 0.257373f, -0.923099f,
	-0.028716f, 1.535322f, 0.104206f,
	28.000000f,
	// 58
	0.707161f, 0.627242f,
	0.564946f, 0.099686f, -0.819084f,
	-0.064307f, 1.534727f, 0.092386f,
	28.000000f,
	// 59
	0.622858f, 0.627242f,
	0.673456f, 0.008621f, -0.739177f,
	-0.096960f, 1.537317f, 0.062667f,
	28.000000f,
	// 60
	0.802470f, 0.758138f,
	-0.515960f, -0.521542f, -0.679544f,
	0.041405f, 1.612660f, 0.098041f,
	28.000000f,
	// 61
	0.618323f, 0.813403f,
	-0.372480f, -0.753113f, -0.542291f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 62
	0.802470f, 0.813403f,
	-0.378643f, -0.807572f, -0.452169f,
	0.034676f, 1.659192f, 0.034598f,
	28.000000f,
	// 63
	0.626493f, 0.758138f,
	-0.059526f, -0.514789f, -0.855248f,
	0.002117f, 1.617986f, 0.109244f,
	28.000000f,
	// 64
	0.802470f, 0.722674f,
	-0.222931f, -0.200507f, -0.953991f,
	0.042744f, 1.590210f, 0.108904f,
	28.000000f,
	// 65
	0.621425f, 0.699916f,
	-0.106188f, 0.054418f, -0.992856f,
	-0.013500f, 1.571897f, 0.120129f,
	28.000000f,
	// 66
	0.776639f, 0.626369f,
	-0.091156f, 0.155032f, -0.983695f,
	0.020197f, 1.531902f, 0.110704f,
	28.000000f,
	// 67
	0.623308f, 0.626369f,
	0.044554f, 0.264573f, -0.963336f,
	-0.029926f, 1.527719f, 0.107236f,
	28.000000f,
	// 68
	0.616973f, 0.814736f,
	-0.378643f, -0.807572f, -0.452169f,
	0.034676f, 1.659192f, 0.034598f,
	28.000000f,
	// 69
	0.803168f, 0.790285f,
	-0.529506f, -0.729055f, -0.433709f,
	0.057302f, 1.640461f, 0.054537f,
	28.000000f,
	// 70
	0.616973f, 0.754502f,
	-0.515960f, -0.521542f, -0.679544f,
	0.041405f, 1.612660f, 0.098041f,
	28.000000f,
	// 71
	0.803168f, 0.749830f,
	-0.709397f, -0.320309f, -0.627820f,
	0.065239f, 1.604875f, 0.071828f,
	28.000000f,
	// 72
	0.803168f, 0.693351f,
	-0.775407f, -0.038957f, -0.630259f,
	0.066598f, 1.573472f, 0.079041f,
	28.000000f,
	// 73
	0.616973f, 0.714180f,
	-0.801813f, -0.115394f, -0.586328f,
	0.041746f, 1.590206f, 0.109733f,
	28.000000f,
	// 74
	0.622197f, 0.626400f,
	-0.754572f, 0.092934f, -0.649604f,
	0.034618f, 1.548805f, 0.112660f,
	28.000000f,
	// 75
	0.803168f, 0.626400f,
	-0.757369f, 0.103116f, -0.644794f,
	0.058984f, 1.532966f, 0.081506f,
	28.000000f,
	// 76
	0.726321f, 0.790285f,
	-0.724112f, -0.688975f, -0.031232f,
	0.062748f, 1.638939f, 0.035341f,
	28.000000f,
	// 77
	0.616973f, 0.790285f,
	-0.529506f, -0.729055f, -0.433709f,
	0.057302f, 1.640461f, 0.054537f,
	28.000000f,
	// 78
	0.726321f, 0.774872f,
	-0.847871f, -0.503924f, -0.164849f,
	0.072912f, 1.625499f, 0.046741f,
	28.000000f,
	// 79
	0.798685f, 0.728845f,
	-0.995252f, -0.082747f, 0.051241f,
	0.085482f, 1.586679f, 0.022891f,
	28.000000f,
	// 80
	0.726321f, 0.754978f,
	-0.899745f, -0.246375f, -0.360219f,
	0.083780f, 1.598162f, 0.056904f,
	28.000000f,
	// 81
	0.628286f, 0.753916f,
	-0.709397f, -0.320309f, -0.627820f,
	0.065239f, 1.604875f, 0.071828f,
	28.000000f,
	// 82
	0.622197f, 0.686057f,
	-0.771702f, 0.043085f, -0.634523f,
	0.058796f, 1.561873f, 0.089786f,
	28.000000f,
	// 83
	0.726321f, 0.687831f,
	-0.945593f, 0.146003f, -0.290754f,
	0.083295f, 1.553507f, 0.057127f,
	28.000000f,
	// 84
	0.622197f, 0.626400f,
	-0.788670f, 0.193454f, -0.583588f,
	0.049327f, 1.524964f, 0.093569f,
	28.000000f,
	// 85
	0.735993f, 0.626400f,
	-0.906837f, 0.267329f, -0.325856f,
	0.074210f, 1.518457f, 0.053655f,
	28.000000f,
	// 86
	0.803168f, 0.697056f,
	-0.979026f, 0.186245f, 0.082587f,
	0.079818f, 1.551825f, 0.019704f,
	28.000000f,
	// 87
	0.739360f, 0.626400f,
	-0.906837f, 0.267329f, -0.325856f,
	0.074210f, 1.518457f, 0.053655f,
	28.000000f,
	// 88
	0.799824f, 0.743785f,
	0.823346f, -0.206660f, -0.528576f,
	-0.085264f, 1.593791f, 0.036232f,
	28.000000f,
	// 89
	0.723368f, 0.625790f,
	0.859438f, 0.044120f, -0.509332f,
	-0.073190f, 1.522032f, 0.067136f,
	28.000000f,
	// 90
	0.799824f, 0.625790f,
	0.978909f, 0.084630f, -0.185943f,
	-0.079567f, 1.523588f, 0.034274f,
	28.000000f,
	// 91
	0.623477f, 0.625790f,
	0.638606f, 0.155475f, -0.753665f,
	-0.044435f, 1.517212f, 0.090507f,
	28.000000f,
	// 92
	0.617274f, 0.746042f,
	0.768136f, -0.140218f, -0.624745f,
	-0.048981f, 1.564617f, 0.096434f,
	28.000000f,
	// 93
	0.617274f, 0.769089f,
	0.737851f, -0.322112f, -0.593144f,
	-0.025872f, 1.613610f, 0.099351f,
	28.000000f,
	// 94
	0.799824f, 0.770465f,
	0.735419f, -0.343331f, -0.584194f,
	-0.066167f, 1.627042f, 0.040732f,
	28.000000f,
	// 95
	0.619763f, 0.719088f,
	0.921581f, 0.084133f, -0.378959f,
	-0.058381f, 1.539871f, 0.081334f,
	28.000000f,
	// 96
	0.802807f, 0.736555f,
	0.925100f, 0.018738f, -0.379260f,
	-0.069953f, 1.549526f, 0.053586f,
	28.000000f,
	// 97
	0.616183f, 0.808200f,
	0.892381f, -0.151851f, -0.424967f,
	-0.050020f, 1.599519f, 0.077578f,
	28.000000f,
	// 98
	0.802807f, 0.625859f,
	0.907122f, 0.229643f, -0.352695f,
	-0.060403f, 1.499814f, 0.050052f,
	28.000000f,
	// 99
	0.625133f, 0.625859f,
	0.892926f, 0.248235f, -0.375584f,
	-0.044162f, 1.498943f, 0.088089f,
	28.000000f,
	// 100
	0.623343f, 0.625859f,
	-0.892926f, 0.248235f, -0.375584f,
	0.044162f, 1.498943f, 0.088089f,
	28.000000f,
	// 101
	0.619763f, 0.719088f,
	-0.921581f, 0.084133f, -0.378959f,
	0.058381f, 1.539871f, 0.081334f,
	28.000000f,
	// 102
	0.802807f, 0.625859f,
	-0.907122f, 0.229644f, -0.352695f,
	0.060403f, 1.499814f, 0.050052f,
	28.000000f,
	// 103
	0.802807f, 0.736555f,
	-0.925100f, 0.018738f, -0.379260f,
	0.069953f, 1.549526f, 0.053586f,
	28.000000f,
	// 104
	0.616183f, 0.808200f,
	-0.892381f, -0.151851f, -0.424967f,
	0.050020f, 1.599519f, 0.077578f,
	28.000000f,
	// 105
	0.798107f, 0.812950f,
	0.988068f, 0.017082f, -0.153069f,
	-0.077091f, 1.606977f, 0.016510f,
	28.000000f,
	// 106
	0.620579f, 0.811830f,
	0.977756f, 0.047892f, -0.204204f,
	-0.070906f, 1.589907f, 0.054531f,
	28.000000f,
	// 107
	0.798107f, 0.713834f,
	0.937311f, 0.190746f, -0.291656f,
	-0.076352f, 1.516063f, 0.011136f,
	28.000000f,
	// 108
	0.620820f, 0.713834f,
	0.920469f, 0.229828f, -0.316096f,
	-0.060353f, 1.513837f, 0.055964f,
	28.000000f,
	// 109
	0.798107f, 0.626036f,
	0.901769f, 0.306814f, -0.304430f,
	-0.055357f, 1.461603f, 0.018119f,
	28.000000f,
	// 110
	0.624400f, 0.626036f,
	0.902515f, 0.305928f, -0.303109f,
	-0.037425f, 1.459695f, 0.069587f,
	28.000000f,
	// 111
	0.622610f, 0.625305f,
	-0.902515f, 0.305928f, -0.303109f,
	0.037425f, 1.459695f, 0.069587f,
	28.000000f,
	// 112
	0.620820f, 0.713834f,
	-0.920469f, 0.229828f, -0.316096f,
	0.060353f, 1.513837f, 0.055964f,
	28.000000f,
	// 113
	0.798107f, 0.625305f,
	-0.901769f, 0.306814f, -0.304430f,
	0.055357f, 1.461603f, 0.018119f,
	28.000000f,
	// 114
	0.798107f, 0.713834f,
	-0.937311f, 0.190746f, -0.291657f,
	0.076352f, 1.516063f, 0.011136f,
	28.000000f,
	// 115
	0.620579f, 0.811830f,
	-0.977756f, 0.047892f, -0.204204f,
	0.070906f, 1.589907f, 0.054531f,
	28.000000f,
	// 116
	0.798107f, 0.812950f,
	-0.988068f, 0.017082f, -0.153069f,
	0.077091f, 1.606977f, 0.016510f,
	28.000000f,
	// 117
	0.804105f, 0.625285f,
	-0.943899f, -0.181714f, 0.275744f,
	0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 118
	0.805415f, 0.663308f,
	-0.936289f, -0.093427f, 0.338577f,
	0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 119
	0.954176f, 0.625285f,
	-0.907047f, 0.019878f, 0.420560f,
	0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 120
	0.955486f, 0.660963f,
	-0.850566f, -0.126254f, 0.510488f,
	0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 121
	0.954176f, 0.783637f,
	-0.694582f, -0.253333f, 0.673333f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 122
	0.804105f, 0.741314f,
	-0.744278f, -0.198461f, 0.637702f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 123
	0.954176f, 0.835210f,
	-0.683647f, -0.569304f, 0.456639f,
	0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 124
	0.804105f, 0.820668f,
	-0.700453f, -0.552728f, 0.451506f,
	0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 125
	0.954176f, 0.870075f,
	-0.483656f, -0.822411f, 0.299528f,
	0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 126
	0.804105f, 0.866462f,
	-0.476127f, -0.829024f, 0.293295f,
	0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 127
	0.954176f, 0.910438f,
	-0.272331f, -0.941858f, 0.196825f,
	0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 128
	0.966381f, 0.813819f,
	-0.823140f, -0.505807f, -0.258069f,
	0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 129
	0.910858f, 0.813819f,
	-0.820803f, -0.495742f, -0.283766f,
	0.076929f, 1.620261f, -0.034087f,
	28.000000f,
	// 130
	0.966381f, 0.866591f,
	-0.734419f, -0.596145f, -0.324408f,
	0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 131
	0.885949f, 0.748008f,
	-0.960827f, -0.266194f, -0.077150f,
	0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 132
	0.966381f, 0.748008f,
	-0.957820f, -0.284483f, 0.040617f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 133
	0.889449f, 0.678400f,
	-0.765870f, -0.582679f, -0.271899f,
	0.107786f, 1.519160f, -0.025793f,
	28.000000f,
	// 134
	0.973380f, 0.681073f,
	-0.818089f, -0.559000f, 0.135088f,
	0.104037f, 1.516353f, -0.060109f,
	28.000000f,
	// 135
	0.974551f, 0.625285f,
	-0.594808f, -0.792251f, 0.136167f,
	0.120408f, 1.502223f, -0.069200f,
	28.000000f,
	// 136
	0.875269f, 0.625285f,
	-0.486503f, -0.842689f, -0.230629f,
	0.127610f, 1.505986f, -0.019476f,
	28.000000f,
	// 137
	0.775987f, 0.625285f,
	-0.337987f, -0.769578f, -0.541769f,
	0.098771f, 1.495740f, 0.013099f,
	28.000000f,
	// 138
	0.805517f, 0.675727f,
	-0.524140f, -0.621670f, -0.582068f,
	0.092062f, 1.510260f, -0.003357f,
	28.000000f,
	// 139
	0.805517f, 0.748008f,
	-0.972011f, -0.203521f, -0.117362f,
	0.092525f, 1.585309f, -0.019936f,
	28.000000f,
	// 140
	0.980154f, 0.898367f,
	-0.114395f, -0.860287f, 0.496809f,
	-0.000000f, 1.653017f, -0.064908f,
	28.000000f,
	// 141
	0.922581f, 0.878810f,
	-0.146951f, -0.869415f, 0.471723f,
	0.020542f, 1.652745f, -0.060649f,
	28.000000f,
	// 142
	0.805887f, 0.928763f,
	-0.028540f, -0.941731f, 0.335155f,
	-0.000000f, 1.666408f, -0.024007f,
	28.000000f,
	// 143
	0.987576f, 0.852207f,
	-0.130305f, -0.597316f, 0.791350f,
	-0.000000f, 1.631638f, -0.090763f,
	28.000000f,
	// 144
	0.918795f, 0.838445f,
	-0.288033f, -0.588693f, 0.755300f,
	0.029034f, 1.630977f, -0.086553f,
	28.000000f,
	// 145
	0.907673f, 0.806423f,
	-0.367391f, -0.360561f, 0.857333f,
	0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 146
	0.987576f, 0.811167f,
	-0.137453f, -0.349799f, 0.926686f,
	-0.000000f, 1.608102f, -0.101128f,
	28.000000f,
	// 147
	0.899942f, 0.676753f,
	-0.424148f, -0.350659f, 0.834947f,
	0.043032f, 1.512310f, -0.124519f,
	28.000000f,
	// 148
	0.986861f, 0.685953f,
	-0.219928f, -0.371397f, 0.902051f,
	0.000715f, 1.515573f, -0.132776f,
	28.000000f,
	// 149
	0.895115f, 0.625285f,
	-0.586366f, -0.371247f, 0.719966f,
	0.059887f, 1.473017f, -0.137307f,
	28.000000f,
	// 150
	0.986861f, 0.625285f,
	-0.244841f, -0.432819f, 0.867595f,
	-0.006680f, 1.489665f, -0.147788f,
	28.000000f,
	// 151
	0.805887f, 0.625285f,
	-0.907047f, 0.019878f, 0.420560f,
	0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 152
	0.807197f, 0.660963f,
	-0.850566f, -0.126254f, 0.510488f,
	0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 153
	0.805887f, 0.798699f,
	-0.694582f, -0.253333f, 0.673333f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 154
	0.973233f, 0.625285f,
	-0.674903f, -0.531596f, 0.511773f,
	0.037818f, 1.518906f, -0.144501f,
	28.000000f,
	// 155
	0.784767f, 0.625285f,
	-0.671296f, -0.455211f, 0.584931f,
	0.100322f, 1.495346f, -0.086546f,
	28.000000f,
	// 156
	0.977068f, 0.688349f,
	-0.660747f, -0.397607f, 0.636649f,
	0.031952f, 1.540253f, -0.130062f,
	28.000000f,
	// 157
	0.801425f, 0.688349f,
	-0.681041f, -0.336136f, 0.650534f,
	0.085688f, 1.525597f, -0.081379f,
	28.000000f,
	// 158
	0.805887f, 0.795299f,
	-0.567084f, -0.328194f, 0.755450f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 159
	0.927640f, 0.803022f,
	-0.367391f, -0.360561f, 0.857333f,
	0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 160
	0.805887f, 0.831375f,
	-0.477379f, -0.511256f, 0.714651f,
	0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 161
	0.805887f, 0.870148f,
	-0.280863f, -0.814423f, 0.507771f,
	0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 162
	0.805887f, 0.911446f,
	-0.038181f, -0.938445f, 0.343313f,
	0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 163
	0.986861f, 0.625285f,
	-0.943899f, -0.181714f, 0.275744f,
	0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 164
	0.884424f, 0.625285f,
	-0.889566f, -0.143278f, -0.433756f,
	0.106455f, 1.465107f, -0.016663f,
	28.000000f,
	// 165
	0.986861f, 0.664912f,
	-0.936289f, -0.093427f, 0.338577f,
	0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 166
	0.896198f, 0.666112f,
	-0.968860f, -0.063957f, -0.239207f,
	0.107935f, 1.487290f, -0.023152f,
	28.000000f,
	// 167
	0.966381f, 0.757377f,
	-0.986284f, -0.117198f, 0.116223f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 168
	0.885310f, 0.754304f,
	-0.988979f, -0.142700f, -0.039451f,
	0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 169
	0.802930f, 0.667312f,
	-0.660650f, -0.220763f, -0.717499f,
	0.082072f, 1.465983f, 0.005543f,
	28.000000f,
	// 170
	0.784106f, 0.625285f,
	-0.656050f, -0.255015f, -0.710327f,
	0.078135f, 1.434644f, 0.020431f,
	28.000000f,
	// 171
	0.954176f, 0.910438f,
	0.272331f, -0.941858f, 0.196825f,
	-0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 172
	0.804105f, 0.866462f,
	0.510347f, -0.825164f, 0.242176f,
	-0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 173
	0.954176f, 0.870075f,
	0.483656f, -0.822411f, 0.299528f,
	-0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 174
	0.804105f, 0.820668f,
	0.818469f, -0.566821f, 0.093927f,
	-0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 175
	0.954176f, 0.835210f,
	0.683647f, -0.569304f, 0.456639f,
	-0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 176
	0.804105f, 0.741314f,
	0.917744f, -0.230224f, 0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 177
	0.954176f, 0.783637f,
	0.694582f, -0.253333f, 0.673333f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 178
	0.805415f, 0.663308f,
	0.936289f, -0.093427f, 0.338577f,
	-0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 179
	0.955486f, 0.660963f,
	0.850566f, -0.126254f, 0.510488f,
	-0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 180
	0.954176f, 0.625488f,
	0.907047f, 0.019878f, 0.420560f,
	-0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 181
	0.804105f, 0.625488f,
	0.943899f, -0.181714f, 0.275744f,
	-0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 182
	0.986415f, 0.664912f,
	0.936289f, -0.093427f, 0.338577f,
	-0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 183
	0.884424f, 0.625488f,
	0.889566f, -0.143278f, -0.433756f,
	-0.106455f, 1.465107f, -0.016663f,
	28.000000f,
	// 184
	0.984742f, 0.625488f,
	0.943899f, -0.181714f, 0.275744f,
	-0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 185
	0.896198f, 0.666112f,
	0.968860f, -0.063957f, -0.239207f,
	-0.107935f, 1.487290f, -0.023152f,
	28.000000f,
	// 186
	0.966381f, 0.757377f,
	0.917744f, -0.230224f, 0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 187
	0.885310f, 0.754304f,
	0.988979f, -0.142700f, -0.039451f,
	-0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 188
	0.802930f, 0.667312f,
	0.660650f, -0.220763f, -0.717499f,
	-0.082072f, 1.465983f, 0.005543f,
	28.000000f,
	// 189
	0.784106f, 0.625488f,
	0.656050f, -0.255015f, -0.710327f,
	-0.078135f, 1.434644f, 0.020431f,
	28.000000f,
	// 190
	0.907673f, 0.806423f,
	0.252149f, -0.331808f, 0.909024f,
	-0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 191
	0.805887f, 0.798699f,
	0.694582f, -0.253333f, 0.673333f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 192
	0.899942f, 0.676753f,
	0.429196f, -0.352008f, 0.831794f,
	-0.043032f, 1.512310f, -0.124519f,
	28.000000f,
	// 193
	0.807197f, 0.660963f,
	0.850566f, -0.126254f, 0.510488f,
	-0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 194
	0.895115f, 0.625488f,
	0.588038f, -0.369242f, 0.719633f,
	-0.059887f, 1.473017f, -0.137307f,
	28.000000f,
	// 195
	0.805887f, 0.625488f,
	0.907047f, 0.019878f, 0.420560f,
	-0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 196
	0.805887f, 0.928763f,
	0.028531f, -0.941731f, 0.335155f,
	0.000000f, 1.666408f, -0.024007f,
	28.000000f,
	// 197
	0.922581f, 0.878810f,
	0.146950f, -0.869416f, 0.471722f,
	-0.020542f, 1.652745f, -0.060649f,
	28.000000f,
	// 198
	0.980154f, 0.898367f,
	0.114395f, -0.860288f, 0.496808f,
	0.000000f, 1.653017f, -0.064908f,
	28.000000f,
	// 199
	0.987576f, 0.852207f,
	0.130305f, -0.597316f, 0.791350f,
	0.000000f, 1.631638f, -0.090763f,
	28.000000f,
	// 200
	0.918795f, 0.838445f,
	0.288033f, -0.588693f, 0.755300f,
	-0.029034f, 1.630977f, -0.086553f,
	28.000000f,
	// 201
	0.987576f, 0.811167f,
	0.139350f, -0.350231f, 0.926240f,
	-0.000000f, 1.608102f, -0.101128f,
	28.000000f,
	// 202
	0.986415f, 0.685953f,
	0.226075f, -0.368799f, 0.901597f,
	0.000720f, 1.515788f, -0.133573f,
	28.000000f,
	// 203
	0.986415f, 0.625488f,
	0.242777f, -0.420362f, 0.874274f,
	0.006680f, 1.489665f, -0.147788f,
	28.000000f,
	// 204
	0.977068f, 0.688349f,
	0.660747f, -0.397607f, 0.636649f,
	-0.031952f, 1.540253f, -0.130062f,
	28.000000f,
	// 205
	0.784767f, 0.625488f,
	0.671296f, -0.455211f, 0.584931f,
	-0.100322f, 1.495346f, -0.086546f,
	28.000000f,
	// 206
	0.973233f, 0.625488f,
	0.674903f, -0.531596f, 0.511773f,
	-0.037818f, 1.518906f, -0.144501f,
	28.000000f,
	// 207
	0.801425f, 0.688349f,
	0.681041f, -0.336136f, 0.650534f,
	-0.085688f, 1.525597f, -0.081379f,
	28.000000f,
	// 208
	0.805887f, 0.795299f,
	0.567084f, -0.328194f, 0.755450f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 209
	0.927640f, 0.803022f,
	0.513940f, -0.389891f, 0.764102f,
	-0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 210
	0.805887f, 0.831375f,
	0.477379f, -0.511256f, 0.714651f,
	-0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 211
	0.805887f, 0.870148f,
	0.280863f, -0.814423f, 0.507771f,
	-0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 212
	0.805887f, 0.911446f,
	0.038171f, -0.938444f, 0.343315f,
	-0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 213
	0.910858f, 0.813819f,
	0.820803f, -0.495742f, -0.283765f,
	-0.076929f, 1.620261f, -0.034087f,
	28.000000f,
	// 214
	0.966381f, 0.813819f,
	0.818469f, -0.566821f, 0.093927f,
	-0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 215
	0.966381f, 0.866591f,
	0.510347f, -0.825164f, 0.242176f,
	-0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 216
	0.885949f, 0.748008f,
	0.960827f, -0.266194f, -0.077150f,
	-0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 217
	0.805517f, 0.748008f,
	0.972011f, -0.203521f, -0.117362f,
	-0.092525f, 1.585309f, -0.019936f,
	28.000000f,
	// 218
	0.805517f, 0.675727f,
	0.524140f, -0.621670f, -0.582068f,
	-0.092062f, 1.510260f, -0.003357f,
	28.000000f,
	// 219
	0.889449f, 0.678400f,
	0.765870f, -0.582679f, -0.271899f,
	-0.107786f, 1.519160f, -0.025793f,
	28.000000f,
	// 220
	0.775987f, 0.625488f,
	0.337987f, -0.769578f, -0.541769f,
	-0.098771f, 1.495740f, 0.013099f,
	28.000000f,
	// 221
	0.875269f, 0.625488f,
	0.486503f, -0.842689f, -0.230629f,
	-0.127610f, 1.505986f, -0.019476f,
	28.000000f,
	// 222
	0.974551f, 0.625488f,
	0.594808f, -0.792251f, 0.136167f,
	-0.120408f, 1.502223f, -0.069200f,
	28.000000f,
	// 223
	0.973380f, 0.681073f,
	0.818089f, -0.559000f, 0.135088f,
	-0.104037f, 1.516353f, -0.060109f,
	28.000000f,
	// 224
	0.966381f, 0.748008f,
	0.917744f, -0.230224f, 0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 225
	0.804078f, 0.758057f,
	0.187599f, -0.282577f, -0.940721f,
	-0.060805f, 1.536139f, -0.021605f,
	28.000000f,
	// 226
	0.804078f, 0.738601f,
	0.144379f, -0.354944f, -0.923672f,
	-0.050344f, 1.486859f, -0.004716f,
	28.000000f,
	// 227
	0.987435f, 0.735105f,
	0.191950f, -0.303547f, -0.933282f,
	-0.094104f, 1.509346f, -0.020197f,
	28.000000f,
	// 228
	0.804078f, 0.626445f,
	0.195472f, -0.333885f, -0.922123f,
	-0.032849f, 1.426416f, 0.022815f,
	28.000000f,
	// 229
	0.987435f, 0.626445f,
	0.268632f, -0.279655f, -0.921754f,
	-0.085385f, 1.463868f, -0.003859f,
	28.000000f,
	// 230
	0.805517f, 0.763698f,
	-0.896482f, -0.162330f, -0.412273f,
	0.074658f, 1.545548f, -0.004579f,
	28.000000f,
	// 231
	0.898783f, 0.779388f,
	-0.896482f, -0.162330f, -0.412273f,
	0.075244f, 1.617200f, -0.034065f,
	28.000000f,
	// 232
	0.842505f, 0.748008f,
	-0.896482f, -0.162330f, -0.412273f,
	0.088396f, 1.509346f, -0.020197f,
	28.000000f,
	// 233
	0.916034f, 0.710986f,
	0.408068f, -0.005339f, -0.912936f,
	-0.094669f, 1.509523f, -0.020318f,
	28.000000f,
	// 234
	0.918992f, 0.762053f,
	-0.033992f, -0.261905f, -0.964495f,
	-0.093080f, 1.585942f, -0.020055f,
	28.000000f,
	// 235
	0.805517f, 0.710632f,
	0.322134f, -0.060707f, -0.944746f,
	-0.069280f, 1.542747f, -0.009165f,
	28.000000f,
	// 236
	0.869572f, 0.779388f,
	-0.143689f, -0.315649f, -0.937933f,
	-0.077391f, 1.621104f, -0.034292f,
	28.000000f,
	// 237
	0.798107f, 0.784918f,
	-0.973143f, 0.064930f, -0.220855f,
	0.078411f, 1.542280f, -0.013824f,
	28.000000f,
	// 238
	0.620820f, 0.784918f,
	-0.973143f, 0.064930f, -0.220855f,
	0.071054f, 1.543109f, 0.018834f,
	28.000000f,
	// 239
	0.798107f, 0.812950f,
	-0.973143f, 0.064930f, -0.220855f,
	0.074968f, 1.595554f, 0.017006f,
	28.000000f,
	// 240
	0.798107f, 0.812950f,
	0.973143f, -0.064930f, 0.220855f,
	0.074968f, 1.595554f, 0.017006f,
	28.000000f,
	// 241
	0.620820f, 0.784918f,
	0.973143f, -0.064930f, 0.220855f,
	0.071054f, 1.543109f, 0.018834f,
	28.000000f,
	// 242
	0.798107f, 0.784918f,
	0.973143f, -0.064930f, 0.220855f,
	0.078411f, 1.542280f, -0.013824f,
	28.000000f,
	// 243
	0.869572f, 0.779388f,
	0.143689f, 0.315649f, 0.937933f,
	-0.077391f, 1.621104f, -0.034292f,
	28.000000f,
	// 244
	0.918992f, 0.762053f,
	0.033992f, 0.261905f, 0.964495f,
	-0.093080f, 1.585942f, -0.020055f,
	28.000000f,
	// 245
	0.805517f, 0.710632f,
	-0.322134f, 0.060707f, 0.944746f,
	-0.069280f, 1.542747f, -0.009165f,
	28.000000f,
	// 246
	0.916034f, 0.710986f,
	-0.408068f, 0.005339f, 0.912936f,
	-0.094669f, 1.509523f, -0.020318f,
	28.000000f,
	// 247
	0.842505f, 0.748008f,
	0.896482f, 0.162330f, 0.412273f,
	0.088396f, 1.509346f, -0.020197f,
	28.000000f,
	// 248
	0.898783f, 0.779388f,
	0.896482f, 0.162330f, 0.412273f,
	0.075244f, 1.617200f, -0.034065f,
	28.000000f,
	// 249
	0.805517f, 0.763698f,
	0.896482f, 0.162330f, 0.412273f,
	0.074658f, 1.545548f, -0.004579f,
	28.000000f,
	// 250
	0.987435f, 0.626445f,
	-0.268632f, 0.279655f, 0.921754f,
	-0.085385f, 1.463868f, -0.003859f,
	28.000000f,
	// 251
	0.804078f, 0.626445f,
	-0.195472f, 0.333885f, 0.922123f,
	-0.032849f, 1.426416f, 0.022815f,
	28.000000f,
	// 252
	0.987435f, 0.735105f,
	-0.191950f, 0.303547f, 0.933282f,
	-0.094104f, 1.509346f, -0.020197f,
	28.000000f,
	// 253
	0.804078f, 0.738601f,
	-0.144379f, 0.354944f, 0.923672f,
	-0.050344f, 1.486859f, -0.004716f,
	28.000000f,
	// 254
	0.804078f, 0.758057f,
	-0.187599f, 0.282577f, 0.940721f,
	-0.060805f, 1.536139f, -0.021605f,
	28.000000f,
	// 255
	0.804105f, 0.625488f,
	-0.943899f, 0.181714f, -0.275744f,
	-0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 256
	0.805415f, 0.663308f,
	-0.936289f, 0.093427f, -0.338577f,
	-0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 257
	0.954176f, 0.625488f,
	-0.907047f, -0.019878f, -0.420560f,
	-0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 258
	0.955486f, 0.660963f,
	-0.850566f, 0.126254f, -0.510488f,
	-0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 259
	0.954176f, 0.783637f,
	-0.760399f, 0.246110f, -0.601019f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 260
	0.804105f, 0.741314f,
	-0.917744f, 0.230224f, -0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 261
	0.954176f, 0.835210f,
	-0.683647f, 0.569304f, -0.456639f,
	-0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 262
	0.804105f, 0.820668f,
	-0.818469f, 0.566821f, -0.093927f,
	-0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 263
	0.954176f, 0.870075f,
	-0.483656f, 0.822411f, -0.299528f,
	-0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 264
	0.804105f, 0.866462f,
	-0.510347f, 0.825164f, -0.242176f,
	-0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 265
	0.954176f, 0.910438f,
	-0.272331f, 0.941858f, -0.196825f,
	-0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 266
	0.966381f, 0.813819f,
	-0.818469f, 0.566821f, -0.093927f,
	-0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 267
	0.910858f, 0.813819f,
	-0.820803f, 0.495742f, 0.283765f,
	-0.076929f, 1.620261f, -0.034087f,
	28.000000f,
	// 268
	0.966381f, 0.866591f,
	-0.510347f, 0.825164f, -0.242176f,
	-0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 269
	0.885949f, 0.748008f,
	-0.960827f, 0.266194f, 0.077150f,
	-0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 270
	0.966381f, 0.748008f,
	-0.917744f, 0.230224f, -0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 271
	0.889449f, 0.678400f,
	-0.765870f, 0.582679f, 0.271898f,
	-0.107786f, 1.519160f, -0.025793f,
	28.000000f,
	// 272
	0.973380f, 0.681073f,
	-0.818089f, 0.559000f, -0.135088f,
	-0.104037f, 1.516353f, -0.060109f,
	28.000000f,
	// 273
	0.974551f, 0.625488f,
	-0.594808f, 0.792251f, -0.136167f,
	-0.120408f, 1.502223f, -0.069200f,
	28.000000f,
	// 274
	0.875269f, 0.625488f,
	-0.486503f, 0.842689f, 0.230629f,
	-0.127610f, 1.505986f, -0.019476f,
	28.000000f,
	// 275
	0.775987f, 0.625488f,
	-0.337987f, 0.769578f, 0.541769f,
	-0.098771f, 1.495740f, 0.013099f,
	28.000000f,
	// 276
	0.805517f, 0.675727f,
	-0.524140f, 0.621670f, 0.582068f,
	-0.092062f, 1.510260f, -0.003357f,
	28.000000f,
	// 277
	0.805517f, 0.748008f,
	-0.972011f, 0.203521f, 0.117362f,
	-0.092525f, 1.585309f, -0.019936f,
	28.000000f,
	// 278
	0.980154f, 0.898367f,
	0.000000f, 0.865972f, -0.500092f,
	0.000000f, 1.653017f, -0.064908f,
	28.000000f,
	// 279
	0.922581f, 0.878810f,
	-0.146951f, 0.869415f, -0.471723f,
	-0.020542f, 1.652745f, -0.060649f,
	28.000000f,
	// 280
	0.805887f, 0.928763f,
	-0.000000f, 0.942114f, -0.335292f,
	-0.000000f, 1.666408f, -0.024007f,
	28.000000f,
	// 281
	0.987576f, 0.852207f,
	-0.000000f, 0.602452f, -0.798155f,
	-0.000000f, 1.631638f, -0.090763f,
	28.000000f,
	// 282
	0.918795f, 0.838445f,
	-0.288033f, 0.588693f, -0.755300f,
	-0.029034f, 1.630977f, -0.086553f,
	28.000000f,
	// 283
	0.907673f, 0.806423f,
	-0.252148f, 0.331807f, -0.909024f,
	-0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 284
	0.987576f, 0.811167f,
	-0.139349f, 0.350231f, -0.926240f,
	0.000000f, 1.608102f, -0.101128f,
	28.000000f,
	// 285
	0.899942f, 0.676753f,
	-0.429196f, 0.352008f, -0.831794f,
	-0.043032f, 1.512310f, -0.124519f,
	28.000000f,
	// 286
	0.986415f, 0.685953f,
	-0.226075f, 0.368799f, -0.901597f,
	0.000720f, 1.515788f, -0.133573f,
	28.000000f,
	// 287
	0.895115f, 0.625488f,
	-0.588038f, 0.369242f, -0.719633f,
	-0.059887f, 1.473017f, -0.137307f,
	28.000000f,
	// 288
	0.986415f, 0.625488f,
	-0.242777f, 0.420362f, -0.874274f,
	0.006680f, 1.489665f, -0.147788f,
	28.000000f,
	// 289
	0.805887f, 0.625488f,
	-0.907047f, -0.019878f, -0.420560f,
	-0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 290
	0.807197f, 0.660963f,
	-0.850566f, 0.126254f, -0.510488f,
	-0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 291
	0.805887f, 0.798699f,
	-0.562785f, 0.260105f, -0.784613f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 292
	0.973233f, 0.625488f,
	-0.674903f, 0.531596f, -0.511773f,
	-0.037818f, 1.518906f, -0.144501f,
	28.000000f,
	// 293
	0.784767f, 0.625488f,
	-0.671296f, 0.455211f, -0.584931f,
	-0.100322f, 1.495346f, -0.086546f,
	28.000000f,
	// 294
	0.977068f, 0.688349f,
	-0.660747f, 0.397607f, -0.636649f,
	-0.031952f, 1.540253f, -0.130062f,
	28.000000f,
	// 295
	0.801425f, 0.688349f,
	-0.681041f, 0.336136f, -0.650534f,
	-0.085688f, 1.525597f, -0.081379f,
	28.000000f,
	// 296
	0.805887f, 0.795299f,
	-0.567084f, 0.328194f, -0.755450f,
	-0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 297
	0.927640f, 0.803022f,
	-0.513940f, 0.389891f, -0.764102f,
	-0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 298
	0.805887f, 0.831375f,
	-0.477379f, 0.511256f, -0.714651f,
	-0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 299
	0.805887f, 0.870148f,
	-0.280863f, 0.814423f, -0.507771f,
	-0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 300
	0.805887f, 0.911446f,
	-0.038181f, 0.938445f, -0.343313f,
	-0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 301
	0.984742f, 0.625488f,
	-0.943899f, 0.181714f, -0.275744f,
	-0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 302
	0.884424f, 0.625488f,
	-0.889566f, 0.143278f, 0.433756f,
	-0.106455f, 1.465107f, -0.016663f,
	28.000000f,
	// 303
	0.986415f, 0.664912f,
	-0.936289f, 0.093427f, -0.338577f,
	-0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 304
	0.896198f, 0.666112f,
	-0.968860f, 0.063957f, 0.239207f,
	-0.107935f, 1.487290f, -0.023152f,
	28.000000f,
	// 305
	0.966381f, 0.757377f,
	-0.917744f, 0.230224f, -0.323639f,
	-0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 306
	0.885310f, 0.754304f,
	-0.988979f, 0.142700f, 0.039451f,
	-0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 307
	0.802930f, 0.667312f,
	-0.660650f, 0.220763f, 0.717499f,
	-0.082072f, 1.465983f, 0.005543f,
	28.000000f,
	// 308
	0.784106f, 0.625488f,
	-0.656050f, 0.255015f, 0.710327f,
	-0.078135f, 1.434644f, 0.020431f,
	28.000000f,
	// 309
	0.954176f, 0.910438f,
	0.272331f, 0.941858f, -0.196825f,
	0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 310
	0.804105f, 0.866462f,
	0.510347f, 0.825164f, -0.242176f,
	0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 311
	0.954176f, 0.870075f,
	0.483656f, 0.822411f, -0.299528f,
	0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 312
	0.804105f, 0.820668f,
	0.818469f, 0.566821f, -0.093927f,
	0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 313
	0.954176f, 0.835210f,
	0.683647f, 0.569304f, -0.456639f,
	0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 314
	0.804105f, 0.741314f,
	0.917744f, 0.230224f, -0.323639f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 315
	0.954176f, 0.783637f,
	0.694582f, 0.253333f, -0.673333f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 316
	0.805415f, 0.663308f,
	0.936289f, 0.093427f, -0.338577f,
	0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 317
	0.955486f, 0.660963f,
	0.850566f, 0.126254f, -0.510488f,
	0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 318
	0.954176f, 0.625285f,
	0.907047f, -0.019878f, -0.420560f,
	0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 319
	0.804105f, 0.625285f,
	0.943899f, 0.181714f, -0.275744f,
	0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 320
	0.986861f, 0.664912f,
	0.936289f, 0.093427f, -0.338577f,
	0.099994f, 1.487822f, -0.051332f,
	28.000000f,
	// 321
	0.884424f, 0.625285f,
	0.889566f, 0.143278f, 0.433756f,
	0.106455f, 1.465107f, -0.016663f,
	28.000000f,
	// 322
	0.986861f, 0.625285f,
	0.943899f, 0.181714f, -0.275744f,
	0.105285f, 1.458501f, -0.052541f,
	28.000000f,
	// 323
	0.896198f, 0.666112f,
	0.968860f, 0.063957f, 0.239207f,
	0.107935f, 1.487290f, -0.023152f,
	28.000000f,
	// 324
	0.966381f, 0.757377f,
	0.917744f, 0.230224f, -0.323639f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 325
	0.885310f, 0.754304f,
	0.988979f, 0.142700f, 0.039451f,
	0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 326
	0.802930f, 0.667312f,
	0.660650f, 0.220763f, 0.717499f,
	0.082072f, 1.465983f, 0.005543f,
	28.000000f,
	// 327
	0.784106f, 0.625285f,
	0.656050f, 0.255015f, 0.710327f,
	0.078135f, 1.434644f, 0.020431f,
	28.000000f,
	// 328
	0.907673f, 0.806423f,
	0.252149f, 0.331807f, -0.909024f,
	0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 329
	0.805887f, 0.798699f,
	0.694582f, 0.253333f, -0.673333f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 330
	0.899942f, 0.676753f,
	0.424148f, 0.350659f, -0.834947f,
	0.043032f, 1.512310f, -0.124519f,
	28.000000f,
	// 331
	0.807197f, 0.660963f,
	0.850566f, 0.126254f, -0.510488f,
	0.080644f, 1.498489f, -0.092434f,
	28.000000f,
	// 332
	0.895115f, 0.625285f,
	0.586366f, 0.371247f, -0.719966f,
	0.059887f, 1.473017f, -0.137307f,
	28.000000f,
	// 333
	0.805887f, 0.625285f,
	0.907047f, -0.019878f, -0.420560f,
	0.076037f, 1.472127f, -0.099108f,
	28.000000f,
	// 334
	0.805887f, 0.928763f,
	-0.000000f, 0.942114f, -0.335292f,
	-0.000000f, 1.666408f, -0.024007f,
	28.000000f,
	// 335
	0.922581f, 0.878810f,
	0.146951f, 0.869415f, -0.471723f,
	0.020542f, 1.652745f, -0.060649f,
	28.000000f,
	// 336
	0.980154f, 0.898367f,
	0.000000f, 0.865972f, -0.500092f,
	0.000000f, 1.653017f, -0.064908f,
	28.000000f,
	// 337
	0.987576f, 0.852207f,
	-0.000000f, 0.602452f, -0.798155f,
	-0.000000f, 1.631638f, -0.090763f,
	28.000000f,
	// 338
	0.918795f, 0.838445f,
	0.288033f, 0.588693f, -0.755300f,
	0.029034f, 1.630977f, -0.086553f,
	28.000000f,
	// 339
	0.987576f, 0.811167f,
	0.137453f, 0.349799f, -0.926686f,
	-0.000000f, 1.608102f, -0.101128f,
	28.000000f,
	// 340
	0.986861f, 0.685953f,
	0.219928f, 0.371397f, -0.902051f,
	0.000715f, 1.515573f, -0.132776f,
	28.000000f,
	// 341
	0.986861f, 0.625285f,
	0.244841f, 0.432819f, -0.867595f,
	-0.006680f, 1.489665f, -0.147788f,
	28.000000f,
	// 342
	0.977068f, 0.688349f,
	0.660747f, 0.397607f, -0.636649f,
	0.031952f, 1.540253f, -0.130062f,
	28.000000f,
	// 343
	0.784767f, 0.625285f,
	0.671296f, 0.455211f, -0.584931f,
	0.100322f, 1.495346f, -0.086546f,
	28.000000f,
	// 344
	0.973233f, 0.625285f,
	0.674903f, 0.531596f, -0.511773f,
	0.037818f, 1.518906f, -0.144501f,
	28.000000f,
	// 345
	0.801425f, 0.688349f,
	0.681041f, 0.336136f, -0.650534f,
	0.085688f, 1.525597f, -0.081379f,
	28.000000f,
	// 346
	0.805887f, 0.795299f,
	0.567084f, 0.328194f, -0.755450f,
	0.071478f, 1.595690f, -0.076474f,
	28.000000f,
	// 347
	0.927640f, 0.803022f,
	0.513940f, 0.389891f, -0.764102f,
	0.032546f, 1.605456f, -0.097677f,
	28.000000f,
	// 348
	0.805887f, 0.831375f,
	0.477379f, 0.511256f, -0.714651f,
	0.061659f, 1.627496f, -0.067251f,
	28.000000f,
	// 349
	0.805887f, 0.870148f,
	0.280863f, 0.814423f, -0.507771f,
	0.043501f, 1.651345f, -0.053173f,
	28.000000f,
	// 350
	0.805887f, 0.911446f,
	0.038181f, 0.938445f, -0.343313f,
	0.014702f, 1.664940f, -0.027963f,
	28.000000f,
	// 351
	0.910858f, 0.813819f,
	0.820803f, 0.495742f, 0.283766f,
	0.076929f, 1.620261f, -0.034087f,
	28.000000f,
	// 352
	0.966381f, 0.813819f,
	0.818469f, 0.566821f, -0.093927f,
	0.078676f, 1.624098f, -0.045094f,
	28.000000f,
	// 353
	0.966381f, 0.866591f,
	0.510347f, 0.825164f, -0.242176f,
	0.051944f, 1.652379f, -0.036545f,
	28.000000f,
	// 354
	0.885949f, 0.748008f,
	0.960827f, 0.266194f, 0.077150f,
	0.094272f, 1.584891f, -0.033678f,
	28.000000f,
	// 355
	0.805517f, 0.748008f,
	0.972011f, 0.203521f, 0.117362f,
	0.092525f, 1.585309f, -0.019936f,
	28.000000f,
	// 356
	0.805517f, 0.675727f,
	0.524140f, 0.621670f, 0.582068f,
	0.092062f, 1.510260f, -0.003357f,
	28.000000f,
	// 357
	0.889449f, 0.678400f,
	0.765870f, 0.582679f, 0.271899f,
	0.107786f, 1.519160f, -0.025793f,
	28.000000f,
	// 358
	0.775987f, 0.625285f,
	0.337987f, 0.769578f, 0.541769f,
	0.098771f, 1.495740f, 0.013099f,
	28.000000f,
	// 359
	0.875269f, 0.625285f,
	0.486503f, 0.842689f, 0.230629f,
	0.127610f, 1.505986f, -0.019476f,
	28.000000f,
	// 360
	0.974551f, 0.625285f,
	0.594808f, 0.792251f, -0.136167f,
	0.120408f, 1.502223f, -0.069200f,
	28.000000f,
	// 361
	0.973380f, 0.681073f,
	0.818089f, 0.559000f, -0.135088f,
	0.104037f, 1.516353f, -0.060109f,
	28.000000f,
	// 362
	0.966381f, 0.748008f,
	0.917744f, 0.230224f, -0.323639f,
	0.091960f, 1.590305f, -0.054839f,
	28.000000f,
	// 363
	0.798107f, 0.812950f,
	0.988068f, -0.017082f, 0.153069f,
	0.077091f, 1.606977f, 0.016510f,
	28.000000f,
	// 364
	0.620579f, 0.811830f,
	0.977756f, -0.047892f, 0.204204f,
	0.070906f, 1.589907f, 0.054531f,
	28.000000f,
	// 365
	0.798107f, 0.713834f,
	0.937311f, -0.190746f, 0.291657f,
	0.076352f, 1.516063f, 0.011136f,
	28.000000f,
	// 366
	0.620820f, 0.713834f,
	0.920469f, -0.229828f, 0.316096f,
	0.060353f, 1.513837f, 0.055964f,
	28.000000f,
	// 367
	0.798107f, 0.625305f,
	0.901769f, -0.306814f, 0.304430f,
	0.055357f, 1.461603f, 0.018119f,
	28.000000f,
	// 368
	0.622610f, 0.625305f,
	0.902515f, -0.305928f, 0.303109f,
	0.037425f, 1.459695f, 0.069587f,
	28.000000f,
	// 369
	0.624400f, 0.626036f,
	-0.902515f, -0.305928f, 0.303109f,
	-0.037425f, 1.459695f, 0.069587f,
	28.000000f,
	// 370
	0.620820f, 0.713834f,
	-0.920469f, -0.229828f, 0.316096f,
	-0.060353f, 1.513837f, 0.055964f,
	28.000000f,
	// 371
	0.798107f, 0.626036f,
	-0.901769f, -0.306814f, 0.304430f,
	-0.055357f, 1.461603f, 0.018119f,
	28.000000f,
	// 372
	0.798107f, 0.713834f,
	-0.937311f, -0.190746f, 0.291656f,
	-0.076352f, 1.516063f, 0.011136f,
	28.000000f,
	// 373
	0.620579f, 0.811830f,
	-0.977756f, -0.047892f, 0.204204f,
	-0.070906f, 1.589907f, 0.054531f,
	28.000000f,
	// 374
	0.798107f, 0.812950f,
	-0.988068f, -0.017082f, 0.153069f,
	-0.077091f, 1.606977f, 0.016510f,
	28.000000f,
	// 375
	0.619763f, 0.719088f,
	0.921581f, -0.084133f, 0.378959f,
	0.058381f, 1.539871f, 0.081334f,
	28.000000f,
	// 376
	0.802807f, 0.736555f,
	0.925100f, -0.018738f, 0.379260f,
	0.069953f, 1.549526f, 0.053586f,
	28.000000f,
	// 377
	0.616183f, 0.808200f,
	0.892381f, 0.151851f, 0.424967f,
	0.050020f, 1.599519f, 0.077578f,
	28.000000f,
	// 378
	0.802807f, 0.625859f,
	0.907122f, -0.229644f, 0.352695f,
	0.060403f, 1.499814f, 0.050052f,
	28.000000f,
	// 379
	0.623343f, 0.625859f,
	0.892926f, -0.248235f, 0.375584f,
	0.044162f, 1.498943f, 0.088089f,
	28.000000f,
	// 380
	0.625133f, 0.625859f,
	-0.892926f, -0.248235f, 0.375584f,
	-0.044162f, 1.498943f, 0.088089f,
	28.000000f,
	// 381
	0.619763f, 0.719088f,
	-0.921581f, -0.084133f, 0.378959f,
	-0.058381f, 1.539871f, 0.081334f,
	28.000000f,
	// 382
	0.802807f, 0.625859f,
	-0.907122f, -0.229643f, 0.352695f,
	-0.060403f, 1.499814f, 0.050052f,
	28.000000f,
	// 383
	0.802807f, 0.736555f,
	-0.925100f, -0.018738f, 0.379260f,
	-0.069953f, 1.549526f, 0.053586f,
	28.000000f,
	// 384
	0.616183f, 0.808200f,
	-0.892381f, 0.151851f, 0.424967f,
	-0.050020f, 1.599519f, 0.077578f,
	28.000000f,
	// 385
	0.799824f, 0.625790f,
	-0.978909f, -0.084630f, 0.185943f,
	-0.079567f, 1.523588f, 0.034274f,
	28.000000f,
	// 386
	0.723368f, 0.625790f,
	-0.859438f, -0.044120f, 0.509332f,
	-0.073190f, 1.522032f, 0.067136f,
	28.000000f,
	// 387
	0.799824f, 0.743785f,
	-0.823346f, 0.206660f, 0.528576f,
	-0.085264f, 1.593791f, 0.036232f,
	28.000000f,
	// 388
	0.617274f, 0.769089f,
	-0.737851f, 0.322112f, 0.593144f,
	-0.025872f, 1.613610f, 0.099351f,
	28.000000f,
	// 389
	0.799824f, 0.770465f,
	-0.735419f, 0.343331f, 0.584194f,
	-0.066167f, 1.627042f, 0.040732f,
	28.000000f,
	// 390
	0.617274f, 0.746042f,
	-0.768136f, 0.140218f, 0.624745f,
	-0.048981f, 1.564617f, 0.096434f,
	28.000000f,
	// 391
	0.623477f, 0.625790f,
	-0.638606f, -0.155475f, 0.753665f,
	-0.044435f, 1.517212f, 0.090507f,
	28.000000f,
	// 392
	0.803168f, 0.626400f,
	0.757369f, -0.103116f, 0.644794f,
	0.058984f, 1.532966f, 0.081506f,
	28.000000f,
	// 393
	0.803168f, 0.693351f,
	0.775407f, 0.038957f, 0.630259f,
	0.066598f, 1.573472f, 0.079041f,
	28.000000f,
	// 394
	0.622197f, 0.626400f,
	0.754572f, -0.092934f, 0.649604f,
	0.034618f, 1.548805f, 0.112660f,
	28.000000f,
	// 395
	0.616973f, 0.714180f,
	0.801813f, 0.115394f, 0.586328f,
	0.041746f, 1.590206f, 0.109733f,
	28.000000f,
	// 396
	0.616973f, 0.754502f,
	0.515960f, 0.521542f, 0.679544f,
	0.041405f, 1.612660f, 0.098041f,
	28.000000f,
	// 397
	0.803168f, 0.749830f,
	0.709397f, 0.320309f, 0.627820f,
	0.065239f, 1.604875f, 0.071828f,
	28.000000f,
	// 398
	0.803168f, 0.790285f,
	0.529506f, 0.729055f, 0.433709f,
	0.057302f, 1.640461f, 0.054537f,
	28.000000f,
	// 399
	0.616973f, 0.814736f,
	0.378643f, 0.807572f, 0.452169f,
	0.034676f, 1.659192f, 0.034598f,
	28.000000f,
	// 400
	0.616973f, 0.790285f,
	0.529506f, 0.729055f, 0.433709f,
	0.057302f, 1.640461f, 0.054537f,
	28.000000f,
	// 401
	0.726321f, 0.790285f,
	0.724112f, 0.688975f, 0.031232f,
	0.062748f, 1.638939f, 0.035341f,
	28.000000f,
	// 402
	0.726321f, 0.774872f,
	0.847871f, 0.503924f, 0.164849f,
	0.072912f, 1.625499f, 0.046741f,
	28.000000f,
	// 403
	0.798685f, 0.728845f,
	0.995252f, 0.082747f, -0.051241f,
	0.085482f, 1.586679f, 0.022891f,
	28.000000f,
	// 404
	0.726321f, 0.754978f,
	0.899745f, 0.246375f, 0.360219f,
	0.083780f, 1.598162f, 0.056904f,
	28.000000f,
	// 405
	0.628286f, 0.753916f,
	0.709397f, 0.320309f, 0.627820f,
	0.065239f, 1.604875f, 0.071828f,
	28.000000f,
	// 406
	0.622197f, 0.686057f,
	0.771702f, -0.043085f, 0.634523f,
	0.058796f, 1.561873f, 0.089786f,
	28.000000f,
	// 407
	0.726321f, 0.687831f,
	0.945593f, -0.146003f, 0.290754f,
	0.083295f, 1.553507f, 0.057127f,
	28.000000f,
	// 408
	0.622197f, 0.626400f,
	0.788670f, -0.193454f, 0.583588f,
	0.049327f, 1.524964f, 0.093569f,
	28.000000f,
	// 409
	0.735993f, 0.626400f,
	0.906837f, -0.267329f, 0.325856f,
	0.074210f, 1.518457f, 0.053655f,
	28.000000f,
	// 410
	0.803168f, 0.697056f,
	0.979026f, -0.186245f, -0.082587f,
	0.079818f, 1.551825f, 0.019704f,
	28.000000f,
	// 411
	0.739360f, 0.626400f,
	0.906837f, -0.267329f, 0.325856f,
	0.074210f, 1.518457f, 0.053655f,
	28.000000f,
	// 412
	0.623308f, 0.626369f,
	-0.044554f, -0.264573f, 0.963336f,
	-0.029926f, 1.527719f, 0.107236f,
	28.000000f,
	// 413
	0.776639f, 0.626369f,
	0.091156f, -0.155032f, 0.983695f,
	0.020197f, 1.531902f, 0.110704f,
	28.000000f,
	// 414
	0.621425f, 0.699916f,
	0.106188f, -0.054418f, 0.992856f,
	-0.013500f, 1.571897f, 0.120129f,
	28.000000f,
	// 415
	0.802470f, 0.722674f,
	0.222931f, 0.200507f, 0.953991f,
	0.042744f, 1.590210f, 0.108904f,
	28.000000f,
	// 416
	0.626493f, 0.758138f,
	0.059526f, 0.514789f, 0.855248f,
	0.002117f, 1.617986f, 0.109244f,
	28.000000f,
	// 417
	0.802470f, 0.758138f,
	0.515960f, 0.521542f, 0.679544f,
	0.041405f, 1.612660f, 0.098041f,
	28.000000f,
	// 418
	0.618323f, 0.813403f,
	0.372480f, 0.753113f, 0.542291f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 419
	0.802470f, 0.813403f,
	0.378643f, 0.807572f, 0.452169f,
	0.034676f, 1.659192f, 0.034598f,
	28.000000f,
	// 420
	0.801966f, 0.627242f,
	-0.836369f, 0.208957f, 0.506777f,
	-0.085011f, 1.555252f, 0.077082f,
	28.000000f,
	// 421
	0.800389f, 0.729003f,
	-0.762935f, 0.424176f, 0.487857f,
	-0.066303f, 1.590520f, 0.093414f,
	28.000000f,
	// 422
	0.622858f, 0.627242f,
	-0.786447f, 0.397300f, 0.472920f,
	-0.122506f, 1.588865f, 0.001340f,
	28.000000f,
	// 423
	0.634489f, 0.734763f,
	-0.652606f, 0.585070f, 0.481453f,
	-0.064624f, 1.640649f, 0.040760f,
	28.000000f,
	// 424
	0.800389f, 0.755838f,
	-0.615631f, 0.610752f, 0.497976f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 425
	0.800389f, 0.774050f,
	-0.426076f, 0.746541f, 0.511015f,
	-0.023117f, 1.635137f, 0.091627f,
	28.000000f,
	// 426
	0.696802f, 0.774050f,
	-0.355909f, 0.799627f, 0.483658f,
	-0.035067f, 1.659636f, 0.046165f,
	28.000000f,
	// 427
	0.800806f, 0.794259f,
	-0.136845f, 0.888569f, 0.437857f,
	-0.002615f, 1.651672f, 0.072467f,
	28.000000f,
	// 428
	0.800578f, 0.813920f,
	-0.057005f, 0.933861f, 0.353064f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 429
	0.679834f, 0.814446f,
	0.372480f, 0.753113f, 0.542291f,
	0.011689f, 1.662551f, 0.046003f,
	28.000000f,
	// 430
	0.618179f, 0.794259f,
	0.401006f, 0.700631f, 0.590178f,
	-0.002615f, 1.651672f, 0.072467f,
	28.000000f,
	// 431
	0.770862f, 0.769407f,
	0.059526f, 0.514789f, 0.855248f,
	0.002117f, 1.617986f, 0.109244f,
	28.000000f,
	// 432
	0.618179f, 0.774050f,
	-0.110383f, 0.599285f, 0.792889f,
	-0.023117f, 1.635137f, 0.091627f,
	28.000000f,
	// 433
	0.713995f, 0.724145f,
	-0.425713f, 0.080970f, 0.901228f,
	-0.045530f, 1.580818f, 0.111686f,
	28.000000f,
	// 434
	0.802173f, 0.720322f,
	-0.214506f, 0.043230f, 0.975766f,
	-0.010065f, 1.573875f, 0.119790f,
	28.000000f,
	// 435
	0.803751f, 0.627242f,
	-0.285741f, -0.257373f, 0.923099f,
	-0.028716f, 1.535322f, 0.104206f,
	28.000000f,
	// 436
	0.707161f, 0.627242f,
	-0.564946f, -0.099686f, 0.819084f,
	-0.064307f, 1.534727f, 0.092386f,
	28.000000f,
	// 437
	0.618179f, 0.724693f,
	-0.648058f, 0.133201f, 0.749852f,
	-0.064868f, 1.592453f, 0.092548f,
	28.000000f,
	// 438
	0.622858f, 0.627242f,
	-0.673456f, -0.008621f, 0.739177f,
	-0.096960f, 1.537317f, 0.062667f,
	28.000000f,
	// 439
	0.618179f, 0.756832f,
	-0.233227f, 0.375872f, 0.896842f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 440
	0.695295f, 0.627242f,
	-0.949680f, -0.077756f, 0.303416f,
	-0.097092f, 1.522417f, 0.038027f,
	28.000000f,
	// 441
	0.713423f, 0.703015f,
	-0.886280f, 0.059727f, 0.459282f,
	-0.092677f, 1.564189f, 0.064414f,
	28.000000f,
	// 442
	0.622858f, 0.627242f,
	-0.984563f, 0.174285f, 0.016142f,
	-0.098884f, 1.537073f, -0.021402f,
	28.000000f,
	// 443
	0.618179f, 0.689436f,
	-0.950748f, 0.309310f, 0.020164f,
	-0.085017f, 1.590763f, 0.017928f,
	28.000000f,
	// 444
	0.618179f, 0.756142f,
	-0.857168f, 0.410647f, 0.310856f,
	-0.064624f, 1.640649f, 0.040760f,
	28.000000f,
	// 445
	0.800389f, 0.759027f,
	-0.758472f, 0.368244f, 0.537696f,
	-0.044644f, 1.614169f, 0.097939f,
	28.000000f,
	// 446
	0.800826f, 0.702446f,
	-0.656753f, -0.093951f, 0.748230f,
	-0.073998f, 1.560009f, 0.079872f,
	28.000000f,
	// 447
	0.801966f, 0.627242f,
	-0.709337f, -0.282886f, 0.645613f,
	-0.076654f, 1.520532f, 0.059656f,
	28.000000f,
	// 448
	0.974719f, 0.624820f,
	0.916270f, 0.031830f, 0.399293f,
	-0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 449
	0.976029f, 0.667324f,
	0.919825f, 0.038343f, 0.390451f,
	-0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 450
	0.809837f, 0.624820f,
	0.920536f, 0.012871f, 0.390446f,
	-0.087723f, 1.428398f, -0.019814f,
	28.000000f,
	// 451
	0.809837f, 0.685884f,
	0.922489f, 0.031368f, 0.384748f,
	-0.089890f, 1.461361f, -0.015059f,
	28.000000f,
	// 452
	0.974719f, 0.738934f,
	0.922096f, 0.058519f, 0.382510f,
	-0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 453
	0.987802f, 0.692314f,
	0.468470f, -0.062373f, 0.881275f,
	0.012621f, 1.483608f, -0.119185f,
	28.000000f,
	// 454
	0.805887f, 0.624820f,
	0.524421f, -0.108273f, 0.844547f,
	-0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 455
	0.981472f, 0.624820f,
	0.449960f, 0.016686f, 0.892893f,
	0.028412f, 1.433224f, -0.126201f,
	28.000000f,
	// 456
	0.807197f, 0.667324f,
	0.541681f, -0.097701f, 0.834887f,
	-0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 457
	0.805887f, 0.738934f,
	0.425834f, -0.144583f, 0.893175f,
	-0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 458
	0.987802f, 0.742586f,
	0.336262f, -0.235176f, 0.911932f,
	0.000000f, 1.592732f, -0.086390f,
	28.000000f,
	// 459
	0.976029f, 0.667324f,
	-0.919825f, 0.038344f, 0.390451f,
	0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 460
	0.809837f, 0.685884f,
	-0.922489f, 0.031368f, 0.384748f,
	0.089890f, 1.461361f, -0.015059f,
	28.000000f,
	// 461
	0.974719f, 0.738934f,
	-0.922096f, 0.058519f, 0.382510f,
	0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 462
	0.811103f, 0.625854f,
	-0.920536f, 0.012871f, 0.390446f,
	0.087723f, 1.428398f, -0.019814f,
	28.000000f,
	// 463
	0.975985f, 0.625854f,
	-0.916270f, 0.031830f, 0.399293f,
	0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 464
	0.983131f, 0.625854f,
	-0.449960f, 0.016686f, 0.892893f,
	-0.028412f, 1.433224f, -0.126201f,
	28.000000f,
	// 465
	0.807153f, 0.625854f,
	-0.524421f, -0.108274f, 0.844547f,
	0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 466
	0.988238f, 0.692314f,
	-0.468470f, -0.062373f, 0.881275f,
	-0.012621f, 1.483608f, -0.119185f,
	28.000000f,
	// 467
	0.807197f, 0.667324f,
	-0.541681f, -0.097701f, 0.834887f,
	0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 468
	0.805887f, 0.738934f,
	-0.425834f, -0.144583f, 0.893175f,
	0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 469
	0.986929f, 0.742586f,
	-0.336261f, -0.235176f, 0.911932f,
	0.000000f, 1.592732f, -0.086390f,
	28.000000f,
	// 470
	0.805887f, 0.626888f,
	-0.717198f, 0.143702f, 0.681892f,
	0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 471
	0.805887f, 0.738934f,
	-0.737381f, 0.072726f, 0.671550f,
	0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 472
	0.974084f, 0.626888f,
	-0.544819f, 0.117420f, 0.830292f,
	0.000095f, 1.442952f, -0.078578f,
	28.000000f,
	// 473
	0.974084f, 0.789827f,
	-0.485301f, 0.066813f, 0.871791f,
	0.000000f, 1.539701f, -0.086046f,
	28.000000f,
	// 474
	0.954176f, 0.626888f,
	-0.717198f, 0.143702f, 0.681892f,
	0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 475
	0.804105f, 0.626888f,
	-0.863094f, 0.099917f, 0.495061f,
	0.084959f, 1.453978f, 0.006272f,
	28.000000f,
	// 476
	0.954176f, 0.786174f,
	-0.737381f, 0.072726f, 0.671550f,
	0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 477
	0.804105f, 0.725300f,
	-0.934907f, -0.018797f, 0.354395f,
	0.073530f, 1.537422f, -0.019451f,
	28.000000f,
	// 478
	0.805887f, 0.738934f,
	0.737381f, 0.072726f, 0.671550f,
	-0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 479
	0.974084f, 0.626371f,
	0.544819f, 0.117420f, 0.830292f,
	-0.000095f, 1.442952f, -0.078578f,
	28.000000f,
	// 480
	0.974084f, 0.789827f,
	0.485301f, 0.066813f, 0.871791f,
	0.000000f, 1.539701f, -0.086046f,
	28.000000f,
	// 481
	0.805887f, 0.626371f,
	0.717198f, 0.143702f, 0.681892f,
	-0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 482
	0.804105f, 0.626371f,
	0.863094f, 0.099917f, 0.495061f,
	-0.084959f, 1.453978f, 0.006272f,
	28.000000f,
	// 483
	0.954176f, 0.786174f,
	0.737381f, 0.072726f, 0.671550f,
	-0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 484
	0.804105f, 0.725300f,
	0.934907f, -0.018797f, 0.354395f,
	-0.073530f, 1.537422f, -0.019451f,
	28.000000f,
	// 485
	0.954176f, 0.626371f,
	0.717198f, 0.143702f, 0.681892f,
	-0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 486
	0.805887f, 0.626371f,
	-0.717198f, -0.143702f, -0.681892f,
	-0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 487
	0.805887f, 0.738934f,
	-0.737381f, -0.072726f, -0.671550f,
	-0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 488
	0.974084f, 0.626371f,
	-0.544819f, -0.117420f, -0.830292f,
	-0.000095f, 1.442952f, -0.078578f,
	28.000000f,
	// 489
	0.974084f, 0.789827f,
	-0.485301f, -0.066813f, -0.871791f,
	0.000000f, 1.539701f, -0.086046f,
	28.000000f,
	// 490
	0.954176f, 0.626371f,
	-0.717198f, -0.143702f, -0.681892f,
	-0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 491
	0.804105f, 0.626371f,
	-0.863094f, -0.099917f, -0.495061f,
	-0.084959f, 1.453978f, 0.006272f,
	28.000000f,
	// 492
	0.954176f, 0.786174f,
	-0.737381f, -0.072726f, -0.671550f,
	-0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 493
	0.804105f, 0.725300f,
	-0.934907f, 0.018797f, -0.354395f,
	-0.073530f, 1.537422f, -0.019451f,
	28.000000f,
	// 494
	0.805887f, 0.738934f,
	0.737381f, -0.072726f, -0.671550f,
	0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 495
	0.974084f, 0.626888f,
	0.544819f, -0.117420f, -0.830292f,
	0.000095f, 1.442952f, -0.078578f,
	28.000000f,
	// 496
	0.974084f, 0.789827f,
	0.485301f, -0.066813f, -0.871791f,
	0.000000f, 1.539701f, -0.086046f,
	28.000000f,
	// 497
	0.805887f, 0.626888f,
	0.717198f, -0.143702f, -0.681892f,
	0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 498
	0.804105f, 0.626888f,
	0.863094f, -0.099917f, -0.495061f,
	0.084959f, 1.453978f, 0.006272f,
	28.000000f,
	// 499
	0.954176f, 0.786174f,
	0.737381f, -0.072726f, -0.671550f,
	0.061312f, 1.536983f, -0.051707f,
	28.000000f,
	// 500
	0.804105f, 0.725300f,
	0.934907f, 0.018797f, -0.354395f,
	0.073530f, 1.537422f, -0.019451f,
	28.000000f,
	// 501
	0.954176f, 0.626888f,
	0.717198f, -0.143702f, -0.681892f,
	0.054456f, 1.440906f, -0.038671f,
	11.000000f,
	// 502
	0.975985f, 0.625854f,
	0.916270f, -0.031830f, -0.399293f,
	0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 503
	0.976029f, 0.667324f,
	0.919825f, -0.038344f, -0.390451f,
	0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 504
	0.811103f, 0.625854f,
	0.920536f, -0.012871f, -0.390446f,
	0.087723f, 1.428398f, -0.019814f,
	28.000000f,
	// 505
	0.809837f, 0.685884f,
	0.922489f, -0.031368f, -0.384748f,
	0.089890f, 1.461361f, -0.015059f,
	28.000000f,
	// 506
	0.974719f, 0.738934f,
	0.922096f, -0.058519f, -0.382510f,
	0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 507
	0.988238f, 0.692314f,
	0.468470f, 0.062373f, -0.881275f,
	-0.012621f, 1.483608f, -0.119185f,
	28.000000f,
	// 508
	0.807153f, 0.625854f,
	0.524421f, 0.108273f, -0.844547f,
	0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 509
	0.983131f, 0.625854f,
	0.449960f, -0.016686f, -0.892893f,
	-0.028412f, 1.433224f, -0.126201f,
	28.000000f,
	// 510
	0.807197f, 0.667324f,
	0.541681f, 0.097701f, -0.834887f,
	0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 511
	0.805887f, 0.738934f,
	0.425834f, 0.144583f, -0.893175f,
	0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 512
	0.986929f, 0.742586f,
	0.336262f, 0.235176f, -0.911932f,
	0.000000f, 1.592732f, -0.086390f,
	28.000000f,
	// 513
	0.976029f, 0.667324f,
	-0.919825f, -0.038343f, -0.390451f,
	-0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 514
	0.809837f, 0.685884f,
	-0.922489f, -0.031368f, -0.384748f,
	-0.089890f, 1.461361f, -0.015059f,
	28.000000f,
	// 515
	0.974719f, 0.738934f,
	-0.922096f, -0.058519f, -0.382510f,
	-0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 516
	0.809837f, 0.624820f,
	-0.920536f, -0.012871f, -0.390446f,
	-0.087723f, 1.428398f, -0.019814f,
	28.000000f,
	// 517
	0.974719f, 0.624820f,
	-0.916270f, -0.031830f, -0.399293f,
	-0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 518
	0.981472f, 0.624820f,
	-0.449960f, -0.016686f, -0.892893f,
	0.028412f, 1.433224f, -0.126201f,
	28.000000f,
	// 519
	0.805887f, 0.624820f,
	-0.524421f, 0.108273f, -0.844547f,
	-0.060930f, 1.425017f, -0.081025f,
	28.000000f,
	// 520
	0.987802f, 0.692314f,
	-0.468470f, 0.062373f, -0.881275f,
	0.012621f, 1.483608f, -0.119185f,
	28.000000f,
	// 521
	0.807197f, 0.667324f,
	-0.541681f, 0.097701f, -0.834887f,
	-0.066407f, 1.457088f, -0.071015f,
	28.000000f,
	// 522
	0.805887f, 0.738934f,
	-0.425834f, 0.144583f, -0.893175f,
	-0.080057f, 1.587885f, -0.058120f,
	28.000000f,
	// 523
	0.987802f, 0.742586f,
	-0.336262f, 0.235176f, -0.911932f,
	0.000000f, 1.592732f, -0.086390f,
	28.000000f,
	// 524
	0.804078f, 0.758057f,
	-0.187599f, -0.282577f, -0.940722f,
	0.060805f, 1.536139f, -0.021605f,
	28.000000f,
	// 525
	0.987435f, 0.735105f,
	-0.182641f, -0.291105f, -0.939095f,
	0.094104f, 1.509346f, -0.020197f,
	28.000000f,
	// 526
	0.804078f, 0.738601f,
	-0.192750f, -0.318344f, -0.928173f,
	0.050344f, 1.486859f, -0.004716f,
	28.000000f,
	// 527
	0.987435f, 0.625411f,
	-0.193350f, -0.329161f, -0.924267f,
	0.085385f, 1.463868f, -0.003859f,
	28.000000f,
	// 528
	0.804078f, 0.625411f,
	-0.210123f, -0.354240f, -0.911242f,
	0.032849f, 1.426416f, 0.022815f,
	28.000000f,
	// 529
	0.804078f, 0.625411f,
	0.210123f, 0.354240f, 0.911242f,
	0.032849f, 1.426416f, 0.022815f,
	28.000000f,
	// 530
	0.987435f, 0.625411f,
	0.193350f, 0.329161f, 0.924267f,
	0.085385f, 1.463868f, -0.003859f,
	28.000000f,
	// 531
	0.804078f, 0.738601f,
	0.192750f, 0.318344f, 0.928173f,
	0.050344f, 1.486859f, -0.004716f,
	28.000000f,
	// 532
	0.987435f, 0.735105f,
	0.182641f, 0.291105f, 0.939095f,
	0.094104f, 1.509346f, -0.020197f,
	28.000000f,
	// 533
	0.804078f, 0.758057f,
	0.187599f, 0.282577f, 0.940722f,
	0.060805f, 1.536139f, -0.021605f,
	28.000000f,
};

//-----------------------------------------------------------------------------
//	_obt@
//-----------------------------------------------------------------------------
static float april_vertex_buf3[] = {
	// 0
	0.314266f, 0.173042f,
	-0.934399f, -0.113060f, -0.337811f,
	0.053708f, 0.247109f, -0.020446f,
	8.000000f,
	// 1
	0.315630f, 0.218354f,
	-0.995609f, -0.091058f, -0.021728f,
	0.036839f, 0.363691f, -0.012803f,
	8.000000f,
	// 2
	0.289763f, 0.218354f,
	-0.732265f, -0.067496f, -0.677667f,
	0.051041f, 0.368993f, -0.043921f,
	8.000000f,
	// 3
	0.248536f, 0.125627f,
	0.019159f, 0.083225f, -0.996347f,
	0.083537f, 0.157490f, -0.042762f,
	8.000000f,
	// 4
	0.323693f, 0.125627f,
	-0.928252f, 0.116086f, -0.353373f,
	0.057889f, 0.157743f, -0.018996f,
	8.000000f,
	// 5
	0.249073f, 0.170350f,
	0.019559f, -0.122775f, -0.992242f,
	0.085440f, 0.241976f, -0.045748f,
	8.000000f,
	// 6
	0.245621f, 0.218354f,
	0.003350f, -0.027368f, -0.999620f,
	0.084713f, 0.375286f, -0.065072f,
	8.000000f,
	// 7
	0.199409f, 0.218354f,
	0.769553f, -0.032085f, -0.637776f,
	0.122102f, 0.374693f, -0.041337f,
	8.000000f,
	// 8
	0.180819f, 0.162103f,
	0.930539f, -0.111472f, -0.348814f,
	0.113843f, 0.222379f, -0.018326f,
	8.000000f,
	// 9
	0.156646f, 0.218354f,
	0.998146f, -0.050224f, -0.034396f,
	0.134251f, 0.371678f, -0.009534f,
	8.000000f,
	// 10
	0.110214f, 0.159108f,
	0.832853f, -0.074901f, 0.548403f,
	0.108507f, 0.210994f, 0.016330f,
	8.000000f,
	// 11
	0.118711f, 0.218354f,
	0.768046f, -0.075503f, 0.635928f,
	0.123612f, 0.366334f, 0.021495f,
	8.000000f,
	// 12
	0.080525f, 0.161556f,
	-0.068439f, -0.037757f, 0.996941f,
	0.083946f, 0.216991f, 0.030965f,
	8.000000f,
	// 13
	0.078375f, 0.125627f,
	-0.069368f, 0.269342f, 0.960543f,
	0.083030f, 0.157702f, 0.031208f,
	8.000000f,
	// 14
	0.048215f, 0.166344f,
	-0.849186f, -0.057916f, 0.524909f,
	0.061938f, 0.231817f, 0.013832f,
	8.000000f,
	// 15
	0.044609f, 0.125627f,
	-0.873988f, 0.168691f, 0.455728f,
	0.061889f, 0.156738f, 0.013050f,
	8.000000f,
	// 16
	0.108288f, 0.125627f,
	0.850780f, 0.137087f, 0.507327f,
	0.104676f, 0.157159f, 0.017496f,
	8.000000f,
	// 17
	0.181861f, 0.125627f,
	0.947208f, 0.101711f, -0.304058f,
	0.108260f, 0.156292f, -0.016261f,
	8.000000f,
	// 18
	0.084092f, 0.218354f,
	0.031483f, -0.068380f, 0.997162f,
	0.090091f, 0.362733f, 0.038825f,
	8.000000f,
	// 19
	0.042323f, 0.218354f,
	-0.722933f, -0.089297f, 0.685123f,
	0.051854f, 0.360348f, 0.020225f,
	8.000000f,
	// 20
	0.012449f, 0.218354f,
	-0.995609f, -0.091058f, -0.021728f,
	0.036839f, 0.363691f, -0.012803f,
	8.000000f,
	// 21
	0.011787f, 0.173042f,
	-0.934399f, -0.113060f, -0.337811f,
	0.053708f, 0.247109f, -0.020446f,
	8.000000f,
	// 22
	0.002649f, 0.125627f,
	-0.928252f, 0.116086f, -0.353373f,
	0.057889f, 0.157743f, -0.018996f,
	8.000000f,
	// 23
	0.492011f, 0.497201f,
	0.990618f, 0.132500f, -0.033456f,
	0.118070f, 0.115332f, -0.003993f,
	9.000000f,
	// 24
	0.467991f, 0.476016f,
	0.782294f, 0.374182f, 0.498001f,
	0.106510f, 0.124120f, 0.032237f,
	9.000000f,
	// 25
	0.476018f, 0.460584f,
	0.860718f, 0.442295f, 0.252072f,
	0.115686f, 0.073150f, 0.069960f,
	9.000000f,
	// 26
	0.482806f, 0.428732f,
	0.829080f, 0.253854f, 0.498181f,
	0.122596f, 0.029266f, 0.145379f,
	9.000000f,
	// 27
	0.492298f, 0.439832f,
	0.923398f, -0.383027f, -0.025051f,
	0.128276f, 0.022762f, 0.107770f,
	9.000000f,
	// 28
	0.480196f, 0.441041f,
	0.820954f, 0.501594f, 0.272835f,
	0.126672f, 0.040418f, 0.120239f,
	9.000000f,
	// 29
	0.437165f, 0.465127f,
	0.041143f, 0.726904f, 0.685506f,
	0.083066f, 0.093766f, 0.070427f,
	9.000000f,
	// 30
	0.436470f, 0.484590f,
	-0.069368f, 0.269342f, 0.960543f,
	0.083030f, 0.157702f, 0.031208f,
	8.000000f,
	// 31
	0.459328f, 0.493511f,
	0.850780f, 0.137087f, 0.507327f,
	0.104676f, 0.157159f, 0.017496f,
	8.000000f,
	// 32
	0.473634f, 0.508382f,
	0.947208f, 0.101711f, -0.304058f,
	0.108260f, 0.156292f, -0.016261f,
	8.000000f,
	// 33
	0.494300f, 0.508812f,
	0.774816f, 0.215251f, -0.594413f,
	0.108234f, 0.126019f, -0.031419f,
	9.000000f,
	// 34
	0.486281f, 0.527253f,
	0.019159f, 0.083225f, -0.996347f,
	0.083537f, 0.157490f, -0.042762f,
	8.000000f,
	// 35
	0.464272f, 0.423648f,
	0.451049f, 0.343833f, 0.823610f,
	0.105729f, 0.030295f, 0.162130f,
	9.000000f,
	// 36
	0.432498f, 0.420555f,
	-0.072778f, 0.433710f, 0.898109f,
	0.073088f, 0.034307f, 0.170990f,
	9.000000f,
	// 37
	0.435992f, 0.441295f,
	0.044455f, 0.878083f, 0.476438f,
	0.079827f, 0.049367f, 0.128527f,
	9.000000f,
	// 38
	0.405630f, 0.475669f,
	-0.733589f, 0.449296f, 0.509882f,
	0.060697f, 0.124679f, 0.030709f,
	9.000000f,
	// 39
	0.415193f, 0.493583f,
	-0.873988f, 0.168691f, 0.455728f,
	0.061889f, 0.156738f, 0.013050f,
	8.000000f,
	// 40
	0.511403f, 0.503549f,
	0.786818f, 0.037359f, -0.616053f,
	0.111550f, 0.092653f, -0.041192f,
	9.000000f,
	// 41
	0.508053f, 0.521651f,
	-0.031572f, 0.210301f, -0.977127f,
	0.082797f, 0.126538f, -0.044719f,
	9.000000f,
	// 42
	0.524212f, 0.517235f,
	0.005872f, 0.110582f, -0.993850f,
	0.082797f, 0.093490f, -0.055720f,
	9.000000f,
	// 43
	0.542110f, 0.512498f,
	-0.040073f, -0.094619f, -0.994707f,
	0.080367f, 0.066258f, -0.053214f,
	9.000000f,
	// 44
	0.528844f, 0.496485f,
	0.783807f, -0.158943f, -0.600319f,
	0.106503f, 0.063215f, -0.039987f,
	9.000000f,
	// 45
	0.513901f, 0.476383f,
	0.997902f, -0.041915f, -0.049349f,
	0.117195f, 0.053848f, 0.012914f,
	9.000000f,
	// 46
	0.507583f, 0.460532f,
	0.996916f, 0.049740f, -0.060707f,
	0.116242f, 0.045233f, 0.054658f,
	9.000000f,
	// 47
	0.393258f, 0.460464f,
	-0.889905f, 0.410659f, 0.198565f,
	0.045335f, 0.073838f, 0.073046f,
	9.000000f,
	// 48
	0.378055f, 0.437011f,
	-0.865428f, -0.499258f, -0.042129f,
	0.037698f, 0.022762f, 0.113363f,
	9.000000f,
	// 49
	0.397668f, 0.438708f,
	-0.826702f, 0.486963f, 0.281835f,
	0.037069f, 0.043688f, 0.124536f,
	9.000000f,
	// 50
	0.401530f, 0.422945f,
	-0.696992f, 0.419038f, 0.581901f,
	0.043497f, 0.033720f, 0.154935f,
	9.000000f,
	// 51
	0.395833f, 0.413222f,
	-0.622921f, -0.659015f, 0.421507f,
	0.043947f, 0.022762f, 0.153529f,
	9.000000f,
	// 52
	0.432498f, 0.413563f,
	-0.073230f, -0.728882f, 0.680711f,
	0.073097f, 0.022762f, 0.167955f,
	9.000000f,
	// 53
	0.464272f, 0.417588f,
	0.327723f, -0.759178f, 0.562358f,
	0.105871f, 0.022762f, 0.159330f,
	9.000000f,
	// 54
	0.481788f, 0.422143f,
	0.604620f, -0.726635f, 0.326247f,
	0.121276f, 0.022762f, 0.144699f,
	9.000000f,
	// 55
	0.378269f, 0.490190f,
	-0.984637f, 0.172655f, -0.026087f,
	0.048783f, 0.126943f, -0.006215f,
	9.000000f,
	// 56
	0.400639f, 0.508175f,
	-0.928252f, 0.116086f, -0.353373f,
	0.057889f, 0.157743f, -0.018996f,
	8.000000f,
	// 57
	0.375858f, 0.507490f,
	-0.763609f, 0.234516f, -0.601585f,
	0.057182f, 0.126287f, -0.028846f,
	9.000000f,
	// 58
	0.385674f, 0.526222f,
	0.019159f, 0.083225f, -0.996347f,
	0.083537f, 0.157490f, -0.042762f,
	8.000000f,
	// 59
	0.359849f, 0.502112f,
	-0.828940f, 0.073429f, -0.554497f,
	0.051666f, 0.092620f, -0.039433f,
	9.000000f,
	// 60
	0.366396f, 0.520507f,
	-0.031572f, 0.210301f, -0.977127f,
	0.082797f, 0.126538f, -0.044719f,
	9.000000f,
	// 61
	0.350237f, 0.516090f,
	0.005872f, 0.110582f, -0.993850f,
	0.082797f, 0.093490f, -0.055720f,
	9.000000f,
	// 62
	0.332339f, 0.511353f,
	-0.040073f, -0.094619f, -0.994707f,
	0.080367f, 0.066258f, -0.053214f,
	9.000000f,
	// 63
	0.344583f, 0.496485f,
	-0.895413f, -0.056809f, -0.441598f,
	0.052585f, 0.063215f, -0.037514f,
	9.000000f,
	// 64
	0.357736f, 0.473930f,
	-0.992345f, -0.107978f, -0.059927f,
	0.054042f, 0.055485f, 0.010685f,
	9.000000f,
	// 65
	0.366948f, 0.460438f,
	-0.971801f, -0.181119f, -0.150995f,
	0.053882f, 0.045233f, 0.052351f,
	9.000000f,
	// 66
	0.400403f, 0.528054f,
	-0.622921f, -0.659015f, 0.421507f,
	0.043947f, 0.022762f, 0.153529f,
	9.000000f,
	// 67
	0.399954f, 0.513036f,
	0.327723f, -0.759178f, 0.562358f,
	0.105871f, 0.022762f, 0.159330f,
	9.000000f,
	// 68
	0.396481f, 0.520570f,
	-0.073230f, -0.728882f, 0.680711f,
	0.073097f, 0.022762f, 0.167955f,
	9.000000f,
	// 69
	0.406537f, 0.508570f,
	0.604620f, -0.726635f, 0.326247f,
	0.121276f, 0.022762f, 0.144699f,
	9.000000f,
	// 70
	0.416296f, 0.529437f,
	-0.865428f, -0.499258f, -0.042129f,
	0.037698f, 0.022762f, 0.113363f,
	9.000000f,
	// 71
	0.422002f, 0.508169f,
	0.923398f, -0.383027f, -0.025051f,
	0.128276f, 0.022762f, 0.107770f,
	9.000000f,
	// 72
	0.323270f, 0.439921f,
	0.000005f, -0.996198f, 0.087120f,
	-0.000000f, 0.865520f, 0.009776f,
	1.000000f,
	// 73
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 74
	0.323270f, 0.427207f,
	-0.764476f, -0.635707f, 0.107016f,
	0.008371f, 0.864584f, 0.009658f,
	32.000000f,
	// 75
	0.322180f, 0.373869f,
	-0.997574f, -0.067770f, 0.015923f,
	0.013603f, 0.751134f, 0.009406f,
	7.000000f,
	// 76
	0.282176f, 0.373869f,
	-0.656550f, -0.097235f, -0.747989f,
	0.030769f, 0.755435f, -0.053067f,
	7.000000f,
	// 77
	0.200058f, 0.434942f,
	0.805160f, 0.023644f, -0.592587f,
	0.130992f, 0.876346f, -0.035772f,
	7.000000f,
	// 78
	0.161690f, 0.459498f,
	0.992184f, 0.124682f, 0.004966f,
	0.144544f, 0.913699f, 0.020404f,
	30.000000f,
	// 79
	0.156646f, 0.373869f,
	0.997101f, -0.051658f, -0.055859f,
	0.143621f, 0.760954f, 0.012035f,
	7.000000f,
	// 80
	0.111124f, 0.373869f,
	0.771882f, -0.083707f, 0.630231f,
	0.127748f, 0.754485f, 0.070004f,
	7.000000f,
	// 81
	0.111502f, 0.449324f,
	0.767418f, 0.044009f, 0.639635f,
	0.130703f, 0.885822f, 0.078484f,
	30.000000f,
	// 82
	0.205617f, 0.373869f,
	0.759293f, -0.066362f, -0.647356f,
	0.123072f, 0.762964f, -0.037950f,
	7.000000f,
	// 83
	0.244241f, 0.373869f,
	0.204423f, -0.069226f, -0.976432f,
	0.085447f, 0.760764f, -0.062558f,
	7.000000f,
	// 84
	0.242260f, 0.442506f,
	0.313564f, -0.079046f, -0.946271f,
	0.082859f, 0.873314f, -0.062585f,
	7.000000f,
	// 85
	0.301557f, 0.441406f,
	-0.332980f, -0.366028f, -0.868993f,
	0.019576f, 0.884431f, -0.072782f,
	1.000000f,
	// 86
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 87
	0.000768f, 0.373869f,
	-0.997574f, -0.067770f, 0.015923f,
	0.013603f, 0.751134f, 0.009406f,
	7.000000f,
	// 88
	0.041462f, 0.373869f,
	-0.696682f, -0.100313f, 0.710332f,
	0.034566f, 0.749105f, 0.076049f,
	7.000000f,
	// 89
	0.006865f, 0.426684f,
	-0.764476f, -0.635707f, 0.107016f,
	0.008371f, 0.864584f, 0.009658f,
	32.000000f,
	// 90
	0.076638f, 0.373869f,
	0.094625f, -0.117650f, 0.988537f,
	0.085105f, 0.750337f, 0.090864f,
	7.000000f,
	// 91
	0.073625f, 0.420769f,
	0.008179f, -0.029530f, 0.999530f,
	0.079041f, 0.858605f, 0.100184f,
	31.000000f,
	// 92
	0.033429f, 0.441549f,
	-0.205524f, -0.338494f, 0.918249f,
	0.027055f, 0.899856f, 0.078798f,
	1.000000f,
	// 93
	0.006865f, 0.435783f,
	0.000005f, -0.996198f, 0.087120f,
	-0.000000f, 0.865520f, 0.009776f,
	1.000000f,
	// 94
	0.007127f, 0.446012f,
	0.000000f, -0.692625f, 0.721298f,
	-0.000000f, 0.892416f, 0.083870f,
	1.000000f,
	// 95
	0.033185f, 0.218354f,
	-0.722933f, -0.089297f, 0.685123f,
	0.051854f, 0.360348f, 0.020225f,
	8.000000f,
	// 96
	0.002048f, 0.238483f,
	-0.999449f, -0.032682f, 0.005751f,
	0.034050f, 0.403343f, -0.009989f,
	8.000000f,
	// 97
	0.002048f, 0.218354f,
	-0.995609f, -0.091058f, -0.021728f,
	0.036839f, 0.363691f, -0.012803f,
	8.000000f,
	// 98
	0.116503f, 0.241970f,
	0.719995f, -0.025744f, 0.693502f,
	0.121450f, 0.419600f, 0.029920f,
	8.000000f,
	// 99
	0.156646f, 0.246477f,
	0.997149f, 0.075178f, 0.006497f,
	0.133803f, 0.432513f, -0.003677f,
	8.000000f,
	// 100
	0.156217f, 0.266215f,
	0.988391f, 0.145002f, 0.045368f,
	0.124916f, 0.494791f, 0.003638f,
	8.000000f,
	// 101
	0.116503f, 0.218354f,
	0.768046f, -0.075503f, 0.635928f,
	0.123612f, 0.366334f, 0.021495f,
	8.000000f,
	// 102
	0.078161f, 0.236664f,
	0.000231f, -0.114604f, 0.993411f,
	0.087672f, 0.403293f, 0.042132f,
	8.000000f,
	// 103
	0.082436f, 0.218354f,
	0.031483f, -0.068380f, 0.997162f,
	0.090091f, 0.362733f, 0.038825f,
	8.000000f,
	// 104
	0.033185f, 0.238054f,
	-0.712048f, -0.102124f, 0.694664f,
	0.049775f, 0.398939f, 0.024755f,
	8.000000f,
	// 105
	0.002048f, 0.261224f,
	-0.999441f, 0.033435f, -0.000410f,
	0.036313f, 0.481389f, 0.000434f,
	8.000000f,
	// 106
	0.041462f, 0.262769f,
	-0.778899f, -0.129529f, 0.613627f,
	0.049584f, 0.482076f, 0.033349f,
	8.000000f,
	// 107
	0.002048f, 0.279392f,
	-0.991099f, -0.074383f, -0.110404f,
	0.037712f, 0.528349f, 0.003929f,
	33.000000f,
	// 108
	0.042841f, 0.276768f,
	-0.761569f, -0.190750f, 0.619376f,
	0.048334f, 0.520933f, 0.047351f,
	33.000000f,
	// 109
	0.076638f, 0.262003f,
	-0.025886f, -0.177821f, 0.983722f,
	0.080243f, 0.477759f, 0.050312f,
	8.000000f,
	// 110
	0.002048f, 0.302173f,
	-0.988806f, -0.142646f, -0.043754f,
	0.031112f, 0.566632f, 0.008593f,
	7.000000f,
	// 111
	0.043970f, 0.303150f,
	-0.703559f, -0.108978f, 0.702231f,
	0.044057f, 0.578269f, 0.056220f,
	7.000000f,
	// 112
	0.002048f, 0.317521f,
	-0.994775f, -0.101338f, -0.012365f,
	0.025539f, 0.618057f, 0.007871f,
	7.000000f,
	// 113
	0.041462f, 0.373869f,
	-0.696682f, -0.100313f, 0.710332f,
	0.034566f, 0.749105f, 0.076049f,
	7.000000f,
	// 114
	0.002048f, 0.373869f,
	-0.997574f, -0.067770f, 0.015923f,
	0.013603f, 0.751134f, 0.009406f,
	7.000000f,
	// 115
	0.076638f, 0.275953f,
	0.070268f, -0.217806f, 0.973459f,
	0.079993f, 0.517167f, 0.063387f,
	33.000000f,
	// 116
	0.076638f, 0.291990f,
	0.053144f, -0.110559f, 0.992448f,
	0.080316f, 0.554058f, 0.067825f,
	7.000000f,
	// 117
	0.076638f, 0.307877f,
	0.085034f, -0.071140f, 0.993835f,
	0.083815f, 0.590985f, 0.066891f,
	7.000000f,
	// 118
	0.076638f, 0.373869f,
	0.094625f, -0.117650f, 0.988537f,
	0.085105f, 0.750337f, 0.090864f,
	7.000000f,
	// 119
	0.116503f, 0.373869f,
	0.771882f, -0.083707f, 0.630231f,
	0.127748f, 0.754485f, 0.070004f,
	7.000000f,
	// 120
	0.116503f, 0.304232f,
	0.784215f, -0.152098f, 0.601559f,
	0.118791f, 0.580967f, 0.051581f,
	7.000000f,
	// 121
	0.156646f, 0.321447f,
	0.988433f, -0.103053f, -0.111266f,
	0.133802f, 0.633210f, 0.007856f,
	7.000000f,
	// 122
	0.156217f, 0.302508f,
	0.981461f, -0.144773f, -0.125595f,
	0.124824f, 0.573295f, 0.008129f,
	7.000000f,
	// 123
	0.116503f, 0.276768f,
	0.774520f, -0.136186f, 0.617715f,
	0.106870f, 0.521230f, 0.044219f,
	33.000000f,
	// 124
	0.156646f, 0.373869f,
	0.997101f, -0.051658f, -0.055859f,
	0.143621f, 0.760954f, 0.012035f,
	7.000000f,
	// 125
	0.198087f, 0.373869f,
	0.759293f, -0.066362f, -0.647356f,
	0.123072f, 0.762964f, -0.037950f,
	7.000000f,
	// 126
	0.199176f, 0.318115f,
	0.661270f, -0.113288f, -0.741544f,
	0.112890f, 0.626212f, -0.033083f,
	7.000000f,
	// 127
	0.198087f, 0.302554f,
	0.696065f, -0.116214f, -0.708511f,
	0.108498f, 0.572905f, -0.025185f,
	7.000000f,
	// 128
	0.198087f, 0.281047f,
	0.720508f, 0.066752f, -0.690227f,
	0.105078f, 0.533791f, -0.023510f,
	7.000000f,
	// 129
	0.156217f, 0.279727f,
	0.999498f, 0.016951f, -0.026757f,
	0.120401f, 0.528199f, 0.007091f,
	33.000000f,
	// 130
	0.116503f, 0.262335f,
	0.706085f, 0.003181f, 0.708120f,
	0.110023f, 0.480804f, 0.036594f,
	8.000000f,
	// 131
	0.198087f, 0.268173f,
	0.742295f, 0.224394f, -0.631384f,
	0.111399f, 0.501762f, -0.027335f,
	8.000000f,
	// 132
	0.245621f, 0.282378f,
	0.054757f, 0.067772f, -0.996197f,
	0.079839f, 0.536991f, -0.037262f,
	7.000000f,
	// 133
	0.245621f, 0.304109f,
	0.106041f, -0.119619f, -0.987141f,
	0.080300f, 0.575539f, -0.037474f,
	7.000000f,
	// 134
	0.245621f, 0.318030f,
	0.152361f, -0.118943f, -0.981141f,
	0.080642f, 0.620874f, -0.044375f,
	7.000000f,
	// 135
	0.198087f, 0.250876f,
	0.755145f, 0.137343f, -0.641009f,
	0.119441f, 0.444053f, -0.039729f,
	8.000000f,
	// 136
	0.245621f, 0.253760f,
	0.014317f, 0.171536f, -0.985074f,
	0.084502f, 0.448293f, -0.059557f,
	8.000000f,
	// 137
	0.245621f, 0.269682f,
	0.009536f, 0.227813f, -0.973658f,
	0.081032f, 0.503741f, -0.044064f,
	8.000000f,
	// 138
	0.285350f, 0.317509f,
	-0.589211f, -0.150689f, -0.793803f,
	0.042160f, 0.620138f, -0.042314f,
	7.000000f,
	// 139
	0.285350f, 0.303839f,
	-0.653386f, -0.201580f, -0.729693f,
	0.045247f, 0.572817f, -0.030121f,
	7.000000f,
	// 140
	0.244241f, 0.373869f,
	0.204423f, -0.069226f, -0.976432f,
	0.085447f, 0.760764f, -0.062558f,
	7.000000f,
	// 141
	0.285350f, 0.373869f,
	-0.656550f, -0.097235f, -0.747989f,
	0.030769f, 0.755435f, -0.053067f,
	7.000000f,
	// 142
	0.324062f, 0.317521f,
	-0.994775f, -0.101338f, -0.012365f,
	0.025539f, 0.618057f, 0.007871f,
	7.000000f,
	// 143
	0.324062f, 0.302173f,
	-0.988806f, -0.142646f, -0.043754f,
	0.031112f, 0.566632f, 0.008593f,
	7.000000f,
	// 144
	0.285350f, 0.281961f,
	-0.647670f, -0.016976f, -0.761732f,
	0.053441f, 0.534396f, -0.028103f,
	7.000000f,
	// 145
	0.324062f, 0.373869f,
	-0.997574f, -0.067770f, 0.015923f,
	0.013603f, 0.751134f, 0.009406f,
	7.000000f,
	// 146
	0.324062f, 0.238483f,
	-0.999449f, -0.032682f, 0.005751f,
	0.034050f, 0.403343f, -0.009989f,
	8.000000f,
	// 147
	0.285350f, 0.218354f,
	-0.732265f, -0.067496f, -0.677667f,
	0.051041f, 0.368993f, -0.043921f,
	8.000000f,
	// 148
	0.324062f, 0.218354f,
	-0.995609f, -0.091058f, -0.021728f,
	0.036839f, 0.363691f, -0.012803f,
	8.000000f,
	// 149
	0.285350f, 0.243520f,
	-0.715363f, 0.035728f, -0.697839f,
	0.047798f, 0.418788f, -0.044197f,
	8.000000f,
	// 150
	0.324062f, 0.261224f,
	-0.999441f, 0.033435f, -0.000410f,
	0.036313f, 0.481389f, 0.000434f,
	8.000000f,
	// 151
	0.285350f, 0.265832f,
	-0.717681f, 0.127186f, -0.684659f,
	0.051331f, 0.494716f, -0.030668f,
	8.000000f,
	// 152
	0.324062f, 0.279392f,
	-0.991099f, -0.074383f, -0.110404f,
	0.037712f, 0.528349f, 0.003929f,
	33.000000f,
	// 153
	0.245621f, 0.218354f,
	0.003350f, -0.027368f, -0.999620f,
	0.084713f, 0.375286f, -0.065072f,
	8.000000f,
	// 154
	0.198087f, 0.218354f,
	0.769553f, -0.032085f, -0.637776f,
	0.122102f, 0.374693f, -0.041337f,
	8.000000f,
	// 155
	0.156646f, 0.218354f,
	0.998146f, -0.050224f, -0.034396f,
	0.134251f, 0.371678f, -0.009534f,
	8.000000f,
	// 156
	0.314266f, 0.173042f,
	0.934399f, -0.113060f, -0.337811f,
	-0.053708f, 0.247109f, -0.020446f,
	4.000000f,
	// 157
	0.289763f, 0.218354f,
	0.732265f, -0.067496f, -0.677667f,
	-0.051041f, 0.368993f, -0.043921f,
	4.000000f,
	// 158
	0.315630f, 0.218354f,
	0.995609f, -0.091058f, -0.021728f,
	-0.036839f, 0.363691f, -0.012803f,
	4.000000f,
	// 159
	0.323693f, 0.125627f,
	0.928252f, 0.116086f, -0.353373f,
	-0.057889f, 0.157743f, -0.018996f,
	4.000000f,
	// 160
	0.248536f, 0.125627f,
	-0.019158f, 0.083225f, -0.996347f,
	-0.083537f, 0.157490f, -0.042762f,
	4.000000f,
	// 161
	0.249073f, 0.170350f,
	-0.019559f, -0.122775f, -0.992242f,
	-0.085440f, 0.241977f, -0.045748f,
	4.000000f,
	// 162
	0.245621f, 0.218354f,
	-0.003350f, -0.027368f, -0.999620f,
	-0.084713f, 0.375286f, -0.065072f,
	4.000000f,
	// 163
	0.199409f, 0.218354f,
	-0.769553f, -0.032085f, -0.637776f,
	-0.122102f, 0.374694f, -0.041337f,
	4.000000f,
	// 164
	0.180819f, 0.162103f,
	-0.930539f, -0.111472f, -0.348814f,
	-0.113843f, 0.222379f, -0.018326f,
	4.000000f,
	// 165
	0.156646f, 0.218354f,
	-0.998146f, -0.050224f, -0.034396f,
	-0.134251f, 0.371678f, -0.009534f,
	4.000000f,
	// 166
	0.110214f, 0.159108f,
	-0.832853f, -0.074901f, 0.548403f,
	-0.108507f, 0.210994f, 0.016330f,
	4.000000f,
	// 167
	0.118711f, 0.218354f,
	-0.768046f, -0.075503f, 0.635928f,
	-0.123612f, 0.366334f, 0.021495f,
	4.000000f,
	// 168
	0.080525f, 0.161556f,
	0.068439f, -0.037757f, 0.996941f,
	-0.083946f, 0.216991f, 0.030965f,
	4.000000f,
	// 169
	0.078375f, 0.125627f,
	0.069368f, 0.269341f, 0.960543f,
	-0.083030f, 0.157702f, 0.031208f,
	4.000000f,
	// 170
	0.044609f, 0.125627f,
	0.873988f, 0.168690f, 0.455728f,
	-0.061889f, 0.156738f, 0.013050f,
	4.000000f,
	// 171
	0.048215f, 0.166344f,
	0.849186f, -0.057916f, 0.524909f,
	-0.061938f, 0.231817f, 0.013832f,
	4.000000f,
	// 172
	0.108288f, 0.125627f,
	-0.850780f, 0.137087f, 0.507328f,
	-0.104676f, 0.157159f, 0.017496f,
	4.000000f,
	// 173
	0.181861f, 0.125627f,
	-0.947208f, 0.101710f, -0.304058f,
	-0.108260f, 0.156292f, -0.016261f,
	4.000000f,
	// 174
	0.084092f, 0.218354f,
	-0.031483f, -0.068380f, 0.997162f,
	-0.090091f, 0.362733f, 0.038825f,
	4.000000f,
	// 175
	0.042323f, 0.218354f,
	0.722933f, -0.089297f, 0.685123f,
	-0.051854f, 0.360348f, 0.020225f,
	4.000000f,
	// 176
	0.012449f, 0.218354f,
	0.995609f, -0.091058f, -0.021728f,
	-0.036839f, 0.363691f, -0.012803f,
	4.000000f,
	// 177
	0.011787f, 0.173042f,
	0.934399f, -0.113060f, -0.337811f,
	-0.053708f, 0.247109f, -0.020446f,
	4.000000f,
	// 178
	0.002649f, 0.125627f,
	0.928252f, 0.116086f, -0.353373f,
	-0.057889f, 0.157743f, -0.018996f,
	4.000000f,
	// 179
	0.492011f, 0.497201f,
	-0.990618f, 0.132499f, -0.033456f,
	-0.118070f, 0.115332f, -0.003993f,
	5.000000f,
	// 180
	0.476018f, 0.460584f,
	-0.860718f, 0.442295f, 0.252072f,
	-0.115686f, 0.073150f, 0.069960f,
	5.000000f,
	// 181
	0.467991f, 0.476016f,
	-0.782294f, 0.374181f, 0.498001f,
	-0.106510f, 0.124120f, 0.032237f,
	5.000000f,
	// 182
	0.482806f, 0.428732f,
	-0.829080f, 0.253854f, 0.498181f,
	-0.122596f, 0.029266f, 0.145379f,
	5.000000f,
	// 183
	0.480196f, 0.441041f,
	-0.820954f, 0.501594f, 0.272835f,
	-0.126672f, 0.040418f, 0.120239f,
	5.000000f,
	// 184
	0.492298f, 0.439832f,
	-0.923398f, -0.383027f, -0.025051f,
	-0.128276f, 0.022762f, 0.107770f,
	5.000000f,
	// 185
	0.437165f, 0.465127f,
	-0.041143f, 0.726904f, 0.685506f,
	-0.083066f, 0.093766f, 0.070427f,
	5.000000f,
	// 186
	0.436470f, 0.484590f,
	0.069368f, 0.269341f, 0.960543f,
	-0.083030f, 0.157702f, 0.031208f,
	4.000000f,
	// 187
	0.459328f, 0.493511f,
	-0.850780f, 0.137087f, 0.507328f,
	-0.104676f, 0.157159f, 0.017496f,
	4.000000f,
	// 188
	0.473634f, 0.508382f,
	-0.947208f, 0.101710f, -0.304058f,
	-0.108260f, 0.156292f, -0.016261f,
	4.000000f,
	// 189
	0.494300f, 0.508812f,
	-0.774816f, 0.215251f, -0.594413f,
	-0.108234f, 0.126019f, -0.031419f,
	5.000000f,
	// 190
	0.486281f, 0.527253f,
	-0.019158f, 0.083225f, -0.996347f,
	-0.083537f, 0.157490f, -0.042762f,
	4.000000f,
	// 191
	0.464272f, 0.423648f,
	-0.451049f, 0.343833f, 0.823610f,
	-0.105729f, 0.030295f, 0.162130f,
	5.000000f,
	// 192
	0.432498f, 0.420555f,
	0.072778f, 0.433710f, 0.898109f,
	-0.073088f, 0.034307f, 0.170990f,
	5.000000f,
	// 193
	0.435992f, 0.441295f,
	-0.044455f, 0.878083f, 0.476438f,
	-0.079827f, 0.049367f, 0.128527f,
	5.000000f,
	// 194
	0.405630f, 0.475669f,
	0.733589f, 0.449296f, 0.509882f,
	-0.060697f, 0.124679f, 0.030709f,
	5.000000f,
	// 195
	0.415193f, 0.493583f,
	0.873988f, 0.168690f, 0.455728f,
	-0.061889f, 0.156738f, 0.013050f,
	4.000000f,
	// 196
	0.511403f, 0.503549f,
	-0.786818f, 0.037359f, -0.616053f,
	-0.111550f, 0.092653f, -0.041192f,
	5.000000f,
	// 197
	0.508053f, 0.521651f,
	0.031572f, 0.210301f, -0.977127f,
	-0.082797f, 0.126538f, -0.044719f,
	5.000000f,
	// 198
	0.524212f, 0.517235f,
	-0.005872f, 0.110582f, -0.993850f,
	-0.082797f, 0.093490f, -0.055720f,
	5.000000f,
	// 199
	0.542110f, 0.512498f,
	0.040073f, -0.094619f, -0.994707f,
	-0.080367f, 0.066258f, -0.053214f,
	5.000000f,
	// 200
	0.528844f, 0.496485f,
	-0.783807f, -0.158943f, -0.600319f,
	-0.106503f, 0.063215f, -0.039987f,
	5.000000f,
	// 201
	0.513901f, 0.476383f,
	-0.997902f, -0.041915f, -0.049349f,
	-0.117195f, 0.053848f, 0.012914f,
	5.000000f,
	// 202
	0.507583f, 0.460532f,
	-0.996916f, 0.049740f, -0.060707f,
	-0.116242f, 0.045233f, 0.054658f,
	5.000000f,
	// 203
	0.393258f, 0.460464f,
	0.889905f, 0.410659f, 0.198565f,
	-0.045335f, 0.073838f, 0.073046f,
	5.000000f,
	// 204
	0.397668f, 0.438708f,
	0.826702f, 0.486963f, 0.281835f,
	-0.037069f, 0.043688f, 0.124536f,
	5.000000f,
	// 205
	0.378055f, 0.437011f,
	0.865428f, -0.499258f, -0.042129f,
	-0.037698f, 0.022762f, 0.113363f,
	5.000000f,
	// 206
	0.401530f, 0.422945f,
	0.696992f, 0.419038f, 0.581901f,
	-0.043497f, 0.033720f, 0.154935f,
	5.000000f,
	// 207
	0.395833f, 0.413222f,
	0.622921f, -0.659015f, 0.421507f,
	-0.043947f, 0.022762f, 0.153529f,
	5.000000f,
	// 208
	0.432498f, 0.413563f,
	0.073230f, -0.728882f, 0.680711f,
	-0.073097f, 0.022762f, 0.167955f,
	5.000000f,
	// 209
	0.464272f, 0.417588f,
	-0.327723f, -0.759178f, 0.562358f,
	-0.105871f, 0.022762f, 0.159330f,
	5.000000f,
	// 210
	0.481788f, 0.422143f,
	-0.604620f, -0.726635f, 0.326247f,
	-0.121276f, 0.022762f, 0.144699f,
	5.000000f,
	// 211
	0.378269f, 0.490190f,
	0.984637f, 0.172654f, -0.026087f,
	-0.048783f, 0.126943f, -0.006215f,
	5.000000f,
	// 212
	0.400639f, 0.508175f,
	0.928252f, 0.116086f, -0.353373f,
	-0.057889f, 0.157743f, -0.018996f,
	4.000000f,
	// 213
	0.375858f, 0.507490f,
	0.763609f, 0.234515f, -0.601585f,
	-0.057182f, 0.126287f, -0.028846f,
	5.000000f,
	// 214
	0.385674f, 0.526222f,
	-0.019158f, 0.083225f, -0.996347f,
	-0.083537f, 0.157490f, -0.042762f,
	4.000000f,
	// 215
	0.359849f, 0.502112f,
	0.828940f, 0.073429f, -0.554497f,
	-0.051666f, 0.092620f, -0.039433f,
	5.000000f,
	// 216
	0.366396f, 0.520507f,
	0.031572f, 0.210301f, -0.977127f,
	-0.082797f, 0.126538f, -0.044719f,
	5.000000f,
	// 217
	0.350237f, 0.516090f,
	-0.005872f, 0.110582f, -0.993850f,
	-0.082797f, 0.093490f, -0.055720f,
	5.000000f,
	// 218
	0.332339f, 0.511353f,
	0.040073f, -0.094619f, -0.994707f,
	-0.080367f, 0.066258f, -0.053214f,
	5.000000f,
	// 219
	0.344583f, 0.496485f,
	0.895413f, -0.056809f, -0.441598f,
	-0.052585f, 0.063215f, -0.037514f,
	5.000000f,
	// 220
	0.357736f, 0.473930f,
	0.992345f, -0.107978f, -0.059927f,
	-0.054042f, 0.055485f, 0.010685f,
	5.000000f,
	// 221
	0.366948f, 0.460438f,
	0.971801f, -0.181119f, -0.150995f,
	-0.053882f, 0.045233f, 0.052351f,
	5.000000f,
	// 222
	0.400403f, 0.528054f,
	0.622921f, -0.659015f, 0.421507f,
	-0.043947f, 0.022762f, 0.153529f,
	5.000000f,
	// 223
	0.396481f, 0.520570f,
	0.073230f, -0.728882f, 0.680711f,
	-0.073097f, 0.022762f, 0.167955f,
	5.000000f,
	// 224
	0.399954f, 0.513036f,
	-0.327723f, -0.759178f, 0.562358f,
	-0.105871f, 0.022762f, 0.159330f,
	5.000000f,
	// 225
	0.406537f, 0.508570f,
	-0.604620f, -0.726635f, 0.326247f,
	-0.121276f, 0.022762f, 0.144699f,
	5.000000f,
	// 226
	0.416296f, 0.529437f,
	0.865428f, -0.499258f, -0.042129f,
	-0.037698f, 0.022762f, 0.113363f,
	5.000000f,
	// 227
	0.422002f, 0.508169f,
	-0.923398f, -0.383027f, -0.025051f,
	-0.128276f, 0.022762f, 0.107770f,
	5.000000f,
	// 228
	0.323270f, 0.439921f,
	0.000005f, -0.996198f, 0.087120f,
	-0.000000f, 0.865520f, 0.009776f,
	1.000000f,
	// 229
	0.323270f, 0.427207f,
	0.764480f, -0.635702f, 0.107016f,
	-0.008371f, 0.864584f, 0.009658f,
	35.000000f,
	// 230
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 231
	0.322180f, 0.373869f,
	0.997574f, -0.067770f, 0.015923f,
	-0.013603f, 0.751134f, 0.009406f,
	3.000000f,
	// 232
	0.282176f, 0.373869f,
	0.656550f, -0.097235f, -0.747989f,
	-0.030769f, 0.755435f, -0.053067f,
	3.000000f,
	// 233
	0.200058f, 0.434942f,
	-0.805160f, 0.023644f, -0.592587f,
	-0.130992f, 0.876346f, -0.035772f,
	3.000000f,
	// 234
	0.156646f, 0.373869f,
	-0.997101f, -0.051658f, -0.055859f,
	-0.143621f, 0.760954f, 0.012035f,
	3.000000f,
	// 235
	0.161690f, 0.459498f,
	-0.992184f, 0.124682f, 0.004965f,
	-0.144544f, 0.913699f, 0.020404f,
	36.000000f,
	// 236
	0.111124f, 0.373869f,
	-0.771882f, -0.083707f, 0.630231f,
	-0.127748f, 0.754485f, 0.070004f,
	3.000000f,
	// 237
	0.111502f, 0.449324f,
	-0.767418f, 0.044009f, 0.639635f,
	-0.130703f, 0.885822f, 0.078484f,
	36.000000f,
	// 238
	0.205617f, 0.373869f,
	-0.759293f, -0.066362f, -0.647356f,
	-0.123072f, 0.762964f, -0.037950f,
	3.000000f,
	// 239
	0.244241f, 0.373869f,
	-0.204423f, -0.069226f, -0.976432f,
	-0.085447f, 0.760764f, -0.062558f,
	3.000000f,
	// 240
	0.242260f, 0.442506f,
	-0.313564f, -0.079045f, -0.946271f,
	-0.082859f, 0.873314f, -0.062585f,
	3.000000f,
	// 241
	0.301557f, 0.441406f,
	0.332980f, -0.366028f, -0.868993f,
	-0.019576f, 0.884431f, -0.072782f,
	1.000000f,
	// 242
	0.323457f, 0.450581f,
	0.000001f, -0.868876f, -0.495029f,
	0.000000f, 0.886002f, -0.056259f,
	1.000000f,
	// 243
	0.000768f, 0.373869f,
	0.997574f, -0.067770f, 0.015923f,
	-0.013603f, 0.751134f, 0.009406f,
	3.000000f,
	// 244
	0.006865f, 0.426684f,
	0.764480f, -0.635702f, 0.107016f,
	-0.008371f, 0.864584f, 0.009658f,
	35.000000f,
	// 245
	0.041462f, 0.373869f,
	0.696682f, -0.100313f, 0.710332f,
	-0.034566f, 0.749105f, 0.076049f,
	3.000000f,
	// 246
	0.076638f, 0.373869f,
	-0.094625f, -0.117650f, 0.988537f,
	-0.085105f, 0.750337f, 0.090864f,
	3.000000f,
	// 247
	0.073625f, 0.420769f,
	-0.008179f, -0.029530f, 0.999530f,
	-0.079041f, 0.858605f, 0.100184f,
	37.000000f,
	// 248
	0.033429f, 0.441549f,
	0.205524f, -0.338494f, 0.918249f,
	-0.027055f, 0.899856f, 0.078798f,
	1.000000f,
	// 249
	0.006865f, 0.435783f,
	0.000005f, -0.996198f, 0.087120f,
	-0.000000f, 0.865520f, 0.009776f,
	1.000000f,
	// 250
	0.007127f, 0.446012f,
	0.000000f, -0.692625f, 0.721298f,
	-0.000000f, 0.892416f, 0.083870f,
	1.000000f,
	// 251
	0.033185f, 0.218354f,
	0.722933f, -0.089297f, 0.685123f,
	-0.051854f, 0.360348f, 0.020225f,
	4.000000f,
	// 252
	0.002048f, 0.218354f,
	0.995609f, -0.091058f, -0.021728f,
	-0.036839f, 0.363691f, -0.012803f,
	4.000000f,
	// 253
	0.002048f, 0.238483f,
	0.999449f, -0.032682f, 0.005751f,
	-0.034050f, 0.403343f, -0.009989f,
	4.000000f,
	// 254
	0.116503f, 0.241970f,
	-0.719995f, -0.025744f, 0.693502f,
	-0.121450f, 0.419600f, 0.029920f,
	4.000000f,
	// 255
	0.156217f, 0.266215f,
	-0.988391f, 0.145002f, 0.045368f,
	-0.124916f, 0.494791f, 0.003638f,
	4.000000f,
	// 256
	0.156646f, 0.246477f,
	-0.997149f, 0.075178f, 0.006497f,
	-0.133803f, 0.432513f, -0.003677f,
	4.000000f,
	// 257
	0.116503f, 0.218354f,
	-0.768046f, -0.075503f, 0.635928f,
	-0.123612f, 0.366334f, 0.021495f,
	4.000000f,
	// 258
	0.078161f, 0.236664f,
	-0.000231f, -0.114604f, 0.993411f,
	-0.087672f, 0.403293f, 0.042132f,
	4.000000f,
	// 259
	0.082436f, 0.218354f,
	-0.031483f, -0.068380f, 0.997162f,
	-0.090091f, 0.362733f, 0.038825f,
	4.000000f,
	// 260
	0.033185f, 0.238054f,
	0.712048f, -0.102124f, 0.694664f,
	-0.049775f, 0.398940f, 0.024755f,
	4.000000f,
	// 261
	0.002048f, 0.261224f,
	0.999441f, 0.033435f, -0.000409f,
	-0.036313f, 0.481389f, 0.000434f,
	4.000000f,
	// 262
	0.041462f, 0.262769f,
	0.778899f, -0.129530f, 0.613627f,
	-0.049584f, 0.482076f, 0.033349f,
	4.000000f,
	// 263
	0.002048f, 0.279392f,
	0.991099f, -0.074383f, -0.110404f,
	-0.037712f, 0.528349f, 0.003929f,
	38.000000f,
	// 264
	0.042841f, 0.276768f,
	0.761569f, -0.190751f, 0.619376f,
	-0.048334f, 0.520933f, 0.047351f,
	38.000000f,
	// 265
	0.076638f, 0.262003f,
	0.025886f, -0.177822f, 0.983722f,
	-0.080243f, 0.477759f, 0.050312f,
	4.000000f,
	// 266
	0.002048f, 0.302173f,
	0.988806f, -0.142646f, -0.043754f,
	-0.031112f, 0.566632f, 0.008593f,
	3.000000f,
	// 267
	0.043970f, 0.303150f,
	0.703559f, -0.108978f, 0.702231f,
	-0.044057f, 0.578269f, 0.056220f,
	3.000000f,
	// 268
	0.002048f, 0.317521f,
	0.994775f, -0.101338f, -0.012365f,
	-0.025539f, 0.618057f, 0.007871f,
	3.000000f,
	// 269
	0.041462f, 0.373869f,
	0.696682f, -0.100313f, 0.710332f,
	-0.034566f, 0.749105f, 0.076049f,
	3.000000f,
	// 270
	0.002048f, 0.373869f,
	0.997574f, -0.067770f, 0.015923f,
	-0.013603f, 0.751134f, 0.009406f,
	3.000000f,
	// 271
	0.076638f, 0.275953f,
	-0.070269f, -0.217806f, 0.973459f,
	-0.079993f, 0.517167f, 0.063387f,
	38.000000f,
	// 272
	0.076638f, 0.291990f,
	-0.053144f, -0.110559f, 0.992448f,
	-0.080316f, 0.554058f, 0.067825f,
	3.000000f,
	// 273
	0.076638f, 0.307877f,
	-0.085034f, -0.071140f, 0.993835f,
	-0.083815f, 0.590985f, 0.066891f,
	3.000000f,
	// 274
	0.076638f, 0.373869f,
	-0.094625f, -0.117650f, 0.988537f,
	-0.085105f, 0.750337f, 0.090864f,
	3.000000f,
	// 275
	0.116503f, 0.373869f,
	-0.771882f, -0.083707f, 0.630231f,
	-0.127748f, 0.754485f, 0.070004f,
	3.000000f,
	// 276
	0.116503f, 0.304232f,
	-0.784215f, -0.152098f, 0.601559f,
	-0.118791f, 0.580967f, 0.051581f,
	3.000000f,
	// 277
	0.156646f, 0.321447f,
	-0.988433f, -0.103053f, -0.111266f,
	-0.133802f, 0.633210f, 0.007856f,
	3.000000f,
	// 278
	0.156217f, 0.302508f,
	-0.981461f, -0.144773f, -0.125595f,
	-0.124824f, 0.573295f, 0.008129f,
	3.000000f,
	// 279
	0.116503f, 0.276768f,
	-0.774520f, -0.136187f, 0.617715f,
	-0.106870f, 0.521230f, 0.044219f,
	38.000000f,
	// 280
	0.156646f, 0.373869f,
	-0.997101f, -0.051658f, -0.055859f,
	-0.143621f, 0.760954f, 0.012035f,
	3.000000f,
	// 281
	0.198087f, 0.373869f,
	-0.759293f, -0.066362f, -0.647356f,
	-0.123072f, 0.762964f, -0.037950f,
	3.000000f,
	// 282
	0.199176f, 0.318115f,
	-0.661270f, -0.113288f, -0.741544f,
	-0.112890f, 0.626211f, -0.033083f,
	3.000000f,
	// 283
	0.198087f, 0.302554f,
	-0.696065f, -0.116214f, -0.708511f,
	-0.108498f, 0.572905f, -0.025185f,
	3.000000f,
	// 284
	0.198087f, 0.281047f,
	-0.720508f, 0.066753f, -0.690227f,
	-0.105078f, 0.533791f, -0.023510f,
	3.000000f,
	// 285
	0.156217f, 0.279727f,
	-0.999498f, 0.016951f, -0.026757f,
	-0.120401f, 0.528199f, 0.007091f,
	38.000000f,
	// 286
	0.116503f, 0.262335f,
	-0.706085f, 0.003181f, 0.708120f,
	-0.110023f, 0.480804f, 0.036594f,
	4.000000f,
	// 287
	0.198087f, 0.268173f,
	-0.742295f, 0.224394f, -0.631384f,
	-0.111399f, 0.501762f, -0.027335f,
	4.000000f,
	// 288
	0.245621f, 0.282378f,
	-0.054757f, 0.067773f, -0.996197f,
	-0.079839f, 0.536991f, -0.037262f,
	3.000000f,
	// 289
	0.245621f, 0.304109f,
	-0.106041f, -0.119619f, -0.987141f,
	-0.080300f, 0.575539f, -0.037474f,
	3.000000f,
	// 290
	0.245621f, 0.318030f,
	-0.152361f, -0.118943f, -0.981141f,
	-0.080642f, 0.620874f, -0.044375f,
	3.000000f,
	// 291
	0.198087f, 0.250876f,
	-0.755145f, 0.137343f, -0.641009f,
	-0.119441f, 0.444053f, -0.039729f,
	4.000000f,
	// 292
	0.245621f, 0.253760f,
	-0.014317f, 0.171536f, -0.985074f,
	-0.084502f, 0.448293f, -0.059557f,
	4.000000f,
	// 293
	0.245621f, 0.269682f,
	-0.009536f, 0.227814f, -0.973658f,
	-0.081032f, 0.503741f, -0.044064f,
	4.000000f,
	// 294
	0.285350f, 0.317509f,
	0.589211f, -0.150689f, -0.793803f,
	-0.042160f, 0.620138f, -0.042314f,
	3.000000f,
	// 295
	0.285350f, 0.303839f,
	0.653386f, -0.201580f, -0.729693f,
	-0.045247f, 0.572817f, -0.030121f,
	3.000000f,
	// 296
	0.244241f, 0.373869f,
	-0.204423f, -0.069226f, -0.976432f,
	-0.085447f, 0.760764f, -0.062558f,
	3.000000f,
	// 297
	0.285350f, 0.373869f,
	0.656550f, -0.097235f, -0.747989f,
	-0.030769f, 0.755435f, -0.053067f,
	3.000000f,
	// 298
	0.324062f, 0.317521f,
	0.994775f, -0.101338f, -0.012365f,
	-0.025539f, 0.618057f, 0.007871f,
	3.000000f,
	// 299
	0.324062f, 0.302173f,
	0.988806f, -0.142646f, -0.043754f,
	-0.031112f, 0.566632f, 0.008593f,
	3.000000f,
	// 300
	0.285350f, 0.281961f,
	0.647670f, -0.016975f, -0.761732f,
	-0.053441f, 0.534396f, -0.028103f,
	3.000000f,
	// 301
	0.324062f, 0.373869f,
	0.997574f, -0.067770f, 0.015923f,
	-0.013603f, 0.751134f, 0.009406f,
	3.000000f,
	// 302
	0.324062f, 0.238483f,
	0.999449f, -0.032682f, 0.005751f,
	-0.034050f, 0.403343f, -0.009989f,
	4.000000f,
	// 303
	0.324062f, 0.218354f,
	0.995609f, -0.091058f, -0.021728f,
	-0.036839f, 0.363691f, -0.012803f,
	4.000000f,
	// 304
	0.285350f, 0.218354f,
	0.732265f, -0.067496f, -0.677667f,
	-0.051041f, 0.368993f, -0.043921f,
	4.000000f,
	// 305
	0.285350f, 0.243520f,
	0.715363f, 0.035728f, -0.697839f,
	-0.047798f, 0.418788f, -0.044197f,
	4.000000f,
	// 306
	0.324062f, 0.261224f,
	0.999441f, 0.033435f, -0.000409f,
	-0.036313f, 0.481389f, 0.000434f,
	4.000000f,
	// 307
	0.285350f, 0.265832f,
	0.717681f, 0.127186f, -0.684659f,
	-0.051331f, 0.494716f, -0.030668f,
	4.000000f,
	// 308
	0.324062f, 0.279392f,
	0.991099f, -0.074383f, -0.110404f,
	-0.037712f, 0.528349f, 0.003929f,
	38.000000f,
	// 309
	0.245621f, 0.218354f,
	-0.003350f, -0.027368f, -0.999620f,
	-0.084713f, 0.375286f, -0.065072f,
	4.000000f,
	// 310
	0.198087f, 0.218354f,
	-0.769553f, -0.032085f, -0.637776f,
	-0.122102f, 0.374694f, -0.041337f,
	4.000000f,
	// 311
	0.156646f, 0.218354f,
	-0.998146f, -0.050224f, -0.034396f,
	-0.134251f, 0.371678f, -0.009534f,
	4.000000f,
};

//-----------------------------------------------------------------------------
//	CfbNXobt@(gCAOXg)
//-----------------------------------------------------------------------------
static int april_index_buf0[] = {
	// 0
	0, 1, 2,
	// 1
	3, 4, 5,
	// 2
	4, 3, 6,
	// 3
	7, 0, 8,
	// 4
	2, 8, 0,
	// 5
	9, 8, 2,
	// 6
	10, 8, 9,
	// 7
	11, 8, 10,
	// 8
	8, 12, 7,
	// 9
	6, 7, 12,
	// 10
	8, 11, 12,
	// 11
	13, 12, 11,
	// 12
	14, 12, 13,
	// 13
	12, 14, 6,
	// 14
	4, 6, 14,
	// 15
	15, 16, 17,
	// 16
	18, 17, 16,
	// 17
	18, 19, 17,
	// 18
	17, 19, 20,
	// 19
	20, 19, 21,
	// 20
	21, 19, 22,
	// 21
	22, 19, 23,
	// 22
	24, 25, 26,
	// 23
	27, 24, 28,
	// 24
	26, 28, 24,
	// 25
	28, 26, 29,
	// 26
	30, 31, 32,
	// 27
	32, 31, 33,
	// 28
	29, 33, 31,
	// 29
	34, 35, 36,
	// 30
	37, 36, 35,
	// 31
	38, 36, 37,
	// 32
	36, 38, 39,
	// 33
	27, 39, 38,
	// 34
	39, 27, 40,
	// 35
	28, 40, 27,
	// 36
	40, 28, 31,
	// 37
	31, 28, 29,
	// 38
	30, 40, 31,
	// 39
	40, 30, 39,
	// 40
	41, 39, 30,
	// 41
	39, 41, 36,
	// 42
	42, 36, 41,
	// 43
	43, 36, 42,
	// 44
	36, 43, 34,
	// 45
	44, 34, 43,
	// 46
	45, 34, 44,
	// 47
	46, 34, 45,
	// 48
	34, 46, 35,
	// 49
	47, 35, 46,
	// 50
	48, 35, 47,
	// 51
	35, 48, 37,
	// 52
	49, 37, 48,
	// 53
	50, 37, 49,
	// 54
	37, 50, 38,
	// 55
	51, 38, 50,
	// 56
	38, 51, 27,
	// 57
	24, 27, 51,
	// 58
	52, 53, 54,
	// 59
	55, 56, 57,
	// 60
	58, 56, 55,
	// 61
	56, 58, 59,
	// 62
	60, 59, 58,
	// 63
	59, 60, 61,
	// 64
	53, 61, 60,
	// 65
	61, 53, 62,
	// 66
	52, 62, 53,
	// 67
	62, 52, 63,
	// 68
	64, 65, 66,
	// 69
	65, 64, 67,
	// 70
	68, 67, 64,
	// 71
	67, 68, 69,
	// 72
	70, 69, 68,
	// 73
	69, 70, 71,
	// 74
	72, 71, 70,
	// 75
	71, 72, 73,
	// 76
	74, 73, 72,
	// 77
	73, 74, 75,
	// 78
	76, 75, 74,
	// 79
	75, 76, 77,
	// 80
	78, 79, 80,
	// 81
	81, 80, 79,
	// 82
	80, 81, 82,
	// 83
	83, 82, 81,
	// 84
	84, 82, 83,
	// 85
	82, 84, 85,
	// 86
	86, 85, 84,
	// 87
	85, 86, 87,
	// 88
	88, 87, 86,
	// 89
	87, 88, 89,
	// 90
	90, 89, 88,
	// 91
	89, 90, 91,
	// 92
	92, 93, 94,
	// 93
	95, 94, 93,
	// 94
	94, 95, 96,
	// 95
	97, 96, 95,
	// 96
	96, 97, 98,
	// 97
	99, 98, 97,
	// 98
	98, 99, 100,
	// 99
	101, 100, 99,
	// 100
	100, 101, 102,
	// 101
	103, 102, 101,
	// 102
	104, 105, 106,
	// 103
	107, 106, 105,
	// 104
	106, 107, 108,
	// 105
	108, 107, 109,
	// 106
	110, 109, 107,
	// 107
	109, 110, 111,
	// 108
	112, 111, 110,
	// 109
	111, 112, 113,
	// 110
	113, 112, 114,
	// 111
	114, 112, 115,
	// 112
	107, 116, 110,
	// 113
	117, 110, 116,
	// 114
	112, 110, 117,
	// 115
	115, 112, 118,
	// 116
	117, 118, 112,
	// 117
	118, 117, 119,
	// 118
	116, 119, 117,
	// 119
	119, 116, 120,
	// 120
	107, 120, 116,
	// 121
	105, 120, 107,
	// 122
	118, 121, 122,
	// 123
	121, 118, 119,
	// 124
	123, 124, 125,
	// 125
	124, 123, 126,
	// 126
	126, 123, 127,
	// 127
	127, 123, 128,
	// 128
	129, 128, 123,
	// 129
	128, 129, 108,
	// 130
	108, 129, 106,
	// 131
	106, 129, 104,
	// 132
	104, 129, 130,
	// 133
	130, 129, 125,
	// 134
	123, 125, 129,
	// 135
	131, 132, 133,
	// 136
	132, 131, 134,
	// 137
	135, 136, 137,
	// 138
	137, 132, 135,
	// 139
	134, 135, 132,
	// 140
	135, 134, 138,
	// 141
	131, 138, 134,
	// 142
	138, 131, 139,
	// 143
	140, 139, 131,
	// 144
	139, 140, 141,
	// 145
	133, 142, 131,
	// 146
	143, 131, 142,
	// 147
	131, 143, 140,
	// 148
	144, 140, 143,
	// 149
	145, 140, 144,
	// 150
	140, 145, 141,
	// 151
	146, 141, 145,
	// 152
	147, 141, 146,
	// 153
	141, 147, 139,
	// 154
	146, 145, 148,
	// 155
	149, 148, 145,
	// 156
	150, 139, 147,
	// 157
	139, 150, 138,
	// 158
	151, 138, 150,
	// 159
	138, 151, 152,
	// 160
	153, 152, 151,
	// 161
	152, 153, 154,
	// 162
	154, 153, 155,
	// 163
	156, 155, 153,
	// 164
	155, 156, 157,
	// 165
	158, 157, 156,
	// 166
	157, 158, 159,
	// 167
	159, 158, 160,
	// 168
	161, 160, 158,
	// 169
	152, 162, 138,
	// 170
	135, 138, 163,
	// 171
	162, 163, 138,
	// 172
	163, 162, 164,
	// 173
	165, 152, 154,
	// 174
	152, 165, 162,
	// 175
	166, 162, 165,
	// 176
	167, 162, 166,
	// 177
	162, 167, 164,
	// 178
	168, 164, 167,
	// 179
	164, 168, 163,
	// 180
	169, 163, 168,
	// 181
	163, 169, 135,
	// 182
	136, 135, 169,
	// 183
	166, 170, 167,
	// 184
	167, 170, 171,
	// 185
	172, 171, 170,
	// 186
	171, 172, 173,
	// 187
	173, 172, 174,
	// 188
	175, 174, 172,
	// 189
	176, 177, 178,
	// 190
	179, 180, 181,
	// 191
	177, 181, 180,
	// 192
	181, 177, 182,
	// 193
	176, 182, 177,
	// 194
	183, 182, 176,
	// 195
	182, 183, 184,
	// 196
	185, 181, 182,
	// 197
	179, 186, 187,
	// 198
	186, 179, 188,
	// 199
	181, 188, 179,
	// 200
	188, 181, 189,
	// 201
	185, 189, 181,
	// 202
	189, 185, 190,
	// 203
	182, 190, 185,
	// 204
	190, 182, 191,
	// 205
	184, 191, 182,
	// 206
	192, 191, 184,
	// 207
	189, 190, 193,
	// 208
	194, 188, 189,
	// 209
	188, 194, 186,
	// 210
	195, 186, 194,
	// 211
	196, 191, 192,
	// 212
	197, 191, 196,
	// 213
	191, 197, 190,
	// 214
	198, 190, 197,
	// 215
	190, 198, 193,
	// 216
	199, 193, 198,
	// 217
	193, 199, 189,
	// 218
	200, 189, 199,
	// 219
	189, 200, 194,
	// 220
	201, 194, 200,
	// 221
	201, 200, 202,
	// 222
	199, 202, 200,
	// 223
	202, 199, 203,
	// 224
	198, 203, 199,
	// 225
	204, 202, 203,
	// 226
	194, 201, 195,
	// 227
	195, 201, 205,
	// 228
	202, 205, 201,
	// 229
	205, 202, 206,
	// 230
	204, 206, 202,
	// 231
	206, 204, 207,
	// 232
	208, 209, 207,
	// 233
	210, 207, 209,
	// 234
	207, 210, 206,
	// 235
	211, 206, 210,
	// 236
	206, 211, 205,
	// 237
	212, 205, 211,
	// 238
	205, 212, 195,
	// 239
	213, 195, 212,
	// 240
	187, 195, 213,
	// 241
	195, 187, 186,
	// 242
	214, 210, 209,
	// 243
	210, 214, 211,
	// 244
	215, 211, 214,
	// 245
	211, 215, 216,
	// 246
	212, 217, 213,
	// 247
	217, 212, 218,
	// 248
	211, 218, 212,
	// 249
	216, 218, 211,
	// 250
	218, 216, 219,
	// 251
	220, 221, 222,
	// 252
	223, 222, 221,
	// 253
	222, 223, 224,
	// 254
	225, 224, 223,
	// 255
	226, 227, 228,
	// 256
	229, 228, 227,
	// 257
	228, 229, 230,
	// 258
	231, 230, 229,
	// 259
	230, 231, 232,
	// 260
	233, 232, 231,
	// 261
	232, 233, 234,
	// 262
	235, 234, 233,
	// 263
	236, 234, 235,
	// 264
	234, 236, 237,
	// 265
	237, 236, 238,
	// 266
	238, 236, 239,
	// 267
	240, 241, 10,
	// 268
	10, 9, 240,
	// 269
	242, 243, 244,
	// 270
	244, 245, 242,
	// 271
	242, 175, 246,
	// 272
	246, 243, 242,
	// 273
	175, 172, 246,
	// 274
	170, 247, 246,
	// 275
	246, 172, 170,
	// 276
	247, 248, 243,
	// 277
	243, 246, 247,
	// 278
	170, 166, 247,
	// 279
	248, 247, 166,
	// 280
	166, 165, 248,
	// 281
	243, 248, 249,
	// 282
	249, 244, 243,
	// 283
	244, 249, 250,
	// 284
	250, 241, 244,
	// 285
	11, 10, 241,
	// 286
	241, 250, 11,
	// 287
	250, 154, 155,
	// 288
	155, 11, 250,
	// 289
	250, 249, 154,
	// 290
	249, 248, 165,
	// 291
	165, 154, 249,
	// 292
	241, 240, 245,
	// 293
	245, 244, 241,
	// 294
	251, 252, 253,
	// 295
	254, 255, 256,
	// 296
	256, 257, 254,
	// 297
	258, 259, 251,
	// 298
	252, 251, 259,
	// 299
	260, 252, 259,
	// 300
	261, 260, 259,
	// 301
	262, 261, 259,
	// 302
	259, 258, 263,
	// 303
	257, 263, 258,
	// 304
	259, 263, 262,
	// 305
	264, 262, 263,
	// 306
	265, 264, 263,
	// 307
	263, 257, 265,
	// 308
	256, 265, 257,
	// 309
	266, 267, 268,
	// 310
	269, 268, 267,
	// 311
	269, 267, 270,
	// 312
	267, 271, 270,
	// 313
	271, 272, 270,
	// 314
	272, 273, 270,
	// 315
	273, 274, 270,
	// 316
	275, 276, 277,
	// 317
	278, 279, 275,
	// 318
	276, 275, 279,
	// 319
	279, 280, 276,
	// 320
	281, 282, 283,
	// 321
	282, 284, 283,
	// 322
	280, 283, 284,
	// 323
	285, 286, 287,
	// 324
	288, 287, 286,
	// 325
	289, 288, 286,
	// 326
	286, 290, 289,
	// 327
	278, 289, 290,
	// 328
	290, 291, 278,
	// 329
	279, 278, 291,
	// 330
	291, 283, 279,
	// 331
	283, 280, 279,
	// 332
	281, 283, 291,
	// 333
	291, 290, 281,
	// 334
	292, 281, 290,
	// 335
	290, 286, 292,
	// 336
	293, 292, 286,
	// 337
	294, 293, 286,
	// 338
	286, 285, 294,
	// 339
	295, 294, 285,
	// 340
	296, 295, 285,
	// 341
	297, 296, 285,
	// 342
	285, 287, 297,
	// 343
	298, 297, 287,
	// 344
	299, 298, 287,
	// 345
	287, 288, 299,
	// 346
	300, 299, 288,
	// 347
	301, 300, 288,
	// 348
	288, 289, 301,
	// 349
	302, 301, 289,
	// 350
	289, 278, 302,
	// 351
	275, 302, 278,
	// 352
	303, 304, 305,
	// 353
	306, 307, 308,
	// 354
	309, 306, 308,
	// 355
	308, 310, 309,
	// 356
	311, 309, 310,
	// 357
	310, 312, 311,
	// 358
	305, 311, 312,
	// 359
	312, 313, 305,
	// 360
	303, 305, 313,
	// 361
	313, 314, 303,
	// 362
	315, 316, 317,
	// 363
	317, 318, 315,
	// 364
	319, 315, 318,
	// 365
	318, 320, 319,
	// 366
	321, 319, 320,
	// 367
	320, 322, 321,
	// 368
	323, 321, 322,
	// 369
	322, 324, 323,
	// 370
	325, 323, 324,
	// 371
	324, 326, 325,
	// 372
	327, 325, 326,
	// 373
	326, 328, 327,
	// 374
	329, 330, 331,
	// 375
	332, 331, 330,
	// 376
	330, 333, 332,
	// 377
	334, 332, 333,
	// 378
	335, 334, 333,
	// 379
	333, 336, 335,
	// 380
	337, 335, 336,
	// 381
	336, 338, 337,
	// 382
	339, 337, 338,
	// 383
	338, 340, 339,
	// 384
	341, 339, 340,
	// 385
	340, 342, 341,
	// 386
	343, 344, 345,
	// 387
	346, 345, 344,
	// 388
	344, 347, 346,
	// 389
	348, 346, 347,
	// 390
	347, 349, 348,
	// 391
	350, 348, 349,
	// 392
	349, 351, 350,
	// 393
	352, 350, 351,
	// 394
	351, 353, 352,
	// 395
	354, 352, 353,
	// 396
	355, 356, 357,
	// 397
	358, 357, 356,
	// 398
	356, 359, 358,
	// 399
	359, 360, 358,
	// 400
	361, 358, 360,
	// 401
	360, 362, 361,
	// 402
	363, 361, 362,
	// 403
	362, 364, 363,
	// 404
	364, 365, 363,
	// 405
	365, 366, 363,
	// 406
	358, 361, 367,
	// 407
	368, 367, 361,
	// 408
	363, 368, 361,
	// 409
	366, 369, 363,
	// 410
	368, 363, 369,
	// 411
	369, 370, 368,
	// 412
	367, 368, 370,
	// 413
	370, 371, 367,
	// 414
	358, 367, 371,
	// 415
	357, 358, 371,
	// 416
	369, 372, 373,
	// 417
	373, 370, 369,
	// 418
	374, 375, 376,
	// 419
	376, 377, 374,
	// 420
	377, 378, 374,
	// 421
	378, 379, 374,
	// 422
	380, 374, 379,
	// 423
	379, 359, 380,
	// 424
	359, 356, 380,
	// 425
	356, 355, 380,
	// 426
	355, 381, 380,
	// 427
	381, 375, 380,
	// 428
	374, 380, 375,
	// 429
	382, 383, 384,
	// 430
	384, 385, 382,
	// 431
	386, 387, 388,
	// 432
	387, 386, 384,
	// 433
	385, 384, 386,
	// 434
	386, 389, 385,
	// 435
	382, 385, 389,
	// 436
	389, 390, 382,
	// 437
	391, 382, 390,
	// 438
	390, 392, 391,
	// 439
	383, 382, 393,
	// 440
	394, 393, 382,
	// 441
	382, 391, 394,
	// 442
	395, 394, 391,
	// 443
	396, 395, 391,
	// 444
	391, 392, 396,
	// 445
	397, 396, 392,
	// 446
	398, 397, 392,
	// 447
	392, 390, 398,
	// 448
	397, 399, 396,
	// 449
	400, 396, 399,
	// 450
	401, 398, 390,
	// 451
	390, 389, 401,
	// 452
	402, 401, 389,
	// 453
	389, 403, 402,
	// 454
	404, 402, 403,
	// 455
	403, 405, 404,
	// 456
	405, 406, 404,
	// 457
	407, 404, 406,
	// 458
	406, 408, 407,
	// 459
	409, 407, 408,
	// 460
	408, 410, 409,
	// 461
	410, 411, 409,
	// 462
	412, 409, 411,
	// 463
	403, 389, 413,
	// 464
	386, 414, 389,
	// 465
	413, 389, 414,
	// 466
	414, 415, 413,
	// 467
	416, 405, 403,
	// 468
	403, 413, 416,
	// 469
	417, 416, 413,
	// 470
	418, 417, 413,
	// 471
	413, 415, 418,
	// 472
	419, 418, 415,
	// 473
	415, 414, 419,
	// 474
	420, 419, 414,
	// 475
	414, 386, 420,
	// 476
	388, 420, 386,
	// 477
	417, 418, 421,
	// 478
	418, 422, 421,
	// 479
	423, 421, 422,
	// 480
	422, 424, 423,
	// 481
	424, 425, 423,
	// 482
	426, 423, 425,
	// 483
	427, 428, 429,
	// 484
	430, 431, 432,
	// 485
	429, 432, 431,
	// 486
	431, 433, 429,
	// 487
	427, 429, 433,
	// 488
	434, 427, 433,
	// 489
	433, 435, 434,
	// 490
	436, 433, 431,
	// 491
	430, 437, 438,
	// 492
	438, 439, 430,
	// 493
	431, 430, 439,
	// 494
	439, 440, 431,
	// 495
	436, 431, 440,
	// 496
	440, 441, 436,
	// 497
	433, 436, 441,
	// 498
	441, 442, 433,
	// 499
	435, 433, 442,
	// 500
	443, 435, 442,
	// 501
	440, 444, 441,
	// 502
	445, 440, 439,
	// 503
	439, 438, 445,
	// 504
	446, 445, 438,
	// 505
	447, 443, 442,
	// 506
	448, 447, 442,
	// 507
	442, 441, 448,
	// 508
	449, 448, 441,
	// 509
	441, 444, 449,
	// 510
	450, 449, 444,
	// 511
	444, 440, 450,
	// 512
	451, 450, 440,
	// 513
	440, 445, 451,
	// 514
	452, 451, 445,
	// 515
	452, 453, 451,
	// 516
	450, 451, 453,
	// 517
	453, 454, 450,
	// 518
	449, 450, 454,
	// 519
	455, 454, 453,
	// 520
	445, 446, 452,
	// 521
	446, 456, 452,
	// 522
	453, 452, 456,
	// 523
	456, 457, 453,
	// 524
	455, 453, 457,
	// 525
	457, 458, 455,
	// 526
	459, 458, 460,
	// 527
	461, 460, 458,
	// 528
	458, 457, 461,
	// 529
	462, 461, 457,
	// 530
	457, 456, 462,
	// 531
	463, 462, 456,
	// 532
	456, 446, 463,
	// 533
	464, 463, 446,
	// 534
	437, 464, 446,
	// 535
	446, 438, 437,
	// 536
	465, 460, 461,
	// 537
	461, 462, 465,
	// 538
	466, 465, 462,
	// 539
	462, 467, 466,
	// 540
	463, 464, 468,
	// 541
	468, 469, 463,
	// 542
	462, 463, 469,
	// 543
	467, 462, 469,
	// 544
	469, 470, 467,
	// 545
	471, 472, 473,
	// 546
	474, 473, 472,
	// 547
	472, 475, 474,
	// 548
	476, 474, 475,
	// 549
	477, 478, 479,
	// 550
	480, 479, 478,
	// 551
	478, 481, 480,
	// 552
	482, 480, 481,
	// 553
	481, 483, 482,
	// 554
	484, 482, 483,
	// 555
	483, 485, 484,
	// 556
	486, 484, 485,
	// 557
	487, 486, 485,
	// 558
	485, 488, 487,
	// 559
	488, 489, 487,
	// 560
	489, 490, 487,
	// 561
	261, 491, 492,
	// 562
	492, 260, 261,
	// 563
	493, 494, 495,
	// 564
	495, 496, 493,
	// 565
	495, 494, 497,
	// 566
	497, 426, 495,
	// 567
	426, 497, 423,
	// 568
	421, 423, 497,
	// 569
	497, 498, 421,
	// 570
	494, 499, 498,
	// 571
	498, 497, 494,
	// 572
	421, 498, 417,
	// 573
	417, 498, 499,
	// 574
	499, 416, 417,
	// 575
	494, 493, 500,
	// 576
	500, 499, 494,
	// 577
	493, 491, 501,
	// 578
	501, 500, 493,
	// 579
	491, 261, 262,
	// 580
	262, 501, 491,
	// 581
	501, 262, 406,
	// 582
	406, 405, 501,
	// 583
	501, 405, 500,
	// 584
	416, 499, 500,
	// 585
	500, 405, 416,
	// 586
	496, 492, 491,
	// 587
	491, 493, 496,
	// 588
	502, 503, 504,
	// 589
	504, 505, 502,
	// 590
	506, 507, 504,
	// 591
	504, 503, 506,
	// 592
	508, 505, 504,
	// 593
	504, 507, 508,
	// 594
	506, 503, 509,
	// 595
	509, 510, 506,
	// 596
	502, 511, 509,
	// 597
	509, 503, 502,
	// 598
	512, 510, 509,
	// 599
	509, 511, 512,
	// 600
	513, 514, 515,
	// 601
	515, 516, 513,
	// 602
	512, 511, 515,
	// 603
	515, 514, 512,
	// 604
	502, 516, 515,
	// 605
	515, 511, 502,
	// 606
	512, 514, 517,
	// 607
	517, 518, 512,
	// 608
	513, 519, 517,
	// 609
	517, 514, 513,
	// 610
	520, 518, 517,
	// 611
	517, 519, 520,
	// 612
	521, 522, 523,
	// 613
	523, 524, 521,
	// 614
	520, 519, 523,
	// 615
	523, 522, 520,
	// 616
	513, 524, 523,
	// 617
	523, 519, 513,
	// 618
	520, 522, 525,
	// 619
	525, 526, 520,
	// 620
	521, 527, 525,
	// 621
	525, 522, 521,
	// 622
	528, 526, 525,
	// 623
	525, 527, 528,
	// 624
	529, 530, 531,
	// 625
	531, 532, 529,
	// 626
	521, 533, 531,
	// 627
	531, 530, 521,
	// 628
	534, 532, 531,
	// 629
	531, 533, 534,
	// 630
	535, 536, 537,
	// 631
	537, 538, 535,
	// 632
	534, 533, 537,
	// 633
	537, 536, 534,
	// 634
	521, 538, 537,
	// 635
	537, 533, 521,
	// 636
	539, 540, 541,
	// 637
	541, 542, 539,
	// 638
	535, 543, 541,
	// 639
	541, 540, 535,
	// 640
	544, 542, 541,
	// 641
	541, 543, 544,
	// 642
	521, 545, 546,
	// 643
	546, 538, 521,
	// 644
	544, 543, 546,
	// 645
	546, 545, 544,
	// 646
	535, 538, 546,
	// 647
	546, 543, 535,
	// 648
	513, 547, 548,
	// 649
	548, 524, 513,
	// 650
	544, 545, 548,
	// 651
	548, 547, 544,
	// 652
	521, 524, 548,
	// 653
	548, 545, 521,
	// 654
	544, 547, 549,
	// 655
	549, 550, 544,
	// 656
	513, 551, 549,
	// 657
	549, 547, 513,
	// 658
	552, 550, 549,
	// 659
	549, 551, 552,
	// 660
	502, 553, 554,
	// 661
	554, 516, 502,
	// 662
	552, 551, 554,
	// 663
	554, 553, 552,
	// 664
	513, 516, 554,
	// 665
	554, 551, 513,
	// 666
	539, 542, 555,
	// 667
	555, 556, 539,
	// 668
	544, 550, 555,
	// 669
	555, 542, 544,
	// 670
	552, 556, 555,
	// 671
	555, 550, 552,
	// 672
	557, 558, 559,
	// 673
	559, 560, 557,
	// 674
	561, 562, 559,
	// 675
	559, 558, 561,
	// 676
	563, 560, 559,
	// 677
	559, 562, 563,
	// 678
	561, 564, 565,
	// 679
	565, 562, 561,
	// 680
	566, 567, 565,
	// 681
	565, 564, 566,
	// 682
	563, 562, 565,
	// 683
	565, 567, 563,
	// 684
	568, 569, 570,
	// 685
	570, 571, 568,
	// 686
	563, 567, 570,
	// 687
	570, 569, 563,
	// 688
	566, 571, 570,
	// 689
	570, 567, 566,
	// 690
	563, 569, 572,
	// 691
	572, 573, 563,
	// 692
	568, 574, 572,
	// 693
	572, 569, 568,
	// 694
	575, 573, 572,
	// 695
	572, 574, 575,
	// 696
	576, 577, 578,
	// 697
	578, 579, 576,
	// 698
	575, 574, 578,
	// 699
	578, 577, 575,
	// 700
	568, 579, 578,
	// 701
	578, 574, 568,
	// 702
	580, 581, 582,
	// 703
	582, 583, 580,
	// 704
	575, 577, 582,
	// 705
	582, 581, 575,
	// 706
	576, 583, 582,
	// 707
	582, 577, 576,
	// 708
	575, 581, 584,
	// 709
	584, 573, 575,
	// 710
	580, 585, 584,
	// 711
	584, 581, 580,
	// 712
	563, 573, 584,
	// 713
	584, 585, 563,
	// 714
	586, 587, 588,
	// 715
	588, 589, 586,
	// 716
	563, 585, 588,
	// 717
	588, 587, 563,
	// 718
	580, 589, 588,
	// 719
	588, 585, 580,
	// 720
	563, 587, 590,
	// 721
	590, 560, 563,
	// 722
	586, 591, 590,
	// 723
	590, 587, 586,
	// 724
	557, 560, 590,
	// 725
	590, 591, 557,
	// 726
	557, 591, 592,
	// 727
	592, 593, 557,
	// 728
	586, 594, 592,
	// 729
	592, 591, 586,
	// 730
	595, 593, 592,
	// 731
	592, 594, 595,
	// 732
	595, 594, 596,
	// 733
	596, 597, 595,
	// 734
	586, 598, 596,
	// 735
	596, 594, 586,
	// 736
	599, 597, 596,
	// 737
	596, 598, 599,
	// 738
	600, 601, 602,
	// 739
	602, 603, 600,
	// 740
	568, 604, 602,
	// 741
	602, 601, 568,
	// 742
	605, 603, 602,
	// 743
	602, 604, 605,
	// 744
	566, 606, 607,
	// 745
	607, 571, 566,
	// 746
	605, 604, 607,
	// 747
	607, 606, 605,
	// 748
	568, 571, 607,
	// 749
	607, 604, 568,
	// 750
	608, 609, 610,
	// 751
	610, 611, 608,
	// 752
	612, 613, 610,
	// 753
	610, 609, 612,
	// 754
	614, 611, 610,
	// 755
	610, 613, 614,
	// 756
	612, 615, 616,
	// 757
	616, 617, 612,
	// 758
	618, 619, 616,
	// 759
	616, 615, 618,
	// 760
	580, 617, 616,
	// 761
	616, 619, 580,
	// 762
	580, 619, 620,
	// 763
	620, 589, 580,
	// 764
	618, 621, 620,
	// 765
	620, 619, 618,
	// 766
	586, 589, 620,
	// 767
	620, 621, 586,
	// 768
	608, 622, 623,
	// 769
	623, 624, 608,
	// 770
	586, 621, 623,
	// 771
	623, 622, 586,
	// 772
	618, 624, 623,
	// 773
	623, 621, 618,
	// 774
	586, 622, 625,
	// 775
	625, 626, 586,
	// 776
	608, 627, 625,
	// 777
	625, 622, 608,
	// 778
	628, 626, 625,
	// 779
	625, 627, 628,
	// 780
	628, 629, 630,
	// 781
	630, 626, 628,
	// 782
	599, 598, 630,
	// 783
	630, 629, 599,
	// 784
	586, 626, 630,
	// 785
	630, 598, 586,
	// 786
	631, 632, 633,
	// 787
	633, 634, 631,
	// 788
	635, 636, 633,
	// 789
	633, 632, 635,
	// 790
	637, 634, 633,
	// 791
	633, 636, 637,
	// 792
	635, 632, 638,
	// 793
	638, 639, 635,
	// 794
	631, 640, 638,
	// 795
	638, 632, 631,
	// 796
	520, 639, 638,
	// 797
	638, 640, 520,
	// 798
	520, 640, 641,
	// 799
	641, 518, 520,
	// 800
	631, 642, 641,
	// 801
	641, 640, 631,
	// 802
	512, 518, 641,
	// 803
	641, 642, 512,
	// 804
	637, 643, 644,
	// 805
	644, 634, 637,
	// 806
	512, 642, 644,
	// 807
	644, 643, 512,
	// 808
	631, 634, 644,
	// 809
	644, 642, 631,
	// 810
	512, 643, 645,
	// 811
	645, 510, 512,
	// 812
	637, 646, 645,
	// 813
	645, 643, 637,
	// 814
	506, 510, 645,
	// 815
	645, 646, 506,
	// 816
	506, 646, 647,
	// 817
	647, 648, 506,
	// 818
	637, 649, 647,
	// 819
	647, 646, 637,
	// 820
	650, 648, 647,
	// 821
	647, 649, 650,
	// 822
	651, 652, 653,
	// 823
	653, 654, 651,
	// 824
	650, 649, 653,
	// 825
	653, 652, 650,
	// 826
	637, 654, 653,
	// 827
	653, 649, 637,
	// 828
	528, 655, 656,
	// 829
	656, 526, 528,
	// 830
	657, 658, 656,
	// 831
	656, 655, 657,
	// 832
	520, 526, 656,
	// 833
	656, 658, 520,
	// 834
	528, 527, 659,
	// 835
	659, 660, 528,
	// 836
	521, 530, 659,
	// 837
	659, 527, 521,
	// 838
	529, 660, 659,
	// 839
	659, 530, 529,
	// 840
	635, 661, 662,
	// 841
	662, 636, 635,
	// 842
	663, 664, 662,
	// 843
	662, 661, 663,
	// 844
	637, 636, 662,
	// 845
	662, 664, 637,
	// 846
	600, 665, 666,
	// 847
	666, 601, 600,
	// 848
	667, 668, 666,
	// 849
	666, 665, 667,
	// 850
	568, 601, 666,
	// 851
	666, 668, 568,
	// 852
	576, 669, 670,
	// 853
	670, 583, 576,
	// 854
	671, 672, 670,
	// 855
	670, 669, 671,
	// 856
	580, 583, 670,
	// 857
	670, 672, 580,
	// 858
	671, 673, 674,
	// 859
	674, 672, 671,
	// 860
	612, 617, 674,
	// 861
	674, 673, 612,
	// 862
	580, 672, 674,
	// 863
	674, 617, 580,
	// 864
	667, 675, 676,
	// 865
	676, 668, 667,
	// 866
	576, 579, 676,
	// 867
	676, 675, 576,
	// 868
	568, 668, 676,
	// 869
	676, 579, 568,
	// 870
	663, 677, 678,
	// 871
	678, 664, 663,
	// 872
	600, 679, 678,
	// 873
	678, 677, 600,
	// 874
	637, 664, 678,
	// 875
	678, 679, 637,
	// 876
	657, 680, 681,
	// 877
	681, 658, 657,
	// 878
	635, 639, 681,
	// 879
	681, 680, 635,
	// 880
	520, 658, 681,
	// 881
	681, 639, 520,
	// 882
	608, 624, 682,
	// 883
	682, 609, 608,
	// 884
	618, 615, 682,
	// 885
	682, 624, 618,
	// 886
	612, 609, 682,
	// 887
	682, 615, 612,
	// 888
	683, 684, 685,
	// 889
	685, 686, 683,
	// 890
	687, 688, 685,
	// 891
	685, 684, 687,
	// 892
	689, 686, 685,
	// 893
	685, 688, 689,
	// 894
	689, 690, 691,
	// 895
	691, 686, 689,
	// 896
	692, 693, 691,
	// 897
	691, 690, 692,
	// 898
	683, 686, 691,
	// 899
	691, 693, 683,
	// 900
	694, 695, 696,
	// 901
	696, 697, 694,
	// 902
	683, 693, 696,
	// 903
	696, 695, 683,
	// 904
	692, 697, 696,
	// 905
	696, 693, 692,
	// 906
	692, 698, 699,
	// 907
	699, 697, 692,
	// 908
	700, 701, 699,
	// 909
	699, 698, 700,
	// 910
	694, 697, 699,
	// 911
	699, 701, 694,
	// 912
	702, 703, 704,
	// 913
	704, 705, 702,
	// 914
	694, 701, 704,
	// 915
	704, 703, 694,
	// 916
	700, 705, 704,
	// 917
	704, 701, 700,
	// 918
	700, 706, 707,
	// 919
	707, 705, 700,
	// 920
	708, 709, 707,
	// 921
	707, 706, 708,
	// 922
	702, 705, 707,
	// 923
	707, 709, 702,
	// 924
	710, 711, 712,
	// 925
	712, 713, 710,
	// 926
	714, 715, 712,
	// 927
	712, 711, 714,
	// 928
	702, 713, 712,
	// 929
	712, 715, 702,
	// 930
	716, 717, 718,
	// 931
	718, 719, 716,
	// 932
	702, 715, 718,
	// 933
	718, 717, 702,
	// 934
	714, 719, 718,
	// 935
	718, 715, 714,
	// 936
	720, 721, 722,
	// 937
	722, 723, 720,
	// 938
	724, 725, 722,
	// 939
	722, 721, 724,
	// 940
	716, 723, 722,
	// 941
	722, 725, 716,
	// 942
	702, 717, 726,
	// 943
	726, 727, 702,
	// 944
	716, 725, 726,
	// 945
	726, 717, 716,
	// 946
	724, 727, 726,
	// 947
	726, 725, 724,
	// 948
	694, 703, 728,
	// 949
	728, 729, 694,
	// 950
	702, 727, 728,
	// 951
	728, 703, 702,
	// 952
	724, 729, 728,
	// 953
	728, 727, 724,
	// 954
	724, 730, 731,
	// 955
	731, 729, 724,
	// 956
	732, 733, 731,
	// 957
	731, 730, 732,
	// 958
	694, 729, 731,
	// 959
	731, 733, 694,
	// 960
	683, 695, 734,
	// 961
	734, 735, 683,
	// 962
	694, 733, 734,
	// 963
	734, 695, 694,
	// 964
	732, 735, 734,
	// 965
	734, 733, 732,
	// 966
	720, 736, 737,
	// 967
	737, 721, 720,
	// 968
	732, 730, 737,
	// 969
	737, 736, 732,
	// 970
	724, 721, 737,
	// 971
	737, 730, 724,
	// 972
	738, 739, 740,
	// 973
	740, 741, 738,
	// 974
	742, 743, 740,
	// 975
	740, 739, 742,
	// 976
	744, 741, 740,
	// 977
	740, 743, 744,
	// 978
	744, 743, 745,
	// 979
	745, 746, 744,
	// 980
	742, 747, 745,
	// 981
	745, 743, 742,
	// 982
	748, 746, 745,
	// 983
	745, 747, 748,
	// 984
	749, 750, 751,
	// 985
	751, 752, 749,
	// 986
	748, 747, 751,
	// 987
	751, 750, 748,
	// 988
	742, 752, 751,
	// 989
	751, 747, 742,
	// 990
	742, 753, 754,
	// 991
	754, 752, 742,
	// 992
	755, 756, 754,
	// 993
	754, 753, 755,
	// 994
	749, 752, 754,
	// 995
	754, 756, 749,
	// 996
	757, 758, 759,
	// 997
	759, 760, 757,
	// 998
	749, 756, 759,
	// 999
	759, 758, 749,
	// 1000
	755, 760, 759,
	// 1001
	759, 756, 755,
	// 1002
	761, 762, 763,
	// 1003
	763, 764, 761,
	// 1004
	757, 760, 763,
	// 1005
	763, 762, 757,
	// 1006
	755, 764, 763,
	// 1007
	763, 760, 755,
	// 1008
	755, 753, 765,
	// 1009
	765, 764, 755,
	// 1010
	742, 766, 765,
	// 1011
	765, 753, 742,
	// 1012
	761, 764, 765,
	// 1013
	765, 766, 761,
	// 1014
	767, 768, 769,
	// 1015
	769, 770, 767,
	// 1016
	761, 766, 769,
	// 1017
	769, 768, 761,
	// 1018
	742, 770, 769,
	// 1019
	769, 766, 742,
	// 1020
	742, 739, 771,
	// 1021
	771, 770, 742,
	// 1022
	738, 772, 771,
	// 1023
	771, 739, 738,
	// 1024
	767, 770, 771,
	// 1025
	771, 772, 767,
	// 1026
	738, 773, 774,
	// 1027
	774, 772, 738,
	// 1028
	775, 776, 774,
	// 1029
	774, 773, 775,
	// 1030
	767, 772, 774,
	// 1031
	774, 776, 767,
	// 1032
	775, 777, 778,
	// 1033
	778, 776, 775,
	// 1034
	779, 780, 778,
	// 1035
	778, 777, 779,
	// 1036
	767, 776, 778,
	// 1037
	778, 780, 767,
	// 1038
	781, 782, 783,
	// 1039
	783, 784, 781,
	// 1040
	785, 786, 783,
	// 1041
	783, 782, 785,
	// 1042
	749, 784, 783,
	// 1043
	783, 786, 749,
	// 1044
	748, 750, 787,
	// 1045
	787, 788, 748,
	// 1046
	749, 786, 787,
	// 1047
	787, 750, 749,
	// 1048
	785, 788, 787,
	// 1049
	787, 786, 785,
	// 1050
	789, 790, 791,
	// 1051
	791, 792, 789,
	// 1052
	793, 794, 791,
	// 1053
	791, 790, 793,
	// 1054
	795, 792, 791,
	// 1055
	791, 794, 795,
	// 1056
	795, 796, 797,
	// 1057
	797, 798, 795,
	// 1058
	761, 799, 797,
	// 1059
	797, 796, 761,
	// 1060
	800, 798, 797,
	// 1061
	797, 799, 800,
	// 1062
	761, 768, 801,
	// 1063
	801, 799, 761,
	// 1064
	767, 802, 801,
	// 1065
	801, 768, 767,
	// 1066
	800, 799, 801,
	// 1067
	801, 802, 800,
	// 1068
	789, 803, 804,
	// 1069
	804, 805, 789,
	// 1070
	800, 802, 804,
	// 1071
	804, 803, 800,
	// 1072
	767, 805, 804,
	// 1073
	804, 802, 767,
	// 1074
	767, 806, 807,
	// 1075
	807, 805, 767,
	// 1076
	808, 809, 807,
	// 1077
	807, 806, 808,
	// 1078
	789, 805, 807,
	// 1079
	807, 809, 789,
	// 1080
	808, 806, 810,
	// 1081
	810, 811, 808,
	// 1082
	767, 780, 810,
	// 1083
	810, 806, 767,
	// 1084
	779, 811, 810,
	// 1085
	810, 780, 779,
	// 1086
	812, 813, 814,
	// 1087
	814, 815, 812,
	// 1088
	816, 817, 814,
	// 1089
	814, 813, 816,
	// 1090
	818, 815, 814,
	// 1091
	814, 817, 818,
	// 1092
	818, 819, 820,
	// 1093
	820, 815, 818,
	// 1094
	700, 821, 820,
	// 1095
	820, 819, 700,
	// 1096
	812, 815, 820,
	// 1097
	820, 821, 812,
	// 1098
	700, 698, 822,
	// 1099
	822, 821, 700,
	// 1100
	692, 823, 822,
	// 1101
	822, 698, 692,
	// 1102
	812, 821, 822,
	// 1103
	822, 823, 812,
	// 1104
	816, 813, 824,
	// 1105
	824, 825, 816,
	// 1106
	812, 823, 824,
	// 1107
	824, 813, 812,
	// 1108
	692, 825, 824,
	// 1109
	824, 823, 692,
	// 1110
	692, 690, 826,
	// 1111
	826, 825, 692,
	// 1112
	689, 827, 826,
	// 1113
	826, 690, 689,
	// 1114
	816, 825, 826,
	// 1115
	826, 827, 816,
	// 1116
	689, 828, 829,
	// 1117
	829, 827, 689,
	// 1118
	830, 831, 829,
	// 1119
	829, 828, 830,
	// 1120
	816, 827, 829,
	// 1121
	829, 831, 816,
	// 1122
	832, 833, 834,
	// 1123
	834, 835, 832,
	// 1124
	816, 831, 834,
	// 1125
	834, 833, 816,
	// 1126
	830, 835, 834,
	// 1127
	834, 831, 830,
	// 1128
	708, 706, 836,
	// 1129
	836, 837, 708,
	// 1130
	700, 838, 836,
	// 1131
	836, 706, 700,
	// 1132
	839, 837, 836,
	// 1133
	836, 838, 839,
	// 1134
	708, 840, 841,
	// 1135
	841, 709, 708,
	// 1136
	710, 713, 841,
	// 1137
	841, 840, 710,
	// 1138
	702, 709, 841,
	// 1139
	841, 713, 702,
	// 1140
	818, 817, 842,
	// 1141
	842, 843, 818,
	// 1142
	816, 844, 842,
	// 1143
	842, 817, 816,
	// 1144
	845, 843, 842,
	// 1145
	842, 844, 845,
	// 1146
	781, 784, 846,
	// 1147
	846, 847, 781,
	// 1148
	749, 848, 846,
	// 1149
	846, 784, 749,
	// 1150
	849, 847, 846,
	// 1151
	846, 848, 849,
	// 1152
	757, 762, 850,
	// 1153
	850, 851, 757,
	// 1154
	761, 852, 850,
	// 1155
	850, 762, 761,
	// 1156
	853, 851, 850,
	// 1157
	850, 852, 853,
	// 1158
	853, 852, 854,
	// 1159
	854, 855, 853,
	// 1160
	761, 796, 854,
	// 1161
	854, 852, 761,
	// 1162
	795, 855, 854,
	// 1163
	854, 796, 795,
	// 1164
	849, 848, 856,
	// 1165
	856, 857, 849,
	// 1166
	749, 758, 856,
	// 1167
	856, 848, 749,
	// 1168
	757, 857, 856,
	// 1169
	856, 758, 757,
	// 1170
	845, 844, 858,
	// 1171
	858, 859, 845,
	// 1172
	816, 860, 858,
	// 1173
	858, 844, 816,
	// 1174
	781, 859, 858,
	// 1175
	858, 860, 781,
	// 1176
	839, 838, 861,
	// 1177
	861, 862, 839,
	// 1178
	700, 819, 861,
	// 1179
	861, 838, 700,
	// 1180
	818, 862, 861,
	// 1181
	861, 819, 818,
	// 1182
	789, 792, 863,
	// 1183
	863, 803, 789,
	// 1184
	795, 798, 863,
	// 1185
	863, 792, 795,
	// 1186
	800, 803, 863,
	// 1187
	863, 798, 800,
	// 1188
	864, 865, 866,
	// 1189
	866, 867, 864,
	// 1190
	868, 867, 866,
	// 1191
	866, 869, 868,
	// 1192
	870, 869, 866,
	// 1193
	866, 865, 870,
	// 1194
	868, 871, 872,
	// 1195
	872, 867, 868,
	// 1196
	864, 867, 872,
	// 1197
	872, 873, 864,
	// 1198
	874, 873, 872,
	// 1199
	872, 871, 874,
	// 1200
	875, 876, 877,
	// 1201
	877, 878, 875,
	// 1202
	874, 878, 877,
	// 1203
	877, 873, 874,
	// 1204
	864, 873, 877,
	// 1205
	877, 876, 864,
	// 1206
	874, 879, 880,
	// 1207
	880, 878, 874,
	// 1208
	875, 878, 880,
	// 1209
	880, 881, 875,
	// 1210
	882, 881, 880,
	// 1211
	880, 879, 882,
	// 1212
	883, 884, 885,
	// 1213
	885, 886, 883,
	// 1214
	882, 886, 885,
	// 1215
	885, 881, 882,
	// 1216
	875, 881, 885,
	// 1217
	885, 884, 875,
	// 1218
	882, 887, 888,
	// 1219
	888, 886, 882,
	// 1220
	883, 886, 888,
	// 1221
	888, 889, 883,
	// 1222
	890, 889, 888,
	// 1223
	888, 887, 890,
	// 1224
	891, 892, 893,
	// 1225
	893, 894, 891,
	// 1226
	883, 894, 893,
	// 1227
	893, 895, 883,
	// 1228
	896, 895, 893,
	// 1229
	893, 892, 896,
	// 1230
	897, 898, 899,
	// 1231
	899, 900, 897,
	// 1232
	896, 900, 899,
	// 1233
	899, 895, 896,
	// 1234
	883, 895, 899,
	// 1235
	899, 898, 883,
	// 1236
	901, 902, 903,
	// 1237
	903, 904, 901,
	// 1238
	897, 904, 903,
	// 1239
	903, 905, 897,
	// 1240
	906, 905, 903,
	// 1241
	903, 902, 906,
	// 1242
	883, 898, 907,
	// 1243
	907, 908, 883,
	// 1244
	906, 908, 907,
	// 1245
	907, 905, 906,
	// 1246
	897, 905, 907,
	// 1247
	907, 898, 897,
	// 1248
	875, 884, 909,
	// 1249
	909, 910, 875,
	// 1250
	906, 910, 909,
	// 1251
	909, 908, 906,
	// 1252
	883, 908, 909,
	// 1253
	909, 884, 883,
	// 1254
	906, 911, 912,
	// 1255
	912, 910, 906,
	// 1256
	875, 910, 912,
	// 1257
	912, 913, 875,
	// 1258
	914, 913, 912,
	// 1259
	912, 911, 914,
	// 1260
	864, 876, 915,
	// 1261
	915, 916, 864,
	// 1262
	914, 916, 915,
	// 1263
	915, 913, 914,
	// 1264
	875, 913, 915,
	// 1265
	915, 876, 875,
	// 1266
	901, 917, 918,
	// 1267
	918, 902, 901,
	// 1268
	906, 902, 918,
	// 1269
	918, 911, 906,
	// 1270
	914, 911, 918,
	// 1271
	918, 917, 914,
	// 1272
	919, 920, 921,
	// 1273
	921, 922, 919,
	// 1274
	923, 922, 921,
	// 1275
	921, 924, 923,
	// 1276
	925, 924, 921,
	// 1277
	921, 920, 925,
	// 1278
	923, 924, 926,
	// 1279
	926, 927, 923,
	// 1280
	928, 927, 926,
	// 1281
	926, 929, 928,
	// 1282
	925, 929, 926,
	// 1283
	926, 924, 925,
	// 1284
	930, 931, 932,
	// 1285
	932, 933, 930,
	// 1286
	925, 933, 932,
	// 1287
	932, 929, 925,
	// 1288
	928, 929, 932,
	// 1289
	932, 931, 928,
	// 1290
	925, 934, 935,
	// 1291
	935, 933, 925,
	// 1292
	930, 933, 935,
	// 1293
	935, 936, 930,
	// 1294
	937, 936, 935,
	// 1295
	935, 934, 937,
	// 1296
	938, 939, 940,
	// 1297
	940, 941, 938,
	// 1298
	937, 941, 940,
	// 1299
	940, 936, 937,
	// 1300
	930, 936, 940,
	// 1301
	940, 939, 930,
	// 1302
	942, 943, 944,
	// 1303
	944, 945, 942,
	// 1304
	937, 945, 944,
	// 1305
	944, 941, 937,
	// 1306
	938, 941, 944,
	// 1307
	944, 943, 938,
	// 1308
	937, 934, 946,
	// 1309
	946, 945, 937,
	// 1310
	942, 945, 946,
	// 1311
	946, 947, 942,
	// 1312
	925, 947, 946,
	// 1313
	946, 934, 925,
	// 1314
	948, 949, 950,
	// 1315
	950, 951, 948,
	// 1316
	925, 951, 950,
	// 1317
	950, 947, 925,
	// 1318
	942, 947, 950,
	// 1319
	950, 949, 942,
	// 1320
	925, 920, 952,
	// 1321
	952, 951, 925,
	// 1322
	948, 951, 952,
	// 1323
	952, 953, 948,
	// 1324
	919, 953, 952,
	// 1325
	952, 920, 919,
	// 1326
	919, 954, 955,
	// 1327
	955, 953, 919,
	// 1328
	948, 953, 955,
	// 1329
	955, 956, 948,
	// 1330
	957, 956, 955,
	// 1331
	955, 954, 957,
	// 1332
	957, 958, 959,
	// 1333
	959, 956, 957,
	// 1334
	948, 956, 959,
	// 1335
	959, 960, 948,
	// 1336
	961, 960, 959,
	// 1337
	959, 958, 961,
	// 1338
	962, 963, 964,
	// 1339
	964, 965, 962,
	// 1340
	930, 965, 964,
	// 1341
	964, 966, 930,
	// 1342
	967, 966, 964,
	// 1343
	964, 963, 967,
	// 1344
	928, 931, 968,
	// 1345
	968, 969, 928,
	// 1346
	967, 969, 968,
	// 1347
	968, 966, 967,
	// 1348
	930, 966, 968,
	// 1349
	968, 931, 930,
	// 1350
	970, 971, 972,
	// 1351
	972, 973, 970,
	// 1352
	974, 973, 972,
	// 1353
	972, 975, 974,
	// 1354
	976, 975, 972,
	// 1355
	972, 971, 976,
	// 1356
	974, 977, 978,
	// 1357
	978, 979, 974,
	// 1358
	980, 979, 978,
	// 1359
	978, 981, 980,
	// 1360
	942, 981, 978,
	// 1361
	978, 977, 942,
	// 1362
	942, 949, 982,
	// 1363
	982, 981, 942,
	// 1364
	980, 981, 982,
	// 1365
	982, 983, 980,
	// 1366
	948, 983, 982,
	// 1367
	982, 949, 948,
	// 1368
	970, 984, 985,
	// 1369
	985, 986, 970,
	// 1370
	948, 986, 985,
	// 1371
	985, 983, 948,
	// 1372
	980, 983, 985,
	// 1373
	985, 984, 980,
	// 1374
	948, 987, 988,
	// 1375
	988, 986, 948,
	// 1376
	970, 986, 988,
	// 1377
	988, 989, 970,
	// 1378
	990, 989, 988,
	// 1379
	988, 987, 990,
	// 1380
	990, 987, 991,
	// 1381
	991, 992, 990,
	// 1382
	961, 992, 991,
	// 1383
	991, 960, 961,
	// 1384
	948, 960, 991,
	// 1385
	991, 987, 948,
	// 1386
	993, 994, 995,
	// 1387
	995, 996, 993,
	// 1388
	997, 996, 995,
	// 1389
	995, 998, 997,
	// 1390
	999, 998, 995,
	// 1391
	995, 994, 999,
	// 1392
	997, 1000, 1001,
	// 1393
	1001, 996, 997,
	// 1394
	993, 996, 1001,
	// 1395
	1001, 1002, 993,
	// 1396
	882, 1002, 1001,
	// 1397
	1001, 1000, 882,
	// 1398
	882, 879, 1003,
	// 1399
	1003, 1002, 882,
	// 1400
	993, 1002, 1003,
	// 1401
	1003, 1004, 993,
	// 1402
	874, 1004, 1003,
	// 1403
	1003, 879, 874,
	// 1404
	999, 994, 1005,
	// 1405
	1005, 1006, 999,
	// 1406
	874, 1006, 1005,
	// 1407
	1005, 1004, 874,
	// 1408
	993, 1004, 1005,
	// 1409
	1005, 994, 993,
	// 1410
	874, 871, 1007,
	// 1411
	1007, 1006, 874,
	// 1412
	999, 1006, 1007,
	// 1413
	1007, 1008, 999,
	// 1414
	868, 1008, 1007,
	// 1415
	1007, 871, 868,
	// 1416
	868, 1009, 1010,
	// 1417
	1010, 1008, 868,
	// 1418
	999, 1008, 1010,
	// 1419
	1010, 1011, 999,
	// 1420
	1012, 1011, 1010,
	// 1421
	1010, 1009, 1012,
	// 1422
	1013, 1014, 1015,
	// 1423
	1015, 1016, 1013,
	// 1424
	1012, 1016, 1015,
	// 1425
	1015, 1011, 1012,
	// 1426
	999, 1011, 1015,
	// 1427
	1015, 1014, 999,
	// 1428
	890, 887, 1017,
	// 1429
	1017, 1018, 890,
	// 1430
	1019, 1018, 1017,
	// 1431
	1017, 1020, 1019,
	// 1432
	882, 1020, 1017,
	// 1433
	1017, 887, 882,
	// 1434
	890, 1021, 1022,
	// 1435
	1022, 889, 890,
	// 1436
	883, 889, 1022,
	// 1437
	1022, 894, 883,
	// 1438
	891, 894, 1022,
	// 1439
	1022, 1021, 891,
	// 1440
	997, 998, 1023,
	// 1441
	1023, 1024, 997,
	// 1442
	1025, 1024, 1023,
	// 1443
	1023, 1026, 1025,
	// 1444
	999, 1026, 1023,
	// 1445
	1023, 998, 999,
	// 1446
	962, 965, 1027,
	// 1447
	1027, 1028, 962,
	// 1448
	1029, 1028, 1027,
	// 1449
	1027, 1030, 1029,
	// 1450
	930, 1030, 1027,
	// 1451
	1027, 965, 930,
	// 1452
	938, 943, 1031,
	// 1453
	1031, 1032, 938,
	// 1454
	1033, 1032, 1031,
	// 1455
	1031, 1034, 1033,
	// 1456
	942, 1034, 1031,
	// 1457
	1031, 943, 942,
	// 1458
	1033, 1034, 1035,
	// 1459
	1035, 1036, 1033,
	// 1460
	974, 1036, 1035,
	// 1461
	1035, 977, 974,
	// 1462
	942, 977, 1035,
	// 1463
	1035, 1034, 942,
	// 1464
	1029, 1030, 1037,
	// 1465
	1037, 1038, 1029,
	// 1466
	938, 1038, 1037,
	// 1467
	1037, 939, 938,
	// 1468
	930, 939, 1037,
	// 1469
	1037, 1030, 930,
	// 1470
	1025, 1026, 1039,
	// 1471
	1039, 1040, 1025,
	// 1472
	962, 1040, 1039,
	// 1473
	1039, 1041, 962,
	// 1474
	999, 1041, 1039,
	// 1475
	1039, 1026, 999,
	// 1476
	1019, 1020, 1042,
	// 1477
	1042, 1043, 1019,
	// 1478
	997, 1043, 1042,
	// 1479
	1042, 1000, 997,
	// 1480
	882, 1000, 1042,
	// 1481
	1042, 1020, 882,
	// 1482
	970, 973, 1044,
	// 1483
	1044, 984, 970,
	// 1484
	980, 984, 1044,
	// 1485
	1044, 979, 980,
	// 1486
	974, 979, 1044,
	// 1487
	1044, 973, 974,
	// 1488
	1045, 1046, 1047,
	// 1489
	1047, 1048, 1045,
	// 1490
	1049, 1048, 1047,
	// 1491
	1047, 1050, 1049,
	// 1492
	1051, 1050, 1047,
	// 1493
	1047, 1046, 1051,
	// 1494
	1051, 1046, 1052,
	// 1495
	1052, 1053, 1051,
	// 1496
	1054, 1053, 1052,
	// 1497
	1052, 1055, 1054,
	// 1498
	1045, 1055, 1052,
	// 1499
	1052, 1046, 1045,
	// 1500
	1056, 1057, 1058,
	// 1501
	1058, 1059, 1056,
	// 1502
	1045, 1059, 1058,
	// 1503
	1058, 1055, 1045,
	// 1504
	1054, 1055, 1058,
	// 1505
	1058, 1057, 1054,
	// 1506
	1054, 1057, 1060,
	// 1507
	1060, 1061, 1054,
	// 1508
	1062, 1061, 1060,
	// 1509
	1060, 1063, 1062,
	// 1510
	1056, 1063, 1060,
	// 1511
	1060, 1057, 1056,
	// 1512
	1064, 1065, 1066,
	// 1513
	1066, 1067, 1064,
	// 1514
	1056, 1067, 1066,
	// 1515
	1066, 1063, 1056,
	// 1516
	1062, 1063, 1066,
	// 1517
	1066, 1065, 1062,
	// 1518
	1062, 1065, 1068,
	// 1519
	1068, 1069, 1062,
	// 1520
	1070, 1069, 1068,
	// 1521
	1068, 1071, 1070,
	// 1522
	1064, 1071, 1068,
	// 1523
	1068, 1065, 1064,
	// 1524
	1072, 1073, 1074,
	// 1525
	1074, 1075, 1072,
	// 1526
	1076, 1075, 1074,
	// 1527
	1074, 1077, 1076,
	// 1528
	1064, 1077, 1074,
	// 1529
	1074, 1073, 1064,
	// 1530
	1078, 1079, 1080,
	// 1531
	1080, 1081, 1078,
	// 1532
	1064, 1081, 1080,
	// 1533
	1080, 1077, 1064,
	// 1534
	1076, 1077, 1080,
	// 1535
	1080, 1079, 1076,
	// 1536
	1082, 1083, 1084,
	// 1537
	1084, 1085, 1082,
	// 1538
	1086, 1085, 1084,
	// 1539
	1084, 1087, 1086,
	// 1540
	1078, 1087, 1084,
	// 1541
	1084, 1083, 1078,
	// 1542
	1064, 1088, 1089,
	// 1543
	1089, 1081, 1064,
	// 1544
	1078, 1081, 1089,
	// 1545
	1089, 1087, 1078,
	// 1546
	1086, 1087, 1089,
	// 1547
	1089, 1088, 1086,
	// 1548
	1056, 1090, 1091,
	// 1549
	1091, 1067, 1056,
	// 1550
	1064, 1067, 1091,
	// 1551
	1091, 1088, 1064,
	// 1552
	1086, 1088, 1091,
	// 1553
	1091, 1090, 1086,
	// 1554
	1086, 1090, 1092,
	// 1555
	1092, 1093, 1086,
	// 1556
	1094, 1093, 1092,
	// 1557
	1092, 1095, 1094,
	// 1558
	1056, 1095, 1092,
	// 1559
	1092, 1090, 1056,
	// 1560
	1045, 1096, 1097,
	// 1561
	1097, 1059, 1045,
	// 1562
	1056, 1059, 1097,
	// 1563
	1097, 1095, 1056,
	// 1564
	1094, 1095, 1097,
	// 1565
	1097, 1096, 1094,
	// 1566
	1082, 1085, 1098,
	// 1567
	1098, 1099, 1082,
	// 1568
	1094, 1099, 1098,
	// 1569
	1098, 1093, 1094,
	// 1570
	1086, 1093, 1098,
	// 1571
	1098, 1085, 1086,
	// 1572
	1100, 1101, 1102,
	// 1573
	1102, 1103, 1100,
	// 1574
	1104, 1103, 1102,
	// 1575
	1102, 1105, 1104,
	// 1576
	1106, 1105, 1102,
	// 1577
	1102, 1101, 1106,
	// 1578
	1106, 1107, 1108,
	// 1579
	1108, 1105, 1106,
	// 1580
	1104, 1105, 1108,
	// 1581
	1108, 1109, 1104,
	// 1582
	1110, 1109, 1108,
	// 1583
	1108, 1107, 1110,
	// 1584
	1111, 1112, 1113,
	// 1585
	1113, 1114, 1111,
	// 1586
	1110, 1114, 1113,
	// 1587
	1113, 1109, 1110,
	// 1588
	1104, 1109, 1113,
	// 1589
	1113, 1112, 1104,
	// 1590
	1104, 1112, 1115,
	// 1591
	1115, 1116, 1104,
	// 1592
	1117, 1116, 1115,
	// 1593
	1115, 1118, 1117,
	// 1594
	1111, 1118, 1115,
	// 1595
	1115, 1112, 1111,
	// 1596
	1119, 1120, 1121,
	// 1597
	1121, 1122, 1119,
	// 1598
	1111, 1122, 1121,
	// 1599
	1121, 1118, 1111,
	// 1600
	1117, 1118, 1121,
	// 1601
	1121, 1120, 1117,
	// 1602
	1123, 1124, 1125,
	// 1603
	1125, 1126, 1123,
	// 1604
	1119, 1126, 1125,
	// 1605
	1125, 1120, 1119,
	// 1606
	1117, 1120, 1125,
	// 1607
	1125, 1124, 1117,
	// 1608
	1117, 1124, 1127,
	// 1609
	1127, 1116, 1117,
	// 1610
	1104, 1116, 1127,
	// 1611
	1127, 1128, 1104,
	// 1612
	1123, 1128, 1127,
	// 1613
	1127, 1124, 1123,
	// 1614
	1129, 1130, 1131,
	// 1615
	1131, 1132, 1129,
	// 1616
	1123, 1132, 1131,
	// 1617
	1131, 1128, 1123,
	// 1618
	1104, 1128, 1131,
	// 1619
	1131, 1130, 1104,
	// 1620
	1104, 1130, 1133,
	// 1621
	1133, 1103, 1104,
	// 1622
	1100, 1103, 1133,
	// 1623
	1133, 1134, 1100,
	// 1624
	1129, 1134, 1133,
	// 1625
	1133, 1130, 1129,
	// 1626
	1100, 1134, 1135,
	// 1627
	1135, 1136, 1100,
	// 1628
	1137, 1136, 1135,
	// 1629
	1135, 1138, 1137,
	// 1630
	1129, 1138, 1135,
	// 1631
	1135, 1134, 1129,
	// 1632
	1137, 1138, 1139,
	// 1633
	1139, 1140, 1137,
	// 1634
	1141, 1140, 1139,
	// 1635
	1139, 1142, 1141,
	// 1636
	1129, 1142, 1139,
	// 1637
	1139, 1138, 1129,
	// 1638
	1143, 1144, 1145,
	// 1639
	1145, 1146, 1143,
	// 1640
	1147, 1146, 1145,
	// 1641
	1145, 1148, 1147,
	// 1642
	1111, 1148, 1145,
	// 1643
	1145, 1144, 1111,
	// 1644
	1110, 1149, 1150,
	// 1645
	1150, 1114, 1110,
	// 1646
	1111, 1114, 1150,
	// 1647
	1150, 1148, 1111,
	// 1648
	1147, 1148, 1150,
	// 1649
	1150, 1149, 1147,
	// 1650
	1151, 1152, 1153,
	// 1651
	1153, 1154, 1151,
	// 1652
	1155, 1154, 1153,
	// 1653
	1153, 1156, 1155,
	// 1654
	1157, 1156, 1153,
	// 1655
	1153, 1152, 1157,
	// 1656
	1157, 1158, 1159,
	// 1657
	1159, 1160, 1157,
	// 1658
	1123, 1160, 1159,
	// 1659
	1159, 1161, 1123,
	// 1660
	1162, 1161, 1159,
	// 1661
	1159, 1158, 1162,
	// 1662
	1123, 1161, 1163,
	// 1663
	1163, 1132, 1123,
	// 1664
	1129, 1132, 1163,
	// 1665
	1163, 1164, 1129,
	// 1666
	1162, 1164, 1163,
	// 1667
	1163, 1161, 1162,
	// 1668
	1151, 1165, 1166,
	// 1669
	1166, 1167, 1151,
	// 1670
	1162, 1167, 1166,
	// 1671
	1166, 1164, 1162,
	// 1672
	1129, 1164, 1166,
	// 1673
	1166, 1165, 1129,
	// 1674
	1129, 1165, 1168,
	// 1675
	1168, 1169, 1129,
	// 1676
	1170, 1169, 1168,
	// 1677
	1168, 1171, 1170,
	// 1678
	1151, 1171, 1168,
	// 1679
	1168, 1165, 1151,
	// 1680
	1170, 1172, 1173,
	// 1681
	1173, 1169, 1170,
	// 1682
	1129, 1169, 1173,
	// 1683
	1173, 1142, 1129,
	// 1684
	1141, 1142, 1173,
	// 1685
	1173, 1172, 1141,
	// 1686
	1174, 1175, 1176,
	// 1687
	1176, 1177, 1174,
	// 1688
	1178, 1177, 1176,
	// 1689
	1176, 1179, 1178,
	// 1690
	1180, 1179, 1176,
	// 1691
	1176, 1175, 1180,
	// 1692
	1180, 1175, 1181,
	// 1693
	1181, 1182, 1180,
	// 1694
	1062, 1182, 1181,
	// 1695
	1181, 1183, 1062,
	// 1696
	1174, 1183, 1181,
	// 1697
	1181, 1175, 1174,
	// 1698
	1062, 1183, 1184,
	// 1699
	1184, 1061, 1062,
	// 1700
	1054, 1061, 1184,
	// 1701
	1184, 1185, 1054,
	// 1702
	1174, 1185, 1184,
	// 1703
	1184, 1183, 1174,
	// 1704
	1178, 1186, 1187,
	// 1705
	1187, 1177, 1178,
	// 1706
	1174, 1177, 1187,
	// 1707
	1187, 1185, 1174,
	// 1708
	1054, 1185, 1187,
	// 1709
	1187, 1186, 1054,
	// 1710
	1054, 1186, 1188,
	// 1711
	1188, 1053, 1054,
	// 1712
	1051, 1053, 1188,
	// 1713
	1188, 1189, 1051,
	// 1714
	1178, 1189, 1188,
	// 1715
	1188, 1186, 1178,
	// 1716
	1051, 1189, 1190,
	// 1717
	1190, 1191, 1051,
	// 1718
	1192, 1191, 1190,
	// 1719
	1190, 1193, 1192,
	// 1720
	1178, 1193, 1190,
	// 1721
	1190, 1189, 1178,
	// 1722
	1194, 1195, 1196,
	// 1723
	1196, 1197, 1194,
	// 1724
	1178, 1197, 1196,
	// 1725
	1196, 1193, 1178,
	// 1726
	1192, 1193, 1196,
	// 1727
	1196, 1195, 1192,
	// 1728
	1070, 1198, 1199,
	// 1729
	1199, 1069, 1070,
	// 1730
	1062, 1069, 1199,
	// 1731
	1199, 1200, 1062,
	// 1732
	1201, 1200, 1199,
	// 1733
	1199, 1198, 1201,
	// 1734
	1070, 1071, 1202,
	// 1735
	1202, 1203, 1070,
	// 1736
	1072, 1203, 1202,
	// 1737
	1202, 1073, 1072,
	// 1738
	1064, 1073, 1202,
	// 1739
	1202, 1071, 1064,
	// 1740
	1180, 1204, 1205,
	// 1741
	1205, 1179, 1180,
	// 1742
	1178, 1179, 1205,
	// 1743
	1205, 1206, 1178,
	// 1744
	1207, 1206, 1205,
	// 1745
	1205, 1204, 1207,
	// 1746
	1143, 1208, 1209,
	// 1747
	1209, 1144, 1143,
	// 1748
	1111, 1144, 1209,
	// 1749
	1209, 1210, 1111,
	// 1750
	1211, 1210, 1209,
	// 1751
	1209, 1208, 1211,
	// 1752
	1119, 1212, 1213,
	// 1753
	1213, 1126, 1119,
	// 1754
	1123, 1126, 1213,
	// 1755
	1213, 1214, 1123,
	// 1756
	1215, 1214, 1213,
	// 1757
	1213, 1212, 1215,
	// 1758
	1215, 1216, 1217,
	// 1759
	1217, 1214, 1215,
	// 1760
	1123, 1214, 1217,
	// 1761
	1217, 1160, 1123,
	// 1762
	1157, 1160, 1217,
	// 1763
	1217, 1216, 1157,
	// 1764
	1211, 1218, 1219,
	// 1765
	1219, 1210, 1211,
	// 1766
	1111, 1210, 1219,
	// 1767
	1219, 1122, 1111,
	// 1768
	1119, 1122, 1219,
	// 1769
	1219, 1218, 1119,
	// 1770
	1207, 1220, 1221,
	// 1771
	1221, 1206, 1207,
	// 1772
	1178, 1206, 1221,
	// 1773
	1221, 1222, 1178,
	// 1774
	1143, 1222, 1221,
	// 1775
	1221, 1220, 1143,
	// 1776
	1201, 1223, 1224,
	// 1777
	1224, 1200, 1201,
	// 1778
	1062, 1200, 1224,
	// 1779
	1224, 1182, 1062,
	// 1780
	1180, 1182, 1224,
	// 1781
	1224, 1223, 1180,
	// 1782
	1151, 1167, 1225,
	// 1783
	1225, 1152, 1151,
	// 1784
	1157, 1152, 1225,
	// 1785
	1225, 1158, 1157,
	// 1786
	1162, 1158, 1225,
	// 1787
	1225, 1167, 1162,
};

//-----------------------------------------------------------------------------
//	CfbNXobt@(gCAOXg)
//-----------------------------------------------------------------------------
static int april_index_buf1[] = {
	// 0
	0, 1, 2,
	// 1
	3, 4, 5,
	// 2
	4, 3, 6,
	// 3
	2, 6, 3,
	// 4
	6, 2, 7,
	// 5
	1, 7, 2,
	// 6
	7, 1, 8,
	// 7
	9, 8, 1,
	// 8
	8, 9, 10,
	// 9
	11, 10, 9,
	// 10
	12, 10, 11,
	// 11
	13, 14, 15,
	// 12
	16, 15, 14,
	// 13
	15, 16, 17,
	// 14
	4, 17, 16,
	// 15
	6, 17, 4,
	// 16
	7, 17, 6,
	// 17
	8, 17, 7,
	// 18
	17, 8, 18,
	// 19
	19, 18, 8,
	// 20
	18, 19, 20,
	// 21
	21, 22, 20,
	// 22
	23, 20, 22,
	// 23
	20, 23, 18,
	// 24
	24, 18, 23,
	// 25
	18, 24, 17,
	// 26
	17, 24, 15,
	// 27
	23, 15, 24,
	// 28
	15, 23, 13,
	// 29
	22, 13, 23,
	// 30
	13, 22, 25,
	// 31
	26, 20, 19,
	// 32
	20, 26, 21,
	// 33
	27, 21, 26,
	// 34
	21, 27, 28,
	// 35
	28, 27, 10,
	// 36
	26, 10, 27,
	// 37
	10, 26, 8,
	// 38
	19, 8, 26,
	// 39
	29, 10, 12,
	// 40
	10, 29, 28,
	// 41
	30, 28, 29,
	// 42
	28, 30, 31,
	// 43
	32, 31, 30,
	// 44
	31, 32, 33,
	// 45
	34, 33, 32,
	// 46
	33, 34, 35,
	// 47
	36, 35, 34,
	// 48
	35, 36, 37,
	// 49
	34, 32, 36,
	// 50
	36, 32, 29,
	// 51
	30, 29, 32,
	// 52
	38, 25, 22,
	// 53
	25, 38, 39,
	// 54
	40, 39, 38,
	// 55
	39, 40, 37,
	// 56
	37, 40, 35,
	// 57
	38, 35, 40,
	// 58
	35, 38, 33,
	// 59
	22, 33, 38,
	// 60
	33, 22, 31,
	// 61
	21, 31, 22,
	// 62
	31, 21, 28,
	// 63
	41, 37, 36,
	// 64
	42, 37, 41,
	// 65
	43, 37, 42,
	// 66
	44, 37, 43,
	// 67
	37, 44, 39,
	// 68
	45, 39, 44,
	// 69
	39, 45, 25,
	// 70
	46, 25, 45,
	// 71
	25, 46, 13,
	// 72
	14, 13, 46,
	// 73
	14, 46, 16,
	// 74
	16, 46, 44,
	// 75
	45, 44, 46,
	// 76
	47, 41, 48,
	// 77
	41, 47, 42,
	// 78
	49, 42, 47,
	// 79
	42, 49, 43,
	// 80
	50, 43, 49,
	// 81
	43, 50, 44,
	// 82
	51, 44, 50,
	// 83
	44, 51, 16,
	// 84
	5, 16, 51,
	// 85
	16, 5, 4,
	// 86
	3, 5, 52,
	// 87
	51, 52, 5,
	// 88
	50, 52, 51,
	// 89
	52, 50, 49,
	// 90
	0, 9, 1,
	// 91
	9, 0, 11,
	// 92
	53, 11, 0,
	// 93
	11, 53, 12,
	// 94
	54, 12, 53,
	// 95
	12, 54, 29,
	// 96
	55, 29, 54,
	// 97
	29, 55, 36,
	// 98
	48, 36, 55,
	// 99
	36, 48, 41,
	// 100
	47, 48, 56,
	// 101
	55, 56, 48,
	// 102
	54, 56, 55,
	// 103
	56, 54, 53,
	// 104
	57, 58, 59,
	// 105
	60, 59, 58,
	// 106
	59, 60, 61,
	// 107
	62, 61, 60,
	// 108
	61, 62, 63,
	// 109
	64, 63, 62,
	// 110
	63, 64, 65,
	// 111
	66, 65, 64,
	// 112
	67, 65, 66,
	// 113
	65, 67, 68,
	// 114
	69, 70, 71,
	// 115
	71, 70, 72,
	// 116
	73, 72, 70,
	// 117
	57, 72, 73,
	// 118
	72, 57, 74,
	// 119
	59, 74, 57,
	// 120
	74, 59, 75,
	// 121
	75, 59, 76,
	// 122
	61, 76, 59,
	// 123
	76, 61, 63,
	// 124
	77, 74, 78,
	// 125
	75, 78, 74,
	// 126
	78, 75, 79,
	// 127
	79, 75, 80,
	// 128
	76, 80, 75,
	// 129
	80, 76, 81,
	// 130
	81, 76, 68,
	// 131
	63, 68, 76,
	// 132
	68, 63, 65,
	// 133
	82, 68, 67,
	// 134
	68, 82, 81,
	// 135
	83, 81, 82,
	// 136
	81, 83, 80,
	// 137
	84, 80, 83,
	// 138
	80, 84, 79,
	// 139
	85, 79, 84,
	// 140
	79, 85, 78,
	// 141
	86, 78, 85,
	// 142
	78, 86, 77,
	// 143
	82, 87, 83,
	// 144
	87, 82, 88,
	// 145
	67, 88, 82,
	// 146
	87, 88, 89,
	// 147
	87, 90, 91,
	// 148
	92, 77, 93,
	// 149
	89, 94, 95,
	// 150
	96, 97, 98,
	// 151
	97, 96, 99,
	// 152
	92, 99, 96,
	// 153
	99, 92, 100,
	// 154
	93, 100, 92,
	// 155
	101, 100, 93,
	// 156
	100, 101, 99,
	// 157
	102, 99, 103,
	// 158
	99, 102, 97,
	// 159
	104, 97, 102,
	// 160
	97, 104, 98,
	// 161
	105, 98, 104,
	// 162
	106, 98, 105,
	// 163
	98, 106, 107,
	// 164
	108, 107, 106,
	// 165
	107, 108, 57,
	// 166
	58, 57, 108,
	// 167
	109, 110, 111,
	// 168
	111, 110, 112,
	// 169
	113, 112, 110,
	// 170
	114, 112, 113,
	// 171
	112, 114, 103,
	// 172
	103, 114, 102,
	// 173
	115, 102, 114,
	// 174
	102, 115, 104,
	// 175
	109, 116, 117,
	// 176
	116, 109, 118,
	// 177
	111, 118, 109,
	// 178
	118, 111, 119,
	// 179
	119, 111, 120,
	// 180
	120, 111, 121,
	// 181
	112, 121, 111,
	// 182
	121, 112, 122,
	// 183
	103, 122, 112,
	// 184
	122, 103, 99,
	// 185
	101, 122, 99,
	// 186
	122, 101, 121,
	// 187
	123, 121, 101,
	// 188
	121, 123, 120,
	// 189
	124, 120, 123,
	// 190
	120, 124, 119,
	// 191
	125, 119, 124,
	// 192
	119, 125, 126,
	// 193
	127, 126, 125,
	// 194
	126, 127, 128,
	// 195
	123, 129, 124,
	// 196
	130, 124, 129,
	// 197
	131, 127, 132,
	// 198
	125, 132, 127,
	// 199
	132, 125, 133,
	// 200
	124, 133, 125,
	// 201
	133, 124, 134,
	// 202
	130, 134, 124,
	// 203
	134, 130, 135,
	// 204
	129, 135, 130,
	// 205
	136, 135, 129,
	// 206
	135, 136, 137,
	// 207
	137, 136, 138,
	// 208
	139, 138, 136,
	// 209
	135, 137, 134,
	// 210
	136, 140, 139,
	// 211
	141, 139, 140,
	// 212
	139, 141, 142,
	// 213
	143, 142, 141,
	// 214
	131, 128, 127,
	// 215
	144, 128, 131,
	// 216
	128, 144, 145,
	// 217
	146, 145, 144,
	// 218
	143, 145, 146,
	// 219
	145, 143, 147,
	// 220
	141, 147, 143,
	// 221
	147, 141, 148,
	// 222
	149, 148, 141,
	// 223
	148, 149, 150,
	// 224
	119, 151, 118,
	// 225
	126, 151, 119,
	// 226
	151, 126, 152,
	// 227
	128, 152, 126,
	// 228
	145, 152, 128,
	// 229
	152, 145, 153,
	// 230
	147, 153, 145,
	// 231
	148, 153, 147,
	// 232
	150, 153, 148,
	// 233
	153, 150, 154,
	// 234
	154, 152, 153,
	// 235
	152, 154, 151,
	// 236
	155, 154, 150,
	// 237
	156, 154, 155,
	// 238
	157, 154, 156,
	// 239
	154, 157, 151,
	// 240
	116, 151, 157,
	// 241
	151, 116, 118,
	// 242
	158, 150, 149,
	// 243
	150, 158, 155,
	// 244
	159, 155, 158,
	// 245
	155, 159, 156,
	// 246
	160, 156, 159,
	// 247
	156, 160, 157,
	// 248
	161, 157, 160,
	// 249
	157, 161, 116,
	// 250
	162, 116, 161,
	// 251
	117, 116, 162,
	// 252
	159, 163, 160,
	// 253
	164, 160, 163,
	// 254
	160, 164, 161,
	// 255
	149, 165, 158,
	// 256
	166, 158, 165,
	// 257
	158, 166, 159,
	// 258
	167, 159, 166,
	// 259
	159, 167, 163,
	// 260
	168, 163, 167,
	// 261
	163, 168, 164,
	// 262
	169, 164, 168,
	// 263
	170, 164, 169,
	// 264
	164, 170, 161,
	// 265
	162, 161, 170,
	// 266
	169, 168, 171,
	// 267
	172, 173, 165,
	// 268
	174, 165, 173,
	// 269
	165, 174, 166,
	// 270
	175, 166, 174,
	// 271
	166, 175, 167,
	// 272
	176, 167, 175,
	// 273
	167, 176, 168,
	// 274
	177, 168, 176,
	// 275
	168, 177, 171,
	// 276
	171, 177, 178,
	// 277
	174, 173, 179,
	// 278
	180, 173, 181,
	// 279
	182, 179, 183,
	// 280
	184, 185, 186,
	// 281
	187, 186, 185,
	// 282
	186, 187, 188,
	// 283
	188, 187, 189,
	// 284
	190, 189, 187,
	// 285
	189, 190, 191,
	// 286
	179, 191, 190,
	// 287
	191, 179, 192,
	// 288
	182, 192, 179,
	// 289
	181, 192, 182,
	// 290
	193, 194, 192,
	// 291
	191, 192, 194,
	// 292
	192, 181, 193,
	// 293
	173, 193, 181,
	// 294
	195, 193, 173,
	// 295
	196, 193, 195,
	// 296
	193, 196, 194,
	// 297
	197, 194, 196,
	// 298
	198, 194, 197,
	// 299
	194, 198, 191,
	// 300
	189, 191, 198,
	// 301
	199, 189, 200,
	// 302
	198, 200, 189,
	// 303
	200, 198, 201,
	// 304
	197, 201, 198,
	// 305
	201, 197, 202,
	// 306
	196, 202, 197,
	// 307
	202, 196, 203,
	// 308
	195, 203, 196,
	// 309
	203, 195, 204,
	// 310
	205, 204, 195,
	// 311
	201, 202, 204,
	// 312
	203, 204, 202,
	// 313
	206, 200, 201,
	// 314
	195, 207, 205,
	// 315
	208, 205, 207,
	// 316
	205, 208, 209,
	// 317
	210, 211, 212,
	// 318
	213, 212, 211,
	// 319
	212, 213, 214,
	// 320
	208, 214, 213,
	// 321
	214, 208, 215,
	// 322
	207, 215, 208,
	// 323
	215, 207, 216,
	// 324
	195, 216, 207,
	// 325
	216, 195, 172,
	// 326
	173, 172, 195,
	// 327
	214, 217, 212,
	// 328
	216, 218, 215,
	// 329
	219, 215, 218,
	// 330
	215, 219, 214,
	// 331
	220, 214, 219,
	// 332
	214, 220, 217,
	// 333
	221, 217, 220,
	// 334
	217, 221, 222,
	// 335
	223, 222, 221,
	// 336
	222, 223, 224,
	// 337
	225, 224, 223,
	// 338
	222, 224, 226,
	// 339
	220, 227, 221,
	// 340
	223, 221, 228,
	// 341
	227, 228, 221,
	// 342
	228, 227, 229,
	// 343
	229, 227, 230,
	// 344
	230, 227, 218,
	// 345
	220, 218, 227,
	// 346
	218, 220, 219,
	// 347
	230, 231, 229,
	// 348
	222, 226, 217,
	// 349
	217, 226, 212,
	// 350
	212, 226, 210,
	// 351
	210, 226, 232,
	// 352
	232, 226, 233,
	// 353
	224, 233, 226,
	// 354
	233, 224, 234,
	// 355
	210, 235, 211,
	// 356
	235, 210, 236,
	// 357
	232, 236, 210,
	// 358
	236, 232, 237,
	// 359
	233, 237, 232,
	// 360
	237, 233, 238,
	// 361
	234, 238, 233,
	// 362
	238, 234, 239,
	// 363
	240, 239, 234,
	// 364
	239, 240, 241,
	// 365
	204, 205, 201,
	// 366
	209, 201, 205,
	// 367
	201, 209, 242,
	// 368
	242, 209, 243,
	// 369
	208, 243, 209,
	// 370
	213, 243, 208,
	// 371
	211, 243, 213,
	// 372
	243, 211, 244,
	// 373
	244, 211, 245,
	// 374
	245, 211, 235,
	// 375
	246, 247, 248,
	// 376
	249, 246, 250,
	// 377
	246, 249, 247,
	// 378
	251, 247, 249,
	// 379
	247, 251, 252,
	// 380
	253, 252, 251,
	// 381
	253, 251, 254,
	// 382
	247, 255, 248,
	// 383
	255, 247, 256,
	// 384
	252, 256, 247,
	// 385
	257, 258, 259,
	// 386
	260, 259, 258,
	// 387
	259, 260, 261,
	// 388
	262, 261, 260,
	// 389
	261, 262, 263,
	// 390
	261, 264, 259,
	// 391
	265, 266, 267,
	// 392
	268, 269, 270,
	// 393
	269, 268, 271,
	// 394
	272, 271, 268,
	// 395
	271, 272, 273,
	// 396
	273, 272, 274,
	// 397
	275, 276, 277,
	// 398
	276, 275, 274,
	// 399
	278, 274, 275,
	// 400
	274, 278, 273,
	// 401
	279, 273, 278,
	// 402
	273, 279, 271,
	// 403
	280, 271, 279,
	// 404
	271, 280, 269,
	// 405
	281, 269, 280,
	// 406
	282, 277, 283,
	// 407
	277, 282, 275,
	// 408
	284, 275, 282,
	// 409
	285, 275, 284,
	// 410
	275, 285, 278,
	// 411
	286, 278, 285,
	// 412
	278, 286, 279,
	// 413
	287, 279, 286,
	// 414
	279, 287, 280,
	// 415
	288, 280, 287,
	// 416
	280, 288, 281,
	// 417
	289, 281, 288,
	// 418
	223, 290, 225,
	// 419
	290, 223, 291,
	// 420
	228, 291, 223,
	// 421
	291, 228, 292,
	// 422
	229, 292, 228,
	// 423
	292, 229, 293,
	// 424
	231, 293, 229,
	// 425
	294, 293, 231,
	// 426
	295, 293, 294,
	// 427
	296, 293, 295,
	// 428
	293, 297, 292,
	// 429
	298, 292, 297,
	// 430
	292, 298, 291,
	// 431
	293, 296, 297,
	// 432
	299, 297, 296,
	// 433
	297, 299, 298,
	// 434
	300, 298, 299,
	// 435
	86, 298, 300,
	// 436
	298, 86, 291,
	// 437
	85, 291, 86,
	// 438
	291, 85, 290,
	// 439
	84, 290, 85,
	// 440
	290, 84, 83,
	// 441
	300, 299, 301,
	// 442
	300, 77, 86,
	// 443
	77, 300, 93,
	// 444
	301, 93, 300,
	// 445
	93, 301, 101,
	// 446
	101, 301, 123,
	// 447
	299, 123, 301,
	// 448
	123, 299, 129,
	// 449
	296, 129, 299,
	// 450
	129, 296, 136,
	// 451
	140, 136, 296,
	// 452
	295, 140, 296,
	// 453
	140, 295, 141,
	// 454
	141, 295, 149,
	// 455
	294, 149, 295,
	// 456
	149, 294, 165,
	// 457
	231, 165, 294,
	// 458
	165, 231, 172,
	// 459
	230, 172, 231,
	// 460
	172, 230, 216,
	// 461
	218, 216, 230,
	// 462
	302, 241, 240,
	// 463
	241, 302, 303,
	// 464
	303, 302, 304,
	// 465
	305, 304, 302,
	// 466
	304, 305, 306,
	// 467
	307, 306, 305,
	// 468
	306, 307, 91,
	// 469
	308, 91, 307,
	// 470
	91, 308, 309,
	// 471
	310, 311, 312,
	// 472
	312, 311, 313,
	// 473
	313, 311, 91,
	// 474
	91, 311, 306,
	// 475
	310, 306, 311,
	// 476
	306, 310, 304,
	// 477
	314, 178, 177,
	// 478
	178, 314, 315,
	// 479
	184, 315, 314,
	// 480
	315, 184, 316,
	// 481
	186, 316, 184,
	// 482
	316, 186, 317,
	// 483
	188, 317, 186,
	// 484
	317, 188, 318,
	// 485
	318, 188, 199,
	// 486
	189, 199, 188,
	// 487
	179, 190, 174,
	// 488
	319, 174, 190,
	// 489
	174, 319, 175,
	// 490
	175, 319, 176,
	// 491
	320, 176, 319,
	// 492
	176, 320, 177,
	// 493
	177, 320, 314,
	// 494
	321, 314, 320,
	// 495
	314, 321, 184,
	// 496
	185, 184, 321,
	// 497
	190, 187, 319,
	// 498
	185, 319, 187,
	// 499
	319, 185, 320,
	// 500
	321, 320, 185,
	// 501
	224, 225, 234,
	// 502
	234, 225, 240,
	// 503
	322, 240, 225,
	// 504
	240, 322, 302,
	// 505
	323, 302, 322,
	// 506
	302, 323, 305,
	// 507
	305, 323, 307,
	// 508
	307, 323, 83,
	// 509
	225, 83, 323,
	// 510
	83, 225, 290,
	// 511
	322, 225, 323,
	// 512
	57, 73, 107,
	// 513
	70, 107, 73,
	// 514
	107, 70, 98,
	// 515
	69, 98, 70,
	// 516
	98, 69, 96,
	// 517
	71, 96, 69,
	// 518
	96, 71, 92,
	// 519
	72, 92, 71,
	// 520
	92, 72, 77,
	// 521
	74, 77, 72,
	// 522
	324, 325, 326,
	// 523
	327, 328, 329,
	// 524
	328, 327, 330,
	// 525
	331, 330, 327,
	// 526
	332, 328, 330,
	// 527
	331, 333, 330,
	// 528
	333, 331, 334,
	// 529
	327, 334, 331,
	// 530
	334, 327, 335,
	// 531
	335, 327, 336,
	// 532
	329, 336, 327,
	// 533
	336, 329, 337,
	// 534
	338, 334, 339,
	// 535
	334, 338, 333,
	// 536
	334, 340, 339,
	// 537
	340, 334, 341,
	// 538
	335, 341, 334,
	// 539
	341, 335, 342,
	// 540
	342, 335, 343,
	// 541
	336, 343, 335,
	// 542
	343, 336, 344,
	// 543
	337, 344, 336,
	// 544
	344, 337, 345,
	// 545
	345, 337, 346,
	// 546
	342, 347, 341,
	// 547
	348, 341, 347,
	// 548
	340, 341, 349,
	// 549
	348, 349, 341,
	// 550
	349, 348, 350,
	// 551
	342, 351, 347,
	// 552
	352, 347, 351,
	// 553
	353, 347, 352,
	// 554
	347, 353, 348,
	// 555
	354, 348, 353,
	// 556
	348, 354, 350,
	// 557
	355, 350, 354,
	// 558
	350, 355, 349,
	// 559
	339, 349, 355,
	// 560
	349, 339, 340,
	// 561
	356, 355, 354,
	// 562
	357, 358, 359,
	// 563
	358, 357, 360,
	// 564
	360, 357, 361,
	// 565
	362, 361, 357,
	// 566
	361, 362, 363,
	// 567
	364, 363, 362,
	// 568
	363, 364, 365,
	// 569
	366, 365, 364,
	// 570
	365, 366, 367,
	// 571
	368, 367, 366,
	// 572
	367, 368, 351,
	// 573
	369, 351, 368,
	// 574
	351, 369, 352,
	// 575
	369, 368, 370,
	// 576
	371, 372, 373,
	// 577
	370, 373, 372,
	// 578
	373, 370, 374,
	// 579
	368, 374, 370,
	// 580
	374, 368, 375,
	// 581
	366, 375, 368,
	// 582
	375, 366, 376,
	// 583
	364, 376, 366,
	// 584
	376, 364, 377,
	// 585
	362, 377, 364,
	// 586
	378, 379, 377,
	// 587
	380, 377, 379,
	// 588
	381, 377, 380,
	// 589
	382, 377, 381,
	// 590
	377, 382, 376,
	// 591
	383, 382, 384,
	// 592
	381, 384, 382,
	// 593
	384, 381, 385,
	// 594
	380, 385, 381,
	// 595
	385, 380, 386,
	// 596
	379, 386, 380,
	// 597
	386, 379, 387,
	// 598
	387, 379, 388,
	// 599
	378, 388, 379,
	// 600
	388, 378, 389,
	// 601
	390, 391, 392,
	// 602
	391, 390, 389,
	// 603
	393, 389, 390,
	// 604
	389, 393, 388,
	// 605
	393, 390, 394,
	// 606
	395, 389, 378,
	// 607
	389, 395, 391,
	// 608
	396, 391, 395,
	// 609
	391, 396, 392,
	// 610
	397, 392, 396,
	// 611
	395, 398, 396,
	// 612
	377, 362, 378,
	// 613
	357, 378, 362,
	// 614
	378, 357, 395,
	// 615
	359, 395, 357,
	// 616
	395, 359, 398,
	// 617
	398, 359, 399,
	// 618
	358, 399, 359,
	// 619
	399, 358, 400,
	// 620
	400, 358, 401,
	// 621
	360, 401, 358,
	// 622
	399, 400, 402,
	// 623
	401, 360, 403,
	// 624
	361, 403, 360,
	// 625
	403, 361, 345,
	// 626
	363, 345, 361,
	// 627
	345, 363, 344,
	// 628
	365, 344, 363,
	// 629
	344, 365, 343,
	// 630
	367, 343, 365,
	// 631
	343, 367, 342,
	// 632
	351, 342, 367,
	// 633
	371, 404, 405,
	// 634
	404, 371, 406,
	// 635
	373, 406, 371,
	// 636
	374, 406, 373,
	// 637
	406, 374, 407,
	// 638
	407, 374, 408,
	// 639
	375, 408, 374,
	// 640
	376, 408, 375,
	// 641
	408, 376, 383,
	// 642
	382, 383, 376,
	// 643
	383, 409, 408,
	// 644
	410, 408, 409,
	// 645
	408, 410, 407,
	// 646
	411, 407, 410,
	// 647
	407, 411, 406,
	// 648
	412, 406, 411,
	// 649
	406, 412, 404,
	// 650
	413, 404, 412,
	// 651
	414, 404, 413,
	// 652
	415, 404, 414,
	// 653
	405, 404, 415,
	// 654
	416, 412, 411,
	// 655
	409, 417, 410,
	// 656
	418, 410, 417,
	// 657
	410, 418, 411,
	// 658
	419, 411, 418,
	// 659
	420, 411, 419,
	// 660
	411, 420, 416,
	// 661
	421, 416, 420,
	// 662
	346, 337, 422,
	// 663
	422, 337, 423,
	// 664
	329, 423, 337,
	// 665
	423, 329, 424,
	// 666
	328, 424, 329,
	// 667
	424, 328, 425,
	// 668
	332, 425, 328,
	// 669
	425, 332, 426,
	// 670
	330, 426, 332,
	// 671
	426, 330, 333,
	// 672
	427, 425, 426,
	// 673
	428, 370, 372,
	// 674
	429, 430, 431,
	// 675
	430, 432, 433,
	// 676
	434, 435, 436,
	// 677
	437, 436, 435,
	// 678
	438, 436, 437,
	// 679
	436, 438, 432,
	// 680
	439, 432, 438,
	// 681
	437, 435, 440,
	// 682
	441, 442, 443,
	// 683
	442, 441, 444,
	// 684
	445, 444, 441,
	// 685
	439, 444, 445,
	// 686
	444, 439, 446,
	// 687
	438, 446, 439,
	// 688
	446, 438, 447,
	// 689
	437, 447, 438,
	// 690
	447, 437, 448,
	// 691
	440, 448, 437,
	// 692
	442, 449, 443,
	// 693
	449, 442, 450,
	// 694
	444, 450, 442,
	// 695
	446, 450, 444,
	// 696
	447, 450, 446,
	// 697
	450, 447, 449,
	// 698
	448, 449, 447,
	// 699
	449, 448, 451,
	// 700
	451, 448, 452,
	// 701
	452, 448, 453,
	// 702
	454, 453, 448,
	// 703
	448, 440, 454,
	// 704
	455, 454, 440,
	// 705
	456, 454, 455,
	// 706
	454, 456, 453,
	// 707
	457, 453, 456,
	// 708
	453, 457, 452,
	// 709
	458, 452, 457,
	// 710
	452, 458, 451,
	// 711
	459, 451, 458,
	// 712
	460, 451, 459,
	// 713
	451, 460, 449,
	// 714
	449, 460, 461,
	// 715
	462, 461, 460,
	// 716
	461, 462, 463,
	// 717
	463, 462, 464,
	// 718
	459, 464, 462,
	// 719
	464, 459, 465,
	// 720
	458, 465, 459,
	// 721
	457, 465, 458,
	// 722
	465, 457, 466,
	// 723
	463, 467, 461,
	// 724
	468, 459, 462,
	// 725
	456, 466, 457,
	// 726
	466, 456, 469,
	// 727
	455, 469, 456,
	// 728
	470, 469, 455,
	// 729
	471, 469, 470,
	// 730
	469, 471, 472,
	// 731
	473, 472, 471,
	// 732
	472, 473, 474,
	// 733
	475, 474, 473,
	// 734
	476, 474, 475,
	// 735
	477, 478, 479,
	// 736
	478, 477, 480,
	// 737
	481, 480, 477,
	// 738
	480, 481, 472,
	// 739
	469, 472, 481,
	// 740
	482, 479, 483,
	// 741
	479, 482, 477,
	// 742
	484, 477, 482,
	// 743
	477, 484, 481,
	// 744
	485, 481, 484,
	// 745
	481, 485, 469,
	// 746
	469, 485, 486,
	// 747
	484, 486, 485,
	// 748
	486, 484, 487,
	// 749
	482, 487, 484,
	// 750
	483, 487, 482,
	// 751
	487, 483, 488,
	// 752
	489, 488, 483,
	// 753
	488, 489, 490,
	// 754
	491, 490, 489,
	// 755
	490, 491, 492,
	// 756
	492, 491, 493,
	// 757
	494, 493, 491,
	// 758
	493, 494, 478,
	// 759
	479, 478, 494,
	// 760
	491, 489, 494,
	// 761
	483, 494, 489,
	// 762
	494, 483, 479,
	// 763
	492, 495, 490,
	// 764
	496, 497, 498,
	// 765
	499, 500, 501,
	// 766
	502, 500, 499,
	// 767
	503, 500, 502,
	// 768
	500, 503, 496,
	// 769
	504, 496, 503,
	// 770
	496, 504, 497,
	// 771
	505, 497, 504,
	// 772
	506, 497, 505,
	// 773
	497, 506, 498,
	// 774
	507, 498, 506,
	// 775
	508, 498, 507,
	// 776
	498, 508, 496,
	// 777
	500, 496, 508,
	// 778
	506, 509, 507,
	// 779
	504, 510, 505,
	// 780
	510, 504, 503,
	// 781
	505, 509, 506,
	// 782
	511, 509, 505,
	// 783
	509, 511, 507,
	// 784
	512, 507, 511,
	// 785
	513, 507, 512,
	// 786
	514, 507, 513,
	// 787
	515, 507, 514,
	// 788
	507, 515, 508,
	// 789
	501, 508, 515,
	// 790
	508, 501, 500,
	// 791
	516, 517, 518,
	// 792
	517, 516, 519,
	// 793
	520, 519, 516,
	// 794
	517, 519, 521,
	// 795
	522, 523, 524,
	// 796
	525, 524, 523,
	// 797
	524, 525, 526,
	// 798
	527, 526, 525,
	// 799
	520, 526, 527,
	// 800
	526, 520, 528,
	// 801
	516, 528, 520,
	// 802
	528, 516, 529,
	// 803
	518, 529, 516,
	// 804
	530, 529, 518,
	// 805
	522, 529, 530,
	// 806
	529, 522, 531,
	// 807
	524, 531, 522,
	// 808
	526, 531, 524,
	// 809
	528, 531, 526,
	// 810
	531, 528, 529,
	// 811
	530, 532, 533,
	// 812
	534, 517, 535,
	// 813
	434, 517, 534,
	// 814
	517, 434, 518,
	// 815
	436, 518, 434,
	// 816
	518, 436, 536,
	// 817
	537, 536, 436,
	// 818
	536, 537, 538,
	// 819
	539, 538, 537,
	// 820
	538, 539, 540,
	// 821
	541, 540, 539,
	// 822
	540, 541, 542,
	// 823
	542, 541, 543,
	// 824
	543, 541, 544,
	// 825
	539, 544, 541,
	// 826
	537, 544, 539,
	// 827
	544, 537, 429,
	// 828
	436, 429, 537,
	// 829
	542, 545, 540,
	// 830
	546, 540, 545,
	// 831
	540, 546, 538,
	// 832
	538, 546, 536,
	// 833
	547, 536, 546,
	// 834
	536, 547, 518,
	// 835
	548, 518, 547,
	// 836
	549, 550, 551,
	// 837
	550, 549, 552,
	// 838
	553, 552, 549,
	// 839
	550, 554, 551,
	// 840
	554, 550, 555,
	// 841
	555, 550, 556,
	// 842
	552, 556, 550,
	// 843
	556, 552, 557,
	// 844
	553, 557, 552,
	// 845
	557, 553, 558,
	// 846
	558, 553, 559,
	// 847
	549, 559, 553,
	// 848
	559, 549, 560,
	// 849
	558, 561, 557,
	// 850
	562, 563, 560,
	// 851
	551, 560, 549,
	// 852
	560, 551, 562,
	// 853
	554, 562, 551,
	// 854
	562, 554, 564,
	// 855
	555, 564, 554,
	// 856
	565, 564, 555,
	// 857
	564, 565, 566,
	// 858
	472, 566, 565,
	// 859
	566, 472, 474,
	// 860
	567, 474, 568,
	// 861
	563, 568, 474,
	// 862
	562, 568, 563,
	// 863
	564, 568, 562,
	// 864
	568, 564, 566,
	// 865
	474, 569, 570,
	// 866
	571, 570, 569,
	// 867
	570, 571, 572,
	// 868
	573, 572, 571,
	// 869
	572, 573, 574,
	// 870
	575, 574, 573,
	// 871
	576, 574, 575,
	// 872
	574, 576, 577,
	// 873
	474, 476, 569,
	// 874
	578, 569, 476,
	// 875
	569, 578, 571,
	// 876
	579, 571, 578,
	// 877
	571, 579, 573,
	// 878
	580, 573, 579,
	// 879
	573, 580, 575,
	// 880
	581, 575, 580,
	// 881
	575, 581, 576,
	// 882
	582, 576, 581,
	// 883
	576, 582, 577,
	// 884
	583, 577, 582,
	// 885
	577, 583, 584,
	// 886
	579, 585, 580,
	// 887
	586, 580, 585,
	// 888
	580, 586, 581,
	// 889
	581, 586, 582,
	// 890
	582, 586, 583,
	// 891
	587, 583, 586,
	// 892
	583, 587, 588,
	// 893
	587, 586, 589,
	// 894
	589, 586, 590,
	// 895
	585, 590, 586,
	// 896
	590, 585, 591,
	// 897
	592, 591, 585,
	// 898
	591, 592, 593,
	// 899
	593, 592, 594,
	// 900
	594, 592, 476,
	// 901
	476, 592, 578,
	// 902
	578, 592, 579,
	// 903
	585, 579, 592,
	// 904
	595, 596, 597,
	// 905
	598, 596, 595,
	// 906
	599, 596, 598,
	// 907
	600, 596, 599,
	// 908
	596, 600, 597,
	// 909
	601, 597, 600,
	// 910
	597, 601, 602,
	// 911
	603, 602, 601,
	// 912
	602, 603, 517,
	// 913
	535, 517, 603,
	// 914
	517, 604, 602,
	// 915
	595, 602, 604,
	// 916
	602, 595, 597,
	// 917
	604, 605, 606,
	// 918
	607, 608, 609,
	// 919
	610, 611, 612,
	// 920
	608, 612, 611,
	// 921
	612, 608, 613,
	// 922
	607, 613, 608,
	// 923
	613, 607, 614,
	// 924
	615, 616, 617,
	// 925
	618, 619, 620,
	// 926
	620, 621, 618,
	// 927
	616, 618, 621,
	// 928
	621, 622, 616,
	// 929
	617, 616, 622,
	// 930
	622, 623, 617,
	// 931
	624, 617, 623,
	// 932
	623, 625, 624,
	// 933
	626, 624, 625,
	// 934
	627, 626, 625,
	// 935
	628, 629, 630,
	// 936
	631, 630, 629,
	// 937
	629, 632, 631,
	// 938
	620, 631, 632,
	// 939
	621, 620, 632,
	// 940
	622, 621, 632,
	// 941
	623, 622, 632,
	// 942
	632, 633, 623,
	// 943
	634, 623, 633,
	// 944
	633, 635, 634,
	// 945
	636, 635, 637,
	// 946
	638, 637, 635,
	// 947
	635, 633, 638,
	// 948
	639, 638, 633,
	// 949
	633, 632, 639,
	// 950
	632, 629, 639,
	// 951
	638, 639, 629,
	// 952
	629, 628, 638,
	// 953
	637, 638, 628,
	// 954
	628, 640, 637,
	// 955
	641, 634, 635,
	// 956
	635, 636, 641,
	// 957
	642, 641, 636,
	// 958
	636, 643, 642,
	// 959
	643, 625, 642,
	// 960
	641, 642, 625,
	// 961
	625, 623, 641,
	// 962
	634, 641, 623,
	// 963
	644, 627, 625,
	// 964
	625, 643, 644,
	// 965
	645, 644, 643,
	// 966
	643, 646, 645,
	// 967
	647, 645, 646,
	// 968
	646, 648, 647,
	// 969
	649, 647, 648,
	// 970
	648, 650, 649,
	// 971
	651, 649, 650,
	// 972
	650, 652, 651,
	// 973
	649, 651, 647,
	// 974
	651, 644, 647,
	// 975
	645, 647, 644,
	// 976
	653, 637, 640,
	// 977
	640, 654, 653,
	// 978
	655, 653, 654,
	// 979
	654, 652, 655,
	// 980
	652, 650, 655,
	// 981
	653, 655, 650,
	// 982
	650, 648, 653,
	// 983
	637, 653, 648,
	// 984
	648, 646, 637,
	// 985
	636, 637, 646,
	// 986
	646, 643, 636,
	// 987
	656, 651, 652,
	// 988
	657, 656, 652,
	// 989
	658, 657, 652,
	// 990
	659, 658, 652,
	// 991
	652, 654, 659,
	// 992
	660, 659, 654,
	// 993
	654, 640, 660,
	// 994
	661, 660, 640,
	// 995
	640, 628, 661,
	// 996
	630, 661, 628,
	// 997
	630, 631, 661,
	// 998
	631, 659, 661,
	// 999
	660, 661, 659,
	// 1000
	662, 663, 656,
	// 1001
	656, 657, 662,
	// 1002
	664, 662, 657,
	// 1003
	657, 658, 664,
	// 1004
	665, 664, 658,
	// 1005
	658, 659, 665,
	// 1006
	666, 665, 659,
	// 1007
	659, 631, 666,
	// 1008
	619, 666, 631,
	// 1009
	631, 620, 619,
	// 1010
	618, 667, 619,
	// 1011
	666, 619, 667,
	// 1012
	665, 666, 667,
	// 1013
	667, 664, 665,
	// 1014
	615, 617, 624,
	// 1015
	624, 626, 615,
	// 1016
	668, 615, 626,
	// 1017
	626, 627, 668,
	// 1018
	669, 668, 627,
	// 1019
	627, 644, 669,
	// 1020
	670, 669, 644,
	// 1021
	644, 651, 670,
	// 1022
	663, 670, 651,
	// 1023
	651, 656, 663,
	// 1024
	662, 671, 663,
	// 1025
	670, 663, 671,
	// 1026
	669, 670, 671,
	// 1027
	671, 668, 669,
	// 1028
	672, 673, 674,
	// 1029
	675, 674, 673,
	// 1030
	673, 676, 675,
	// 1031
	677, 675, 676,
	// 1032
	676, 678, 677,
	// 1033
	679, 677, 678,
	// 1034
	678, 680, 679,
	// 1035
	681, 679, 680,
	// 1036
	682, 681, 680,
	// 1037
	680, 683, 682,
	// 1038
	684, 685, 686,
	// 1039
	685, 687, 686,
	// 1040
	688, 686, 687,
	// 1041
	672, 688, 687,
	// 1042
	687, 689, 672,
	// 1043
	673, 672, 689,
	// 1044
	689, 690, 673,
	// 1045
	690, 691, 673,
	// 1046
	676, 673, 691,
	// 1047
	691, 678, 676,
	// 1048
	692, 693, 689,
	// 1049
	690, 689, 693,
	// 1050
	693, 694, 690,
	// 1051
	694, 695, 690,
	// 1052
	691, 690, 695,
	// 1053
	695, 696, 691,
	// 1054
	696, 683, 691,
	// 1055
	678, 691, 683,
	// 1056
	683, 680, 678,
	// 1057
	697, 682, 683,
	// 1058
	683, 696, 697,
	// 1059
	698, 697, 696,
	// 1060
	696, 695, 698,
	// 1061
	699, 698, 695,
	// 1062
	695, 694, 699,
	// 1063
	700, 699, 694,
	// 1064
	694, 693, 700,
	// 1065
	701, 700, 693,
	// 1066
	693, 692, 701,
	// 1067
	697, 698, 702,
	// 1068
	702, 703, 697,
	// 1069
	682, 697, 703,
	// 1070
	702, 704, 703,
	// 1071
	702, 705, 706,
	// 1072
	707, 708, 692,
	// 1073
	704, 709, 710,
	// 1074
	711, 712, 713,
	// 1075
	713, 714, 711,
	// 1076
	707, 711, 714,
	// 1077
	714, 715, 707,
	// 1078
	708, 707, 715,
	// 1079
	716, 708, 715,
	// 1080
	715, 714, 716,
	// 1081
	717, 718, 714,
	// 1082
	714, 713, 717,
	// 1083
	719, 717, 713,
	// 1084
	713, 712, 719,
	// 1085
	720, 719, 712,
	// 1086
	721, 720, 712,
	// 1087
	712, 722, 721,
	// 1088
	723, 721, 722,
	// 1089
	722, 672, 723,
	// 1090
	674, 723, 672,
	// 1091
	724, 725, 726,
	// 1092
	725, 727, 726,
	// 1093
	728, 726, 727,
	// 1094
	729, 728, 727,
	// 1095
	727, 718, 729,
	// 1096
	718, 717, 729,
	// 1097
	730, 729, 717,
	// 1098
	717, 719, 730,
	// 1099
	724, 731, 732,
	// 1100
	732, 733, 724,
	// 1101
	725, 724, 733,
	// 1102
	733, 734, 725,
	// 1103
	734, 735, 725,
	// 1104
	735, 736, 725,
	// 1105
	727, 725, 736,
	// 1106
	736, 737, 727,
	// 1107
	718, 727, 737,
	// 1108
	737, 714, 718,
	// 1109
	716, 714, 737,
	// 1110
	737, 736, 716,
	// 1111
	738, 716, 736,
	// 1112
	736, 735, 738,
	// 1113
	739, 738, 735,
	// 1114
	735, 734, 739,
	// 1115
	740, 739, 734,
	// 1116
	734, 741, 740,
	// 1117
	742, 740, 741,
	// 1118
	741, 743, 742,
	// 1119
	738, 739, 744,
	// 1120
	745, 744, 739,
	// 1121
	746, 747, 742,
	// 1122
	740, 742, 747,
	// 1123
	747, 748, 740,
	// 1124
	739, 740, 748,
	// 1125
	748, 749, 739,
	// 1126
	745, 739, 749,
	// 1127
	749, 750, 745,
	// 1128
	744, 745, 750,
	// 1129
	751, 744, 750,
	// 1130
	750, 752, 751,
	// 1131
	752, 753, 751,
	// 1132
	754, 751, 753,
	// 1133
	750, 749, 752,
	// 1134
	751, 754, 755,
	// 1135
	756, 755, 754,
	// 1136
	754, 757, 756,
	// 1137
	758, 756, 757,
	// 1138
	746, 742, 743,
	// 1139
	759, 746, 743,
	// 1140
	743, 760, 759,
	// 1141
	761, 759, 760,
	// 1142
	758, 761, 760,
	// 1143
	760, 762, 758,
	// 1144
	756, 758, 762,
	// 1145
	762, 763, 756,
	// 1146
	764, 756, 763,
	// 1147
	763, 765, 764,
	// 1148
	734, 733, 766,
	// 1149
	741, 734, 766,
	// 1150
	766, 767, 741,
	// 1151
	743, 741, 767,
	// 1152
	760, 743, 767,
	// 1153
	767, 768, 760,
	// 1154
	762, 760, 768,
	// 1155
	763, 762, 768,
	// 1156
	765, 763, 768,
	// 1157
	768, 769, 765,
	// 1158
	769, 768, 767,
	// 1159
	767, 766, 769,
	// 1160
	770, 765, 769,
	// 1161
	771, 770, 769,
	// 1162
	772, 771, 769,
	// 1163
	769, 766, 772,
	// 1164
	732, 772, 766,
	// 1165
	766, 733, 732,
	// 1166
	773, 764, 765,
	// 1167
	765, 770, 773,
	// 1168
	774, 773, 770,
	// 1169
	770, 771, 774,
	// 1170
	775, 774, 771,
	// 1171
	771, 772, 775,
	// 1172
	776, 775, 772,
	// 1173
	772, 732, 776,
	// 1174
	777, 776, 732,
	// 1175
	731, 777, 732,
	// 1176
	774, 775, 778,
	// 1177
	779, 778, 775,
	// 1178
	775, 776, 779,
	// 1179
	764, 773, 780,
	// 1180
	781, 780, 773,
	// 1181
	773, 774, 781,
	// 1182
	782, 781, 774,
	// 1183
	774, 778, 782,
	// 1184
	783, 782, 778,
	// 1185
	778, 779, 783,
	// 1186
	784, 783, 779,
	// 1187
	785, 784, 779,
	// 1188
	779, 776, 785,
	// 1189
	777, 785, 776,
	// 1190
	784, 786, 783,
	// 1191
	787, 780, 788,
	// 1192
	789, 788, 780,
	// 1193
	780, 781, 789,
	// 1194
	790, 789, 781,
	// 1195
	781, 782, 790,
	// 1196
	791, 790, 782,
	// 1197
	782, 783, 791,
	// 1198
	792, 791, 783,
	// 1199
	783, 786, 792,
	// 1200
	786, 793, 792,
	// 1201
	789, 794, 788,
	// 1202
	795, 796, 788,
	// 1203
	797, 798, 794,
	// 1204
	799, 800, 801,
	// 1205
	802, 801, 800,
	// 1206
	800, 803, 802,
	// 1207
	803, 804, 802,
	// 1208
	805, 802, 804,
	// 1209
	804, 806, 805,
	// 1210
	794, 805, 806,
	// 1211
	806, 807, 794,
	// 1212
	797, 794, 807,
	// 1213
	796, 797, 807,
	// 1214
	808, 807, 809,
	// 1215
	806, 809, 807,
	// 1216
	807, 808, 796,
	// 1217
	788, 796, 808,
	// 1218
	810, 788, 808,
	// 1219
	811, 810, 808,
	// 1220
	808, 809, 811,
	// 1221
	812, 811, 809,
	// 1222
	813, 812, 809,
	// 1223
	809, 806, 813,
	// 1224
	804, 813, 806,
	// 1225
	814, 815, 804,
	// 1226
	813, 804, 815,
	// 1227
	815, 816, 813,
	// 1228
	812, 813, 816,
	// 1229
	816, 817, 812,
	// 1230
	811, 812, 817,
	// 1231
	817, 818, 811,
	// 1232
	810, 811, 818,
	// 1233
	818, 819, 810,
	// 1234
	820, 810, 819,
	// 1235
	816, 819, 817,
	// 1236
	818, 817, 819,
	// 1237
	821, 816, 815,
	// 1238
	810, 820, 822,
	// 1239
	823, 822, 820,
	// 1240
	820, 824, 823,
	// 1241
	825, 826, 827,
	// 1242
	828, 827, 826,
	// 1243
	826, 829, 828,
	// 1244
	823, 828, 829,
	// 1245
	829, 830, 823,
	// 1246
	822, 823, 830,
	// 1247
	830, 831, 822,
	// 1248
	810, 822, 831,
	// 1249
	831, 787, 810,
	// 1250
	788, 810, 787,
	// 1251
	829, 826, 832,
	// 1252
	831, 830, 833,
	// 1253
	834, 833, 830,
	// 1254
	830, 829, 834,
	// 1255
	835, 834, 829,
	// 1256
	829, 832, 835,
	// 1257
	836, 835, 832,
	// 1258
	832, 837, 836,
	// 1259
	838, 836, 837,
	// 1260
	837, 839, 838,
	// 1261
	840, 838, 839,
	// 1262
	837, 841, 839,
	// 1263
	835, 836, 842,
	// 1264
	838, 843, 836,
	// 1265
	842, 836, 843,
	// 1266
	843, 844, 842,
	// 1267
	844, 845, 842,
	// 1268
	845, 833, 842,
	// 1269
	835, 842, 833,
	// 1270
	833, 834, 835,
	// 1271
	845, 844, 846,
	// 1272
	837, 832, 841,
	// 1273
	832, 826, 841,
	// 1274
	826, 825, 841,
	// 1275
	825, 847, 841,
	// 1276
	847, 848, 841,
	// 1277
	839, 841, 848,
	// 1278
	848, 849, 839,
	// 1279
	825, 827, 850,
	// 1280
	850, 851, 825,
	// 1281
	847, 825, 851,
	// 1282
	851, 852, 847,
	// 1283
	848, 847, 852,
	// 1284
	852, 853, 848,
	// 1285
	849, 848, 853,
	// 1286
	853, 854, 849,
	// 1287
	855, 849, 854,
	// 1288
	854, 856, 855,
	// 1289
	819, 816, 820,
	// 1290
	824, 820, 816,
	// 1291
	816, 857, 824,
	// 1292
	857, 858, 824,
	// 1293
	823, 824, 858,
	// 1294
	828, 823, 858,
	// 1295
	827, 828, 858,
	// 1296
	858, 859, 827,
	// 1297
	859, 860, 827,
	// 1298
	860, 850, 827,
	// 1299
	861, 862, 863,
	// 1300
	864, 865, 861,
	// 1301
	861, 863, 864,
	// 1302
	866, 864, 863,
	// 1303
	863, 867, 866,
	// 1304
	868, 866, 867,
	// 1305
	868, 869, 866,
	// 1306
	863, 862, 870,
	// 1307
	870, 871, 863,
	// 1308
	867, 863, 871,
	// 1309
	872, 873, 874,
	// 1310
	875, 874, 873,
	// 1311
	873, 876, 875,
	// 1312
	877, 875, 876,
	// 1313
	876, 878, 877,
	// 1314
	876, 873, 879,
	// 1315
	880, 881, 882,
	// 1316
	883, 884, 885,
	// 1317
	885, 886, 883,
	// 1318
	887, 883, 886,
	// 1319
	886, 888, 887,
	// 1320
	888, 889, 887,
	// 1321
	890, 891, 892,
	// 1322
	892, 889, 890,
	// 1323
	893, 890, 889,
	// 1324
	889, 888, 893,
	// 1325
	894, 893, 888,
	// 1326
	888, 886, 894,
	// 1327
	895, 894, 886,
	// 1328
	886, 885, 895,
	// 1329
	896, 895, 885,
	// 1330
	897, 898, 891,
	// 1331
	891, 890, 897,
	// 1332
	899, 897, 890,
	// 1333
	900, 899, 890,
	// 1334
	890, 893, 900,
	// 1335
	901, 900, 893,
	// 1336
	893, 894, 901,
	// 1337
	902, 901, 894,
	// 1338
	894, 895, 902,
	// 1339
	903, 902, 895,
	// 1340
	895, 896, 903,
	// 1341
	904, 903, 896,
	// 1342
	838, 840, 905,
	// 1343
	905, 906, 838,
	// 1344
	843, 838, 906,
	// 1345
	906, 907, 843,
	// 1346
	844, 843, 907,
	// 1347
	907, 908, 844,
	// 1348
	846, 844, 908,
	// 1349
	909, 846, 908,
	// 1350
	910, 909, 908,
	// 1351
	911, 910, 908,
	// 1352
	908, 907, 912,
	// 1353
	913, 912, 907,
	// 1354
	907, 906, 913,
	// 1355
	908, 912, 911,
	// 1356
	914, 911, 912,
	// 1357
	912, 913, 914,
	// 1358
	915, 914, 913,
	// 1359
	701, 915, 913,
	// 1360
	913, 906, 701,
	// 1361
	700, 701, 906,
	// 1362
	906, 905, 700,
	// 1363
	699, 700, 905,
	// 1364
	905, 698, 699,
	// 1365
	915, 916, 914,
	// 1366
	915, 701, 692,
	// 1367
	692, 708, 915,
	// 1368
	916, 915, 708,
	// 1369
	708, 716, 916,
	// 1370
	716, 738, 916,
	// 1371
	914, 916, 738,
	// 1372
	738, 744, 914,
	// 1373
	911, 914, 744,
	// 1374
	744, 751, 911,
	// 1375
	755, 911, 751,
	// 1376
	910, 911, 755,
	// 1377
	755, 756, 910,
	// 1378
	756, 764, 910,
	// 1379
	909, 910, 764,
	// 1380
	764, 780, 909,
	// 1381
	846, 909, 780,
	// 1382
	780, 787, 846,
	// 1383
	845, 846, 787,
	// 1384
	787, 831, 845,
	// 1385
	833, 845, 831,
	// 1386
	917, 855, 856,
	// 1387
	856, 918, 917,
	// 1388
	918, 919, 917,
	// 1389
	920, 917, 919,
	// 1390
	919, 921, 920,
	// 1391
	922, 920, 921,
	// 1392
	921, 705, 922,
	// 1393
	923, 922, 705,
	// 1394
	705, 924, 923,
	// 1395
	925, 926, 927,
	// 1396
	926, 928, 927,
	// 1397
	928, 705, 927,
	// 1398
	705, 921, 927,
	// 1399
	925, 927, 921,
	// 1400
	921, 919, 925,
	// 1401
	929, 792, 793,
	// 1402
	793, 930, 929,
	// 1403
	799, 929, 930,
	// 1404
	930, 931, 799,
	// 1405
	800, 799, 931,
	// 1406
	931, 932, 800,
	// 1407
	803, 800, 932,
	// 1408
	932, 933, 803,
	// 1409
	933, 814, 803,
	// 1410
	804, 803, 814,
	// 1411
	794, 789, 805,
	// 1412
	934, 805, 789,
	// 1413
	789, 790, 934,
	// 1414
	790, 791, 934,
	// 1415
	935, 934, 791,
	// 1416
	791, 792, 935,
	// 1417
	792, 929, 935,
	// 1418
	936, 935, 929,
	// 1419
	929, 799, 936,
	// 1420
	801, 936, 799,
	// 1421
	805, 934, 802,
	// 1422
	801, 802, 934,
	// 1423
	934, 935, 801,
	// 1424
	936, 801, 935,
	// 1425
	839, 849, 840,
	// 1426
	849, 855, 840,
	// 1427
	937, 840, 855,
	// 1428
	855, 917, 937,
	// 1429
	938, 937, 917,
	// 1430
	917, 920, 938,
	// 1431
	920, 922, 938,
	// 1432
	922, 698, 938,
	// 1433
	840, 938, 698,
	// 1434
	698, 905, 840,
	// 1435
	937, 938, 840,
	// 1436
	672, 722, 688,
	// 1437
	686, 688, 722,
	// 1438
	722, 712, 686,
	// 1439
	684, 686, 712,
	// 1440
	712, 711, 684,
	// 1441
	685, 684, 711,
	// 1442
	711, 707, 685,
	// 1443
	687, 685, 707,
	// 1444
	707, 692, 687,
	// 1445
	689, 687, 692,
	// 1446
	939, 940, 941,
	// 1447
	942, 943, 944,
	// 1448
	944, 945, 942,
	// 1449
	946, 942, 945,
	// 1450
	947, 945, 944,
	// 1451
	946, 945, 948,
	// 1452
	948, 949, 946,
	// 1453
	942, 946, 949,
	// 1454
	949, 950, 942,
	// 1455
	950, 951, 942,
	// 1456
	943, 942, 951,
	// 1457
	951, 952, 943,
	// 1458
	953, 954, 949,
	// 1459
	949, 948, 953,
	// 1460
	949, 954, 955,
	// 1461
	955, 956, 949,
	// 1462
	950, 949, 956,
	// 1463
	956, 957, 950,
	// 1464
	957, 958, 950,
	// 1465
	951, 950, 958,
	// 1466
	958, 959, 951,
	// 1467
	952, 951, 959,
	// 1468
	959, 960, 952,
	// 1469
	960, 961, 952,
	// 1470
	957, 956, 962,
	// 1471
	963, 962, 956,
	// 1472
	955, 964, 956,
	// 1473
	963, 956, 964,
	// 1474
	964, 965, 963,
	// 1475
	957, 962, 966,
	// 1476
	967, 966, 962,
	// 1477
	968, 967, 962,
	// 1478
	962, 963, 968,
	// 1479
	969, 968, 963,
	// 1480
	963, 965, 969,
	// 1481
	970, 969, 965,
	// 1482
	965, 964, 970,
	// 1483
	954, 970, 964,
	// 1484
	964, 955, 954,
	// 1485
	971, 969, 970,
	// 1486
	972, 973, 974,
	// 1487
	974, 975, 972,
	// 1488
	975, 976, 972,
	// 1489
	977, 972, 976,
	// 1490
	976, 978, 977,
	// 1491
	979, 977, 978,
	// 1492
	978, 980, 979,
	// 1493
	981, 979, 980,
	// 1494
	980, 982, 981,
	// 1495
	983, 981, 982,
	// 1496
	982, 966, 983,
	// 1497
	984, 983, 966,
	// 1498
	966, 967, 984,
	// 1499
	984, 985, 983,
	// 1500
	986, 987, 988,
	// 1501
	985, 988, 987,
	// 1502
	987, 989, 985,
	// 1503
	983, 985, 989,
	// 1504
	989, 990, 983,
	// 1505
	981, 983, 990,
	// 1506
	990, 991, 981,
	// 1507
	979, 981, 991,
	// 1508
	991, 992, 979,
	// 1509
	977, 979, 992,
	// 1510
	993, 992, 994,
	// 1511
	995, 994, 992,
	// 1512
	996, 995, 992,
	// 1513
	997, 996, 992,
	// 1514
	992, 991, 997,
	// 1515
	998, 999, 997,
	// 1516
	996, 997, 999,
	// 1517
	999, 1000, 996,
	// 1518
	995, 996, 1000,
	// 1519
	1000, 1001, 995,
	// 1520
	994, 995, 1001,
	// 1521
	1001, 1002, 994,
	// 1522
	1002, 1003, 994,
	// 1523
	993, 994, 1003,
	// 1524
	1003, 1004, 993,
	// 1525
	1005, 1006, 1007,
	// 1526
	1007, 1004, 1005,
	// 1527
	1008, 1005, 1004,
	// 1528
	1004, 1003, 1008,
	// 1529
	1008, 1009, 1005,
	// 1530
	1010, 993, 1004,
	// 1531
	1004, 1007, 1010,
	// 1532
	1011, 1010, 1007,
	// 1533
	1007, 1006, 1011,
	// 1534
	1012, 1011, 1006,
	// 1535
	1010, 1011, 1013,
	// 1536
	992, 993, 977,
	// 1537
	972, 977, 993,
	// 1538
	993, 1010, 972,
	// 1539
	973, 972, 1010,
	// 1540
	1010, 1013, 973,
	// 1541
	1013, 1014, 973,
	// 1542
	974, 973, 1014,
	// 1543
	1014, 1015, 974,
	// 1544
	1015, 1016, 974,
	// 1545
	975, 974, 1016,
	// 1546
	1014, 1017, 1015,
	// 1547
	1016, 1018, 975,
	// 1548
	976, 975, 1018,
	// 1549
	1018, 960, 976,
	// 1550
	978, 976, 960,
	// 1551
	960, 959, 978,
	// 1552
	980, 978, 959,
	// 1553
	959, 958, 980,
	// 1554
	982, 980, 958,
	// 1555
	958, 957, 982,
	// 1556
	966, 982, 957,
	// 1557
	986, 1019, 1020,
	// 1558
	1020, 1021, 986,
	// 1559
	987, 986, 1021,
	// 1560
	989, 987, 1021,
	// 1561
	1021, 1022, 989,
	// 1562
	1022, 1023, 989,
	// 1563
	990, 989, 1023,
	// 1564
	991, 990, 1023,
	// 1565
	1023, 998, 991,
	// 1566
	997, 991, 998,
	// 1567
	998, 1023, 1024,
	// 1568
	1025, 1024, 1023,
	// 1569
	1023, 1022, 1025,
	// 1570
	1026, 1025, 1022,
	// 1571
	1022, 1021, 1026,
	// 1572
	1027, 1026, 1021,
	// 1573
	1021, 1020, 1027,
	// 1574
	1028, 1027, 1020,
	// 1575
	1029, 1028, 1020,
	// 1576
	1030, 1029, 1020,
	// 1577
	1019, 1030, 1020,
	// 1578
	1031, 1026, 1027,
	// 1579
	1024, 1025, 1032,
	// 1580
	1033, 1032, 1025,
	// 1581
	1025, 1026, 1033,
	// 1582
	1034, 1033, 1026,
	// 1583
	1035, 1034, 1026,
	// 1584
	1026, 1031, 1035,
	// 1585
	1036, 1035, 1031,
	// 1586
	961, 1037, 952,
	// 1587
	1037, 1038, 952,
	// 1588
	943, 952, 1038,
	// 1589
	1038, 1039, 943,
	// 1590
	944, 943, 1039,
	// 1591
	1039, 1040, 944,
	// 1592
	947, 944, 1040,
	// 1593
	1040, 1041, 947,
	// 1594
	945, 947, 1041,
	// 1595
	1041, 948, 945,
	// 1596
	1042, 1041, 1040,
	// 1597
	1043, 988, 985,
	// 1598
	1044, 1045, 1046,
	// 1599
	1046, 1047, 1048,
	// 1600
	1049, 1050, 1051,
	// 1601
	1052, 1051, 1050,
	// 1602
	1053, 1052, 1050,
	// 1603
	1050, 1048, 1053,
	// 1604
	1054, 1053, 1048,
	// 1605
	1052, 1055, 1051,
	// 1606
	1056, 1057, 1058,
	// 1607
	1058, 1059, 1056,
	// 1608
	1060, 1056, 1059,
	// 1609
	1054, 1060, 1059,
	// 1610
	1059, 1061, 1054,
	// 1611
	1053, 1054, 1061,
	// 1612
	1061, 1062, 1053,
	// 1613
	1052, 1053, 1062,
	// 1614
	1062, 1063, 1052,
	// 1615
	1055, 1052, 1063,
	// 1616
	1058, 1057, 1064,
	// 1617
	1064, 1065, 1058,
	// 1618
	1059, 1058, 1065,
	// 1619
	1061, 1059, 1065,
	// 1620
	1062, 1061, 1065,
	// 1621
	1065, 1064, 1062,
	// 1622
	1063, 1062, 1064,
	// 1623
	1064, 1066, 1063,
	// 1624
	1066, 1067, 1063,
	// 1625
	1067, 1068, 1063,
	// 1626
	1069, 1063, 1068,
	// 1627
	1063, 1069, 1055,
	// 1628
	1070, 1055, 1069,
	// 1629
	1071, 1070, 1069,
	// 1630
	1069, 1068, 1071,
	// 1631
	1072, 1071, 1068,
	// 1632
	1068, 1067, 1072,
	// 1633
	1073, 1072, 1067,
	// 1634
	1067, 1066, 1073,
	// 1635
	1074, 1073, 1066,
	// 1636
	1075, 1074, 1066,
	// 1637
	1066, 1064, 1075,
	// 1638
	1064, 1076, 1075,
	// 1639
	1077, 1075, 1076,
	// 1640
	1076, 1078, 1077,
	// 1641
	1078, 1079, 1077,
	// 1642
	1074, 1077, 1079,
	// 1643
	1079, 1080, 1074,
	// 1644
	1073, 1074, 1080,
	// 1645
	1072, 1073, 1080,
	// 1646
	1080, 1081, 1072,
	// 1647
	1078, 1076, 1082,
	// 1648
	1083, 1077, 1074,
	// 1649
	1071, 1072, 1081,
	// 1650
	1081, 1084, 1071,
	// 1651
	1070, 1071, 1084,
	// 1652
	1085, 1070, 1084,
	// 1653
	1086, 1085, 1084,
	// 1654
	1084, 1087, 1086,
	// 1655
	1088, 1086, 1087,
	// 1656
	1087, 1089, 1088,
	// 1657
	1090, 1088, 1089,
	// 1658
	1091, 1090, 1089,
	// 1659
	1092, 1093, 1094,
	// 1660
	1094, 1095, 1092,
	// 1661
	1096, 1092, 1095,
	// 1662
	1095, 1087, 1096,
	// 1663
	1084, 1096, 1087,
	// 1664
	1097, 1098, 1093,
	// 1665
	1093, 1092, 1097,
	// 1666
	1099, 1097, 1092,
	// 1667
	1092, 1096, 1099,
	// 1668
	1100, 1099, 1096,
	// 1669
	1096, 1084, 1100,
	// 1670
	1084, 1101, 1100,
	// 1671
	1099, 1100, 1101,
	// 1672
	1101, 1102, 1099,
	// 1673
	1097, 1099, 1102,
	// 1674
	1098, 1097, 1102,
	// 1675
	1102, 1103, 1098,
	// 1676
	1104, 1098, 1103,
	// 1677
	1103, 1105, 1104,
	// 1678
	1106, 1104, 1105,
	// 1679
	1105, 1107, 1106,
	// 1680
	1107, 1108, 1106,
	// 1681
	1109, 1106, 1108,
	// 1682
	1108, 1094, 1109,
	// 1683
	1093, 1109, 1094,
	// 1684
	1106, 1109, 1104,
	// 1685
	1098, 1104, 1109,
	// 1686
	1109, 1093, 1098,
	// 1687
	1107, 1105, 1110,
	// 1688
	1111, 1112, 1113,
	// 1689
	1114, 1115, 1116,
	// 1690
	1117, 1114, 1116,
	// 1691
	1118, 1117, 1116,
	// 1692
	1116, 1111, 1118,
	// 1693
	1119, 1118, 1111,
	// 1694
	1111, 1113, 1119,
	// 1695
	1120, 1119, 1113,
	// 1696
	1121, 1120, 1113,
	// 1697
	1113, 1112, 1121,
	// 1698
	1122, 1121, 1112,
	// 1699
	1123, 1122, 1112,
	// 1700
	1112, 1111, 1123,
	// 1701
	1116, 1123, 1111,
	// 1702
	1121, 1122, 1124,
	// 1703
	1119, 1120, 1125,
	// 1704
	1125, 1118, 1119,
	// 1705
	1120, 1121, 1124,
	// 1706
	1126, 1120, 1124,
	// 1707
	1124, 1122, 1126,
	// 1708
	1127, 1126, 1122,
	// 1709
	1128, 1127, 1122,
	// 1710
	1129, 1128, 1122,
	// 1711
	1130, 1129, 1122,
	// 1712
	1122, 1123, 1130,
	// 1713
	1115, 1130, 1123,
	// 1714
	1123, 1116, 1115,
	// 1715
	1131, 1132, 1133,
	// 1716
	1133, 1134, 1131,
	// 1717
	1135, 1131, 1134,
	// 1718
	1133, 1136, 1134,
	// 1719
	1137, 1138, 1139,
	// 1720
	1140, 1139, 1138,
	// 1721
	1138, 1141, 1140,
	// 1722
	1142, 1140, 1141,
	// 1723
	1135, 1142, 1141,
	// 1724
	1141, 1143, 1135,
	// 1725
	1131, 1135, 1143,
	// 1726
	1143, 1144, 1131,
	// 1727
	1132, 1131, 1144,
	// 1728
	1145, 1132, 1144,
	// 1729
	1137, 1145, 1144,
	// 1730
	1144, 1146, 1137,
	// 1731
	1138, 1137, 1146,
	// 1732
	1141, 1138, 1146,
	// 1733
	1143, 1141, 1146,
	// 1734
	1146, 1144, 1143,
	// 1735
	1145, 1147, 1148,
	// 1736
	1149, 1150, 1133,
	// 1737
	1049, 1149, 1133,
	// 1738
	1133, 1132, 1049,
	// 1739
	1050, 1049, 1132,
	// 1740
	1132, 1151, 1050,
	// 1741
	1152, 1050, 1151,
	// 1742
	1151, 1153, 1152,
	// 1743
	1154, 1152, 1153,
	// 1744
	1153, 1155, 1154,
	// 1745
	1156, 1154, 1155,
	// 1746
	1155, 1157, 1156,
	// 1747
	1157, 1158, 1156,
	// 1748
	1158, 1159, 1156,
	// 1749
	1154, 1156, 1159,
	// 1750
	1152, 1154, 1159,
	// 1751
	1159, 1044, 1152,
	// 1752
	1050, 1152, 1044,
	// 1753
	1157, 1155, 1160,
	// 1754
	1161, 1160, 1155,
	// 1755
	1155, 1153, 1161,
	// 1756
	1153, 1151, 1161,
	// 1757
	1162, 1161, 1151,
	// 1758
	1151, 1132, 1162,
	// 1759
	1163, 1162, 1132,
	// 1760
	1164, 1165, 1166,
	// 1761
	1166, 1167, 1164,
	// 1762
	1168, 1164, 1167,
	// 1763
	1166, 1165, 1169,
	// 1764
	1169, 1170, 1166,
	// 1765
	1170, 1171, 1166,
	// 1766
	1167, 1166, 1171,
	// 1767
	1171, 1172, 1167,
	// 1768
	1168, 1167, 1172,
	// 1769
	1172, 1173, 1168,
	// 1770
	1173, 1174, 1168,
	// 1771
	1164, 1168, 1174,
	// 1772
	1174, 1175, 1164,
	// 1773
	1173, 1172, 1176,
	// 1774
	1177, 1175, 1178,
	// 1775
	1165, 1164, 1175,
	// 1776
	1175, 1177, 1165,
	// 1777
	1169, 1165, 1177,
	// 1778
	1177, 1179, 1169,
	// 1779
	1170, 1169, 1179,
	// 1780
	1180, 1170, 1179,
	// 1781
	1179, 1181, 1180,
	// 1782
	1087, 1180, 1181,
	// 1783
	1181, 1089, 1087,
	// 1784
	1182, 1183, 1089,
	// 1785
	1178, 1089, 1183,
	// 1786
	1177, 1178, 1183,
	// 1787
	1179, 1177, 1183,
	// 1788
	1183, 1181, 1179,
	// 1789
	1089, 1184, 1185,
	// 1790
	1186, 1185, 1184,
	// 1791
	1184, 1187, 1186,
	// 1792
	1188, 1186, 1187,
	// 1793
	1187, 1189, 1188,
	// 1794
	1190, 1188, 1189,
	// 1795
	1191, 1190, 1189,
	// 1796
	1189, 1192, 1191,
	// 1797
	1089, 1185, 1091,
	// 1798
	1193, 1091, 1185,
	// 1799
	1185, 1186, 1193,
	// 1800
	1194, 1193, 1186,
	// 1801
	1186, 1188, 1194,
	// 1802
	1195, 1194, 1188,
	// 1803
	1188, 1190, 1195,
	// 1804
	1196, 1195, 1190,
	// 1805
	1190, 1191, 1196,
	// 1806
	1197, 1196, 1191,
	// 1807
	1191, 1192, 1197,
	// 1808
	1198, 1197, 1192,
	// 1809
	1192, 1199, 1198,
	// 1810
	1194, 1195, 1200,
	// 1811
	1201, 1200, 1195,
	// 1812
	1195, 1196, 1201,
	// 1813
	1196, 1197, 1201,
	// 1814
	1197, 1198, 1201,
	// 1815
	1202, 1201, 1198,
	// 1816
	1198, 1203, 1202,
	// 1817
	1202, 1204, 1201,
	// 1818
	1204, 1205, 1201,
	// 1819
	1200, 1201, 1205,
	// 1820
	1205, 1206, 1200,
	// 1821
	1207, 1200, 1206,
	// 1822
	1206, 1208, 1207,
	// 1823
	1208, 1209, 1207,
	// 1824
	1209, 1091, 1207,
	// 1825
	1091, 1193, 1207,
	// 1826
	1193, 1194, 1207,
	// 1827
	1200, 1207, 1194,
	// 1828
	1210, 1211, 1212,
	// 1829
	1213, 1210, 1212,
	// 1830
	1214, 1213, 1212,
	// 1831
	1215, 1214, 1212,
	// 1832
	1212, 1211, 1215,
	// 1833
	1216, 1215, 1211,
	// 1834
	1211, 1217, 1216,
	// 1835
	1218, 1216, 1217,
	// 1836
	1217, 1133, 1218,
	// 1837
	1150, 1218, 1133,
	// 1838
	1133, 1217, 1219,
	// 1839
	1210, 1219, 1217,
	// 1840
	1217, 1211, 1210,
	// 1841
	1219, 1220, 1221,
	// 1842
	1222, 1223, 1224,
	// 1843
	1225, 1226, 1227,
	// 1844
	1224, 1227, 1226,
	// 1845
	1226, 1228, 1224,
	// 1846
	1222, 1224, 1228,
	// 1847
	1228, 1229, 1222,
};

//-----------------------------------------------------------------------------
//	CfbNXobt@(gCAOXg)
//-----------------------------------------------------------------------------
static int april_index_buf2[] = {
	// 0
	0, 1, 2,
	// 1
	2, 1, 3,
	// 2
	3, 1, 4,
	// 3
	4, 1, 5,
	// 4
	5, 1, 6,
	// 5
	6, 1, 7,
	// 6
	8, 7, 1,
	// 7
	7, 8, 9,
	// 8
	10, 9, 8,
	// 9
	9, 10, 11,
	// 10
	12, 11, 10,
	// 11
	11, 12, 13,
	// 12
	13, 12, 14,
	// 13
	14, 12, 15,
	// 14
	10, 15, 12,
	// 15
	15, 10, 0,
	// 16
	8, 0, 10,
	// 17
	0, 8, 1,
	// 18
	16, 17, 18,
	// 19
	19, 17, 16,
	// 20
	17, 19, 20,
	// 21
	21, 20, 19,
	// 22
	22, 20, 21,
	// 23
	20, 22, 23,
	// 24
	24, 23, 22,
	// 25
	23, 24, 25,
	// 26
	26, 24, 27,
	// 27
	24, 26, 25,
	// 28
	28, 25, 26,
	// 29
	29, 25, 28,
	// 30
	30, 25, 29,
	// 31
	25, 30, 23,
	// 32
	31, 23, 30,
	// 33
	23, 31, 20,
	// 34
	18, 20, 31,
	// 35
	20, 18, 17,
	// 36
	32, 33, 34,
	// 37
	35, 34, 33,
	// 38
	34, 35, 36,
	// 39
	37, 36, 35,
	// 40
	38, 36, 37,
	// 41
	36, 38, 39,
	// 42
	39, 38, 40,
	// 43
	41, 42, 43,
	// 44
	44, 42, 41,
	// 45
	45, 42, 44,
	// 46
	46, 42, 45,
	// 47
	47, 42, 46,
	// 48
	42, 47, 43,
	// 49
	48, 43, 47,
	// 50
	49, 50, 51,
	// 51
	52, 51, 50,
	// 52
	53, 54, 55,
	// 53
	54, 53, 49,
	// 54
	49, 53, 50,
	// 55
	56, 50, 53,
	// 56
	57, 50, 56,
	// 57
	58, 50, 57,
	// 58
	50, 58, 52,
	// 59
	59, 52, 58,
	// 60
	60, 61, 62,
	// 61
	61, 60, 63,
	// 62
	64, 63, 60,
	// 63
	63, 64, 65,
	// 64
	66, 65, 64,
	// 65
	65, 66, 67,
	// 66
	68, 69, 70,
	// 67
	71, 70, 69,
	// 68
	72, 70, 71,
	// 69
	70, 72, 73,
	// 70
	73, 72, 74,
	// 71
	74, 72, 75,
	// 72
	76, 77, 68,
	// 73
	77, 76, 78,
	// 74
	79, 78, 76,
	// 75
	80, 78, 79,
	// 76
	78, 80, 81,
	// 77
	81, 80, 82,
	// 78
	83, 82, 80,
	// 79
	82, 83, 84,
	// 80
	85, 84, 83,
	// 81
	77, 78, 81,
	// 82
	83, 86, 87,
	// 83
	86, 83, 79,
	// 84
	80, 79, 83,
	// 85
	88, 89, 90,
	// 86
	91, 89, 92,
	// 87
	88, 92, 89,
	// 88
	92, 88, 93,
	// 89
	94, 93, 88,
	// 90
	95, 96, 97,
	// 91
	96, 95, 98,
	// 92
	98, 95, 99,
	// 93
	100, 101, 102,
	// 94
	102, 101, 103,
	// 95
	104, 103, 101,
	// 96
	105, 106, 107,
	// 97
	108, 107, 106,
	// 98
	107, 108, 109,
	// 99
	109, 108, 110,
	// 100
	111, 112, 113,
	// 101
	113, 112, 114,
	// 102
	115, 114, 112,
	// 103
	114, 115, 116,
	// 104
	117, 118, 119,
	// 105
	119, 118, 120,
	// 106
	120, 118, 121,
	// 107
	122, 121, 118,
	// 108
	121, 122, 123,
	// 109
	124, 123, 122,
	// 110
	123, 124, 125,
	// 111
	126, 125, 124,
	// 112
	125, 126, 127,
	// 113
	128, 129, 130,
	// 114
	129, 128, 131,
	// 115
	132, 131, 128,
	// 116
	131, 132, 133,
	// 117
	134, 133, 132,
	// 118
	135, 133, 134,
	// 119
	136, 133, 135,
	// 120
	137, 133, 136,
	// 121
	138, 133, 137,
	// 122
	133, 138, 131,
	// 123
	139, 131, 138,
	// 124
	131, 139, 129,
	// 125
	140, 141, 142,
	// 126
	143, 141, 140,
	// 127
	141, 143, 144,
	// 128
	144, 143, 145,
	// 129
	146, 145, 143,
	// 130
	145, 146, 147,
	// 131
	148, 147, 146,
	// 132
	147, 148, 149,
	// 133
	150, 149, 148,
	// 134
	151, 152, 149,
	// 135
	149, 152, 147,
	// 136
	153, 147, 152,
	// 137
	147, 153, 145,
	// 138
	154, 155, 156,
	// 139
	157, 156, 155,
	// 140
	158, 156, 157,
	// 141
	156, 158, 159,
	// 142
	159, 158, 144,
	// 143
	160, 144, 158,
	// 144
	161, 144, 160,
	// 145
	144, 161, 141,
	// 146
	162, 141, 161,
	// 147
	142, 141, 162,
	// 148
	163, 164, 165,
	// 149
	166, 165, 164,
	// 150
	165, 166, 167,
	// 151
	167, 166, 168,
	// 152
	168, 166, 169,
	// 153
	164, 169, 166,
	// 154
	169, 164, 170,
	// 155
	171, 172, 173,
	// 156
	174, 173, 172,
	// 157
	173, 174, 175,
	// 158
	176, 175, 174,
	// 159
	175, 176, 177,
	// 160
	178, 177, 176,
	// 161
	177, 178, 179,
	// 162
	179, 178, 180,
	// 163
	180, 178, 181,
	// 164
	182, 183, 184,
	// 165
	183, 182, 185,
	// 166
	186, 185, 182,
	// 167
	187, 185, 186,
	// 168
	188, 185, 187,
	// 169
	185, 188, 183,
	// 170
	189, 183, 188,
	// 171
	190, 191, 192,
	// 172
	193, 192, 191,
	// 173
	192, 193, 194,
	// 174
	194, 193, 195,
	// 175
	196, 197, 198,
	// 176
	198, 197, 199,
	// 177
	200, 199, 197,
	// 178
	190, 199, 200,
	// 179
	199, 190, 201,
	// 180
	192, 201, 190,
	// 181
	201, 192, 202,
	// 182
	194, 202, 192,
	// 183
	202, 194, 203,
	// 184
	204, 205, 206,
	// 185
	205, 204, 207,
	// 186
	207, 204, 208,
	// 187
	209, 208, 204,
	// 188
	200, 208, 209,
	// 189
	208, 200, 210,
	// 190
	210, 200, 211,
	// 191
	197, 211, 200,
	// 192
	211, 197, 212,
	// 193
	212, 197, 196,
	// 194
	213, 214, 215,
	// 195
	214, 213, 216,
	// 196
	217, 216, 213,
	// 197
	218, 216, 217,
	// 198
	216, 218, 219,
	// 199
	220, 219, 218,
	// 200
	221, 219, 220,
	// 201
	222, 219, 221,
	// 202
	223, 219, 222,
	// 203
	224, 219, 223,
	// 204
	219, 224, 216,
	// 205
	214, 216, 224,
	// 206
	225, 226, 227,
	// 207
	228, 227, 226,
	// 208
	229, 227, 228,
	// 209
	230, 231, 232,
	// 210
	233, 234, 235,
	// 211
	236, 235, 234,
	// 212
	237, 238, 239,
	// 213
	240, 241, 242,
	// 214
	243, 244, 245,
	// 215
	246, 245, 244,
	// 216
	247, 248, 249,
	// 217
	250, 251, 252,
	// 218
	253, 252, 251,
	// 219
	252, 253, 254,
	// 220
	255, 256, 257,
	// 221
	257, 256, 258,
	// 222
	258, 256, 259,
	// 223
	260, 259, 256,
	// 224
	259, 260, 261,
	// 225
	262, 261, 260,
	// 226
	261, 262, 263,
	// 227
	264, 263, 262,
	// 228
	263, 264, 265,
	// 229
	266, 267, 268,
	// 230
	267, 266, 269,
	// 231
	270, 269, 266,
	// 232
	269, 270, 271,
	// 233
	272, 271, 270,
	// 234
	273, 271, 272,
	// 235
	274, 271, 273,
	// 236
	275, 271, 274,
	// 237
	276, 271, 275,
	// 238
	271, 276, 269,
	// 239
	277, 269, 276,
	// 240
	269, 277, 267,
	// 241
	278, 279, 280,
	// 242
	281, 279, 278,
	// 243
	279, 281, 282,
	// 244
	282, 281, 283,
	// 245
	284, 283, 281,
	// 246
	283, 284, 285,
	// 247
	286, 285, 284,
	// 248
	285, 286, 287,
	// 249
	288, 287, 286,
	// 250
	289, 290, 287,
	// 251
	287, 290, 285,
	// 252
	291, 285, 290,
	// 253
	285, 291, 283,
	// 254
	292, 293, 294,
	// 255
	295, 294, 293,
	// 256
	296, 294, 295,
	// 257
	294, 296, 297,
	// 258
	297, 296, 282,
	// 259
	298, 282, 296,
	// 260
	299, 282, 298,
	// 261
	282, 299, 279,
	// 262
	300, 279, 299,
	// 263
	280, 279, 300,
	// 264
	301, 302, 303,
	// 265
	304, 303, 302,
	// 266
	303, 304, 305,
	// 267
	305, 304, 306,
	// 268
	306, 304, 307,
	// 269
	302, 307, 304,
	// 270
	307, 302, 308,
	// 271
	309, 310, 311,
	// 272
	312, 311, 310,
	// 273
	311, 312, 313,
	// 274
	314, 313, 312,
	// 275
	313, 314, 315,
	// 276
	316, 315, 314,
	// 277
	315, 316, 317,
	// 278
	317, 316, 318,
	// 279
	318, 316, 319,
	// 280
	320, 321, 322,
	// 281
	321, 320, 323,
	// 282
	324, 323, 320,
	// 283
	325, 323, 324,
	// 284
	326, 323, 325,
	// 285
	323, 326, 321,
	// 286
	327, 321, 326,
	// 287
	328, 329, 330,
	// 288
	331, 330, 329,
	// 289
	330, 331, 332,
	// 290
	332, 331, 333,
	// 291
	334, 335, 336,
	// 292
	336, 335, 337,
	// 293
	338, 337, 335,
	// 294
	328, 337, 338,
	// 295
	337, 328, 339,
	// 296
	330, 339, 328,
	// 297
	339, 330, 340,
	// 298
	332, 340, 330,
	// 299
	340, 332, 341,
	// 300
	342, 343, 344,
	// 301
	343, 342, 345,
	// 302
	345, 342, 346,
	// 303
	347, 346, 342,
	// 304
	338, 346, 347,
	// 305
	346, 338, 348,
	// 306
	348, 338, 349,
	// 307
	335, 349, 338,
	// 308
	349, 335, 350,
	// 309
	350, 335, 334,
	// 310
	351, 352, 353,
	// 311
	352, 351, 354,
	// 312
	355, 354, 351,
	// 313
	356, 354, 355,
	// 314
	354, 356, 357,
	// 315
	358, 357, 356,
	// 316
	359, 357, 358,
	// 317
	360, 357, 359,
	// 318
	361, 357, 360,
	// 319
	362, 357, 361,
	// 320
	357, 362, 354,
	// 321
	352, 354, 362,
	// 322
	363, 364, 365,
	// 323
	366, 365, 364,
	// 324
	365, 366, 367,
	// 325
	367, 366, 368,
	// 326
	369, 370, 371,
	// 327
	371, 370, 372,
	// 328
	373, 372, 370,
	// 329
	372, 373, 374,
	// 330
	375, 376, 377,
	// 331
	376, 375, 378,
	// 332
	378, 375, 379,
	// 333
	380, 381, 382,
	// 334
	382, 381, 383,
	// 335
	384, 383, 381,
	// 336
	385, 386, 387,
	// 337
	387, 388, 389,
	// 338
	388, 387, 390,
	// 339
	386, 390, 387,
	// 340
	390, 386, 391,
	// 341
	392, 393, 394,
	// 342
	394, 393, 395,
	// 343
	395, 393, 396,
	// 344
	397, 396, 393,
	// 345
	398, 396, 397,
	// 346
	396, 398, 399,
	// 347
	399, 400, 401,
	// 348
	402, 401, 400,
	// 349
	401, 402, 403,
	// 350
	403, 402, 404,
	// 351
	405, 404, 402,
	// 352
	406, 404, 405,
	// 353
	404, 406, 407,
	// 354
	408, 407, 406,
	// 355
	407, 408, 409,
	// 356
	405, 402, 400,
	// 357
	410, 407, 411,
	// 358
	403, 407, 410,
	// 359
	407, 403, 404,
	// 360
	412, 413, 414,
	// 361
	415, 414, 413,
	// 362
	414, 415, 416,
	// 363
	417, 416, 415,
	// 364
	416, 417, 418,
	// 365
	419, 418, 417,
	// 366
	420, 421, 422,
	// 367
	422, 421, 423,
	// 368
	424, 423, 421,
	// 369
	425, 423, 424,
	// 370
	423, 425, 426,
	// 371
	427, 426, 425,
	// 372
	426, 427, 428,
	// 373
	429, 430, 431,
	// 374
	432, 431, 430,
	// 375
	433, 431, 432,
	// 376
	431, 433, 434,
	// 377
	434, 433, 435,
	// 378
	435, 433, 436,
	// 379
	437, 436, 433,
	// 380
	436, 437, 438,
	// 381
	437, 433, 439,
	// 382
	432, 439, 433,
	// 383
	440, 441, 442,
	// 384
	442, 441, 443,
	// 385
	443, 441, 444,
	// 386
	444, 441, 445,
	// 387
	445, 441, 446,
	// 388
	440, 446, 441,
	// 389
	446, 440, 447,
	// 390
	448, 449, 450,
	// 391
	450, 449, 451,
	// 392
	452, 451, 449,
	// 393
	453, 454, 455,
	// 394
	454, 453, 456,
	// 395
	456, 453, 457,
	// 396
	458, 457, 453,
	// 397
	459, 460, 461,
	// 398
	460, 459, 462,
	// 399
	462, 459, 463,
	// 400
	464, 465, 466,
	// 401
	467, 466, 465,
	// 402
	468, 466, 467,
	// 403
	466, 468, 469,
	// 404
	470, 471, 472,
	// 405
	473, 472, 471,
	// 406
	474, 475, 476,
	// 407
	477, 476, 475,
	// 408
	478, 479, 480,
	// 409
	479, 478, 481,
	// 410
	482, 483, 484,
	// 411
	483, 482, 485,
	// 412
	486, 487, 488,
	// 413
	489, 488, 487,
	// 414
	490, 491, 492,
	// 415
	493, 492, 491,
	// 416
	494, 495, 496,
	// 417
	495, 494, 497,
	// 418
	498, 499, 500,
	// 419
	499, 498, 501,
	// 420
	502, 503, 504,
	// 421
	504, 503, 505,
	// 422
	506, 505, 503,
	// 423
	507, 508, 509,
	// 424
	508, 507, 510,
	// 425
	510, 507, 511,
	// 426
	512, 511, 507,
	// 427
	513, 514, 515,
	// 428
	514, 513, 516,
	// 429
	516, 513, 517,
	// 430
	518, 519, 520,
	// 431
	521, 520, 519,
	// 432
	522, 520, 521,
	// 433
	520, 522, 523,
	// 434
	524, 525, 526,
	// 435
	527, 526, 525,
	// 436
	526, 527, 528,
	// 437
	529, 530, 531,
	// 438
	532, 531, 530,
	// 439
	531, 532, 533,
};

//-----------------------------------------------------------------------------
//	CfbNXobt@(gCAOXg)
//-----------------------------------------------------------------------------
static int april_index_buf3[] = {
	// 0
	0, 1, 2,
	// 1
	0, 3, 4,
	// 2
	3, 0, 5,
	// 3
	2, 5, 0,
	// 4
	6, 5, 2,
	// 5
	7, 5, 6,
	// 6
	5, 7, 8,
	// 7
	9, 8, 7,
	// 8
	8, 9, 10,
	// 9
	11, 10, 9,
	// 10
	10, 11, 12,
	// 11
	13, 14, 15,
	// 12
	14, 13, 12,
	// 13
	12, 13, 10,
	// 14
	16, 10, 13,
	// 15
	10, 16, 8,
	// 16
	17, 8, 16,
	// 17
	3, 8, 17,
	// 18
	8, 3, 5,
	// 19
	18, 12, 11,
	// 20
	19, 12, 18,
	// 21
	12, 19, 14,
	// 22
	20, 14, 19,
	// 23
	21, 14, 20,
	// 24
	14, 21, 15,
	// 25
	22, 15, 21,
	// 26
	23, 24, 25,
	// 27
	26, 27, 28,
	// 28
	25, 28, 27,
	// 29
	28, 25, 29,
	// 30
	24, 29, 25,
	// 31
	29, 24, 30,
	// 32
	30, 24, 31,
	// 33
	23, 31, 24,
	// 34
	31, 23, 32,
	// 35
	33, 32, 23,
	// 36
	32, 33, 34,
	// 37
	26, 28, 35,
	// 38
	36, 35, 37,
	// 39
	28, 37, 35,
	// 40
	37, 28, 29,
	// 41
	29, 30, 38,
	// 42
	39, 38, 30,
	// 43
	33, 23, 40,
	// 44
	34, 33, 41,
	// 45
	40, 41, 33,
	// 46
	41, 40, 42,
	// 47
	42, 40, 43,
	// 48
	43, 40, 44,
	// 49
	44, 40, 45,
	// 50
	23, 45, 40,
	// 51
	45, 23, 46,
	// 52
	25, 46, 23,
	// 53
	46, 25, 27,
	// 54
	47, 48, 49,
	// 55
	49, 48, 50,
	// 56
	51, 50, 48,
	// 57
	50, 51, 36,
	// 58
	52, 36, 51,
	// 59
	53, 36, 52,
	// 60
	36, 53, 35,
	// 61
	54, 35, 53,
	// 62
	35, 54, 26,
	// 63
	27, 26, 54,
	// 64
	37, 50, 36,
	// 65
	50, 37, 49,
	// 66
	29, 49, 37,
	// 67
	49, 29, 47,
	// 68
	38, 47, 29,
	// 69
	47, 38, 55,
	// 70
	39, 55, 38,
	// 71
	56, 55, 39,
	// 72
	55, 56, 57,
	// 73
	58, 57, 56,
	// 74
	57, 59, 55,
	// 75
	60, 57, 58,
	// 76
	57, 60, 59,
	// 77
	61, 59, 60,
	// 78
	62, 59, 61,
	// 79
	63, 59, 62,
	// 80
	64, 59, 63,
	// 81
	59, 64, 55,
	// 82
	55, 64, 47,
	// 83
	65, 47, 64,
	// 84
	48, 47, 65,
	// 85
	66, 67, 68,
	// 86
	67, 66, 69,
	// 87
	70, 69, 66,
	// 88
	69, 70, 71,
	// 89
	72, 73, 74,
	// 90
	75, 74, 76,
	// 91
	77, 78, 79,
	// 92
	79, 78, 80,
	// 93
	81, 80, 78,
	// 94
	79, 82, 77,
	// 95
	83, 77, 82,
	// 96
	77, 83, 84,
	// 97
	76, 84, 83,
	// 98
	84, 76, 85,
	// 99
	74, 85, 76,
	// 100
	86, 85, 74,
	// 101
	87, 88, 89,
	// 102
	80, 81, 90,
	// 103
	91, 90, 81,
	// 104
	90, 91, 88,
	// 105
	92, 88, 91,
	// 106
	88, 92, 89,
	// 107
	89, 92, 93,
	// 108
	93, 92, 94,
	// 109
	95, 96, 97,
	// 110
	98, 99, 100,
	// 111
	99, 98, 101,
	// 112
	102, 101, 98,
	// 113
	101, 102, 103,
	// 114
	103, 102, 95,
	// 115
	104, 95, 102,
	// 116
	95, 104, 96,
	// 117
	96, 104, 105,
	// 118
	106, 105, 104,
	// 119
	105, 106, 107,
	// 120
	108, 106, 109,
	// 121
	104, 109, 106,
	// 122
	102, 109, 104,
	// 123
	109, 102, 98,
	// 124
	108, 107, 106,
	// 125
	107, 108, 110,
	// 126
	111, 110, 108,
	// 127
	110, 111, 112,
	// 128
	113, 112, 111,
	// 129
	112, 113, 114,
	// 130
	109, 115, 108,
	// 131
	116, 108, 115,
	// 132
	108, 116, 111,
	// 133
	117, 111, 116,
	// 134
	111, 117, 113,
	// 135
	113, 117, 118,
	// 136
	118, 117, 119,
	// 137
	120, 119, 117,
	// 138
	119, 120, 121,
	// 139
	121, 120, 122,
	// 140
	122, 120, 123,
	// 141
	116, 123, 120,
	// 142
	123, 116, 115,
	// 143
	116, 120, 117,
	// 144
	124, 119, 121,
	// 145
	124, 121, 125,
	// 146
	125, 121, 126,
	// 147
	122, 126, 121,
	// 148
	126, 122, 127,
	// 149
	127, 122, 128,
	// 150
	128, 122, 129,
	// 151
	123, 129, 122,
	// 152
	129, 123, 130,
	// 153
	130, 123, 109,
	// 154
	115, 109, 123,
	// 155
	109, 98, 130,
	// 156
	100, 130, 98,
	// 157
	130, 100, 129,
	// 158
	131, 129, 100,
	// 159
	129, 131, 128,
	// 160
	132, 128, 131,
	// 161
	128, 132, 127,
	// 162
	133, 127, 132,
	// 163
	127, 133, 126,
	// 164
	134, 126, 133,
	// 165
	100, 135, 131,
	// 166
	136, 131, 135,
	// 167
	137, 131, 136,
	// 168
	131, 137, 132,
	// 169
	134, 133, 138,
	// 170
	139, 138, 133,
	// 171
	126, 134, 125,
	// 172
	125, 134, 140,
	// 173
	140, 134, 141,
	// 174
	138, 141, 134,
	// 175
	141, 138, 142,
	// 176
	142, 138, 143,
	// 177
	139, 143, 138,
	// 178
	143, 139, 144,
	// 179
	133, 144, 139,
	// 180
	132, 144, 133,
	// 181
	145, 141, 142,
	// 182
	146, 147, 148,
	// 183
	147, 146, 149,
	// 184
	150, 149, 146,
	// 185
	149, 150, 151,
	// 186
	152, 151, 150,
	// 187
	151, 152, 144,
	// 188
	143, 144, 152,
	// 189
	144, 132, 151,
	// 190
	137, 151, 132,
	// 191
	151, 137, 149,
	// 192
	136, 149, 137,
	// 193
	149, 136, 147,
	// 194
	147, 136, 153,
	// 195
	153, 136, 154,
	// 196
	135, 154, 136,
	// 197
	154, 135, 99,
	// 198
	100, 99, 135,
	// 199
	154, 99, 155,
	// 200
	101, 155, 99,
	// 201
	156, 157, 158,
	// 202
	156, 159, 160,
	// 203
	160, 161, 156,
	// 204
	157, 156, 161,
	// 205
	162, 157, 161,
	// 206
	163, 162, 161,
	// 207
	161, 164, 163,
	// 208
	165, 163, 164,
	// 209
	164, 166, 165,
	// 210
	167, 165, 166,
	// 211
	166, 168, 167,
	// 212
	169, 170, 171,
	// 213
	171, 168, 169,
	// 214
	168, 166, 169,
	// 215
	172, 169, 166,
	// 216
	166, 164, 172,
	// 217
	173, 172, 164,
	// 218
	160, 173, 164,
	// 219
	164, 161, 160,
	// 220
	174, 167, 168,
	// 221
	175, 174, 168,
	// 222
	168, 171, 175,
	// 223
	176, 175, 171,
	// 224
	177, 176, 171,
	// 225
	171, 170, 177,
	// 226
	178, 177, 170,
	// 227
	179, 180, 181,
	// 228
	182, 183, 184,
	// 229
	180, 184, 183,
	// 230
	183, 185, 180,
	// 231
	181, 180, 185,
	// 232
	185, 186, 181,
	// 233
	186, 187, 181,
	// 234
	179, 181, 187,
	// 235
	187, 188, 179,
	// 236
	189, 179, 188,
	// 237
	188, 190, 189,
	// 238
	182, 191, 183,
	// 239
	192, 193, 191,
	// 240
	183, 191, 193,
	// 241
	193, 185, 183,
	// 242
	185, 194, 186,
	// 243
	195, 186, 194,
	// 244
	189, 196, 179,
	// 245
	190, 197, 189,
	// 246
	196, 189, 197,
	// 247
	197, 198, 196,
	// 248
	198, 199, 196,
	// 249
	199, 200, 196,
	// 250
	200, 201, 196,
	// 251
	179, 196, 201,
	// 252
	201, 202, 179,
	// 253
	180, 179, 202,
	// 254
	202, 184, 180,
	// 255
	203, 204, 205,
	// 256
	204, 206, 205,
	// 257
	207, 205, 206,
	// 258
	206, 192, 207,
	// 259
	208, 207, 192,
	// 260
	209, 208, 192,
	// 261
	192, 191, 209,
	// 262
	210, 209, 191,
	// 263
	191, 182, 210,
	// 264
	184, 210, 182,
	// 265
	193, 192, 206,
	// 266
	206, 204, 193,
	// 267
	185, 193, 204,
	// 268
	204, 203, 185,
	// 269
	194, 185, 203,
	// 270
	203, 211, 194,
	// 271
	195, 194, 211,
	// 272
	212, 195, 211,
	// 273
	211, 213, 212,
	// 274
	214, 212, 213,
	// 275
	213, 211, 215,
	// 276
	216, 214, 213,
	// 277
	213, 215, 216,
	// 278
	217, 216, 215,
	// 279
	218, 217, 215,
	// 280
	219, 218, 215,
	// 281
	220, 219, 215,
	// 282
	215, 211, 220,
	// 283
	211, 203, 220,
	// 284
	221, 220, 203,
	// 285
	205, 221, 203,
	// 286
	222, 223, 224,
	// 287
	224, 225, 222,
	// 288
	226, 222, 225,
	// 289
	225, 227, 226,
	// 290
	228, 229, 230,
	// 291
	231, 232, 229,
	// 292
	233, 234, 235,
	// 293
	234, 236, 235,
	// 294
	237, 235, 236,
	// 295
	234, 233, 238,
	// 296
	239, 238, 233,
	// 297
	233, 240, 239,
	// 298
	232, 239, 240,
	// 299
	240, 241, 232,
	// 300
	229, 232, 241,
	// 301
	242, 229, 241,
	// 302
	243, 244, 245,
	// 303
	236, 246, 237,
	// 304
	247, 237, 246,
	// 305
	246, 245, 247,
	// 306
	248, 247, 245,
	// 307
	245, 244, 248,
	// 308
	244, 249, 248,
	// 309
	249, 250, 248,
	// 310
	251, 252, 253,
	// 311
	254, 255, 256,
	// 312
	256, 257, 254,
	// 313
	258, 254, 257,
	// 314
	257, 259, 258,
	// 315
	259, 251, 258,
	// 316
	260, 258, 251,
	// 317
	251, 253, 260,
	// 318
	253, 261, 260,
	// 319
	262, 260, 261,
	// 320
	261, 263, 262,
	// 321
	264, 265, 262,
	// 322
	260, 262, 265,
	// 323
	258, 260, 265,
	// 324
	265, 254, 258,
	// 325
	264, 262, 263,
	// 326
	263, 266, 264,
	// 327
	267, 264, 266,
	// 328
	266, 268, 267,
	// 329
	269, 267, 268,
	// 330
	268, 270, 269,
	// 331
	265, 264, 271,
	// 332
	272, 271, 264,
	// 333
	264, 267, 272,
	// 334
	273, 272, 267,
	// 335
	267, 269, 273,
	// 336
	269, 274, 273,
	// 337
	274, 275, 273,
	// 338
	276, 273, 275,
	// 339
	275, 277, 276,
	// 340
	277, 278, 276,
	// 341
	278, 279, 276,
	// 342
	272, 276, 279,
	// 343
	279, 271, 272,
	// 344
	272, 273, 276,
	// 345
	280, 277, 275,
	// 346
	280, 281, 277,
	// 347
	281, 282, 277,
	// 348
	278, 277, 282,
	// 349
	282, 283, 278,
	// 350
	283, 284, 278,
	// 351
	284, 285, 278,
	// 352
	279, 278, 285,
	// 353
	285, 286, 279,
	// 354
	286, 265, 279,
	// 355
	271, 279, 265,
	// 356
	265, 286, 254,
	// 357
	255, 254, 286,
	// 358
	286, 285, 255,
	// 359
	287, 255, 285,
	// 360
	285, 284, 287,
	// 361
	288, 287, 284,
	// 362
	284, 283, 288,
	// 363
	289, 288, 283,
	// 364
	283, 282, 289,
	// 365
	290, 289, 282,
	// 366
	255, 287, 291,
	// 367
	292, 291, 287,
	// 368
	293, 292, 287,
	// 369
	287, 288, 293,
	// 370
	290, 294, 289,
	// 371
	295, 289, 294,
	// 372
	282, 281, 290,
	// 373
	281, 296, 290,
	// 374
	296, 297, 290,
	// 375
	294, 290, 297,
	// 376
	297, 298, 294,
	// 377
	298, 299, 294,
	// 378
	295, 294, 299,
	// 379
	299, 300, 295,
	// 380
	289, 295, 300,
	// 381
	288, 289, 300,
	// 382
	301, 298, 297,
	// 383
	302, 303, 304,
	// 384
	304, 305, 302,
	// 385
	306, 302, 305,
	// 386
	305, 307, 306,
	// 387
	308, 306, 307,
	// 388
	307, 300, 308,
	// 389
	299, 308, 300,
	// 390
	300, 307, 288,
	// 391
	293, 288, 307,
	// 392
	307, 305, 293,
	// 393
	292, 293, 305,
	// 394
	305, 304, 292,
	// 395
	304, 309, 292,
	// 396
	309, 310, 292,
	// 397
	291, 292, 310,
	// 398
	310, 256, 291,
	// 399
	255, 291, 256,
	// 400
	310, 311, 256,
	// 401
	257, 256, 311,
};

//-----------------------------------------------------------------------------
//	}eAf[^e[u
//-----------------------------------------------------------------------------
static MaterialData april_material[] =
{
	{
		Color( 0.900000, 0.900000, 0.900000, 1.000000 ),
		Color( 0.788235, 0.000000, 0.000000, 1.000000 ),
		Color( 0.788235, 0.000000, 0.000000, 1.000000 ),
		0,
		NULL,
	},
	{
		Color( 0.900000, 0.900000, 0.900000, 1.000000 ),
		Color( 0.741176, 0.701961, 0.584314, 1.000000 ),
		Color( 0.741176, 0.701961, 0.584314, 1.000000 ),
		0,
		NULL,
	},
	{
		Color( 0.900000, 0.900000, 0.900000, 1.000000 ),
		Color( 0.235294, 0.235294, 0.235294, 1.000000 ),
		Color( 0.235294, 0.235294, 0.235294, 1.000000 ),
		0,
		NULL,
	},
	{
		Color( 0.900000, 0.900000, 0.900000, 1.000000 ),
		Color( 0.203922, 0.203922, 0.203922, 1.000000 ),
		Color( 0.203922, 0.203922, 0.203922, 1.000000 ),
		0,
		NULL,
	},
};

//-----------------------------------------------------------------------------
//	}eAPʂ̃NX^f[^e[u
//-----------------------------------------------------------------------------
static ClusterData april_cluster[] =
{
	{
		0,
		0,
		0,
		1226,
		april_vertex_buf0,
		MVF_TRIANGLES,
		5364,
		april_index_buf0,
		0,
		NULL,
		0,
		NULL,
	},
	{
		0,
		1,
		1,
		1230,
		april_vertex_buf1,
		MVF_TRIANGLES,
		5544,
		april_index_buf1,
		0,
		NULL,
		0,
		NULL,
	},
	{
		0,
		2,
		2,
		534,
		april_vertex_buf2,
		MVF_TRIANGLES,
		1320,
		april_index_buf2,
		0,
		NULL,
		0,
		NULL,
	},
	{
		0,
		3,
		3,
		312,
		april_vertex_buf3,
		MVF_TRIANGLES,
		1206,
		april_index_buf3,
		0,
		NULL,
		0,
		NULL,
	},
};

//-----------------------------------------------------------------------------
//	bVf[^
//-----------------------------------------------------------------------------
static MeshData april_mesh =
{
	4,
	4,
	april_cluster,
	4,
	april_material,
};

//-----------------------------------------------------------------------------
//	ff[^
//-----------------------------------------------------------------------------
ModelData lady_model =
{
	0,
	1,
	&april_mesh,
	april_BONE_NUM,
	april_bone,
	april_bone_inv_mtx,
	april_MULTI_BONE_WEIGHT_NUM,
	april_weight,
};
